// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2020-01-03T12:41:20, by ESR Version 2.2.0.28 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationIITR
{

    public partial class IITR2020Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="IITR2020Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public IITR2020Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString().ToLower() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Get string value between [first] a and [last] b.
        /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

        /// <summary>
        /// Get string value after [first] a.
        /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

        /// <summary>
        /// Get string value after [last] a.
        /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
                return 0;
            else
                return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return (from x in nodes select x).Distinct().Count() != 1;
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());

        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

        public DateTime Date(DateTime? datetime)
        {
            return datetime.GetValueOrDefault().Date;
        }

        //The logic in After function expects "---" for day and "--" for month. 
        //Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
            return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response = true;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length == 14)
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 3), out numeric))
                        response = false;

                }
                else if (usi.Length == 9)
                {

                    if (Regex.IsMatch(usi, @"^([a-zA-Z]{3}\d{4}[a-zA-Z]{2})$"))
                        response = false;
                }
            }
            return response;
        }

        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
            return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
            decimal numberValue;
            decimal.TryParse(value, out numberValue);
            return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':
                        options = options | RegexOptions.IgnoreCase;
                        break;
                    case 'm':
                        options = options | RegexOptions.Multiline;
                        break;
                    case 's':
                        options = options | RegexOptions.Singleline;
                        break;
                    case 'n':
                        options = options | RegexOptions.ExplicitCapture;
                        break;
                    case 'x':
                        options = options | RegexOptions.IgnorePatternWhitespace;
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public IITR2020 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string, ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(IITR2020 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

            #region Manual Rules - Rules marked for manual coding

            #region VR.ATO.IITR.000013

            /*  VR.ATO.IITR.000013
                Where the number of days not liable for medicare levy surcharge is less than the whole reporting period, and either income test is triggered; and the reportable employer superannuation contributions is greater than 8% of all income from salary and wages, check reportable employer superannuation contributions as MLS liability may be incurred.

            Legacy Rule Format:
                IF ([iitr177] = NULL OR [iitr177] < (RP:period.endDate - RP:period.startDate + 1)) AND ((([iitr213] <> NULLORBLANK OR [iitr171] <> NULL) AND ((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + ConditionalValue([iitr157] > 0, [iitr330], 0) + [iitr399] - ConditionalValue((([iitr29] > ConvertToDate(30,6, [iitr10] - 55)) OR ([iitr29] <= ConvertToDate(1,7, [iitr10] - 61))), SUM((ConditionalValue(COUNT(SCHEDULE = 'INCDTLS') = 1) AND ([incdtls333] <> TRUE), [incdtls330], 0)), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) + [iitr225] + ConditionalValue(([iitr492] + [iitr493]) > 3772, ([iitr492] + [iitr493]), 0) + [iitr227] + [iitr234] + [iitr231] - [iitr236]) > (180000 + ConditionalValue([iitr171] > 1, ((1500 * [iitr171]) - 1), 0)))) OR (([iitr213] = NULLORBLANK) AND ([iitr171] = NULL) AND ((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + ConditionalValue([iitr157] > 0, [iitr330], 0) + [iitr399] - ConditionalValue((([iitr29] > ConvertToDate(30,6, [iitr10] - 55)) OR ([iitr29] <= ConvertToDate(1,7, [iitr10] - 61))), SUM(ConditionalValue((COUNT(SCHEDULE = 'INCDTLS') = 1) AND ([incdtls333] <> TRUE), [incdtls330], 0)), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0)) > 90000))) AND ([iitr201] > ([iitr601] * 0.08))
                   RETURN VALIDATION MESSAGE
                ENDIF

            Technical Business Rule Format:
                (^IITR177 = NULL OR ^IITR177 < (^EndDate - ^StartDate1 + 1)) AND (((^IITR213 <> BLANK OR ^IITR171 <> NULL) AND ((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ConditionalValue(^IITR157 > 0, ^IITR330, 0) + ^IITR399 - ConditionalValue(((^IITR29 > ConvertToDate(30,6, ^IITR10 - 55)) OR (^IITR29 <= ConvertToDate(1,7, ^IITR10 - 61))), Sum((ConditionalValue(CountDocument('INCDTLS') = 1) AND (^INCDTLS333 <> TRUE), ^INCDTLS330, 0)), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) + ^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, (^IITR492 + ^IITR493), 0) + ^IITR227 + ^IITR234 + ^IITR231 - ^IITR236) > (180000 + ConditionalValue(^IITR171 > 1, ((1500 * ^IITR171) - 1), 0)))) OR ((^IITR213 = BLANK) AND (^IITR171 = NULL) AND ((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ConditionalValue(^IITR157 > 0, ^IITR330, 0) + ^IITR399 - ConditionalValue(((^IITR29 > ConvertToDate(30,6, ^IITR10 - 55)) OR (^IITR29 <= ConvertToDate(1,7, ^IITR10 - 61))), Sum(ConditionalValue((CountDocument('INCDTLS') = 1) AND (^INCDTLS333 <> TRUE), ^INCDTLS330, 0)), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0)) > 90000))) AND (^IITR201 > (^IITR601 * 0.08))

            Data Elements:

            ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

            ^EndDate = RP

            ^StartDate1 = RP

            ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count

            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text

            ^IITR171 = RP:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count

            ^IITR157 = RP:Income.Taxable.Amount

            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

            ^IITR330 = RP:InternationalDealings.ExemptForeignEmploymentIncome.Amount

            ^IITR399 = RP:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount

            ^IITR29 = RP:PersonDemographicDetails.Birth.Date

            ^IITR10 = RP:Report.TargetFinancial.Year

            ^INCDTLS333 = INCDTLS333

            ^INCDTLS330 = INCDTLS330

            ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

            ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

            ^DDCTNS407 = DDCTNS407

            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount

            ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount

            ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount

            ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount

            ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount

            ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount

            ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount

            ^IITR601 = RP:Income.SalaryOrWages.Amount
            */
            VRATOIITR000013(response, report);
            #endregion // VR.ATO.IITR.000013

            #region VR.ATO.IITR.000236

            /*  VR.ATO.IITR.000236
                        Total tax withheld does not equal the sum of all tax withheld items

                    Legacy Rule Format:
                        IF (([iitr113] <> NULL) AND ([iitr113] <> ([iitr85] + [iitr88] + [iitr600] + [iitr606] + [iitr608] + [iitr91] + [iitr111] + [iitr625] + [iitr610]))) 
                        OR (([iitr113] = NULL) AND (([iitr85] + [iitr88] + [iitr600] + [iitr606] + [iitr608] + [iitr91] + [iitr111] + [iitr625] + [iitr610]) <> 0))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ((^IITR113 <> NULL) AND (^IITR113 <> (^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR625 + ^IITR610))) OR ((^IITR113 = NULL) AND ((^IITR85 + ^IITR88 + ^IITR600 + ^IITR606 + ^IITR608 + ^IITR91 + ^IITR111 + ^IITR625 + ^IITR610) <> 0))

            Data Elements:

                ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount

                ^IITR85 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount

                ^IITR88 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentPensionsAndAllowances.Amount

                ^IITR600 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSalaryOrWages.Amount

                ^IITR606 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount

                ^IITR608 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount

                ^IITR91 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount

                ^IITR111 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount

                ^IITR625 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmploymentTerminationPayment.Amount

                ^IITR610 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldSuperannuationLumpSumPayment.Amount
                */
            VRATOIITR000236(response, report);
            #endregion // VR.ATO.IITR.000236

            #region VR.ATO.IITR.730435

            /*  VR.ATO.IITR.000236
                The sum of Primary production deferred losses and Non-primary production deferred losses must be equal to the sum of Business loss activity - Net loss amount where the Business loss activity - Type of Loss is "8" (loss is to be deferred)

                Technical Business Rule Format:
                    IF ([iitr299] <> NULL OR [iitr300] <> NULL) AND ([iitr299] + [iitr300] <> SUM(ConditionalValue([iitr482] = "8", [iitr487], 0)))
                */
            VRATOIITR730435(response, report);

            #endregion // VR.ATO.IITR.730435

            #region VR.ATO.IITR.000263

            /*  VR.ATO.IITR.000263
                        The total of all income fields does not equal the amount at the Total income or loss field.

                    Legacy Rule Format:
                        IF (([iitr131] <> NULL) AND OutsideRange([iitr131], ([iitr86] + [iitr89] + [iitr601] + [iitr607] + ([iitr609]*0.05) + [iitr626] + [iitr65] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + SUM([iitr99]) + SUM([iitr100]) + [iitr112] + [iitr115] + [iitr118] + [iitr119] + [iitr120] + [iitr127] + [iitr242] + [iitr243] - [iitr245] - [iitr246] + [iitr252] + [iitr255] + [iitr259] - [iitr260] - [iitr265] + [iitr279] + [iitr281] + [iitr285] + [iitr299] + [iitr300] + [iitr306] + [iitr311] + [iitr316] + [iitr318] + [iitr321] + [iitr322] + [iitr323] + [iitr324] + [iitr327] + [iitr328] + [iitr334] - [iitr335] - [iitr336] - [iitr337] + [iitr339] + [iitr341] + SUM([iitr348]) + SUM([iitr561]) + [iitr650] + SUM([iitr655])), 1))
                        OR
                        (([iitr131] = NULL) AND OutsideRange(0, ([iitr86] + [iitr89] + [iitr601] + [iitr607] + ([iitr609]*0.05) + [iitr626] + [iitr65] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + SUM([iitr99]) + SUM([iitr100]) + [iitr112] + [iitr115] + [iitr118] + [iitr119] + [iitr120] + [iitr127] + [iitr242] + [iitr243] - [iitr245] - [iitr246] + [iitr252] + [iitr255] + [iitr259] - [iitr260] - [iitr265] + [iitr279] + [iitr281] + [iitr285] + [iitr299] + [iitr300] + [iitr306] + [iitr311] + [iitr316] + [iitr318] + [iitr321] + [iitr322] + [iitr323] + [iitr324] + [iitr327] + [iitr328] + [iitr334] - [iitr335] - [iitr336] - [iitr337] + [iitr339] + [iitr341] + SUM([iitr348]) + SUM([iitr561]) + [iitr650] + SUM([iitr655])), 1))
                            RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ((^IITR131 <> NULL) AND OutsideRange(^IITR131, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + Sum(^IITR99) + Sum(^IITR100) + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + Sum(^IITR348) + Sum(^IITR561) + ^IITR650 + Sum(^IITR655)), 1)) OR((^IITR131 = NULL) AND OutsideRange(0, (^IITR86 + ^IITR89 + ^IITR601 + ^IITR607 + (^IITR609*0.05) + ^IITR626 + ^IITR65 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + Sum(^IITR99) + Sum(^IITR100) + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR252 + ^IITR255 + ^IITR259 - ^IITR260 - ^IITR265 + ^IITR279 + ^IITR281 + ^IITR285 + ^IITR299 + ^IITR300 + ^IITR306 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR328 + ^IITR334 - ^IITR335 - ^IITR336 - ^IITR337 + ^IITR339 + ^IITR341 + Sum(^IITR348) + Sum(^IITR561) + ^IITR650 + Sum(^IITR655)), 1))

            Data Elements:

                ^IITR131 = RP:Income.Net.Amount

                ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount

                ^IITR89 = RP:Pension.Total.Amount

                ^IITR601 = RP:Income.SalaryOrWages.Amount

                ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount

                ^IITR609 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount

                ^IITR626 = RP:Income.EmploymentTerminationPaymentTaxable.Amount

                ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount

                ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount

                ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount

                ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount

                ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount

                ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount

                ^IITR99 = RP.{SLSPSeqNum}:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount

                ^IITR100 = RP.{SLSPSeqNum}:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount

                ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount

                ^IITR115 = RP:Income.Interest.Gross.Amount

                ^IITR118 = RP:Income.DividendsUnfranked.Amount

                ^IITR119 = RP:Income.DividendsFranked.Amount

                ^IITR120 = RP:IncomeTax.FrankingCredits.Amount

                ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount

                ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount

                ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount

                ^IITR245 = RP.Prim:Expense.LandcareOperationsAcceleratedDepreciation.Amount

                ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount

                ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount

                ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount

                ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount

                ^IITR260 = RP:Expense.LandcareOperationsNonPrimaryProduction.Amount

                ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount

                ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount

                ^IITR281 = RP:Income.PrimaryProductionNet.Amount

                ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount

                ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount

                ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount

                ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount

                ^IITR311 = RP:Capital.Gains.Net.Amount

                ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount

                ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount

                ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount

                ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount

                ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount

                ^IITR324 = RP:InternationalDealings.ForeignRent.Amount

                ^IITR327 = RP:Income.InternationalDealings.Net.Amount

                ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount

                ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount

                ^IITR335 = RP:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount

                ^IITR336 = RP:IncomeTax.Deduction.CapitalWorksDeductions.Amount

                ^IITR337 = RP:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount

                ^IITR339 = RP:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount

                ^IITR341 = RP:Income.ForestryManagedInvestmentScheme.Amount

                ^IITR615 = RP:IncomeTax.IncomeCategory1Other.Amount

                ^IITR616 = RP:IncomeTax.IncomeCategory2Total.Amount

                ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount

                ^IITR618 = RP:IncomeTax.IncomeCategoryMiscellaneousOther.Amount
                */
            VRATOIITR000263(response, report);
            #endregion // VR.ATO.IITR.000263

            #region VR.ATO.IITR.000222

            /*  VR.ATO.IITR.000222
                        Tax withheld from Australian Government allowances and payments like newstart, youth allowance and austudy payment are greater than or equal to the amount of Australian Government allowances and payments like Newstart, youth allowance and austudy payment.  Check both amounts and correct as necessary.

                    Legacy Rule Format:
                        IF ([iitr85] > 0) AND (([iitr86] = NULL) OR ([iitr86] <= [iitr85]))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR85 > 0) AND ((^IITR86 = NULL) OR (^IITR86 <= ^IITR85))

            Data Elements:

                ^IITR85 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentAllowancesAndPayments.Amount

                ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
                */
            VRATOIITR000222(response, report);
            #endregion // VR.ATO.IITR.000222

            #region VR.ATO.IITR.000230

            /*  VR.ATO.IITR.000230
                        Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" type has been completed without an amount at Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts".

                    Legacy Rule Format:
                        IF ([iitr265] = NULL OR [iitr265] = 0) AND ([iitr266] <> NULL)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR265 = NULL OR ^IITR265 = 0) AND (^IITR266 <> NULL)

            Data Elements:

                ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount

                ^IITR266 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Code
                */
            VRATOIITR000230(response, report);
            #endregion // VR.ATO.IITR.000230

            #region VR.ATO.IITR.000237

            /*  VR.ATO.IITR.000237
                        Share of net income from trusts less capital gains, foreign income and franked distributions is greater than zero and the Share of net income from trusts less capital gains, foreign income and franked distributions action code is missing.

                    Legacy Rule Format:
                        IF ([iitr255] > 0) AND ([iitr256] = NULL)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR255 > 0) AND (^IITR256 = NULL)

            Data Elements:

                ^IITR256 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Code

                ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
                */
            VRATOIITR000237(response, report);
            #endregion // VR.ATO.IITR.000237

            #region VR.ATO.IITR.000503

            /*  VR.ATO.IITR.000503
            When taxpayer and their dependants have been covered by private patient hospital cover for the entire income year, their Private health insurance details - Health insurer ID, Membership number, and correct Tax claim code must also be provided.

            Legacy Rule Format:
            WHERE IN CONTEXT(RP.{PHISeqNum})
            IF [iitr176] = TRUE AND (COUNT(RP.{PHISeqNum}) = 0 OR ([iitr181] = NULLORBLANK OR [iitr180] = NULLORBLANK OR [iitr185] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR176 = TRUE AND (Count(^Context) = 0 OR (^IITR181 = BLANK OR ^IITR180 = BLANK OR ^IITR185 = NULL))

            Data Elements:

            ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator

            ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier

            ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier

            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code

            ^Context = RP:RP.{PHISeqNum}
            */
            assertion = (report.IITR176 == true && (Count(report.RPPHISeqNumContextCollection) == 0 || (report.RPPHISeqNumContextCollection.Any(x => string.IsNullOrWhiteSpace(x.IITR181) || string.IsNullOrWhiteSpace(x.IITR180) || x.IITR185 == null))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000503",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Private health insurance policy details must be completed",
                    LongDescription = @"When taxpayer and their dependants have been covered by private patient hospital cover for the entire income year, their Private health insurance details - Health insurer ID, Membership number, and correct Tax claim code must also be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000503" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR176", Value = GetValueOrEmpty(report.IITR176) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR181", Value = "NULL" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR180", Value = "NULL" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "NULL" });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000503

            #region VR.ATO.IITR.000604

            /*  VR.ATO.IITR.000604
                        Private health insurance policy has an entry with Tax claim code "Claiming your spouses share of rebate" then there must be a matching entry with Tax claim code "Claiming your share of rebate". The number of lines with tax claim code "Claiming your spouses share of rebate" must be equal to the number of lines with tax claim code "Claiming your share of rebate" for a particular policy, but this cannot be enforced due to technical constraints.

                    Legacy Rule Format:
                        IF ([iitr185:Claiming your spouses share of rebate] <> NULL) AND ((RP.{PHISeqNum} WHERE ([iitr185] = "Claiming your share of rebate" AND [iitr180: Claiming your spouses share of rebate] = [iitr180] AND [iitr181: Claiming your spouses share of rebate] = [iitr181])) = NULL)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                        [iitr185:Claiming your spouses share of rebate] = ([iitr185] = "Claiming your spouses share of rebate")
                        [iitr180:Claiming your spouses share of rebate] = ([iitr180] WHERE [iitr185] = "Claiming your spouses share of rebate")
                        [iitr181:Claiming your spouses share of rebate] = ([iitr181] WHERE [iitr185] = "Claiming your spouses share of rebate")

                Technical Business Rule Format:
                        ([iitr185:Claiming your spouses share of rebate] <> NULL) AND ((RP.{PHISeqNum} WHERE (^IITR185 = 'Claiming your share of rebate' AND [iitr180: Claiming your spouses share of rebate] = ^IITR180 AND [iitr181: Claiming your spouses share of rebate] = ^IITR181)) = NULL)           [iitr185:Claiming your spouses share of rebate] = (^IITR185 = 'Claiming your spouses share of rebate') [iitr180:Claiming your spouses share of rebate] = (^IITR180 WHERE ^IITR185 = 'Claiming your spouses share of rebate') [iitr181:Claiming your spouses share of rebate] = (^IITR181 WHERE ^IITR185 = 'Claiming your spouses share of rebate')

            Data Elements:

                ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code

                ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier

                ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
                */
            VRATOIITR000604(response, report);
            #endregion // VR.ATO.IITR.000604

            #region VR.ATO.IITR.000645

            /*  VR.ATO.IITR.000645
                        Unable to confirm whether the correct Non-resident foreign income amount has been provided for the simple self-assessment method, as the Foreign occupation code provided on the Non-Resident Foreign Income (NRFI) schedule is not recognised. Record the details of the message and contact the agency service desk.

                    Legacy Rule Format:
                        IF COUNT(SCHEDULE = "NRFI") = 1 AND [nrfi3] = "Simple" AND [nrfi2] <> NULL AND SUBSTRING([nrfi2],1,4) <> SET(DOMAIN(OCCUPATION PREFIX CODES))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        CountDocument('NRFI') = 1 AND ^NRFI3 = 'Simple' AND ^NRFI2 <> NULL AND Substring(^NRFI2,1,4) <> SET(DOMAIN(OCCUPATION PREFIX CODES))

            Data Elements:

                ^NRFI3 = NRFI3

                ^NRFI2 = NRFI2
                */
            VRATOIITR000645(response, report);
            #endregion // VR.ATO.IITR.000645

            #region VR.ATO.IITR.100031

            /*  VR.ATO.IITR.100031
                        For a resident taxpayer, where the sum of taxable income or loss and the net loss amounts that exceeds or equal to zero, the reported income for the purposes of the non-commercial losses income test is equal to $250,000 or more. Ensure loss codes used and/or amounts reported at the relevant labels are correct. A copy of the formula used to calculate income for this test can be found at www.ato.gov.au/ncl

                    Legacy Rule Format:
                        IF [iitr19] = TRUE AND ANY OCCURRENCE OF([iitr482]) = SET("1","2","3","4") AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","5","8"), [iitr487], 0))) >= 0 AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","5","8"), [iitr487], 0)) + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - ([iitr153] - [iitr154]) - ([iitr155] - [iitr156])) >= 250000
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR19 = TRUE AND AnyOccurrence(^IITR482, InSet(^IITR482, '"1","2","3","4"')) AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","5","8"'), ^IITR487, 0))) >= 0 AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","5","8"'), ^IITR487, 0)) + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - (^IITR153 - ^IITR154) - (^IITR155 - ^IITR156)) >= 250000

            Data Elements:

                ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount

                ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator

                ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount

                ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount

                ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount

                ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
                */
            VRATOIITR100031(response, report);
            #endregion // VR.ATO.IITR.100031

            #region VR.ATO.IITR.100032

            /*  VR.ATO.IITR.100032
                        For a resident taxpayer where the sum of taxable income or loss and the net loss amounts is less than zero, the reported income for the purposes of the non-commercial losses income test is equal to $250,000 or more. Ensure loss codes used and/or amounts reported at the relevant labels are correct. A copy of the formula used to calculate income for this test can be found at www.ato.gov.au/ncl

                    Legacy Rule Format:
                        IF [iitr19] = TRUE AND ANY OCCURRENCE OF([iitr482]) = SET("1","2","3","4") AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","8"), [iitr487], 0))) < 0 AND (ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - ([iitr153] - [iitr154]) - ([iitr155] - [iitr156])) >= 250000
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR19 = TRUE AND AnyOccurrence(^IITR482, InSet(^IITR482, '"1","2","3","4"')) AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","8"'), ^IITR487, 0))) < 0 AND (ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - (^IITR153 - ^IITR154) - (^IITR155 - ^IITR156)) >= 250000

            Data Elements:

                ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount

                ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator

                ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount

                ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount

                ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount

                ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
                */
            VRATOIITR100032(response, report);
            #endregion // VR.ATO.IITR.100032

            #region VR.ATO.IITR.100033

            /*  VR.ATO.IITR.100033
                        For a non-resident taxpayer where the sum of taxable income or loss and the net loss amounts exceeds or equal to zero, the reported income for the purposes of the non-commercial losses income test is equal to $250,000 or more. Ensure loss codes used and/or amounts reported at the relevant labels are correct. A copy of the formula used to calculate income for this test can be found at www.ato.gov.au/ncl

                    Legacy Rule Format:
                        IF [iitr19] = FALSE AND ANY OCCURRENCE OF([iitr482]) = SET("1","2","3","4") AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","8"), [iitr487], 0)) + [iitr146] + [iitr147] - [iitr115] - [iitr118] - [iitr119] - [iitr120] - [iitr328]) >= 0 AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","8"), [iitr487], 0)) + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) + [iitr146] + [iitr147] - [iitr115] - [iitr118] - [iitr119] - [iitr120] - [iitr328] - ([iitr153] - [iitr154]) - ([iitr155] - [iitr156])) >= 250000
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR19 = FALSE AND AnyOccurrence(^IITR482, InSet(^IITR482, '"1","2","3","4"')) AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","8"'), ^IITR487, 0)) + ^IITR146 + ^IITR147 - ^IITR115 - ^IITR118 - ^IITR119 - ^IITR120 - ^IITR328) >= 0 AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","8"'), ^IITR487, 0)) + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) + ^IITR146 + ^IITR147 - ^IITR115 - ^IITR118 - ^IITR119 - ^IITR120 - ^IITR328 - (^IITR153 - ^IITR154) - (^IITR155 - ^IITR156)) >= 250000

            Data Elements:

                ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount

                ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator

                ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount

                ^IITR146 = RP:IncomeTax.Deduction.Interest.Amount

                ^IITR147 = RP:IncomeTax.Deduction.Dividend.Amount

                ^IITR115 = RP:Income.Interest.Gross.Amount

                ^IITR118 = RP:Income.DividendsUnfranked.Amount

                ^IITR119 = RP:Income.DividendsFranked.Amount

                ^IITR120 = RP:IncomeTax.FrankingCredits.Amount

                ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount

                ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount

                ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount

                ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
                */
            VRATOIITR100033(response, report);
            #endregion // VR.ATO.IITR.100033

            #region VR.ATO.IITR.100034

            /*  VR.ATO.IITR.100034
                        For a non-resident taxpayer where the sum of taxable income or loss and the net loss amounts is less than zero, the reported income for the purposes of the non-commercial losses income test is equal to $250,000 or more. Ensure loss codes used and/or amounts reported at the relevant labels are correct. A copy of the formula used to calculate income for this test can be found at www.ato.gov.au/ncl

                    Legacy Rule Format:
                        IF [iitr19] = FALSE AND ANY OCCURRENCE OF([iitr482]) = SET("1","2","3","4") AND (([iitr157] - [iitr650]) + SUM(ConditionalValue([iitr482] <> SET("0","8"), [iitr487], 0)) + [iitr146] + [iitr147] - [iitr115] - [iitr118] - [iitr119] - [iitr120] - [iitr328]) < 0 AND (ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - ([iitr153] - [iitr154]) - ([iitr155] - [iitr156])) >= 250000
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR19 = FALSE AND AnyOccurrence(^IITR482, InSet(^IITR482, '"1","2","3","4"')) AND ((^IITR157 - ^IITR650) + Sum(ConditionalValue(NotInSet(^IITR482, '"0","8"'), ^IITR487, 0)) + ^IITR146 + ^IITR147 - ^IITR115 - ^IITR118 - ^IITR119 - ^IITR120 - ^IITR328) < 0 AND (ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - (^IITR153 - ^IITR154) - (^IITR155 - ^IITR156)) >= 250000

            Data Elements:

                ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount

                ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator

                ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount

                ^IITR146 = RP:IncomeTax.Deduction.Interest.Amount

                ^IITR147 = RP:IncomeTax.Deduction.Dividend.Amount

                ^IITR115 = RP:Income.Interest.Gross.Amount

                ^IITR118 = RP:Income.DividendsUnfranked.Amount

                ^IITR119 = RP:Income.DividendsFranked.Amount

                ^IITR120 = RP:IncomeTax.FrankingCredits.Amount

                ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount

                ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount

                ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount

                ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
                */
            VRATOIITR100034(response, report);
            #endregion // VR.ATO.IITR.100034

            #region VR.ATO.IITR.100043

            /*  VR.ATO.IITR.100043
                        Adjusted taxable income must equal the sum of Taxable income or loss (when amount above $0), Reportable employer superannuation contributions, Tax-free government pensions, Target foreign income, Net financial investment loss, Net rental property loss, and all Deduction claimed amounts, plus Total reportable fringe benefits amount from employers not exempt under section 57A and 53.0% of Total reportable fringe benefits amount from employers exempt under section 57A (when combined Total reportable fringe benefits amount above $3,772), less Child support you paid. If you are completing a tax return for a deceased person, this value must be divided by the number of days the taxpayer was alive during the financial year and multiplied by the total number of days in the financial year.

                    Legacy Rule Format:
                        IF (([iitr28] = NULL OR [iitr28] > RP:period.endDate) AND (([iitr208] <> NULL AND [iitr208] <> ((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + [iitr202] + [iitr203] + [iitr204] + [iitr205] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - [iitr206]) +/- 1)) OR ([iitr208] = NULL AND ((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + [iitr202] + [iitr203] + [iitr204] + [iitr205] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - [iitr206]) +/- 1) <> 0))) OR (([iitr28] > (RP:period.startDate - 1) AND [iitr28] < (RP:period.endDate + 1)) AND (([iitr208] <> NULL AND [iitr208] <> (((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + [iitr202] + [iitr203] + [iitr204] + [iitr205] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - [iitr206]) * (RP:period.endDate - RP:period.startDate + 1) / ([iitr28] - RP:period.startDate + 1)) +/- 1)) OR ([iitr208] = NULL AND ((((ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + [iitr202] + [iitr203] + [iitr204] + [iitr205] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) - [iitr206]) * (RP:period.endDate - RP:period.startDate + 1) / ([iitr28] - RP:period.startDate + 1)) +/- 1) <> 0)))) OR ([iitr28] < RP:period.startDate AND [iitr208] <> 0)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ((^IITR28 = NULL OR ^IITR28 > ^EndDate) AND ((^IITR208 <> NULL AND ^IITR208 <> ((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ^IITR202 + ^IITR203 + ^IITR204 + ^IITR205 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - ^IITR206) +/- 1)) OR (^IITR208 = NULL AND ((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ^IITR202 + ^IITR203 + ^IITR204 + ^IITR205 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - ^IITR206) +/- 1) <> 0))) OR ((^IITR28 > (^StartDate1 - 1) AND ^IITR28 < (^EndDate + 1)) AND ((^IITR208 <> NULL AND ^IITR208 <> (((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ^IITR202 + ^IITR203 + ^IITR204 + ^IITR205 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - ^IITR206) * (^EndDate - ^StartDate2 + 1) / (^IITR28 - ^StartDate3 + 1)) +/- 1)) OR (^IITR208 = NULL AND ((((ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ^IITR202 + ^IITR203 + ^IITR204 + ^IITR205 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) - ^IITR206) * (^EndDate - ^StartDate4 + 1) / (^IITR28 - ^StartDate5 + 1)) +/- 1) <> 0)))) OR (^IITR28 < ^StartDate6 AND ^IITR208 <> 0)

            Data Elements:

                ^IITR208 = RP:Income.TaxableAdjusted.Amount

                ^EndDate = RP

                ^StartDate1 = RP

                ^StartDate2 = RP

                ^StartDate3 = RP

                ^StartDate4 = RP

                ^StartDate5 = RP

                ^StartDate6 = RP

                ^IITR28 = RP:PersonDemographicDetails.Death.Date

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^IITR202 = RP:Pension.TaxFree.Amount

                ^IITR203 = RP:InternationalDealings.ForeignIncomeTarget.Amount

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR206 = RP:ChildSupport.Payment.Amount
                */
            VRATOIITR100043(response, report);
            #endregion // VR.ATO.IITR.100043

            #region VR.ATO.IITR.200014

            /*  VR.ATO.IITR.200014
                        Where the 'Seniors and pensioners - Tax offset code' indicates at any time during the year the taxpayer was single or widowed, or separated; and all occurrences of Deduction claimed amounts are null, check deductible personal superannuation contributions.

                    Legacy Rule Format:
                        IF ([iitr163] = "Single") AND (COUNT(SCHEDULE="DDCTNS") = 0 OR ALL OCCURRENCES OF([ddctns407]) = NULL)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR163 = 'Single') AND (CountDocument('DDCTNS') = 0 OR ^DDCTNS407 = NULL)

            Data Elements:

                ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code

                ^DDCTNS407 = DDCTNS407
                */
            VRATOIITR200014(response, report);
            #endregion // VR.ATO.IITR.200014

            #region VR.ATO.IITR.200015

            /*  VR.ATO.IITR.200015
                        Where the 'Seniors and pensioners - Tax offset code' is being claimed, and the sum of income fields is greater than $83,580 where there is a spouse, or $50,119 where there is no spouse; and the Reportable employer superannuation contributions is greater than 8% of all income from salary and wages, check Reportable employer superannuation contributions as SPO entitlement may be impacted.

                    Legacy Rule Format:
                        IF [iitr163] <> NULLORBLANK AND (([iitr213] <> NULLORBLANK AND (ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) + [iitr204] + [iitr205] + [iitr225] + [iitr230] + [iitr226] + ConditionalValue(([iitr492] + [iitr493]) > 3772, (([iitr492] * 0.530) + [iitr493]), 0) + [iitr231] + [iitr234]) > 83580) OR ([iitr213] = NULLORBLANK AND (ConditionalValue([iitr157] > 0, [iitr157], 0) + ConditionalValue(([iitr490] + [iitr491]) > 3772, (([iitr490] * 0.530) + [iitr491]), 0) + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0) + [iitr204] + [iitr205]) > 50119)) AND [iitr201] > ([iitr601] * 0.08)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR163 <> BLANK AND ((^IITR213 <> BLANK AND (ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) + ^IITR204 + ^IITR205 + ^IITR225 + ^IITR230 + ^IITR226 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR231 + ^IITR234) > 83580) OR (^IITR213 = BLANK AND (ConditionalValue(^IITR157 > 0, ^IITR157, 0) + ConditionalValue((^IITR490 + ^IITR491) > 3772, ((^IITR490 * 0.530) + ^IITR491), 0) + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0) + ^IITR204 + ^IITR205) > 50119)) AND ^IITR201 > (^IITR601 * 0.08)

            Data Elements:

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code

                ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR225 = RP.SPOUSE:Income.Taxable.Amount

                ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount

                ^IITR226 = RP.SPOUSE:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount

                ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount

                ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount

                ^IITR601 = RP:Income.SalaryOrWages.Amount
                */
            VRATOIITR200015(response, report);
            #endregion // VR.ATO.IITR.200015

            #region VR.ATO.IITR.200034

            /*  VR.ATO.IITR.200034
            Spouse's or de facto spouse's family name is present and the taxpayer had a spouse for the full year and had no Medicare levy surcharge. Combined Total reportable fringe benefits amounts exceed $3,772 and taxable income or loss plus total reportable fringe benefits amounts plus net amount on which family trust has been paid plus exempt foreign employment income exceeds $22,398 and number of days not liable for MLS, spouse income details also required.

            Legacy Rule Format:
                IF ([iitr213] <> NULLORBLANK OR [iitr220] = TRUE) AND [iitr176] = FALSE AND ([iitr157] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + ConditionalValue([iitr157] > 0, [iitr330], 0) + [iitr399] - ConditionalValue((COUNT(SCHEDULE = 'INCDTLS') = 1) AND (ANY OCCURRENCE OF([incdtls333]) <> TRUE AND [iitr29] <> NULL AND ([iitr29] > ConvertToDate(30,06,([iitr10] - 55)) OR [iitr29] <= ConvertToDate(01,07,([iitr10] - 61)))), SUM([incdtls330]), 0) + [iitr204] + [iitr205] + [iitr201] + ConditionalValue(COUNT(SCHEDULE = "DDCTNS") = 1, RoundDown(SUM([ddctns407]), 0), 0)) > 22801 AND ([iitr177] = NULL OR ([iitr225] = NULL AND [iitr226] = NULL AND [iitr227] = NULL AND [iitr492] = NULL AND [iitr493] = NULL AND [iitr231] = NULL AND [iitr234] = NULL AND [iitr236] = NULL))
                    RETURN VALIDATION MESSAGE
                ENDIF

            Technical Business Rule Format:
                    (^IITR213 <> BLANK OR ^IITR220 = TRUE) AND ^IITR176 = FALSE AND (^IITR157 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ConditionalValue(^IITR157 > 0, ^IITR330, 0) + ^IITR399 - ConditionalValue((CountDocument('INCDTLS') = 1) AND (AnyOccurrence(^INCDTLS333, ^INCDTLS333 <> TRUE) AND ^IITR29 <> NULL AND (^IITR29 > ConvertToDate(30,06,(^IITR10 - 55)) OR ^IITR29 <= ConvertToDate(01,07,(^IITR10 - 61)))), Sum(^INCDTLS330), 0) + ^IITR204 + ^IITR205 + ^IITR201 + ConditionalValue(CountDocument('DDCTNS') = 1, RoundDown(Sum(^DDCTNS407), 0), 0)) > 22801 AND (^IITR177 = NULL OR (^IITR225 = NULL AND ^IITR226 = NULL AND ^IITR227 = NULL AND ^IITR492 = NULL AND ^IITR493 = NULL AND ^IITR231 = NULL AND ^IITR234 = NULL AND ^IITR236 = NULL))

            Data Elements:

                ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count

                ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text

                ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator

                ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR330 = RP:InternationalDealings.ExemptForeignEmploymentIncome.Amount

                ^IITR399 = RP:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount

                ^INCDTLS333 = INCDTLS333

                ^IITR29 = RP:PersonDemographicDetails.Birth.Date

                ^IITR10 = RP:Report.TargetFinancial.Year

                ^INCDTLS330 = INCDTLS330

                ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount

                ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^DDCTNS407 = DDCTNS407

                ^IITR225 = RP.SPOUSE:Income.Taxable.Amount

                ^IITR226 = RP.SPOUSE:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount

                ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount

                ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount

                ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount

                ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount

            */

            VRATOIITR200034(response, report);

            #endregion // VR.ATO.IITR.200034

            #region VR.ATO.IITR.210034

            /*  VR.ATO.IITR.210034
                        If two or more rows have been entered for one policy, tax claim codes must be the same on all rows except where the tax claim code is "Claiming your spouses share of rebate" or "Covered as dependent child" in any of those rows. Tax claim code(s) must be corrected.

                    Legacy Rule Format:
                        WHERE IN CONTEXT(RP.{PHISeqNum})
                        IF ([iitr180] = [iitr180:Other]) AND ([iitr181] = [iitr181:Other]) AND ([iitr185] <> SET("Claiming your spouses share of rebate","Covered as dependent child")) AND ([iitr185] <> [iitr185:Other])
                           RETURN VALIDATION MESSAGE
                        ENDIF

                        [iitr180:Other] = ANY OTHER OCCURRENCE OF ([iitr180] WHERE  [iitr185] <> SET("Claiming your spouses share of rebate","Covered as dependent child"))
                        [iitr181:Other] = ANY OTHER OCCURRENCE OF ([iitr181] WHERE  [iitr185] <> SET("Claiming your spouses share of rebate","Covered as dependent child"))
                        [iitr185:Other] = ANY OTHER OCCURRENCE OF ([iitr185] WHERE  [iitr185] <> SET("Claiming your spouses share of rebate","Covered as dependent child"))

                Technical Business Rule Format:
                        (^IITR180 = [iitr180:Other]) AND (^IITR181 = [iitr181:Other]) AND (NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"')) AND (^IITR185 <> [iitr185:Other])           [iitr180:Other] = ANY OTHER OCCURRENCE OF (^IITR180 WHERE  NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"')) [iitr181:Other] = ANY OTHER OCCURRENCE OF (^IITR181 WHERE  NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"')) [iitr185:Other] = ANY OTHER OCCURRENCE OF (^IITR185 WHERE  NotInSet(^IITR185, '"Claiming your spouses share of rebate","Covered as dependent child"'))

            Data Elements:

                ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code

                ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier

                ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
                */
            VRATOIITR210034(response, report);
            #endregion // VR.ATO.IITR.210034

            #region VR.ATO.IITR.210035

            /*  VR.ATO.IITR.210035
                        You will need the private health insurance statement to complete the private health insurance policy details. Ensure that you have only entered the amounts shown on the statement at Your premiums eligible for Australian Government rebate and Your Australian Government rebate received. These values are dollar amounts.

                    Legacy Rule Format:
                        WHERE IN CONTEXT(RP.{PHISeqNum})
                        IF ([iitr185] = SET("No dependants", "Dependants", "Claiming your share of rebate", "Claiming your spouses share of rebate")) AND ([iitr183] > 0) AND (([iitr182] <> NULL AND [iitr183] >= [iitr182]) OR ([iitr182] = NULL))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (InSet(^IITR185, '"No dependants", "Dependants", "Claiming your share of rebate", "Claiming your spouses share of rebate"')) AND (^IITR183 > 0) AND ((^IITR182 <> NULL AND ^IITR183 >= ^IITR182) OR (^IITR182 = NULL))

            Data Elements:

                ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount

                ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code

                ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
                */
            VRATOIITR210035(response, report);
            #endregion // VR.ATO.IITR.210035

            #region VR.ATO.IITR.300005

            /*  VR.ATO.IITR.300005
            Where the sum of the taxpayers adjusted taxable income and their spouse's adjusted taxable income is greater than $150,000; and the reportable employer superannuation contributions is greater than 8% of Salary or wages gross income, check reportable employer superannuation contributions.

            Legacy Rule Format:
                IF (([iitr208] + [iitr237]) > 150000 AND [iitr201] > ([iitr601] * 0.08))
                   RETURN VALIDATION MESSAGE
                ENDIF

            Technical Business Rule Format:
                (^IITR208 + ^IITR237 > 150000 AND ^IITR201 > (^IITR601 * 0.08))

            Data Elements:

                ^IITR208 = RP:Income.TaxableAdjusted.Amount

                ^IITR237 = RP.Spouse:Income.TaxableAdjusted.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount

                ^IITR601 = RP:Income.SalaryOrWages.Amount

                */
            VRATOIITR300005(response, report);
            #endregion // VR.ATO.IITR.300005

            #region VR.ATO.IITR.300039

            /*  VR.ATO.IITR.300039
                        A loss amount has been entered at primary production business income or non-primary production business income or Net Personal Services Income, but there are no Business loss activity details.

                    Legacy Rule Format:
                        IF ([iitr281] < 0 OR [iitr285] < 0 OR [iitr279] < 0) AND [iitr479] = NULLORBLANK
                          RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR281 < 0 OR ^IITR285 < 0 OR ^IITR279 < 0) AND ^IITR479 = BLANK

            Data Elements:

                ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description

                ^IITR281 = RP:Income.PrimaryProductionNet.Amount

                ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount

                ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
                */
            VRATOIITR300039(response, report);
            #endregion // VR.ATO.IITR.300039

            #region VR.ATO.IITR.300040

            /*  VR.ATO.IITR.300040
                        A loss has been entered at PP distribution from partnerships or non-PP distribution from partnerships and business loss activity details have not been entered.

                    Legacy Rule Format:
                        WHERE IN CONTEXT(RP.{LOSSSeqNum})
                        IF ([iitr242] < 0 OR [iitr252] < 0) AND [iitr573] = "1" AND [iitr479] = NULLORBLANK
                            RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR242 < 0 OR ^IITR252 < 0) AND ^IITR573 = '1' AND ^IITR479 = BLANK

            Data Elements:

                ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description

                ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount

                ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount

                ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
                */
            VRATOIITR300040(response, report);
            #endregion // VR.ATO.IITR.300040

            #region VR.ATO.IITR.300087

            /*  VR.ATO.IITR.300087
                        Taxpayer is ineligible to make deposits and claim deductions for deductible deposits because taxpayer's non-primary production income exceeded the threshold amount.

                    Legacy Rule Format:
                        IF ([iitr302] > 0) AND (([iitr157] + [iitr154] + [iitr156] - [iitr311] - ([iitr242] + [iitr243] - [iitr245] - [iitr246] + [iitr281] + [iitr299] + [iitr306]) - ConditionalValue(COUNT(SCHEDULE = "INCDTLS") = 1,SUM(ConditionalValue([incdtls138] = SET("D","B","N"),[incdtls140],0)),0) - SUM(ConditionalValue((COUNT(SCHEDULE = "INCDTLS") = 1) AND ([incdtls333] = FALSE),([incdtls330] + [incdtls331]),0))) > 100000)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR302 > 0) AND ((^IITR157 + ^IITR154 + ^IITR156 - ^IITR311 - (^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR281 + ^IITR299 + ^IITR306) - ConditionalValue(CountDocument('INCDTLS') = 1,Sum(ConditionalValue(InSet(^INCDTLS138, '"D","B","N"'),^INCDTLS140,0)),0) - Sum(ConditionalValue((CountDocument('INCDTLS') = 1) AND (^INCDTLS333 = FALSE),(^INCDTLS330 + ^INCDTLS331),0))) > 100000)

            Data Elements:

                ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount

                ^IITR157 = RP:Income.Taxable.Amount

                ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount

                ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount

                ^IITR311 = RP:Capital.Gains.Net.Amount

                ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount

                ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount

                ^IITR245 = RP.Partnership:Expense.LandcareOperationsAcceleratedDepreciation.Amount

                ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount

                ^IITR281 = RP:Income.PrimaryProductionNet.Amount

                ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount

                ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount

                ^INCDTLS138 = INCDTLS138

                ^INCDTLS140 = INCDTLS140

                ^INCDTLS333 = INCDTLS333

                ^INCDTLS330 = INCDTLS330

                ^INCDTLS331 = INCDTLS331
                */
            VRATOIITR300087(response, report);
            #endregion // VR.ATO.IITR.300087

            #region VR.ATO.IITR.310027

            /*  VR.ATO.IITR.310027
                        The answer to "Satisfied the results test" is No, and no answer has been provided to the "Received a personal services business determination(s) for the whole of the period PSI earned" question.

                    Legacy Rule Format:
                        IF ([iitr406] = NULL) AND ([iitr404] = TRUE) AND ([iitr405] = FALSE)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR406 = NULL) AND (^IITR404 = TRUE) AND (^IITR405 = FALSE)

            Data Elements:

                ^IITR406 = RP:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator

                ^IITR404 = RP:Income.PersonalServicesIncomeIncluded.Indicator

                ^IITR405 = RP:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
                */
            VRATOIITR310027(response, report);
            #endregion // VR.ATO.IITR.310027

            #region VR.ATO.IITR.400063

            /*  VR.ATO.IITR.400063
                The Sequence Container within the Reporting Party Loss context must be assigned sequentially beginning at 1 and must not exceed 10
                
                Legacy Rule Format:
                IF ([iitr573] <> SET(1-10)) OR ([iitr573] > COUNT(RP.{LOSSSeqNum}))
                   RETURN VALIDATION MESSAGE
                ENDIF
                
                Technical Business Rule Format:
                (^IITR573 <> BLANK AND (IsNumeric(^IITR573) = 'FALSE' OR AsNumeric(^IITR573) < 1 OR AsNumeric(^IITR573) > 10)) OR (^IITR573 > Count(^Context))

                 Data Elements:
                    ^Context = RP.{LOSSSeqNum}
                    ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
            */
            VRATOIITR400063(response, report);
            #endregion // VR.ATO.IITR.400063

            #region VR.ATO.IITR.410018

            /*  VR.ATO.IITR.410018
                        Primary production deferred losses and/or non-primary production deferred losses have been entered without Business loss activity details being completed.

                    Legacy Rule Format:
                        IF ([iitr299] + [iitr300]) > 0 AND (COUNT(RP.{LOSSSeqNum}) = 0 OR ALL OCCURRENCES OF ([iitr479]) = NULLORBLANK)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR299 + ^IITR300) > 0 AND (Count(^Context) = 0 OR  ^IITR479 = BLANK)

            Data Elements:

                ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description

                ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount

                ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount

                ^Context = RP.{LOSSSeqNum}
                */
            VRATOIITR410018(response, report);
            #endregion // VR.ATO.IITR.410018

            #region VR.ATO.IITR.410034

            /*  VR.ATO.IITR.410034
                        For income test purposes, spouse's adjusted taxable income (ATI) is the sum of spouse's taxable income, spouse's adjusted fringe benefit (Your spouse's total reportable fringe benefits amount from employers exempt under section 57A x 0.530 plus Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A), spouse's target foreign income, spouse's tax-free pensions (exempt pensions plus tax-free pensions paid under Military Rehabilitation and Compensation Act), spouse's total net investment loss, spouse's reportable superannuation contributions less child support the spouse paid. For the benefit of other calculations, ensure the ATI amount is correct.

                    Legacy Rule Format:
                        IF [iitr223] <> TRUE AND (([iitr237] = NULL AND (([iitr225] + ConditionalValue(([iitr492] + [iitr493]) > 3772, (([iitr492] * 0.530) + [iitr493]), 0) + [iitr233] + [iitr230] + [iitr232] + [iitr234] + [iitr231] - [iitr235]) +/- 1) <> 0) OR ([iitr237] <> NULL AND [iitr237] <> (([iitr225] + ConditionalValue(([iitr492] + [iitr493]) > 3772, (([iitr492] * 0.530) + [iitr493]), 0) + [iitr233] + [iitr230] + [iitr232] + [iitr234] + [iitr231] - [iitr235]) +/- 1)))
                            RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR223 <> TRUE AND ((^IITR237 = NULL AND ((^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235) +/- 1) <> 0) OR (^IITR237 <> NULL AND ^IITR237 <> ((^IITR225 + ConditionalValue((^IITR492 + ^IITR493) > 3772, ((^IITR492 * 0.530) + ^IITR493), 0) + ^IITR233 + ^IITR230 + ^IITR232 + ^IITR234 + ^IITR231 - ^IITR235) +/- 1)))

            Data Elements:

                ^IITR223 = RP.SPOUSE:PersonDemographicDetails.Deceased.Indicator

                ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount

                ^IITR225 = RP.SPOUSE:Income.Taxable.Amount

                ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount

                ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount

                ^IITR233 = RP.SPOUSE:InternationalDealings.ForeignIncomeTarget.Amount

                ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount

                ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount

                ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount

                ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount

                ^IITR235 = RP.SPOUSE:ChildSupport.Payment.Amount
                */
            VRATOIITR410034(response, report);
            #endregion // VR.ATO.IITR.410034

            #region VR.ATO.IITR.630005

            /*  VR.ATO.IITR.630005
                        Check Total Tax Withheld amount is greater than or equal to the sum of the Income amounts.

                    Legacy Rule Format:
                        IF [iitr113] >= ([iitr601] + [iitr65] + [iitr607] + [iitr609] + [iitr626] + [iitr86] + [iitr89] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + [iitr611] + [iitr612] + [iitr112])
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR113 >= (^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112)

            Data Elements:

                ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount

                ^IITR601 = RP:Income.SalaryOrWages.Amount

                ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount

                ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount

                ^IITR609 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount

                ^IITR626 = RP:Income.EmploymentTerminationPaymentTaxable.Amount

                ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount

                ^IITR89 = RP:Pension.Total.Amount

                ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount

                ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount

                ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount

                ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount

                ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount

                ^IITR611 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount

                ^IITR612 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount

                ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
                */
            VRATOIITR630005(response, report);
            #endregion // VR.ATO.IITR.630005

            #region VR.ATO.IITR.410068

            /*  VR.ATO.IITR.410068
                        Business loss activity - Partnership or sole trader codes are: '161' - Partnerships; '006' - Sole Trader.

                    Legacy Rule Format:
                        IF [iitr481] <> NULL AND [iitr481] <> SET("006", "161")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        ^IITR481 <> NULL AND NotInSet(^IITR481, '"006", "161"')

            Data Elements:

                ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
                */
            VRATOIITR410068(response, report);
            #endregion // VR.ATO.IITR.410068

            #region VR.ATO.IITR.410083

            /*  VR.ATO.IITR.410083
                        Distributions to your spouse on which family trust distribution tax has been paid has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr227] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR227, 'U', 11, 0)

            Data Elements:

                ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
                */
            VRATOIITR410083(response, report);
            #endregion // VR.ATO.IITR.410083

            #region VR.ATO.IITR.410085

            /*  VR.ATO.IITR.410085
                        Amount of any Australian Government pensions and allowances received by your spouse in the year of the return has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr229] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR229, 'U', 11, 0)

            Data Elements:

                ^IITR229 = RP.SPOUSE:Pension.Total.Amount
                */
            VRATOIITR410085(response, report);
            #endregion // VR.ATO.IITR.410085

            #region VR.ATO.IITR.410086

            /*  VR.ATO.IITR.410086
                        Amount of any exempt pension income received by your spouse in the year of the return has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr230] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR230, 'U', 11, 0)

            Data Elements:

                ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
                */
            VRATOIITR410086(response, report);
            #endregion // VR.ATO.IITR.410086

            #region VR.ATO.IITR.410116

            /*  VR.ATO.IITR.410116
                        Small business entity simplified depreciation - Deduction for certain assets has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr507] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR507, 'U', 11, 0)

            Data Elements:

                ^IITR507 = RP:IncomeTax.Deduction.LowCostAssetDepreciation.Amount
                */
            VRATOIITR410116(response, report);
            #endregion // VR.ATO.IITR.410116

            #region VR.ATO.IITR.410117

            /*  VR.ATO.IITR.410117
                        Small business entity simplified depreciation - Deduction for general small business pool has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr508] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR508, 'U', 11, 0)

            Data Elements:

                ^IITR508 = RP:IncomeTax.Deduction.SmallBusinessPoolDepreciation.Amount
                */
            VRATOIITR410117(response, report);
            #endregion // VR.ATO.IITR.410117

            #region VR.ATO.IITR.600051

            /*  VR.ATO.IITR.600051
                        Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses has a maximum field length of 11

                    Legacy Rule Format:
                        IF [iitr137] <> MONETARY(U,11,0)
                             RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        NotMonetary(^IITR137, 'U', 11, 0)

            Data Elements:

                ^IITR137 = RP:IncomeTax.Deduction.Clothing.Amount
                */
            VRATOIITR600051(response, report);
            #endregion // VR.ATO.IITR.600051

            #region VR.ATO.IITR.730075

            /*  VR.ATO.IITR.730075
            When the Community Development Employment Project (CDEP) amount is present, the Australian Government allowances and payments like Newstart, youth allowance and austudy payment amount must be provided
    
            Legacy Rule Format:
            IF [iitr602] <> NULL AND [IITR86] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR602 <> NULL AND ^IITR86 = NULL
    
            Data Elements:
    
            ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
    
            ^IITR602 = RP:Income.CommunityDevelopmentEmploymentProject.Amount
            */
            assertion = (report.IITR602 != null && report.IITR86 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730075",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian Government allowances and payments like Newstart, youth allowance and austudy payment must be provided",
                    LongDescription = @"When the Community Development Employment Project (CDEP) amount is present, the Australian Government allowances and payments like Newstart, youth allowance and austudy payment amount must be provided",
                    Location = "/xbrli:xbrl/tns:Income.AustralianGovernmentAllowancesAndPayments.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730075" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR602", Value = GetValueOrEmpty(report.IITR602) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730075

            #region VR.ATO.IITR.730108

            /*  VR.ATO.IITR.730108
                        Either one or the sum of Superannuation deduction claimed amounts is the same as the amount provided for Reportable employer superannuation contributions. A deduction for contributions paid by the employer from before-tax income (including the compulsory super guarantee and salary sacrifice amounts) is not claimable, and the return may be adjusted. Check and correct if necessary.

                    Legacy Rule Format:
                        IF COUNT(SCHEDULE = "DDCTNS") = 1 AND [iitr201] > 0 AND (ANY OCCURRENCE OF(RoundDown([ddctns407], 0)) = [iitr201] OR [iitr201] = RoundDown(SUM([ddctns407]), 0))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        CountDocument('DDCTNS') = 1 AND ^IITR201 > 0 AND (ANY OCCURRENCE OF(RoundDown(^DDCTNS407, 0)) = ^IITR201 OR ^IITR201 = RoundDown(Sum(^DDCTNS407), 0))

            Data Elements:

                ^DDCTNS407 = rvctc2.02.14:IncomeTax.Deduction.SuperannuationContribution.Amount

                ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
                */
            VRATOIITR730108(response, report);
            #endregion // VR.ATO.IITR.730108

            #region VR.ATO.IITR.730163

            /*  VR.ATO.IITR.730163
                        When an amount above zero is provided for "Foreign income tax offset", the "Net foreign employment income - payment summary" amount must not exceed the sum of "Salary or wages gross income", "Salary or wages lump sum A" and "Tax withheld - lump sum payments in arrears"

                    Legacy Rule Format:
                        IF ([iitr331] > 0) AND ([iitr329] > ([iitr601] + [iitr607] + [iitr354]))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR331 > 0) AND (^IITR329 > (^IITR601 + ^IITR607 + ^IITR354))

            Data Elements:

                ^IITR331 = RP:Income.InternationalDealings.TaxOffset.Amount

                ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount

                ^IITR601 = RP:Income.SalaryOrWages.Amount

                ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount

                ^IITR354 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldLumpSumPaymentsInArrears.Amount
                */
            VRATOIITR730163(response, report);
            #endregion // VR.ATO.IITR.730163

            #region VR.ATO.IITR.730303

            /*  VR.ATO.IITR.730303
                        Income for surcharge purposes is used to determine if the taxpayer is liable for Medicare Levy Surcharge. Where applicable, complete Deductible personal superannuation contributions from the Deduction schedule.

                    Legacy Rule Format:
                        IF ([iitr176] <> TRUE) AND ([iitr177] < (RP:Period.endDate - RP:Period.startDate + 1)) AND (COUNT(SCHEDULE = "DDCTNS") = 0 OR ALL OCCURRENCES OF([ddctns407]) = NULL)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                Technical Business Rule Format:
                        (^IITR176 <> TRUE) AND (^IITR177 < (^EndDate - ^StartDate1 + 1)) AND (CountDocument('DDCTNS') = 0 OR ^DDCTNS407 = NULL)

            Data Elements:

                ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator

                ^EndDate = RP

                ^StartDate1 = RP

                ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count

                ^DDCTNS407 = DDCTNS407
                */
            VRATOIITR730303(response, report);
            #endregion // VR.ATO.IITR.730303

            #region VR.ATO.IITR.730362

            /*  VR.ATO.IITR.730362
            At Business income and expenses, the sum of Net income or loss from business this year for primary production must equal Total primary production business income minus all business expenses plus other reconciliation adjustments
    
            Legacy Rule Format:
            IF (([iitr436] + [iitr439] + [iitr441] + [iitr443] + [iitr447]) - ([iitr700] + [iitr701] - [iitr702]) - ([iitr703] + [iitr704] + [iitr705] + [iitr706] + [iitr707] + [iitr708] + [iitr709] + [iitr710] + [iitr711] + [iitr712] + [iitr713]) - [iitr714] - [iitr715] - [iitr716] + [iitr717] + [iitr718]) <> ([iitr474])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR436 + ^IITR439 + ^IITR441 + ^IITR443 + ^IITR447) - (^IITR700 + ^IITR701 - ^IITR702) - (^IITR703 + ^IITR704 + ^IITR705 + ^IITR706 + ^IITR707 + ^IITR708 + ^IITR709 + ^IITR710 + ^IITR711 + ^IITR712 + ^IITR713) - ^IITR714 - ^IITR715 - ^IITR716 + ^IITR717 + ^IITR718) <> ^IITR474
    
            Data Elements:
    
            ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
    
            ^IITR701 = RP.Prim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR703 = RP.Prim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR704 = RP.Prim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR705 = RP.Prim:Expense.Operating.BadDebts.Amount
    
            ^IITR706 = RP.Prim:Expense.Operating.Lease.Amount
    
            ^IITR707 = RP.Prim:Expense.Operating.Rent.Amount
    
            ^IITR708 = RP.Prim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR709 = RP.Prim:Expense.Operating.InterestForeign.Amount
    
            ^IITR710 = RP.Prim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR712 = RP.Prim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR713 = RP.Prim:Expense.Operating.Other.Amount
    
            ^IITR714 = RP.Prim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
    
            ^IITR715 = RP.Prim:Expense.ProjectPoolAllowableDeduction.Amount
    
            ^IITR716 = RP.Prim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR717 = RP.Prim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR718 = RP.Prim:Expense.ReconciliationAdjustments.Amount
            */
            assertion = (report.IITR436.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR447.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR701.GetValueOrDefault() - report.IITR702.GetValueOrDefault()) - (report.IITR703.GetValueOrDefault() + report.IITR704.GetValueOrDefault() + report.IITR705.GetValueOrDefault() + report.IITR706.GetValueOrDefault() + report.IITR707.GetValueOrDefault() + report.IITR708.GetValueOrDefault() + report.IITR709.GetValueOrDefault() + report.IITR710.GetValueOrDefault() + report.IITR711.GetValueOrDefault() + report.IITR712.GetValueOrDefault() + report.IITR713.GetValueOrDefault()) - report.IITR714.GetValueOrDefault() - report.IITR715.GetValueOrDefault() - report.IITR716.GetValueOrDefault() + report.IITR717.GetValueOrDefault() + report.IITR718.GetValueOrDefault() != report.IITR474.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730362",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business Items are incorrect",
                    LongDescription = @"At Business income and expenses, the sum of Net income or loss from business this year for primary production must equal Total primary production business income minus all business expenses plus other reconciliation adjustments",
                    Location = "/xbrli:xbrl/tns:Income.BusinessPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730362" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR701", Value = GetValueOrEmpty(report.IITR701) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR703", Value = GetValueOrEmpty(report.IITR703) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR704", Value = GetValueOrEmpty(report.IITR704) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR705", Value = GetValueOrEmpty(report.IITR705) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR706", Value = GetValueOrEmpty(report.IITR706) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR707", Value = GetValueOrEmpty(report.IITR707) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR708", Value = GetValueOrEmpty(report.IITR708) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR709", Value = GetValueOrEmpty(report.IITR709) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR710", Value = GetValueOrEmpty(report.IITR710) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR712", Value = GetValueOrEmpty(report.IITR712) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR713", Value = GetValueOrEmpty(report.IITR713) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR714", Value = GetValueOrEmpty(report.IITR714) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR715", Value = GetValueOrEmpty(report.IITR715) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR716", Value = GetValueOrEmpty(report.IITR716) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR717", Value = GetValueOrEmpty(report.IITR717) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR718", Value = GetValueOrEmpty(report.IITR718) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730362

            #region VR.ATO.IITR.730363

            /*  VR.ATO.IITR.730363
            At Business income and expenses, the sum of Net income or loss from business this year for non-primary production must equal Total non-primary production business income minus all business expenses plus other reconciliation adjustments
    
            Legacy Rule Format:
            IF (([iitr437] + [iitr438] + [iitr440] + [iitr442] + [iitr445] + [iitr448]) - ([iitr719] + [iitr720] - [iitr721]) - ([iitr722] + [iitr723] + [iitr724] + [iitr725] + [iitr726] + [iitr727] + [iitr728] + [iitr729] + [iitr730] + [iitr731] + [iitr732] + [iitr733]) - [iitr734] - [iitr735] - [iitr736] + [iitr737] + [iitr738]) <> ([iitr475])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR437 + ^IITR438 + ^IITR440 + ^IITR442 + ^IITR445 + ^IITR448) - (^IITR719 + ^IITR720 - ^IITR721) - (^IITR722 + ^IITR723 + ^IITR724 + ^IITR725 + ^IITR726 + ^IITR727 + ^IITR728 + ^IITR729 + ^IITR730 + ^IITR731 + ^IITR732 + ^IITR733) - ^IITR734 - ^IITR735 - ^IITR736 + ^IITR737 + ^IITR738) <> ^IITR475
    
            Data Elements:
    
            ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
    
            ^IITR720 = RP.NonPrim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
    
            ^IITR722 = RP.NonPrim:Expense.ForeignResidentWithholding.Amount
    
            ^IITR723 = RP.NonPrim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR724 = RP.NonPrim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR725 = RP.NonPrim:Expense.Operating.BadDebts.Amount
    
            ^IITR726 = RP.NonPrim:Expense.Operating.Lease.Amount
    
            ^IITR727 = RP.NonPrim:Expense.Operating.Rent.Amount
    
            ^IITR728 = RP.NonPrim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR729 = RP.NonPrim:Expense.Operating.InterestForeign.Amount
    
            ^IITR730 = RP.NonPrim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR732 = RP.NonPrim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR733 = RP.NonPrim:Expense.Operating.Other.Amount
    
            ^IITR734 = RP.NonPrim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
    
            ^IITR735 = RP.NonPrim:Expense.ProjectPoolAllowableDeduction.Amount
    
            ^IITR736 = RP.NonPrim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR737 = RP.NonPrim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR738 = RP.NonPrim:Expense.ReconciliationAdjustments.Amount
            */
            assertion = (report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + report.IITR448.GetValueOrDefault() - (report.IITR719.GetValueOrDefault() + report.IITR720.GetValueOrDefault() - report.IITR721.GetValueOrDefault()) - (report.IITR722.GetValueOrDefault() + report.IITR723.GetValueOrDefault() + report.IITR724.GetValueOrDefault() + report.IITR725.GetValueOrDefault() + report.IITR726.GetValueOrDefault() + report.IITR727.GetValueOrDefault() + report.IITR728.GetValueOrDefault() + report.IITR729.GetValueOrDefault() + report.IITR730.GetValueOrDefault() + report.IITR731.GetValueOrDefault() + report.IITR732.GetValueOrDefault() + report.IITR733.GetValueOrDefault()) - report.IITR734.GetValueOrDefault() - report.IITR735.GetValueOrDefault() - report.IITR736.GetValueOrDefault() + report.IITR737.GetValueOrDefault() + report.IITR738.GetValueOrDefault() != report.IITR475.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730363",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business Items are incorrect",
                    LongDescription = @"At Business income and expenses, the sum of Net income or loss from business this year for non-primary production must equal Total non-primary production business income minus all business expenses plus other reconciliation adjustments",
                    Location = "/xbrli:xbrl/tns:Income.BusinessNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730363" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR720", Value = GetValueOrEmpty(report.IITR720) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR722", Value = GetValueOrEmpty(report.IITR722) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR723", Value = GetValueOrEmpty(report.IITR723) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR724", Value = GetValueOrEmpty(report.IITR724) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR725", Value = GetValueOrEmpty(report.IITR725) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR726", Value = GetValueOrEmpty(report.IITR726) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR727", Value = GetValueOrEmpty(report.IITR727) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR728", Value = GetValueOrEmpty(report.IITR728) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR729", Value = GetValueOrEmpty(report.IITR729) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR730", Value = GetValueOrEmpty(report.IITR730) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR732", Value = GetValueOrEmpty(report.IITR732) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR733", Value = GetValueOrEmpty(report.IITR733) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR734", Value = GetValueOrEmpty(report.IITR734) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR735", Value = GetValueOrEmpty(report.IITR735) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR736", Value = GetValueOrEmpty(report.IITR736) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR737", Value = GetValueOrEmpty(report.IITR737) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR738", Value = GetValueOrEmpty(report.IITR738) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730363

            #endregion Manual Rules - Rules marked for manual coding

            #region VR.ATO.GEN.000209

            /*  VR.ATO.GEN.000209
            Invalid context. The number of Reporting party contexts must equal 1
    
            Legacy Rule Format:
            IF COUNT(RP) <> 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = RP
            */
            assertion = (Count(report.RPCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430296",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party contexts must equal 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.000209" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.000209

            #region VR.ATO.GEN.000458

            /*  VR.ATO.GEN.000458
            The Trustee Suffix code is not a valid code
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonNameDetails.NameSuffix.Text <> NULLORBLANK) AND (pyde.xx.xx:PersonNameDetails.NameSuffix.Text <> SET(DOMAIN(SUFFIX CODES)))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR23 <> BLANK) AND (NotInDomain(^IITR23, 'SUFFIX CODES'))
    
            Data Elements:
    
            ^IITR23 = RP:PersonNameDetails.NameSuffix.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR23) != true && !(IsMatch(report.IITR23, @"^(ESQ|II|III|IV|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000458",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suffix is invalid",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.NameSuffix.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.000458" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR23", Value = GetValueOrEmpty(report.IITR23) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.000458

            #region VR.ATO.GEN.000459

            /*  VR.ATO.GEN.000459
            The Title code is not a valid code
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonNameDetails.Title.Text <> NULLORBLANK) AND (pyde.xx.xx:PersonNameDetails.Title.Text <> SET(DOMAIN(TITLE CODES)))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR21 <> BLANK) AND (NotInDomain(^IITR21, 'TITLE CODES'))
    
            Data Elements:
    
            ^IITR21 = RP:PersonNameDetails.Title.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR21) != true && !(IsMatch(report.IITR21, @"^(2LT|AB|ABBOT|AC|ACM|ADM|AIR CDRE|ALDERMAN|AM|ARCHBISHOP|ARCHDEACON|ASSOC PROF|AVM|BARON|BARONESS|BISHOP|BR|BRIG|CANON|CAPT|CARDINAL|CDRE|CDT|CHAP|CMDR|CMM|COL|CONST|COUNT|COUNTESS|CPL|CPO|DAME|DEACON|DEACONESS|DEAN|DEPUTY SUPT|DR|DUCHESS|DUKE|EARL|EF|FLGOFF|FLT LT|FR|FSGT|GEN|GNR|GP CAPT|HON JUDGE|HON JUST|HON|HRH|INSP|JUDGE|JUST|LAC|LACW|LADY|LBDR|LCPL|LORD|LS|LT CMDR|LT COL|LT GEN|LT|MADAM|MAJ GEN|MAJ|MASTER|MATRON|MAYOR|MAYORESS|MIDN|MISS|MON|MOST REV|MR|MRS|MS|PASTOR|PATRIARCH|PLT OFF|PO|PRIOR|PROF|PTE|RABBI|RADM|RECTOR|REV|RF|RT HON|RT REV MON|RT REV|RTREV BISHOP|SBLT|SEN|SGT|SIR|SMN|SNR CONST|SQN LDR|SR|SSGT|SUPR|SWAMI|TF|VADM|VERY REV|VICAR|VISCOUNT|WG CDR|WO|WO1|WO2)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000459",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Title is invalid",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.Title.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.000459" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR21", Value = GetValueOrEmpty(report.IITR21) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.000459

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP(Instant)
    
            ^OtherTFN = RP(Instant)
    
            ^TFN = RP
            */
            assertion = (report.RPInstantExists != false && report.RPInstantIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInstantOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.BUS
    
            ^OtherTFN = RP:RP.BUS
    
            ^TFN = RP
            */
            assertion = (report.RPBUSExists != false && report.RPBUSIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPBUSOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Eligible
    
            ^OtherTFN = RP:RP.Eligible
    
            ^TFN = RP
            */
            assertion = (report.RPEligibleExists != false && report.RPEligibleIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPEligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Ineligible
    
            ^OtherTFN = RP:RP.Ineligible
    
            ^TFN = RP
            */
            assertion = (report.RPIneligibleExists != false && report.RPIneligibleIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPIneligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Investor
    
            ^OtherTFN = RP:RP.Investor
    
            ^TFN = RP
            */
            assertion = (report.RPInvestorExists != false && report.RPInvestorIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP.Investor:RP.Investor.YPrevious
    
            ^OtherTFN = RP.Investor:RP.Investor.YPrevious
    
            ^TFN = RP
            */
            assertion = (report.RPInvestorYPreviousExists != false && report.RPInvestorYPreviousIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorYPreviousOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.JFOREIGN
    
            ^OtherTFN = RP:RP.JFOREIGN
    
            ^TFN = RP
            */
            assertion = (report.RPJFOREIGNExists != false && report.RPJFOREIGNIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPJFOREIGNOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.LimitedPartners
    
            ^OtherTFN = RP:RP.LimitedPartners
    
            ^TFN = RP
            */
            assertion = (report.RPLimitedPartnersExists != false && report.RPLimitedPartnersIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP.LimitedPartners:RP.LimitedPartners.YPrevious
    
            ^OtherTFN = RP.LimitedPartners:RP.LimitedPartners.YPrevious
    
            ^TFN = RP
            */
            assertion = (report.RPLimitedPartnersYPreviousExists != false && report.RPLimitedPartnersYPreviousIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersYPreviousOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Partnership
    
            ^OtherTFN = RP:RP.Partnership
    
            ^TFN = RP
            */
            assertion = (report.RPPartnershipExists != false && report.RPPartnershipIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPartnershipOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.POS
    
            ^OtherTFN = RP:RP.POS
    
            ^TFN = RP
            */
            assertion = (report.RPPOSExists != false && report.RPPOSIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPOSOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Prim
    
            ^OtherTFN = RP:RP.Prim
    
            ^TFN = RP
            */
            assertion = (report.RPPrimExists != false && report.RPPrimIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPrimOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.RES
    
            ^OtherTFN = RP:RP.RES
    
            ^TFN = RP
            */
            assertion = (report.RPRESExists != false && report.RPRESIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPRESOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.SPOUSE
    
            ^OtherTFN = RP:RP.SPOUSE
    
            ^TFN = RP
            */
            assertion = (report.RPSPOUSEExists != false && report.RPSPOUSEIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP.SPOUSE:RP.SPOUSE.Eligible
    
            ^OtherTFN = RP.SPOUSE:RP.SPOUSE.Eligible
    
            ^TFN = RP
            */
            assertion = (report.RPSPOUSEEligibleExists != false && report.RPSPOUSEEligibleIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEEligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP.SPOUSE:RP.SPOUSE.Ineligible
    
            ^OtherTFN = RP.SPOUSE:RP.SPOUSE.Ineligible
    
            ^TFN = RP
            */
            assertion = (report.RPSPOUSEIneligibleExists != false && report.RPSPOUSEIneligibleIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEIneligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.TrueAndCorrect
    
            ^OtherTFN = RP:RP.TrueAndCorrect
    
            ^TFN = RP
            */
            assertion = (report.RPTrueAndCorrectExists != false && report.RPTrueAndCorrectIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrueAndCorrectOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.Trust
    
            ^OtherTFN = RP:RP.Trust
    
            ^TFN = RP
            */
            assertion = (report.RPTrustExists != false && report.RPTrustIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrustOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.001023

            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^Context <> NULL AND ^OtherTFN <> ^TFN
    
            Data Elements:
    
            ^Context = RP:RP.WHM
    
            ^OtherTFN = RP:RP.WHM
    
            ^TFN = RP
            */
            assertion = (report.RPWHMExists != false && report.RPWHMIdentifierTFN != report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.001023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Unexpected TFN mismatch with Reporting Party",
                    LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPWHMOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.001023

            #region VR.ATO.GEN.428247

            /*  VR.ATO.GEN.428247
            Your Tax Agent number has failed the Tax Agent registration algorithm check. Input the correct Tax Agent registration number.
    
            Legacy Rule Format:
            IF ((pyid.xx.xx:Identifiers.TaxAgentNumber.Identifier) <> NULLORBLANK) AND (TANALGORITHM(pyid.xx.xx:Identifiers.TaxAgentNumber.Identifier) = FALSE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR542 <> BLANK) AND (FailsTANAlgorithm(^IITR542))
    
            Data Elements:
    
            ^IITR542 = INT.TrueAndCorrect:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR542) != true && FailsTANAlgorithm(report.IITR542));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.410009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The Tax Agent number has failed the Tax Agent number algorithm check",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxAgentNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.428247" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR542", Value = report.IITR542 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.428247

            #region VR.ATO.GEN.430230

            /*  VR.ATO.GEN.430230
            The e-mail address must contain an @ symbol
    
            Legacy Rule Format:
            IF (pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text <> NULLORBLANK) AND (pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text DOES NOT CONTAIN "@")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR51 <> BLANK) AND (NotContains(^IITR51, '@'))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR51) != true && !(report.IITR51 == null ? true : report.IITR51.ToUpperInvariant().Contains(@"@")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430230",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Email address must contain an @ symbol",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.430230" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.430230

            #region VR.ATO.GEN.430231

            /*  VR.ATO.GEN.430231
            An email address must not start with a space or include a space within it
    
            Legacy Rule Format:
            IF pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text = FOUND(" ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR51, ' ')
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (report.IITR51 == null ? false : report.IITR51.ToUpperInvariant().Contains(@" "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430231",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"An email address must not start with a space or include a space within it",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.430231" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.430231

            #region VR.ATO.GEN.430232

            /*  VR.ATO.GEN.430232
            E-mail address must contain a dot (.)
    
            Legacy Rule Format:
            IF (pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text <> NULLORBLANK) AND (pyde.xx.xx:ElectronicContact.ElectronicMail.Address.Text DOES NOT CONTAIN ".")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR51 <> BLANK) AND (NotContains(^IITR51, '.'))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR51) != true && !(report.IITR51 == null ? true : report.IITR51.ToUpperInvariant().Contains(@".")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430232",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Email address must contain a dot (.)",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.430232" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.430232

            #region VR.ATO.GEN.432041

            /*  VR.ATO.GEN.432041
            Bank account name must not be longer than 32 characters
    
            Legacy Rule Format:
            IF LENGTH(pyid.xx.xx:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text) > 32
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR55) > 32
    
            Data Elements:
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = (Length(report.IITR55) > 32);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.432041",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Bank account name must not be longer than 32 characters",
                    LongDescription = @"32 characters is the Banking Standard and set by the Banking Industry",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.432041" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.432041

            #region VR.ATO.GEN.438019

            /*  VR.ATO.GEN.438019
            If an exemption or rollover has been applied then the exemption or rollover code(s) must be supplied.
    
            Legacy Rule Format:
            IF (RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator = TRUE) AND (COUNT(RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code <> NULL) = 0)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR309 = TRUE) AND (Count(^IITR310) = 0)
    
            Data Elements:
    
            ^IITR309 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
            */
            assertion = (report.IITR309 == true && Count(report.IITR310Collection) == 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438019",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Exemption or rollover code not supplied",
                    LongDescription = @"If an exemption or rollover has been applied then the exemption or rollover code(s) must be supplied",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438019" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR309", Value = GetValueOrEmpty(report.IITR309) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438019

            #region VR.ATO.GEN.438021

            /*  VR.ATO.GEN.438021
            If an exemption or rollover code(s) is provided then the exemption or rollover applied indicator must be true
    
            Legacy Rule Format:
            IF (COUNT(RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code <> NULL) > 0) AND (RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator <> TRUE)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (Count(^IITR310) > 0) AND (^IITR309 <> TRUE)
    
            Data Elements:
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
    
            ^IITR309 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Indicator
            */
            assertion = (Count(report.IITR310Collection) > 0 && report.IITR309 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438021",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Exemption or rollover applied indicator must be true",
                    LongDescription = @"If an exemption or rollover code(s) is provided then the exemption or rollover applied indicator must be true",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438021" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR309", Value = GetValueOrEmpty(report.IITR309) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438021

            #region VR.ATO.GEN.438058

            /*  VR.ATO.GEN.438058
            The number of Reporting Party Investor contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.Investor)) > 1 
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Investor
            */
            assertion = (Count(report.RPInvestorCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438058",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party: Investor contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438058" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438058

            #region VR.ATO.GEN.438059

            /*  VR.ATO.GEN.438059
            The number of Reporting Party Limited Partners contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.LimitedPartners)) > 1 
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.LimitedPartners
            */
            assertion = (Count(report.RPLimitedPartnersCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438059",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party: Limited Partners contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438059" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438059

            #region VR.ATO.GEN.438070

            /*  VR.ATO.GEN.438070
            If an Intermediary is present, Intermediary Declarer contact name must be provided.
    
            Legacy Rule Format:
            IF ((CONTEXT(INT.TrueAndCorrect)<>NULL) AND (INT.TrueAndCorrect:pyde.xx.xx:PersonUnstructuredName.FullName.Text = NULLORBLANK))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^Context <> NULL) AND (^IITR538 = BLANK))
    
            Data Elements:
    
            ^IITR538 = INT.TrueAndCorrect:PersonUnstructuredName.FullName.Text
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && string.IsNullOrWhiteSpace(report.IITR538) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438070",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer contact name must be provided",
                    LongDescription = @"If an Intermediary is present, Intermediary Declarer contact name must be provided.",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438070" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR538", Value = report.IITR538 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438070

            #region VR.ATO.GEN.438076

            /*  VR.ATO.GEN.438076
            If an Intermediary is present, Intermediary Declarer Telephone number must be provided.
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect)<>NULL) AND (INT.TrueAndCorrect:pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR541 = BLANK)
    
            Data Elements:
    
            ^IITR541 = INT.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && string.IsNullOrWhiteSpace(report.IITR541) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438076",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Contact telephone details must be provided",
                    LongDescription = @"If an Intermediary is present, Intermediary Declarer Telephone number must be provided.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Minimal.Number[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438076" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR541", Value = report.IITR541 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438076

            #region VR.ATO.GEN.438078

            /*  VR.ATO.GEN.438078
            If an Intermediary is present, Intermediary Declarer Signature Date must be present.
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect)<>NULL) AND (INT.TrueAndCorrect:pyin.xx.xx:Declaration.Signature.Date = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR543 = NULL)
    
            Data Elements:
    
            ^IITR543 = INT.TrueAndCorrect:Declaration.Signature.Date
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && report.IITR543 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438078",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration Signature Date is required",
                    LongDescription = @"If an Intermediary is present, Intermediary Declarer Signature Date must be present.",
                    Location = "/xbrli:xbrl/tns:Declaration.Signature.Date[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438078" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR543", Value = GetValueOrEmpty(report.IITR543) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438078

            #region VR.ATO.GEN.438081

            /*  VR.ATO.GEN.438081
            Invalid context. The number of Reporting Party Investor YPrevious contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.Investor.YPrevious)) > 1 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.Investor:RP.Investor.YPrevious
            */
            assertion = (Count(report.RPInvestorYPreviousCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438081",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party:Investor:YPrevious contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorYPreviousLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438081" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438081

            #region VR.ATO.GEN.438082

            /*  VR.ATO.GEN.438082
            Invalid context. The number of Reporting Party Limited Partners YPrevious contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.LimitedPartners.YPrevious)) > 1 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.LimitedPartners:RP.LimitedPartners.YPrevious
            */
            assertion = (Count(report.RPLimitedPartnersYPreviousCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438082",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party:Limited Partners:YPrevious contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersYPreviousLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438082" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.438082

            #region VR.ATO.GEN.500009

            /*  VR.ATO.GEN.500009
            The TFN has failed the algorithm check.
    
            Legacy Rule Format:
            IF (TFNALGORITHM (RP:entity.identifier.TFN) = FALSE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FailsTFNAlgorithm(^TFN))
    
            Data Elements:
    
            ^TFN = RP
            */
            assertion = FailsTFNAlgorithm(report.RPIdentifierTFN);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Tax File Number has failed the algorithm check",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500009" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500009

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = INT.TrueAndCorrect
            */
            assertion = ((report.INTTrueAndCorrectExists == true) && (report.INTTrueAndCorrectStartDate != null && report.INTTrueAndCorrectStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.BUS
            */
            assertion = ((report.RPBUSExists == true) && (report.RPBUSStartDate != null && report.RPBUSStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Eligible
            */
            assertion = ((report.RPEligibleExists == true) && (report.RPEligibleStartDate != null && report.RPEligibleStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Ineligible
            */
            assertion = ((report.RPIneligibleExists == true) && (report.RPIneligibleStartDate != null && report.RPIneligibleStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Investor
            */
            assertion = ((report.RPInvestorExists == true) && (report.RPInvestorStartDate != null && report.RPInvestorStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP.Investor:RP.Investor.YPrevious
            */
            assertion = ((report.RPInvestorYPreviousExists == true) && (report.RPInvestorYPreviousStartDate != null && report.RPInvestorYPreviousStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.JFOREIGN
            */
            assertion = ((report.RPJFOREIGNExists == true) && (report.RPJFOREIGNStartDate != null && report.RPJFOREIGNStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.LimitedPartners
            */
            assertion = ((report.RPLimitedPartnersExists == true) && (report.RPLimitedPartnersStartDate != null && report.RPLimitedPartnersStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP.LimitedPartners:RP.LimitedPartners.YPrevious
            */
            assertion = ((report.RPLimitedPartnersYPreviousExists == true) && (report.RPLimitedPartnersYPreviousStartDate != null && report.RPLimitedPartnersYPreviousStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Partnership
            */
            assertion = ((report.RPPartnershipExists == true) && (report.RPPartnershipStartDate != null && report.RPPartnershipStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.POS
            */
            assertion = ((report.RPPOSExists == true) && (report.RPPOSStartDate != null && report.RPPOSStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Prim
            */
            assertion = ((report.RPPrimExists == true) && (report.RPPrimStartDate != null && report.RPPrimStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.RES
            */
            assertion = ((report.RPRESExists == true) && (report.RPRESStartDate != null && report.RPRESStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.SPOUSE
            */
            assertion = ((report.RPSPOUSEExists == true) && (report.RPSPOUSEStartDate != null && report.RPSPOUSEStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP.SPOUSE:RP.SPOUSE.Eligible
            */
            assertion = ((report.RPSPOUSEEligibleExists == true) && (report.RPSPOUSEEligibleStartDate != null && report.RPSPOUSEEligibleStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP.SPOUSE:RP.SPOUSE.Ineligible
            */
            assertion = ((report.RPSPOUSEIneligibleExists == true) && (report.RPSPOUSEIneligibleStartDate != null && report.RPSPOUSEIneligibleStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.TrueAndCorrect
            */
            assertion = ((report.RPTrueAndCorrectExists == true) && (report.RPTrueAndCorrectStartDate != null && report.RPTrueAndCorrectStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.Trust
            */
            assertion = ((report.RPTrustExists == true) && (report.RPTrustStartDate != null && report.RPTrustStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500030

            /*  VR.ATO.GEN.500030
            Invalid context. Period start date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
    
            Data Elements:
    
            ^StartDate = RP
    
            ^StartDate1 = RP:RP.WHM
            */
            assertion = ((report.RPWHMExists == true) && (report.RPWHMStartDate != null && report.RPWHMStartDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500030

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = INT.TrueAndCorrect
            */
            assertion = ((report.INTTrueAndCorrectExists == true) && (report.INTTrueAndCorrectEndDate != null && report.INTTrueAndCorrectEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.BUS
            */
            assertion = ((report.RPBUSExists == true) && (report.RPBUSEndDate != null && report.RPBUSEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Eligible
            */
            assertion = ((report.RPEligibleExists == true) && (report.RPEligibleEndDate != null && report.RPEligibleEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Ineligible
            */
            assertion = ((report.RPIneligibleExists == true) && (report.RPIneligibleEndDate != null && report.RPIneligibleEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Investor
            */
            assertion = ((report.RPInvestorExists == true) && (report.RPInvestorEndDate != null && report.RPInvestorEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP.Investor:RP.Investor.YPrevious
            */
            assertion = ((report.RPInvestorYPreviousExists == true) && (report.RPInvestorYPreviousEndDate != null && report.RPInvestorYPreviousEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.JFOREIGN
            */
            assertion = ((report.RPJFOREIGNExists == true) && (report.RPJFOREIGNEndDate != null && report.RPJFOREIGNEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.LimitedPartners
            */
            assertion = ((report.RPLimitedPartnersExists == true) && (report.RPLimitedPartnersEndDate != null && report.RPLimitedPartnersEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP.LimitedPartners:RP.LimitedPartners.YPrevious
            */
            assertion = ((report.RPLimitedPartnersYPreviousExists == true) && (report.RPLimitedPartnersYPreviousEndDate != null && report.RPLimitedPartnersYPreviousEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Partnership
            */
            assertion = ((report.RPPartnershipExists == true) && (report.RPPartnershipEndDate != null && report.RPPartnershipEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.POS
            */
            assertion = ((report.RPPOSExists == true) && (report.RPPOSEndDate != null && report.RPPOSEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Prim
            */
            assertion = ((report.RPPrimExists == true) && (report.RPPrimEndDate != null && report.RPPrimEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.RES
            */
            assertion = ((report.RPRESExists == true) && (report.RPRESEndDate != null && report.RPRESEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.SPOUSE
            */
            assertion = ((report.RPSPOUSEExists == true) && (report.RPSPOUSEEndDate != null && report.RPSPOUSEEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP.SPOUSE:RP.SPOUSE.Eligible
            */
            assertion = ((report.RPSPOUSEEligibleExists == true) && (report.RPSPOUSEEligibleEndDate != null && report.RPSPOUSEEligibleEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP.SPOUSE:RP.SPOUSE.Ineligible
            */
            assertion = ((report.RPSPOUSEIneligibleExists == true) && (report.RPSPOUSEIneligibleEndDate != null && report.RPSPOUSEIneligibleEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.TrueAndCorrect
            */
            assertion = ((report.RPTrueAndCorrectExists == true) && (report.RPTrueAndCorrectEndDate != null && report.RPTrueAndCorrectEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.Trust
            */
            assertion = ((report.RPTrustExists == true) && (report.RPTrustEndDate != null && report.RPTrustEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500033

            /*  VR.ATO.GEN.500033
            Invalid context. Period end date must be the same across all duration contexts.
    
            Legacy Rule Format:
            IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
    
            Data Elements:
    
            ^EndDate = RP
    
            ^EndDate1 = RP:RP.WHM
            */
            assertion = ((report.RPWHMExists == true) && (report.RPWHMEndDate != null && report.RPWHMEndDate != report.RPEndDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500033

            #region VR.ATO.GEN.500037

            /*  VR.ATO.GEN.500037
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonUnstructuredName.FullName.Text <> NULLORBLANK) AND (pyde.xx.xx:PersonUnstructuredName.FullName.Text CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR538, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR538 = INT.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = IsMatch(report.IITR538, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500037",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500037" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR538", Value = report.IITR538 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500037

            #region VR.ATO.GEN.500037

            /*  VR.ATO.GEN.500037
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonUnstructuredName.FullName.Text <> NULLORBLANK) AND (pyde.xx.xx:PersonUnstructuredName.FullName.Text CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR550, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR550 = RP.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = IsMatch(report.IITR550, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500037",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500037" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR550", Value = GetValueOrEmpty(report.IITR550) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500037

            #region VR.ATO.GEN.500046

            /*  VR.ATO.GEN.500046
            Invalid context. The number of RP.TrueAndCorrect contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(RP.TrueAndCorrect) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.TrueAndCorrect
            */
            assertion = (Count(report.RPTrueAndCorrectCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500046",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of RP.TrueAndCorrect contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrueAndCorrectLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500046" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500046

            #region VR.ATO.GEN.500051

            /*  VR.ATO.GEN.500051
            Scheme for Intermediary.TrueAndCorrect must be set to http://www.abr.gov.au/abn
    
            Legacy Rule Format:
            IF (INT.TrueAndCorrect:entity.identifier.scheme <> "http://www.abr.gov.au/abn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.abr.gov.au/abn'
    
            Data Elements:
    
            ^IdentifierScheme = INT.TrueAndCorrect
            */
            assertion = ((report.INTTrueAndCorrectExists == true) && (report.INTTrueAndCorrectIdentifierScheme != @"http://www.abr.gov.au/abn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500051",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Intermediary.TrueAndCorrect must be ""http://www.abr.gov.au/abn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.INTTrueAndCorrectOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500051" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500051

            #region VR.ATO.GEN.500053

            /*  VR.ATO.GEN.500053
            Scheme for RP.TrueAndCorrect must be set to http://www.ato.gov.au/tfn
    
            Legacy Rule Format:
            IF (RP.TrueAndCorrect:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.TrueAndCorrect
            */
            assertion = ((report.RPTrueAndCorrectExists == true) && (report.RPTrueAndCorrectIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500053",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for ReportingParty.TrueAndCorrect must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrueAndCorrectOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500053" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500053

            #region VR.ATO.GEN.500054

            /*  VR.ATO.GEN.500054
            ABN in the context definition must pass the ABN algorithm check
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect) <> NULL) AND (ABNALGORITHM(INT.TrueAndCorrect:entity.identifier.ABN) = FALSE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (FailsABNAlgorithm(^ABN))
    
            Data Elements:
    
            ^Context = INT.TrueAndCorrect
    
            ^ABN = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && FailsABNAlgorithm(report.INTTrueAndCorrectIdentifierABN));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500054",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Intermediary declarer Australian Business Number has failed the algorithm check",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.INTTrueAndCorrectOccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500054" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500054

            #region VR.ATO.GEN.500055

            /*  VR.ATO.GEN.500055
            Declarer Contact Name has a maximum field length of 200
    
            Legacy Rule Format:
            IF LENGTH(pyde.xx.xx:PersonUnstructuredName.FullName.Text) > 200
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR538) > 200
    
            Data Elements:
    
            ^IITR538 = INT.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = (Length(report.IITR538) > 200);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500055",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name must not exceed 200 characters",
                    LongDescription = @"For Declarer Contact Name, the maximum allowable characters for this form is 200",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500055" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR538", Value = report.IITR538 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500055

            #region VR.ATO.GEN.500055

            /*  VR.ATO.GEN.500055
            Declarer Contact Name has a maximum field length of 200
    
            Legacy Rule Format:
            IF LENGTH(pyde.xx.xx:PersonUnstructuredName.FullName.Text) > 200
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR550) > 200
    
            Data Elements:
    
            ^IITR550 = RP.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = (Length(report.IITR550) > 200);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500055",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name must not exceed 200 characters",
                    LongDescription = @"For Declarer Contact Name, the maximum allowable characters for this form is 200",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500055" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR550", Value = GetValueOrEmpty(report.IITR550) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500055

            #region VR.ATO.GEN.500058

            /*  VR.ATO.GEN.500058
            Declarer Position held of person making the declaration has a maximum field length of 50
    
            Legacy Rule Format:
            IF LENGTH(pyde.xx.xx:PersonNameDetails.Position.Text) > 50
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR539) > 50
    
            Data Elements:
    
            ^IITR539 = INT.TrueAndCorrect:PersonNameDetails.Position.Text
            */
            assertion = (Length(report.IITR539) > 50);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500058",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer position must not exceed 50 characters",
                    LongDescription = @"For Declarer position, the maximum allowable characters for this form is 50",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.Position.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500058" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR539", Value = GetValueOrEmpty(report.IITR539) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500058

            #region VR.ATO.GEN.500058

            /*  VR.ATO.GEN.500058
            Declarer Position held of person making the declaration has a maximum field length of 50
    
            Legacy Rule Format:
            IF LENGTH(pyde.xx.xx:PersonNameDetails.Position.Text) > 50
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR551) > 50
    
            Data Elements:
    
            ^IITR551 = RP.TrueAndCorrect:PersonNameDetails.Position.Text
            */
            assertion = (Length(report.IITR551) > 50);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500058",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer position must not exceed 50 characters",
                    LongDescription = @"For Declarer position, the maximum allowable characters for this form is 50",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.Position.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500058" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR551", Value = GetValueOrEmpty(report.IITR551) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500058

            #region VR.ATO.GEN.500059

            /*  VR.ATO.GEN.500059
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonNameDetails.Position.Text <> NULLORBLANK) AND (ANY CHARACTER OF pyde.xx.xx:PersonNameDetails.Position.Text <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR539 <> BLANK) AND (NotCharacterInSet(^IITR539, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR539 = INT.TrueAndCorrect:PersonNameDetails.Position.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR539) != true && !(IsMatch(report.IITR539, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500059",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer position held of person making the declaration contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.Position.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500059" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR539", Value = GetValueOrEmpty(report.IITR539) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500059

            #region VR.ATO.GEN.500059

            /*  VR.ATO.GEN.500059
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyde.xx.xx:PersonNameDetails.Position.Text <> NULLORBLANK) AND (ANY CHARACTER OF pyde.xx.xx:PersonNameDetails.Position.Text <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR551 <> BLANK) AND (NotCharacterInSet(^IITR551, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR551 = RP.TrueAndCorrect:PersonNameDetails.Position.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR551) != true && !(IsMatch(report.IITR551, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500059",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer position held of person making the declaration contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.Position.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500059" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR551", Value = GetValueOrEmpty(report.IITR551) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500059

            #region VR.ATO.GEN.500064

            /*  VR.ATO.GEN.500064
            Tax agent number is required when the declarer is a tax agent
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect) <> NULL) AND (INT.TrueAndCorrect:pyid.xx.xx:Identifiers.TaxAgentNumber.Identifier = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR542 = NULL)
    
            Data Elements:
    
            ^IITR542 = INT.TrueAndCorrect:Identifiers.TaxAgentNumber.Identifier
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && report.IITR542 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500064",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer tax agent number must be present",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxAgentNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500064" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR542", Value = report.IITR542 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500064

            #region VR.ATO.GEN.500066

            /*  VR.ATO.GEN.500066
            Signature date must not be later than today
    
            Legacy Rule Format:
            IF (pyin.xx.xx:Declaration.Signature.Date > DATE(TODAY))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR543 > Today())
    
            Data Elements:
    
            ^IITR543 = INT.TrueAndCorrect:Declaration.Signature.Date
            */
            assertion = (report.IITR543.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430255",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Signature date must not be later than today",
                    Location = "/xbrli:xbrl/tns:Declaration.Signature.Date[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500066" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR543", Value = GetValueOrEmpty(report.IITR543) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500066

            #region VR.ATO.GEN.500066

            /*  VR.ATO.GEN.500066
            Signature date must not be later than today
    
            Legacy Rule Format:
            IF (pyin.xx.xx:Declaration.Signature.Date > DATE(TODAY))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR554 > Today())
    
            Data Elements:
    
            ^IITR554 = RP.TrueAndCorrect:Declaration.Signature.Date
            */
            assertion = (report.IITR554.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430255",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Signature date must not be later than today",
                    Location = "/xbrli:xbrl/tns:Declaration.Signature.Date[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500066" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR554", Value = GetValueOrEmpty(report.IITR554) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500066

            #region VR.ATO.GEN.500069

            /*  VR.ATO.GEN.500069
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = _ [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyin.xx.xx:Declaration.SignatoryIdentifier.Text <> NULLORBLANK) AND (ANY CHARACTER OF pyin.xx.xx:Declaration.SignatoryIdentifier.Text <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","_","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR545 <> BLANK) AND (NotCharacterInSet(^IITR545, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","_","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR545 = INT.TrueAndCorrect:Declaration.SignatoryIdentifier.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR545) != true && !(IsMatch(report.IITR545, @"^[a-zA-Z0-9!@\$%&\*\(\)\-_=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500069",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer identifier contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - _ = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:Declaration.SignatoryIdentifier.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500069" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR545", Value = report.IITR545 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500069

            #region VR.ATO.GEN.500069

            /*  VR.ATO.GEN.500069
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = _ [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF (pyin.xx.xx:Declaration.SignatoryIdentifier.Text <> NULLORBLANK) AND (ANY CHARACTER OF pyin.xx.xx:Declaration.SignatoryIdentifier.Text <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","_","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR556 <> BLANK) AND (NotCharacterInSet(^IITR556, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","_","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR556 = RP.TrueAndCorrect:Declaration.SignatoryIdentifier.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR556) != true && !(IsMatch(report.IITR556, @"^[a-zA-Z0-9!@\$%&\*\(\)\-_=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500069",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer identifier contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - _ = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:Declaration.SignatoryIdentifier.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500069" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR556", Value = GetValueOrEmpty(report.IITR556) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500069

            #region VR.ATO.GEN.500072

            /*  VR.ATO.GEN.500072
            Invalid context. The number of RP.RES contexts must equal 1.
    
            Legacy Rule Format:
            IF COUNT(RP.RES) <> 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = RP:RP.RES
            */
            assertion = (Count(report.RPRESCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500072",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of RP.RES contexts must equal 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPRESLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500072" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500072

            #region VR.ATO.GEN.500073

            /*  VR.ATO.GEN.500073
            Scheme for RP.POS must be set to http://www.ato.gov.au/tfn
    
            Legacy Rule Format:
            IF (RP.POS:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.POS
            */
            assertion = ((report.RPPOSExists == true) && (report.RPPOSIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500073",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for RP.POS must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPOSOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500073" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500073

            #region VR.ATO.GEN.500074

            /*  VR.ATO.GEN.500074
            Scheme for RP.RES must be set to http://www.ato.gov.au/tfn
    
            Legacy Rule Format:
            IF (RP.RES:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.RES
            */
            assertion = ((report.RPRESExists == true) && (report.RPRESIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500074",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for RP.RES must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPRESOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500074" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500074

            #region VR.ATO.GEN.500075

            /*  VR.ATO.GEN.500075
            Entity identifier scheme for ReportingParty must be "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP
            */
            assertion = ((report.RPExists == true) && (report.RPIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438029",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for ReportingParty must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500075" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500075

            #region VR.ATO.GEN.500077

            /*  VR.ATO.GEN.500077
            A maximum of 25 exemption or rollover codes are permitted
    
            Legacy Rule Format:
            IF COUNT(rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code) > 25
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^IITR310) > 25
    
            Data Elements:
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
            */
            assertion = (Count(report.IITR310Collection) > 25);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500077",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The maximum number of exemption or rollover codes permitted is 25",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500077" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500077

            #region VR.ATO.GEN.500088

            /*  VR.ATO.GEN.500088
            Invalid context. The number of Reporting Party (Instant) contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(RP(Instant)) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP(Instant)
            */
            assertion = (Count(report.RPInstantCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500088",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party (Instant) contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInstantLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500088" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500088

            #region VR.ATO.GEN.500089

            /*  VR.ATO.GEN.500089
            Entity identifier scheme for Reporting Party (Instant) must be "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP(Instant):entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP(Instant)
            */
            assertion = ((report.RPInstantExists == true) && (report.RPInstantIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500089",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party (Instant) must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInstantOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500089" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500089

            #region VR.ATO.GEN.500090

            /*  VR.ATO.GEN.500090
            Invalid context. Period date of Reporting Party (Instant) must match period start date of Reporting Party.
    
            Legacy Rule Format:
            IF (RP(Instant):period.instantDate <> RP:period.startDate)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^InstantDate1 <> ^StartDate1
    
            Data Elements:
    
            ^StartDate1 = RP
    
            ^InstantDate1 = RP(Instant)
            */
            assertion = ((report.RPInstantExists == true) && (report.RPInstantInstantDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500090",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party (Instant) period date is invalid",
                    LongDescription = @"Invalid context. Period date of Reporting Party (Instant) must match period start date of Reporting Party.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500090" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500090

            #region VR.ATO.GEN.500094

            /*  VR.ATO.GEN.500094
            Intermediary Declaration Statement Accepted Indicator must be 'TRUE'
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect) <> NULL) AND (INT.TrueAndCorrect:pyin.xx.xx:Declaration.StatementAccepted.Indicator <> TRUE)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR544 <> TRUE)
    
            Data Elements:
    
            ^IITR544 = INT.TrueAndCorrect:Declaration.StatementAccepted.Indicator
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && report.IITR544 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500094",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Intermediary Declaration Statement Accepted Indicator must be 'TRUE'",
                    Location = "/xbrli:xbrl/tns:Declaration.StatementAccepted.Indicator[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500094" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR544", Value = GetValueOrEmpty(report.IITR544) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500094

            #region VR.ATO.GEN.500100

            /*  VR.ATO.GEN.500100
            Reporting Party Declaration Statement Accepted Indicator must be 'TRUE'
    
            Legacy Rule Format:
            IF (CONTEXT(RP.TrueAndCorrect) <> NULL) AND (RP.TrueAndCorrect:pyin.xx.xx:Declaration.StatementAccepted.Indicator <> TRUE)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR555 <> TRUE)
    
            Data Elements:
    
            ^IITR555 = RP.TrueAndCorrect:Declaration.StatementAccepted.Indicator
    
            ^Context = RP:RP.TrueAndCorrect
            */
            assertion = (report.RPTrueAndCorrectExists != false && report.IITR555 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Declaration Statement Accepted Indicator must be 'TRUE'",
                    Location = "/xbrli:xbrl/tns:Declaration.StatementAccepted.Indicator[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500100" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR555", Value = GetValueOrEmpty(report.IITR555) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500100

            #region VR.ATO.GEN.500103

            /*  VR.ATO.GEN.500103
            Invalid context. The number of RP.POS contexts must equal 1.
    
            Legacy Rule Format:
            IF COUNT(RP.POS) <> 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = RP:RP.POS
            */
            assertion = (Count(report.RPPOSCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500103",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of RP.POS contexts must equal 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPOSLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500103" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500103

            #region VR.ATO.GEN.500146

            /*  VR.ATO.GEN.500146
            Invalid context. The number of Intermediary.TrueAndCorrect contexts must equal 1.
    
            Legacy Rule Format:
            IF COUNT(INT.TrueAndCorrect) <> 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (Count(report.INTTrueAndCorrectCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500146",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Intermediary.TrueAndCorrect contexts must equal 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.INTTrueAndCorrectLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500146" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500146

            #region VR.ATO.GEN.500147

            /*  VR.ATO.GEN.500147
            Telephone number is required, if an area code is provided
    
            Legacy Rule Format:
            WHERE IN CONTEXT(RP.TrueAndCorrect)
            IF pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number = NULLORBLANK AND pyde.xx.xx:ElectronicContact.Telephone.Country.Code <> NULLORBLANK
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR553 = BLANK AND ^IITR580 <> BLANK
    
            Data Elements:
    
            ^IITR580 = RP.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
    
            ^IITR553 = RP.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR553) == true && string.IsNullOrWhiteSpace(report.IITR580) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500061",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Telephone number is required, if an area code is provided",
                    LongDescription = @"Declarer telephone number is required when Declarer telephone area code is provided",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500147" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR553", Value = GetValueOrEmpty(report.IITR553) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR580", Value = GetValueOrEmpty(report.IITR580) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500147

            #region VR.ATO.GEN.500148

            /*  VR.ATO.GEN.500148
            Area code is required, if a Telephone number is provided
    
            Legacy Rule Format:
            WHERE IN CONTEXT(RP.TrueAndCorrect)
            IF pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number <> NULLORBLANK AND pyde.xx.xx:ElectronicContact.Telephone.Country.Code = NULLORBLANK
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR553 <> BLANK AND ^IITR580 = BLANK
    
            Data Elements:
    
            ^IITR580 = RP.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
    
            ^IITR553 = RP.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR553) != true && string.IsNullOrWhiteSpace(report.IITR580) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500062",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Area code is required, if a Telephone number is provided",
                    LongDescription = @"Declarer daytime phone area code is required when Declarer daytime phone number is provided",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500148" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR553", Value = GetValueOrEmpty(report.IITR553) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR580", Value = GetValueOrEmpty(report.IITR580) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500148

            #region VR.ATO.GEN.500149

            /*  VR.ATO.GEN.500149
            If an area code is supplied and Intermediary is present, Intermediary Telephone number is required.
    
            Legacy Rule Format:
            WHERE IN CONTEXT(INT.TrueAndCorrect)
            IF pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number = NULLORBLANK AND pyde.xx.xx:ElectronicContact.Telephone.Country.Code <> NULLORBLANK
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR541 = BLANK AND ^IITR581 <> BLANK
    
            Data Elements:
    
            ^IITR581 = INT.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
    
            ^IITR541 = INT.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR541) == true && string.IsNullOrWhiteSpace(report.IITR581) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438072",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Telephone number is required, if an area code is provided",
                    LongDescription = @"If an area code is supplied and Intermediary is present, Intermediary Telephone number is required.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500149" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR541", Value = report.IITR541 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR581", Value = report.IITR581 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500149

            #region VR.ATO.GEN.500150

            /*  VR.ATO.GEN.500150
            If a telephone number is supplied and Intermediary is present, Intermediary area code is required.
    
            Legacy Rule Format:
            WHERE IN CONTEXT(INT.TrueAndCorrect)
            IF pyde.xx.xx:ElectronicContact.Telephone.Minimal.Number <> NULLORBLANK AND pyde.xx.xx:ElectronicContact.Telephone.Country.Code = NULLORBLANK
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR541 <> BLANK AND ^IITR581 = BLANK
    
            Data Elements:
    
            ^IITR581 = INT.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
    
            ^IITR541 = INT.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR541) != true && string.IsNullOrWhiteSpace(report.IITR581) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438074",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Area code is required, if a Telephone number is provided",
                    LongDescription = @"If a telephone number is supplied and Intermediary is present, Intermediary area code is required.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500150" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR541", Value = report.IITR541 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR581", Value = report.IITR581 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500150

            #region VR.ATO.IITR.000001

            /*  VR.ATO.IITR.000001
            Current postal address - Address line 1 field contains incorrect 'care of' reference.  The only acceptable 'care of' reference is C/-.
    
            Legacy Rule Format:
            IF ([iitr33] <> NULLORBLANK) AND ([iitr33] STARTSWITH SET("CO ") OR [iitr33] = FOUND("C/O","C/","Care Of"))
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR33 <> BLANK) AND (StartsWithSet(^IITR33,'"CO "') OR FoundSet(^IITR33, '"C/O","C/","Care Of"'))
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR33) != true && (IsMatch(report.IITR33, @"^(CO )", RegexOptions.IgnoreCase) || IsMatch(report.IITR33, @"(^(C/O|C/|Care Of)$)|(^(.*)( C/O | C/ | Care Of )(.*)$)|(^(C/O |C/ |Care Of )(.*)$)|(^(.*)( C/O| C/| Care Of)$)", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 1 is incorrect",
                    LongDescription = @"Current postal address - Address line 1 contains incorrect 'care of' reference.  The only acceptable 'care of' reference is C/-.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000001

            #region VR.ATO.IITR.000002

            /*  VR.ATO.IITR.000002
            Current postal address - Address line 2 field cannot contain 'care of' reference.
    
            Legacy Rule Format:
            IF ([iitr34] <> NULLORBLANK) AND ([iitr34] STARTSWITH SET("CO ") OR [iitr34] = FOUND("C/O","C/","Care Of","C/-"))
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR34 <> BLANK) AND (StartsWithSet(^IITR34,'"CO "') OR FoundSet(^IITR34, '"C/O","C/","Care Of","C/-"'))
    
            Data Elements:
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR34) != true && (IsMatch(report.IITR34, @"^(CO )", RegexOptions.IgnoreCase) || IsMatch(report.IITR34, @"(^(C/O|C/|Care Of|C/-)$)|(^(.*)( C/O | C/ | Care Of | C/- )(.*)$)|(^(C/O |C/ |Care Of |C/- )(.*)$)|(^(.*)( C/O| C/| Care Of| C/-)$)", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 2 must not contain a 'care of' reference",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000002

            #region VR.ATO.IITR.000003

            /*  VR.ATO.IITR.000003
            AS ABOVE' is not acceptable in the field.
    
            Legacy Rule Format:
            IF (([iitr41] = FOUND("AS ABOVE")) OR ([iitr42] = FOUND("AS ABOVE")))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((FoundSet(^IITR41, '"AS ABOVE"')) OR (FoundSet(^IITR42, '"AS ABOVE"')))
    
            Data Elements:
    
            ^IITR41 = RP.RES:AddressDetails.Line1.Text
    
            ^IITR42 = RP.RES:AddressDetails.Line2.Text
            */
            assertion = (IsMatch(report.IITR41, @"(^(AS ABOVE)$)|(^(.*)( AS ABOVE )(.*)$)|(^(AS ABOVE )(.*)$)|(^(.*)( AS ABOVE)$)", RegexOptions.IgnoreCase) || IsMatch(report.IITR42, @"(^(AS ABOVE)$)|(^(.*)( AS ABOVE )(.*)$)|(^(AS ABOVE )(.*)$)|(^(.*)( AS ABOVE)$)", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address must not contain ""AS ABOVE""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR41", Value = report.IITR41 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR42", Value = GetValueOrEmpty(report.IITR42) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000003

            #region VR.ATO.IITR.000004

            /*  VR.ATO.IITR.000004
            Where the Number of dependent children and students for Medicare levy reduction is greater than zero, Spouses family name and Spouses taxable income is present, the spouse is between the ages 55 and 61 on 30 June of the reporting period, and Your spouse's taxed element of a SLS zero tax rate is not present, check spouse's income for correct calculation of Medicare levy reduction.
    
            Legacy Rule Format:
            IF ([iitr171] > 0) AND ([iitr213] <> NULLORBLANK) AND ([iitr225] <> NULL) AND ([iitr217] <> NULL) AND ([iitr217] < ConvertToDate(30,6, [iitr10] - 55)) AND ([iitr217] > ConvertToDate(1,7, [iitr10] - 61)) AND ([iitr236] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR171 > 0) AND (^IITR213 <> BLANK) AND (^IITR225 <> NULL) AND (^IITR217 <> NULL) AND (^IITR217 < ConvertToDate(30,6, ^IITR10 - 55)) AND (^IITR217 > ConvertToDate(1,7, ^IITR10 - 61)) AND (^IITR236 = NULL)
    
            Data Elements:
    
            ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount
    
            ^IITR171 = RP:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = (report.IITR171.GetValueOrDefault() > 0 && string.IsNullOrWhiteSpace(report.IITR213) != true && report.IITR225 != null && report.IITR217 != null && report.IITR217.GetValueOrDefault() < ConvertToDate(30, 6, report.IITR10.GetValueOrDefault() - 55) && report.IITR217.GetValueOrDefault() > ConvertToDate(1, 7, report.IITR10.GetValueOrDefault() - 61) && report.IITR236 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000004",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check spouse's income for correct calculation of Medicare levy reduction",
                    LongDescription = @"Check spouse income label, 'Your spouse's taxed element of a SLS zero tax rate'; if the spouse received a lump sum which includes the low rate cap this label must be completed to correctly calculate the Medicare levy reduction.",
                    Location = "/xbrli:xbrl/tns:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR171", Value = report.IITR171.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR236", Value = GetValueOrEmpty(report.IITR236) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000004

            #region VR.ATO.IITR.000005

            /*  VR.ATO.IITR.000005
            Address line 1 contains 'Care of' reference and no street address in Address line 2. If 'Care of' reference is on Address line 1, it must be followed by a name then Address line 2 must contain the street address.
    
            Legacy Rule Format:
            IF (([iitr33] CONTAINS "C/-") AND ([iitr34] = NULLORBLANK))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((Contains(^IITR33, 'C/-')) AND (^IITR34 = BLANK))
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = ((report.IITR33 == null ? false : report.IITR33.ToUpperInvariant().Contains(@"C/-")) && string.IsNullOrWhiteSpace(report.IITR34) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000005",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"C/- must be followed by a Name and the Address on line 2 for Current postal address",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000005" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000005

            #region VR.ATO.IITR.000006

            /*  VR.ATO.IITR.000006
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr22] <> NULLORBLANK) AND ([iitr22] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR22, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR22, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000006",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000006" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000006

            #region VR.ATO.IITR.000007

            /*  VR.ATO.IITR.000007
            This is an annual accounting submission. The dates provided should be for your annual accounting period, commencing on the 1st day of the month. For normal balancers, this will be the period 1 July - 30 June
    
            Legacy Rule Format:
            IF (((RP:period.endDate.Year - RP:period.startDate.Year) * 12) + RP:period.endDate.Month - RP:period.startDate.Month + 1) > 23
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (((Year(^EndDate) - Year(^StartDate1)) * 12) + MonthAsInt(^EndDate) - MonthAsInt(^StartDate2) + 1) > 23
    
            Data Elements:
    
            ^EndDate = RP
    
            ^StartDate1 = RP
    
            ^StartDate2 = RP
            */
            assertion = ((Year(report.RPEndDate) - Year(report.RPStartDate)) * 12 + MonthAsInt(report.RPEndDate) - MonthAsInt(report.RPStartDate) + 1 > 23);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The account period dates must not exceed 23 months for an approved transitional period",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000007" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000007

            #region VR.ATO.IITR.000008

            /*  VR.ATO.IITR.000008
            Individual name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used
    
            Legacy Rule Format:
            IF ([iitr22] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR22, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR22, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000008",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family name cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000008" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000008

            #region VR.ATO.IITR.000009

            /*  VR.ATO.IITR.000009
            Year of return is mandatory
    
            Legacy Rule Format:
            IF [iitr10] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR10 = NULL
    
            Data Elements:
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = (report.IITR10 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Year of return must be present",
                    Location = "/xbrli:xbrl/tns:Report.TargetFinancial.Year",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000009

            #region VR.ATO.IITR.000010

            /*  VR.ATO.IITR.000010
            Australian residency indicator is mandatory
    
            Legacy Rule Format:
            IF [iitr19] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR19 = NULL
    
            Data Elements:
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
            */
            assertion = (report.IITR19 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000010",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian residency indicator must be present",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesPersonStatus.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000010" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000010

            #region VR.ATO.IITR.000012

            /*  VR.ATO.IITR.000012
            Family Name field contains all numeric characters with any combination of spaces; at least one alpha must be present
    
            Legacy Rule Format:
            IF ([iitr22] <> NULLORBLANK) AND ([iitr22] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR22 <> BLANK) AND (NotContainsSet(^IITR22, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR22) != true && !(IsMatch(report.IITR22, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family Name field cannot contain all numeric characters including any spaces",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000012

            #region VR.ATO.IITR.000014

            /*  VR.ATO.IITR.000014
            Field contains all numeric characters with any combination of spaces; at least one alpha must be present
    
            Legacy Rule Format:
            IF ([iitr33] <> NULLORBLANK) AND ([iitr33] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR33 <> BLANK) AND (NotContainsSet(^IITR33, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR33) != true && !(IsMatch(report.IITR33, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000014",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 1 must contain at least one alphabetical character",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000014

            #region VR.ATO.IITR.000015

            /*  VR.ATO.IITR.000015
            Field contains all numeric characters with any combination of spaces; at least one alpha must be present
    
            Legacy Rule Format:
            IF ([iitr34] <> NULLORBLANK) AND ([iitr34] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR34 <> BLANK) AND (NotContainsSet(^IITR34, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR34) != true && !(IsMatch(report.IITR34, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000015",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 2 must contain at least one alphabetical character",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000015

            #region VR.ATO.IITR.000016

            /*  VR.ATO.IITR.000016
            Individual or non-individual name field contains repeated hyphen, apostrophe, or space characters
    
            Legacy Rule Format:
            IF ([iitr22] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR22, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR22, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family Name field contains repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000016

            #region VR.ATO.IITR.000018

            /*  VR.ATO.IITR.000018
            Name field cannot contain 'space hyphen space'
    
            Legacy Rule Format:
            IF ([iitr22] CONTAINS " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR22, ' - ')
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = (report.IITR22 == null ? false : report.IITR22.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family name field must not have space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000018

            #region VR.ATO.IITR.000019

            /*  VR.ATO.IITR.000019
            Individual name field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field
    
            Legacy Rule Format:
            IF ([iitr22] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR22, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR22, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000019",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000019" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000019

            #region VR.ATO.IITR.000020

            /*  VR.ATO.IITR.000020
            A valid Amendment Sequence Number must be provided when Amendment indicator is set. Valid values are 1-9
    
            Legacy Rule Format:
            IF ([iitr16] = TRUE) AND ([iitr56] <> SET(1-9))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR16 = TRUE) AND ((^IITR56 < 1 OR ^IITR56 > 9))
    
            Data Elements:
    
            ^IITR56 = RP:Report.AmendmentSequence.Number
    
            ^IITR16 = RP:Report.Amendment.Indicator
            */
            assertion = (report.IITR16 == true && (report.IITR56.GetValueOrDefault() < 1 || report.IITR56.GetValueOrDefault() > 9));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000020",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Where the lodgment is an amendment, a valid sequence number of 1 to 9 must be provided",
                    LongDescription = @"A valid Amendment Sequence Number must be provided when Amendment indicator is set. Valid values are 1-9.",
                    Location = "/xbrli:xbrl/tns:Report.AmendmentSequence.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000020" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR16", Value = GetValueOrEmpty(report.IITR16) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR56", Value = report.IITR56.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000020

            #region VR.ATO.IITR.000021

            /*  VR.ATO.IITR.000021
            Individual name field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field
    
            Legacy Rule Format:
            IF ([iitr22] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR22, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR22, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000021",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Family name field contains ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR as a suffix",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000021" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000021

            #region VR.ATO.IITR.000022

            /*  VR.ATO.IITR.000022
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr31] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr31] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR31 <> BLANK) AND (NotCharacterInSet(^IITR31, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR31 = RP:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR31) != true && !(IsMatch(report.IITR31, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000022",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Additional Information contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000022" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR31", Value = GetValueOrEmpty(report.IITR31) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000022

            #region VR.ATO.IITR.000023

            /*  VR.ATO.IITR.000023
            Date of death is present and title is not Executor for (EF) or Representative for (RF) or Trustee for (TF). Only these titles are allowed for a deceased taxpayer
    
            Legacy Rule Format:
            IF (([iitr28] <> NULL) AND ([iitr21] <> SET("EF", "RF", "TF"))) 
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR28 <> NULL) AND (NotInSet(^IITR21, '"EF", "RF", "TF"')))
    
            Data Elements:
    
            ^IITR28 = RP:PersonDemographicDetails.Death.Date
    
            ^IITR21 = RP:PersonNameDetails.Title.Text
            */
            assertion = (report.IITR28 != null && !(IsMatch(report.IITR21, @"^(EF|RF|TF)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Check deceased taxpayer's title",
                    LongDescription = @"Date of death is present and title is not Executor for (EF) or Representative for (RF) or Trustee for (TF). Only these titles are allowed for a deceased taxpayer.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Death.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000023" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR28", Value = GetValueOrEmpty(report.IITR28) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR21", Value = GetValueOrEmpty(report.IITR21) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000023

            #region VR.ATO.IITR.000025

            /*  VR.ATO.IITR.000025
            Family name is mandatory
    
            Legacy Rule Format:
            IF [iitr22] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR22 = BLANK
    
            Data Elements:
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR22) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000025",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Surname required",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000025" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000025

            #region VR.ATO.IITR.000026

            /*  VR.ATO.IITR.000026
            Name changed indicator is mandatory
    
            Legacy Rule Format:
            IF [iitr26] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR26 = NULL
    
            Data Elements:
    
            ^IITR26 = RP:Party.ChangeName.Indicator
            */
            assertion = (report.IITR26 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The ""Has name or title changed since last tax return lodged"" question must be answered",
                    Location = "/xbrli:xbrl/tns:Party.ChangeName.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR26", Value = GetValueOrEmpty(report.IITR26) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000026

            #region VR.ATO.IITR.000027

            /*  VR.ATO.IITR.000027
            Date of birth is mandatory
    
            Legacy Rule Format:
            IF [iitr29] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR29 = NULL
    
            Data Elements:
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
            */
            assertion = (report.IITR29 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000027",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Date of birth required",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Birth.Date[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000027" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000027

            #region VR.ATO.IITR.000031

            /*  VR.ATO.IITR.000031
            Final tax return is mandatory
    
            Legacy Rule Format:
            IF [iitr30] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR30 = NULL
    
            Data Elements:
    
            ^IITR30 = RP:Lodgment.FinalReturn.Indicator
            */
            assertion = (report.IITR30 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000031",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Final tax return must be present",
                    Location = "/xbrli:xbrl/tns:Lodgment.FinalReturn.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000031" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR30", Value = GetValueOrEmpty(report.IITR30) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000031

            #region VR.ATO.IITR.000032

            /*  VR.ATO.IITR.000032
            If requesting an amendment, the Amendment indicator, Amendment type code, Amendment Sequence Number and Reason for amendment must be completed. If not lodging an amendment, the Amendment indicator, Amendment type code, Amendment Sequence Number and Reason for amendment are not required.
    
            Legacy Rule Format:
            IF ([iitr16] = TRUE AND ([iitr17] = NULLORBLANK OR [iitr18] = NULLORBLANK OR [iitr56] = NULL)) OR ([iitr16] <> TRUE AND ([iitr17] <> NULLORBLANK OR [iitr18] <> NULLORBLANK OR [iitr56] <> NULL))
                   RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR16 = TRUE AND (^IITR17 = BLANK OR ^IITR18 = BLANK OR ^IITR56 = NULL)) OR (^IITR16 <> TRUE AND (^IITR17 <> BLANK OR ^IITR18 <> BLANK OR ^IITR56 <> NULL))
    
            Data Elements:
    
            ^IITR16 = RP:Report.Amendment.Indicator
    
            ^IITR17 = RP:Report.AmendmentType.Code
    
            ^IITR18 = RP:Report.AmendmentReason.Text
    
            ^IITR56 = RP:Report.AmendmentSequence.Number
            */
            assertion = (report.IITR16 == true && (string.IsNullOrWhiteSpace(report.IITR17) == true || string.IsNullOrWhiteSpace(report.IITR18) == true || report.IITR56 == null) || report.IITR16 != true && (string.IsNullOrWhiteSpace(report.IITR17) != true || string.IsNullOrWhiteSpace(report.IITR18) != true || report.IITR56 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000032",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"When requesting an amendment, all amendment details must be provided",
                    LongDescription = @"When requesting an amendment to the Individual Income Tax Return, the Amendment type code, Amendment Sequence Number and Reason for amendment must be completed, with the Amendment indicator set to 'yes' (true). If not lodging an amendment, the Amendment indicator, Amendment type code, Amendment Sequence Number and Reason for amendment are not required.",
                    Location = "/xbrli:xbrl/tns:Report.Amendment.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000032" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR16", Value = GetValueOrEmpty(report.IITR16) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR17", Value = GetValueOrEmpty(report.IITR17) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR18", Value = GetValueOrEmpty(report.IITR18) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR56", Value = report.IITR56.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000032

            #region VR.ATO.IITR.000033

            /*  VR.ATO.IITR.000033
            Accounting period start date must commence on or after 1st January in the previous year
    
            Legacy Rule Format:
            IF RP:Period.startDate < ConvertToDate(1,1, [iitr10]-1)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^StartDate1 < ConvertToDate(1,1, ^IITR10-1)
    
            Data Elements:
    
            ^StartDate1 = RP
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = ((report.RPExists == true) && (report.RPStartDate < ConvertToDate(1, 1, report.IITR10.GetValueOrDefault() - 1)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Date financial year from date must commence on or after 1st January in the previous year",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000033" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000033

            #region VR.ATO.IITR.000044

            /*  VR.ATO.IITR.000044
            When Family name is provided, First name must also be provided.
    
            Legacy Rule Format:
            IF ([iitr24] = NULLORBLANK) AND ([iitr22] <> NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR24 = BLANK) AND (^IITR22 <> BLANK)
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
    
            ^IITR22 = RP:PersonNameDetails.FamilyName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR24) == true && string.IsNullOrWhiteSpace(report.IITR22) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000044",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check name is complete where First name field is blank",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000044" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR22", Value = report.IITR22 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000044

            #region VR.ATO.IITR.000049

            /*  VR.ATO.IITR.000049
            Current postal address - Address line 1 has a maximum field length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr33]) > 38
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR33) > 38
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (Length(report.IITR33) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000049",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 1 must not exceed 38 characters",
                    LongDescription = @"For Current postal address - Address line 1, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000049" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000049

            #region VR.ATO.IITR.000050

            /*  VR.ATO.IITR.000050
            Current postal address - Address line 2 has a maximum field length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr34]) > 38
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR34) > 38
    
            Data Elements:
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = (Length(report.IITR34) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000050",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 2 must not exceed 38 characters",
                    LongDescription = @"For Current postal address - Address line 2, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000050" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000050

            #region VR.ATO.IITR.000051

            /*  VR.ATO.IITR.000051
            Current postal address - Suburb/Town has a maximum field length of 27
    
            Legacy Rule Format:
            IF LENGTH([iitr35]) > 27
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR35) > 27
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
            */
            assertion = (Length(report.IITR35) > 27);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000051",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Suburb/Town must not exceed 27 characters",
                    LongDescription = @"For Current postal address - Suburb/Town, the maximum allowable characters for this form is 27",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000051" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000051

            #region VR.ATO.IITR.000052

            /*  VR.ATO.IITR.000052
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
            Legacy Rule Format:
            IF ([iitr18] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr18] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR18 <> BLANK) AND (NotCharacterInSet(^IITR18, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR18 = RP:Report.AmendmentReason.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR18) != true && !(IsMatch(report.IITR18, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000052",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reason for amendment contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:Report.AmendmentReason.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000052" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR18", Value = GetValueOrEmpty(report.IITR18) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000052

            #region VR.ATO.IITR.000054

            /*  VR.ATO.IITR.000054
            Either the taxpayer's Daytime phone number or Your mobile phone number must be provided.
    
            Legacy Rule Format:
            IF ([iitr579] = NULLORBLANK OR [iitr50] = NULLORBLANK) AND ([iitr48] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR579 = BLANK OR ^IITR50 = BLANK) AND (^IITR48 = BLANK)
    
            Data Elements:
    
            ^IITR48 = RP:ElectronicContact.Telephone.Mobile.Number
    
            ^IITR579 = RP:ElectronicContact.Telephone.Country.Code
    
            ^IITR50 = RP:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = ((string.IsNullOrWhiteSpace(report.IITR579) == true || string.IsNullOrWhiteSpace(report.IITR50) == true) && string.IsNullOrWhiteSpace(report.IITR48) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001054",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check taxpayer phone contact details",
                    LongDescription = @"Neither the taxpayer's daytime phone number or mobile phone number have been provided",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Mobile.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000054" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR579", Value = GetValueOrEmpty(report.IITR579) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR50", Value = GetValueOrEmpty(report.IITR50) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR48", Value = GetValueOrEmpty(report.IITR48) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000054

            #region VR.ATO.IITR.000056

            /*  VR.ATO.IITR.000056
            The dates provided should be the 1st of the month.
    
            Legacy Rule Format:
            IF (RP:period.startDate.Day <> 1)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (Day(^StartDate1) <> 1)
    
            Data Elements:
    
            ^StartDate1 = RP
            */
            assertion = (Day(report.RPStartDate) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000056",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The period start date must be the first of the month",
                    LongDescription = @"This is an annual accounting submission. The dates provided should be for your annual accounting period, commencing on the 1st day of the month. For normal balancers, this will be the period 1 July - 30 June.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000056" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000056

            #region VR.ATO.IITR.000061

            /*  VR.ATO.IITR.000061
            Check that account name details are correct where numerics have been entered.
    
            Legacy Rule Format:
            IF [iitr55] CONTAINS SET(0-9)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR55, '0-9')
    
            Data Elements:
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = IsMatch(report.IITR55, @"[0-9]", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000061",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check account name where field contains numerics",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000061" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000061

            #region VR.ATO.IITR.000071

            /*  VR.ATO.IITR.000071
            The number of days full levy exemption and/or the number of days half levy exemption exceed accounting period.
    
            Legacy Rule Format:
            IF ([iitr172] + [iitr174]) > (RP:period.endDate - RP:period.startDate + 1)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR172 + ^IITR174) > (DaysInDuration(^EndDate - ^StartDate1) + 1)
    
            Data Elements:
    
            ^IITR172 = RP:IncomeTax.MedicareLevy.ExemptionFullDays.Count
    
            ^EndDate = RP
    
            ^StartDate1 = RP
    
            ^IITR174 = RP:IncomeTax.MedicareLevy.ExemptionHalfDays.Count
            */
            assertion = ((report.RPExists == true) && (report.IITR172.GetValueOrDefault() + report.IITR174.GetValueOrDefault() > (report.RPEndDate.GetValueOrDefault() - report.RPStartDate.GetValueOrDefault()).Days + 1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000071",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The combined days for full and half Medicare levy exemption must be within income year.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.ExemptionFullDays.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000071" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR172", Value = report.IITR172.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR174", Value = report.IITR174.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000071

            #region VR.ATO.IITR.000080

            /*  VR.ATO.IITR.000080
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr33] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr33] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR33 <> BLANK) AND (NotCharacterInSet(^IITR33, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR33) != true && !(IsMatch(report.IITR33, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000080",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Address Line 1 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000080" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000080

            #region VR.ATO.IITR.000081

            /*  VR.ATO.IITR.000081
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr34] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr34] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR34 <> BLANK) AND (NotCharacterInSet(^IITR34, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR34) != true && !(IsMatch(report.IITR34, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000081",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Address Line 2 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000081" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000081

            #region VR.ATO.IITR.000089

            /*  VR.ATO.IITR.000089
            The spouse must be between preservation age and 59 at the time they received a superannuation lump sum payment where the taxed element has a zero tax rate
    
            Legacy Rule Format:
            IF ([iitr236] > 0) AND ([iitr217] <> NULL) AND (([iitr217] > 1962-06-30) OR ([iitr217] <= ConvertToDate(1,7,[iitr10] - 61)))
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR236 > 0) AND (^IITR217 <> NULL) AND ((^IITR217 > AsDate('1962-06-30')) OR (^IITR217 <= ConvertToDate(1,7,^IITR10 - 61)))
    
            Data Elements:
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = (report.IITR236.GetValueOrDefault() > 0 && report.IITR217 != null && (report.IITR217.GetValueOrDefault() > AsDate(@"1962-06-30") || report.IITR217.GetValueOrDefault() <= ConvertToDate(1, 7, report.IITR10.GetValueOrDefault() - 61)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001089",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The spouse is not within the correct age range",
                    LongDescription = @"The spouse must be between preservation age and 59 at the time they received a superannuation lump sum payment where the taxed element has a zero tax rate",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Birth.Date[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000089" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR236", Value = GetValueOrEmpty(report.IITR236) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000089

            #region VR.ATO.IITR.000100

            /*  VR.ATO.IITR.000100
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr33] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR33, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (report.IITR33 == null ? false : report.IITR33.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 1 cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000100" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000100

            #region VR.ATO.IITR.000101

            /*  VR.ATO.IITR.000101
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr34] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR34, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR34 = RP.POS:AddressDetails.Line2.Text
            */
            assertion = (report.IITR34 == null ? false : report.IITR34.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 2 cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000101" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR34", Value = GetValueOrEmpty(report.IITR34) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000101

            #region VR.ATO.IITR.000102

            /*  VR.ATO.IITR.000102
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr35] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR35, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
            */
            assertion = (report.IITR35 == null ? false : report.IITR35.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Suburb/Town/City cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000102" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000102

            #region VR.ATO.IITR.000104

            /*  VR.ATO.IITR.000104
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr41] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR41, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR41 = RP.RES:AddressDetails.Line1.Text
            */
            assertion = (report.IITR41 == null ? false : report.IITR41.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000104",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 1 cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000104" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR41", Value = report.IITR41 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000104

            #region VR.ATO.IITR.000105

            /*  VR.ATO.IITR.000105
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr42] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR42, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR42 = RP.RES:AddressDetails.Line2.Text
            */
            assertion = (report.IITR42 == null ? false : report.IITR42.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000105",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 2 cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000105" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR42", Value = GetValueOrEmpty(report.IITR42) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000105

            #region VR.ATO.IITR.000106

            /*  VR.ATO.IITR.000106
            Unknown cannot be entered as an Address.  Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr43] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR43, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
            */
            assertion = (report.IITR43 == null ? false : report.IITR43.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000106",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Suburb/Town/City cannot contain ""UNKNOWN""",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000106" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000106

            #region VR.ATO.IITR.000108

            /*  VR.ATO.IITR.000108
            Numerics [0 to 9] are not allowed in the suburb/town field.
    
            Legacy Rule Format:
            IF (([iitr38] = NULL) OR ([iitr38] = "au")) AND ([iitr35] CONTAINS SET(0-9))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR38 = NULL) OR (^IITR38 = 'au')) AND (ContainsSet(^IITR35, '0-9'))
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
    
            ^IITR38 = RP.POS:AddressDetails.Country.Code
            */
            assertion = ((report.IITR38 == null || report.IITR38 == @"au") && IsMatch(report.IITR35, @"[0-9]", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000108",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address must not contain numeric characters when an Australian address is provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000108" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR38", Value = GetValueOrEmpty(report.IITR38) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000108

            #region VR.ATO.IITR.000109

            /*  VR.ATO.IITR.000109
            Numerics [0 to 9] are not allowed in the suburb/town field.
    
            Legacy Rule Format:
            IF (([iitr52] = NULL) OR ([iitr52] = "au")) AND ([iitr43] CONTAINS SET(0-9))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR52 = NULL) OR (^IITR52 = 'au')) AND (ContainsSet(^IITR43, '0-9'))
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
    
            ^IITR52 = RP.RES:AddressDetails.Country.Code
            */
            assertion = ((report.IITR52 == null || report.IITR52 == @"au") && IsMatch(report.IITR43, @"[0-9]", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000109",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address must not contain numeric characters when an Australian address is provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000109" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR52", Value = GetValueOrEmpty(report.IITR52) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000109

            #region VR.ATO.IITR.000110

            /*  VR.ATO.IITR.000110
            State code [QLD,NSW,VIC,SA,WA,NT,ACT,TAS] or a leading space or combination of spaces with a State code is present in the suburb/town field.
    
            Legacy Rule Format:
            IF (([iitr38] = NULL) OR ([iitr38] = "au")) AND ([iitr35] = FOUND("QLD","NSW","VIC","SA","WA","NT","ACT","TAS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR38 = NULL) OR (^IITR38 = 'au')) AND (FoundSet(^IITR35, '"QLD","NSW","VIC","SA","WA","NT","ACT","TAS"'))
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
    
            ^IITR38 = RP.POS:AddressDetails.Country.Code
            */
            assertion = ((report.IITR38 == null || report.IITR38 == @"au") && IsMatch(report.IITR35, @"(^(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$)|(^(.*)( QLD | NSW | VIC | SA | WA | NT | ACT | TAS )(.*)$)|(^(QLD |NSW |VIC |SA |WA |NT |ACT |TAS )(.*)$)|(^(.*)( QLD| NSW| VIC| SA| WA| NT| ACT| TAS)$)", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000110",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City cannot contain state code",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000110" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR38", Value = GetValueOrEmpty(report.IITR38) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000110

            #region VR.ATO.IITR.000111

            /*  VR.ATO.IITR.000111
            State code [QLD,NSW,VIC,SA,WA,NT,ACT,TAS] or a leading space or combination of spaces with a State code is present in the suburb/town field.
    
            Legacy Rule Format:
            IF (([iitr52] = NULL) OR ([iitr52] = "au")) AND ([iitr43] = FOUND("QLD","NSW","VIC","SA","WA","NT","ACT","TAS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR52 = NULL) OR (^IITR52 = 'au')) AND (FoundSet(^IITR43, '"QLD","NSW","VIC","SA","WA","NT","ACT","TAS"'))
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
    
            ^IITR52 = RP.RES:AddressDetails.Country.Code
            */
            assertion = ((report.IITR52 == null || report.IITR52 == @"au") && IsMatch(report.IITR43, @"(^(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$)|(^(.*)( QLD | NSW | VIC | SA | WA | NT | ACT | TAS )(.*)$)|(^(QLD |NSW |VIC |SA |WA |NT |ACT |TAS )(.*)$)|(^(.*)( QLD| NSW| VIC| SA| WA| NT| ACT| TAS)$)", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000111",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City cannot contain state code",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000111" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR52", Value = GetValueOrEmpty(report.IITR52) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000111

            #region VR.ATO.IITR.000112

            /*  VR.ATO.IITR.000112
            State, postcode, or country are missing from the address field.  Determine whether the address is Australian or overseas and correct accordingly.
    
            Legacy Rule Format:
            IF ([iitr36] = NULL) AND ([iitr37] = NULL) AND (([iitr38] = NULL) OR ([iitr38] = "au"))
                        RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR36 = NULL) AND (^IITR37 = NULL) AND ((^IITR38 = NULL) OR (^IITR38 = 'au'))
    
            Data Elements:
    
            ^IITR36 = RP.POS:AddressDetails.StateOrTerritory.Code
    
            ^IITR37 = RP.POS:AddressDetails.Postcode.Text
    
            ^IITR38 = RP.POS:AddressDetails.Country.Code
            */
            assertion = (report.IITR36 == null && report.IITR37 == null && (report.IITR38 == null || report.IITR38 == @"au"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000112",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address state and postcode are required for Australian addresses",
                    LongDescription = @"State, postcode, or country are required in the Current postal address field.  Determine whether the address is Australian or overseas and correct accordingly",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000112" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR36", Value = GetValueOrEmpty(report.IITR36) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR37", Value = GetValueOrEmpty(report.IITR37) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR38", Value = GetValueOrEmpty(report.IITR38) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000112

            #region VR.ATO.IITR.000113

            /*  VR.ATO.IITR.000113
            State, postcode, or country are missing from the address field.  Determine whether the address is Australian or overseas and correct accordingly.
    
            Legacy Rule Format:
            IF ([iitr44] = NULL) AND ([iitr45] = NULL) AND (([iitr52] = NULL) OR ([iitr52] = "au"))
                        RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR44 = NULL) AND (^IITR45 = NULL) AND ((^IITR52 = NULL) OR (^IITR52 = 'au'))
    
            Data Elements:
    
            ^IITR44 = RP.RES:AddressDetails.StateOrTerritory.Code
    
            ^IITR45 = RP.RES:AddressDetails.Postcode.Text
    
            ^IITR52 = RP.RES:AddressDetails.Country.Code
            */
            assertion = (report.IITR44 == null && report.IITR45 == null && (report.IITR52 == null || report.IITR52 == @"au"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000113",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address state and postcode are required for Australian addresses",
                    LongDescription = @"State, postcode, or country are required in the Home postal address field.  Determine whether the address is Australian or overseas and correct accordingly",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000113" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR44", Value = GetValueOrEmpty(report.IITR44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR45", Value = GetValueOrEmpty(report.IITR45) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR52", Value = GetValueOrEmpty(report.IITR52) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000113

            #region VR.ATO.IITR.000114

            /*  VR.ATO.IITR.000114
            State is present in the address field without a postcode.
    
            Legacy Rule Format:
            IF ([iitr36] <> NULL) AND ([iitr37] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR36 <> NULL) AND (^IITR37 = NULL)
    
            Data Elements:
    
            ^IITR36 = RP.POS:AddressDetails.StateOrTerritory.Code
    
            ^IITR37 = RP.POS:AddressDetails.Postcode.Text
            */
            assertion = (report.IITR36 != null && report.IITR37 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000114",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The postcode from the Current postal address must be present if State is present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000114" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR36", Value = GetValueOrEmpty(report.IITR36) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR37", Value = GetValueOrEmpty(report.IITR37) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000114

            #region VR.ATO.IITR.000115

            /*  VR.ATO.IITR.000115
            Country name is present with State or postcode in the address field.  Determine whether the address is Australian or overseas and correct accordingly.
    
            Legacy Rule Format:
            IF ([iitr38] <> NULL) AND ([iitr38] <> "au") AND (([iitr36] <> NULL) OR ([iitr37] <> NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR38 <> NULL) AND (^IITR38 <> 'au') AND ((^IITR36 <> NULL) OR (^IITR37 <> NULL))
    
            Data Elements:
    
            ^IITR38 = RP.POS:AddressDetails.Country.Code
    
            ^IITR36 = RP.POS:AddressDetails.StateOrTerritory.Code
    
            ^IITR37 = RP.POS:AddressDetails.Postcode.Text
            */
            assertion = (report.IITR38 != null && report.IITR38 != @"au" && (report.IITR36 != null || report.IITR37 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000115",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australia must be entered as the country where an Australian state or territory has been entered.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Country.Code[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000115" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR38", Value = GetValueOrEmpty(report.IITR38) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR36", Value = GetValueOrEmpty(report.IITR36) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR37", Value = GetValueOrEmpty(report.IITR37) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000115

            #region VR.ATO.IITR.000116

            /*  VR.ATO.IITR.000116
            Country name is present with State or postcode in the address field.  Determine whether the address is Australian or overseas and correct accordingly.
    
            Legacy Rule Format:
            IF (([iitr44] <> NULL) OR ([iitr45] <> NULL)) AND (([iitr52] <> NULL) AND ([iitr52] <> "au"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR44 <> NULL) OR (^IITR45 <> NULL)) AND ((^IITR52 <> NULL) AND (^IITR52 <> 'au'))
    
            Data Elements:
    
            ^IITR52 = RP.RES:AddressDetails.Country.Code
    
            ^IITR44 = RP.RES:AddressDetails.StateOrTerritory.Code
    
            ^IITR45 = RP.RES:AddressDetails.Postcode.Text
            */
            assertion = ((report.IITR44 != null || report.IITR45 != null) && (report.IITR52 != null && report.IITR52 != @"au"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000116",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"State and postcode must not be present for non-Australian addresses",
                    LongDescription = @"Country name is present with State or Postcode in the Home address field.  Determine whether the address is Australian or overseas and correct accordingly",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Country.Code[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000116" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR44", Value = GetValueOrEmpty(report.IITR44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR45", Value = GetValueOrEmpty(report.IITR45) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR52", Value = GetValueOrEmpty(report.IITR52) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000116

            #region VR.ATO.IITR.000117

            /*  VR.ATO.IITR.000117
            Postcode is present in the address field without a State code.
    
            Legacy Rule Format:
            IF ([iitr37] <> NULLORBLANK) AND ([iitr36] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR37 <> BLANK) AND (^IITR36 = BLANK)
    
            Data Elements:
    
            ^IITR36 = RP.POS:AddressDetails.StateOrTerritory.Code
    
            ^IITR37 = RP.POS:AddressDetails.Postcode.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR37) != true && string.IsNullOrWhiteSpace(report.IITR36) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000117",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - State must be present if Postcode is present",
                    LongDescription = @"If the Current postal address is an Australian address, then state and postcode must be present. If the address is an overseas address, then country must be present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000117" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR37", Value = GetValueOrEmpty(report.IITR37) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR36", Value = GetValueOrEmpty(report.IITR36) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000117

            #region VR.ATO.IITR.000118

            /*  VR.ATO.IITR.000118
            Postcode is present in the address field without a State code.
    
            Legacy Rule Format:
            IF ([iitr45] <> NULLORBLANK) AND ([iitr44] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR45 <> BLANK) AND (^IITR44 = BLANK)
    
            Data Elements:
    
            ^IITR44 = RP.RES:AddressDetails.StateOrTerritory.Code
    
            ^IITR45 = RP.RES:AddressDetails.Postcode.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR45) != true && string.IsNullOrWhiteSpace(report.IITR44) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000118",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - State must be present if Postcode is present",
                    LongDescription = @"If the Home address is an Australian address, then state and postcode must be present. If the address is an overseas address, then country must be present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000118" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR45", Value = GetValueOrEmpty(report.IITR45) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR44", Value = GetValueOrEmpty(report.IITR44) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000118

            #region VR.ATO.IITR.000121

            /*  VR.ATO.IITR.000121
            Daytime phone area code is present without daytime phone number.
    
            Legacy Rule Format:
            IF ([iitr50] = NULLORBLANK) AND ([iitr579] <> NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR50 = BLANK) AND (^IITR579 <> BLANK)
    
            Data Elements:
    
            ^IITR579 = RP:ElectronicContact.Telephone.Country.Code
    
            ^IITR50 = RP:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR50) == true && string.IsNullOrWhiteSpace(report.IITR579) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000121",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Telephone number is required, if an area code is provided",
                    LongDescription = @"Daytime phone number is required when daytime phone area code is provided",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000121" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR50", Value = GetValueOrEmpty(report.IITR50) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR579", Value = GetValueOrEmpty(report.IITR579) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000121

            #region VR.ATO.IITR.000122

            /*  VR.ATO.IITR.000122
            State is present in the address field without a postcode.
    
            Legacy Rule Format:
            IF ([iitr44] <> NULL) AND ([iitr45] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR44 <> NULL) AND (^IITR45 = NULL)
    
            Data Elements:
    
            ^IITR44 = RP.RES:AddressDetails.StateOrTerritory.Code
    
            ^IITR45 = RP.RES:AddressDetails.Postcode.Text
            */
            assertion = (report.IITR44 != null && report.IITR45 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000122",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The postcode from the Home address must be present if State is present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000122" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR44", Value = GetValueOrEmpty(report.IITR44) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR45", Value = GetValueOrEmpty(report.IITR45) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000122

            #region VR.ATO.IITR.000123

            /*  VR.ATO.IITR.000123
            Information has been provided at BSB number, or account number, or account name, however, not all of the information is present.  Check BSB number, account number, and account name and input the missing information.
    
            Legacy Rule Format:
            IF ([iitr53] <> NULL OR [iitr54] <> NULLORBLANK OR [iitr55] <> NULLORBLANK) AND ([iitr53] = NULL OR [iitr54] = NULLORBLANK OR [iitr55] = NULLORBLANK)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR53 <> NULL OR ^IITR54 <> BLANK OR ^IITR55 <> BLANK) AND (^IITR53 = NULL OR ^IITR54 = BLANK OR ^IITR55 = BLANK)
    
            Data Elements:
    
            ^IITR53 = RP:FinancialInstitutionAccount.BankStateBranch.Number
    
            ^IITR54 = RP:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = ((report.IITR53 != null || string.IsNullOrWhiteSpace(report.IITR54) != true || string.IsNullOrWhiteSpace(report.IITR55) != true) && (report.IITR53 == null || string.IsNullOrWhiteSpace(report.IITR54) == true || string.IsNullOrWhiteSpace(report.IITR55) == true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000123",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Where either BSB number, account number or account name is provided, all must be present",
                    LongDescription = @"Financial institution details are needed for the Tax office to pay any refund owing the taxpayer. All details must be provided, even if provided in the past.",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.BankStateBranch.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000123" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR53", Value = GetValueOrEmpty(report.IITR53) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR54", Value = GetValueOrEmpty(report.IITR54) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000123

            #region VR.ATO.IITR.000125

            /*  VR.ATO.IITR.000125
            The email address starts with an @ symbol, or ends with an @ symbol, or contains more than one @ symbol. Email addresses must be in the format 'name@domain.sub-domain'.
    
            Legacy Rule Format:
            IF (([iitr51] STARTS WITH "@") OR ([iitr51] ENDS WITH "@") OR ([iitr51] CONTAINS MORE THAN ONE "@"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((StartsWith(^IITR51, '@')) OR (EndsWith(^IITR51, '@')) OR (ContainsMultiple(^IITR51, '@')))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (IsMatch(report.IITR51, @"^(@)", RegexOptions.IgnoreCase) || IsMatch(report.IITR51, @"(@)$", RegexOptions.IgnoreCase) || IsMatch(report.IITR51, @"@(.*)@", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000125",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid @ symbol in email address",
                    LongDescription = @"The email address starts with an @ symbol, or ends with an @ symbol, or contains more than one @ symbol. Email addresses must be in the format 'name@domain.sub-domain'",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000125" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000125

            #region VR.ATO.IITR.000128

            /*  VR.ATO.IITR.000128
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr37] <> NULLORBLANK) AND ([iitr37] < 0200 OR [iitr37] > 9999)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR37 <> BLANK) AND (^IITR37 < 0200 OR ^IITR37 > 9999)
    
            Data Elements:
    
            ^IITR37 = RP.POS:AddressDetails.Postcode.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR37) != true && (AsNumeric(report.IITR37) < 200 || AsNumeric(report.IITR37) > 9999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000128",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"For an Australian address, Current postal address - Postcode is invalid. Valid range is 0200 - 9999.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Postcode.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000128" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR37", Value = GetValueOrEmpty(report.IITR37) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000128

            #region VR.ATO.IITR.000129

            /*  VR.ATO.IITR.000129
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr45] <> NULLORBLANK) AND ([iitr45] < 0200 OR [iitr45] > 9999)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR45 <> BLANK) AND (^IITR45 < 0200 OR ^IITR45 > 9999)
    
            Data Elements:
    
            ^IITR45 = RP.RES:AddressDetails.Postcode.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR45) != true && (AsNumeric(report.IITR45) < 200 || AsNumeric(report.IITR45) > 9999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000129",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"For an Australian address, Home address - Postcode is invalid. Valid range is 0200 - 9999.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Postcode.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000129" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR45", Value = GetValueOrEmpty(report.IITR45) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000129

            #region VR.ATO.IITR.000132

            /*  VR.ATO.IITR.000132
            The Bank/State/Branch number is present and it is either less than six characters in length or the number is less than 012000 or greater than 999999
    
            Legacy Rule Format:
            IF [iitr53] <> NULLORBLANK AND ([iitr53] < 012000 OR [iitr53] > 999999)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR53 <> BLANK AND (^IITR53 < 012000 OR ^IITR53 > 999999)
    
            Data Elements:
    
            ^IITR53 = RP:FinancialInstitutionAccount.BankStateBranch.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR53) != true && (AsNumeric(report.IITR53) < 12000 || AsNumeric(report.IITR53) > 999999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000132",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Bank/State/Branch number invalid. Valid range is 012000 - 999999.",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.BankStateBranch.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000132" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR53", Value = GetValueOrEmpty(report.IITR53) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000132

            #region VR.ATO.IITR.000133

            /*  VR.ATO.IITR.000133
            The email address starts with a dot, or ends with a dot, or contains adjacent dots. Email addresses must be in the format 'name@domain.sub-domain'.
    
            Legacy Rule Format:
            IF (([iitr51] CONTAINS "..")  OR ([iitr51] STARTS WITH ".") OR ([iitr51] ENDS WITH "."))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (Contains(^IITR51, '..')  OR (StartsWith(^IITR51, '.')) OR (EndsWith(^IITR51,'.')))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = ((report.IITR51 == null ? false : report.IITR51.ToUpperInvariant().Contains(@"..")) || IsMatch(report.IITR51, @"^(\.)", RegexOptions.IgnoreCase) || IsMatch(report.IITR51, @"(\.)$", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000133",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid dot in email address",
                    LongDescription = @"The email address starts with a dot, or ends with a dot, or contains adjacent dots. Email addresses must be in the format 'name@domain.sub-domain'",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000133" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000133

            #region VR.ATO.IITR.000134

            /*  VR.ATO.IITR.000134
            The email address field has a dot character adjacent to an @ symbol. Email addresses must be in the format 'name@domain.sub-domain'.
    
            Legacy Rule Format:
            IF ([iitr51] CONTAINS ".@") OR ([iitr51] CONTAINS "@.")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (Contains(^IITR51, '.@') OR Contains(^IITR51,'@.'))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = ((report.IITR51 == null ? false : report.IITR51.ToUpperInvariant().Contains(@".@")) || (report.IITR51 == null ? false : report.IITR51.ToUpperInvariant().Contains(@"@.")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000134",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid dot and @ symbol in email address",
                    LongDescription = @"The email address field has a dot character adjacent to an @ symbol. Email addresses must be in the format 'name@domain.sub-domain'",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000134" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000134

            #region VR.ATO.IITR.000135

            /*  VR.ATO.IITR.000135
            Reason for amendment has a maximum field length of 3000
    
            Legacy Rule Format:
            IF LENGTH([iitr18]) > 3000
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR18) > 3000
    
            Data Elements:
    
            ^IITR18 = RP:Report.AmendmentReason.Text
            */
            assertion = (Length(report.IITR18) > 3000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000135",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reason for amendment must not exceed 3000 characters",
                    LongDescription = @"For Reason for amendment, the maximum allowable characters for this form is 3000",
                    Location = "/xbrli:xbrl/tns:Report.AmendmentReason.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000135" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR18", Value = GetValueOrEmpty(report.IITR18) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000135

            #region VR.ATO.IITR.000137

            /*  VR.ATO.IITR.000137
            Daytime phone number is present without daytime phone area code.
    
            Legacy Rule Format:
            IF ([iitr50] <> NULLORBLANK) AND ([iitr579] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR50 <> BLANK) AND (^IITR579 = BLANK)
    
            Data Elements:
    
            ^IITR579 = RP:ElectronicContact.Telephone.Country.Code
    
            ^IITR50 = RP:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR50) != true && string.IsNullOrWhiteSpace(report.IITR579) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000137",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Area code is required, if a Telephone number is provided",
                    LongDescription = @"Daytime phone area code is required when a Daytime phone number is provided",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000137" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR50", Value = GetValueOrEmpty(report.IITR50) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR579", Value = GetValueOrEmpty(report.IITR579) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000137

            #region VR.ATO.IITR.000139

            /*  VR.ATO.IITR.000139
            Your Australian mobile phone number should start with 04 and followed by 8 numeric characters.
    
            Legacy Rule Format:
            IF (([iitr48] <> NULLORBLANK) AND NOT ([iitr48] STARTSWITH "04"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR48 <> BLANK) AND NOT (StartsWith(^IITR48, '04')))
    
            Data Elements:
    
            ^IITR48 = RP:ElectronicContact.Telephone.Mobile.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR48) != true && !(IsMatch(report.IITR48, @"^(04)", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000139",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your mobile phone number is incorrect",
                    LongDescription = @"Your Australian mobile phone number should start with 04 and followed by 8 numeric characters",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Mobile.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000139" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR48", Value = GetValueOrEmpty(report.IITR48) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000139

            #region VR.ATO.IITR.000140

            /*  VR.ATO.IITR.000140
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr36] <> NULLORBLANK) AND ([iitr36] <> SET("QLD","NSW","VIC","SA","WA","NT","ACT","TAS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR36 <> BLANK) AND (NotInSet(^IITR36, '"QLD","NSW","VIC","SA","WA","NT","ACT","TAS"'))
    
            Data Elements:
    
            ^IITR36 = RP.POS:AddressDetails.StateOrTerritory.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR36) != true && !(IsMatch(report.IITR36, @"^(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000140",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid State code",
                    LongDescription = @"The State code in the Current postal address is not Valid (Valid States are ""QLD"",""NSW"",""VIC"",""SA"",""WA"",""NT"",""ACT"",""TAS"")",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000140" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR36", Value = GetValueOrEmpty(report.IITR36) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000140

            #region VR.ATO.IITR.000141

            /*  VR.ATO.IITR.000141
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr44] <> NULLORBLANK) AND ([iitr44] <> SET("QLD","NSW","VIC","SA","WA","NT","ACT","TAS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR44 <> BLANK) AND (NotInSet(^IITR44, '"QLD","NSW","VIC","SA","WA","NT","ACT","TAS"'))
    
            Data Elements:
    
            ^IITR44 = RP.RES:AddressDetails.StateOrTerritory.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR44) != true && !(IsMatch(report.IITR44, @"^(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000141",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid State code",
                    LongDescription = @"The State code in the Home address is not Valid (Valid States are ""QLD"",""NSW"",""VIC"",""SA"",""WA"",""NT"",""ACT"",""TAS"")",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000141" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR44", Value = GetValueOrEmpty(report.IITR44) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000141

            #region VR.ATO.IITR.000145

            /*  VR.ATO.IITR.000145
            Home address - Address line 1 has a maximum field length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr41]) > 38
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR41) > 38
    
            Data Elements:
    
            ^IITR41 = RP.RES:AddressDetails.Line1.Text
            */
            assertion = (Length(report.IITR41) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000145",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 1 must not exceed 38 characters",
                    LongDescription = @"For Home address - Address line 1, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000145" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR41", Value = report.IITR41 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000145

            #region VR.ATO.IITR.000146

            /*  VR.ATO.IITR.000146
            Home address - Address line 2 has a maximum field length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr42]) > 38
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR42) > 38
    
            Data Elements:
    
            ^IITR42 = RP.RES:AddressDetails.Line2.Text
            */
            assertion = (Length(report.IITR42) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000146",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 2 must not exceed 38 characters",
                    LongDescription = @"For Home address - Address line 2, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000146" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR42", Value = GetValueOrEmpty(report.IITR42) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000146

            #region VR.ATO.IITR.000147

            /*  VR.ATO.IITR.000147
            Home address - Suburb/Town has a maximum field length of 27
    
            Legacy Rule Format:
            IF LENGTH([iitr43]) > 27
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR43) > 27
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
            */
            assertion = (Length(report.IITR43) > 27);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000147",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Suburb/Town must not exceed 27 characters",
                    LongDescription = @"For Home address - Suburb/Town, the maximum allowable characters for this form is 27",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000147" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000147

            #region VR.ATO.IITR.000151

            /*  VR.ATO.IITR.000151
            Your mobile phone number has a maximum field length of 10
    
            Legacy Rule Format:
            IF LENGTH([iitr48]) > 10
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR48) > 10
    
            Data Elements:
    
            ^IITR48 = RP:ElectronicContact.Telephone.Mobile.Number
            */
            assertion = (Length(report.IITR48) > 10);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000151",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your mobile phone number must not exceed 10 characters",
                    LongDescription = @"For Your mobile phone number, the maximum allowable characters for this form is 10",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Mobile.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000151" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR48", Value = GetValueOrEmpty(report.IITR48) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000151

            #region VR.ATO.IITR.000153

            /*  VR.ATO.IITR.000153
            Daytime phone number has a maximum field length of 15
    
            Legacy Rule Format:
            IF LENGTH([iitr50]) > 15
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR50) > 15
    
            Data Elements:
    
            ^IITR50 = RP:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (Length(report.IITR50) > 15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000153",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Daytime phone number must not exceed 15 characters",
                    LongDescription = @"For Daytime phone number, the maximum allowable characters for this form is 15",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Minimal.Number[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000153" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR50", Value = GetValueOrEmpty(report.IITR50) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000153

            #region VR.ATO.IITR.000154

            /*  VR.ATO.IITR.000154
            Contact E-mail address has a maximum field length of 76
    
            Legacy Rule Format:
            IF LENGTH([iitr51]) > 76
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR51) > 76
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (Length(report.IITR51) > 76);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000154",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Contact E-mail address must not exceed 76 characters",
                    LongDescription = @"For Contact E-mail address, the maximum allowable characters for this form is 76",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000154" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000154

            #region VR.ATO.IITR.000156

            /*  VR.ATO.IITR.000156
            Account number has a maximum field length of 9
    
            Legacy Rule Format:
            IF LENGTH([iitr54]) > 9
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR54) > 9
    
            Data Elements:
    
            ^IITR54 = RP:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
            */
            assertion = (Length(report.IITR54) > 9);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000156",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Account number must not exceed 9 characters",
                    LongDescription = @"For Account number, the maximum allowable characters for this form is 9",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccount.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000156" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR54", Value = GetValueOrEmpty(report.IITR54) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000156

            #region VR.ATO.IITR.000159

            /*  VR.ATO.IITR.000159
            Spouse's Customer reference number has a maximum field length of 10
    
            Legacy Rule Format:
            IF LENGTH([iitr533]) > 10
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR533) > 10
    
            Data Elements:
    
            ^IITR533 = RP.SPOUSE:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier
            */
            assertion = (Length(report.IITR533) > 10);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000159",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's Customer reference number must not exceed 10 characters",
                    LongDescription = @"For Spouse's Customer reference number, the maximum allowable characters for this form is 10",
                    Location = "/xbrli:xbrl/tns:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000159" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR533", Value = GetValueOrEmpty(report.IITR533) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000159

            #region VR.ATO.IITR.000160

            /*  VR.ATO.IITR.000160
            Client's reference has a maximum field length of 12
    
            Legacy Rule Format:
            IF LENGTH([iitr536]) > 12
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR536) > 12
    
            Data Elements:
    
            ^IITR536 = INT.TrueAndCorrect:Identifiers.TaxAgentClientReference.Text
            */
            assertion = (Length(report.IITR536) > 12);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001160",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Client's reference must not exceed 12 characters",
                    LongDescription = @"For Client's reference, the maximum allowable characters for this form is 12",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxAgentClientReference.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000160" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR536", Value = GetValueOrEmpty(report.IITR536) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000160

            #region VR.ATO.IITR.000162

            /*  VR.ATO.IITR.000162
            Home address - Address line 1 is mandatory
    
            Legacy Rule Format:
            IF [iitr41] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR41 = BLANK
    
            Data Elements:
    
            ^IITR41 = RP.RES:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR41) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000162",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 1 must be provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000162" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR41", Value = report.IITR41 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000162

            #region VR.ATO.IITR.000163

            /*  VR.ATO.IITR.000163
            Home address - Suburb/Town is mandatory
    
            Legacy Rule Format:
            IF [iitr43] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR43 = BLANK
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR43) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000163",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Suburb/Town must be provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000163" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000163

            #region VR.ATO.IITR.000164

            /*  VR.ATO.IITR.000164
            Numeric field, values nnn where n is a digit 0 to 9 only to be used.
    
            Legacy Rule Format:
            IF ([iitr48] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr48] <> SET(0-9))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR48 <> BLANK) AND (NotCharacterInSet(^IITR48, '0-9'))
    
            Data Elements:
    
            ^IITR48 = RP:ElectronicContact.Telephone.Mobile.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR48) != true && !(IsMatch(report.IITR48, @"^[0-9]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000164",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your mobile phone number must be numeric",
                    LongDescription = @"Your mobile number must be a numeric field, values nnn where n is a digit 0 to 9 only to be used.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Mobile.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000164" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR48", Value = GetValueOrEmpty(report.IITR48) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000164

            #region VR.ATO.IITR.000168

            /*  VR.ATO.IITR.000168
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr41] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr41] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR41 <> BLANK) AND (NotCharacterInSet(^IITR41, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR41 = RP.RES:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR41) != true && !(IsMatch(report.IITR41, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000168",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 1 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000168" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR41", Value = report.IITR41 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000168

            #region VR.ATO.IITR.000169

            /*  VR.ATO.IITR.000169
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr42] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr42] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR42 <> BLANK) AND (NotCharacterInSet(^IITR42, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR42 = RP.RES:AddressDetails.Line2.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR42) != true && !(IsMatch(report.IITR42, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000169",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Address line 2 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000169" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR42", Value = GetValueOrEmpty(report.IITR42) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000169

            #region VR.ATO.IITR.000170

            /*  VR.ATO.IITR.000170
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr43] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr43] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR43 <> BLANK) AND (NotCharacterInSet(^IITR43, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR43 = RP.RES:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR43) != true && !(IsMatch(report.IITR43, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000170",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Home address - Suburb/Town contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPRESId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000170" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR43", Value = report.IITR43 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000170

            #region VR.ATO.IITR.000178

            /*  VR.ATO.IITR.000178
            A text character must be one of the following: A to Z a to z 0 to 9 & * ( ) - ' , . / or a space character.
    
            Legacy Rule Format:
            IF ([iitr55] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr55] <> SET("a-z","A-Z","0-9","&","*","(",")","-","'",",",".","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR55 <> BLANK) AND (NotCharacterInSet(^IITR55, '"a-z","A-Z","0-9","&","*","(",")","-","'",",",".","/"," "'))
    
            Data Elements:
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR55) != true && !(IsMatch(report.IITR55, @"^[a-zA-Z0-9&\*\(\)\-',\./ ]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000178",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Account name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 & * ( ) - ' , . / or a space character.",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000178" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000178

            #region VR.ATO.IITR.000185

            /*  VR.ATO.IITR.000185
            The account name is preceded by a space, or contains only a space. Remove all leading spaces.
    
            Legacy Rule Format:
            IF ([iitr55] STARTSWITH " ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            StartsWith(^IITR55, ' ')
    
            Data Elements:
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = IsMatch(report.IITR55, @"^( )", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000185",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Account name contains a leading space",
                    LongDescription = @"The account name is preceded by a space, or contains only a space. Remove all leading spaces",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000185" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000185

            #region VR.ATO.IITR.000187

            /*  VR.ATO.IITR.000187
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr35] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr35] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR35 <> BLANK) AND (NotCharacterInSet(^IITR35, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR35) != true && !(IsMatch(report.IITR35, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000187",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000187" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000187

            #region VR.ATO.IITR.000188

            /*  VR.ATO.IITR.000188
            Additional Information has a maximum field length of 3000
    
            Legacy Rule Format:
            IF LENGTH([iitr31]) > 3000
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR31) > 3000
    
            Data Elements:
    
            ^IITR31 = RP:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text
            */
            assertion = (Length(report.IITR31) > 3000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000188",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Additional Information must not exceed 3000 characters",
                    LongDescription = @"Additional Information, the maximum allowable characters for this form is 3000",
                    Location = "/xbrli:xbrl/tns:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000188" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR31", Value = GetValueOrEmpty(report.IITR31) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000188

            #region VR.ATO.IITR.000190

            /*  VR.ATO.IITR.000190
            Declaration Signatory identifier text must be present
    
            Legacy Rule Format:
            IF (CONTEXT(INT.TrueAndCorrect) <> NULL) AND ([iitr545] = NULLORBLANK)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^Context <> NULL) AND (^IITR545 = BLANK)
    
            Data Elements:
    
            ^IITR545 = INT.TrueAndCorrect:Declaration.SignatoryIdentifier.Text
    
            ^Context = INT.TrueAndCorrect
            */
            assertion = (report.INTTrueAndCorrectExists != false && string.IsNullOrWhiteSpace(report.IITR545) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000190",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration Signatory identifier text must be present",
                    Location = "/xbrli:xbrl/tns:Declaration.SignatoryIdentifier.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000190" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR545", Value = report.IITR545 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000190

            #region VR.ATO.IITR.000198

            /*  VR.ATO.IITR.000198
            Locality name is mandatory
    
            Legacy Rule Format:
            IF [iitr35] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR35 = BLANK
    
            Data Elements:
    
            ^IITR35 = RP.POS:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR35) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000198",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Locality name must be present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000198" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR35", Value = report.IITR35 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000198

            #region VR.ATO.IITR.000199

            /*  VR.ATO.IITR.000199
            Current postal address - Address line 1 is mandatory
    
            Legacy Rule Format:
            IF [iitr33] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR33 = BLANK
    
            Data Elements:
    
            ^IITR33 = RP.POS:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR33) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000199",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Current postal address - Address line 1 must be present",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPPOSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000199" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR33", Value = report.IITR33 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000199

            #region VR.ATO.IITR.000200

            /*  VR.ATO.IITR.000200
            TFN amounts deducted on interest are greater than or equal to 50% of gross interest.
    
            Legacy Rule Format:
            IF ([iitr116] > 0) AND ([iitr116] >= ([iitr115]*0.5))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR116 > 0) AND (^IITR116 >= (^IITR115*0.5))
    
            Data Elements:
    
            ^IITR116 = RP:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount
    
            ^IITR115 = RP:Income.Interest.Gross.Amount
            */
            assertion = (report.IITR116.GetValueOrDefault() > 0 && report.IITR116.GetValueOrDefault() >= report.IITR115.GetValueOrDefault() * 0.5M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000200",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"TFN amounts withheld from gross interest is incorrect",
                    LongDescription = @"TFN amounts deducted on interest are greater than or equal to 50% of gross interest",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000200" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR116", Value = GetValueOrEmpty(report.IITR116) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR115", Value = GetValueOrEmpty(report.IITR115) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000200

            #region VR.ATO.IITR.000201

            /*  VR.ATO.IITR.000201
            TFN amounts withheld from dividends is greater than 50% of the unfranked amount.
    
            Legacy Rule Format:
            IF ([iitr121] > 0) AND ((([iitr118] *0.5) + 1) < [iitr121])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR121 > 0) AND (((^IITR118 *0.5) + 1) < ^IITR121)
    
            Data Elements:
    
            ^IITR121 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount
    
            ^IITR118 = RP:Income.DividendsUnfranked.Amount
            */
            assertion = (report.IITR121.GetValueOrDefault() > 0 && report.IITR118.GetValueOrDefault() * 0.5M + 1 < report.IITR121.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000201",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"TFN amounts withheld from dividends must be less than 50% of the unfranked amount.",
                    LongDescription = @"If no TFN was provided, the amounts withheld from dividends cannot be greater than 50% of the unfranked amount.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000201" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR121", Value = GetValueOrEmpty(report.IITR121) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000201

            #region VR.ATO.IITR.000202

            /*  VR.ATO.IITR.000202
            Tax withheld from attributed personal services income is greater than 50% of Attributed personal services income
    
            Legacy Rule Format:
            IF ([iitr111] > 0) AND ([iitr111] > ([iitr112] * 0.5))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR111 > 0) AND (^IITR111 > (^IITR112 * 0.5))
    
            Data Elements:
    
            ^IITR111 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount
    
            ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
            */
            assertion = (report.IITR111.GetValueOrDefault() > 0 && report.IITR111.GetValueOrDefault() > report.IITR112.GetValueOrDefault() * 0.5M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000202",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld from attributed PSI incorrect",
                    LongDescription = @"Tax withheld from attributed personal services income is greater than 50% of Attributed personal services income",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000202" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR111", Value = GetValueOrEmpty(report.IITR111) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000202

            #region VR.ATO.IITR.000203

            /*  VR.ATO.IITR.000203
            Other deductions relating to amounts shown type has been completed without an amount at Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts.  When the deduction amount includes any deferred non-commercial business losses from a prior year, the code must be given to describe the business loss.
    
            Legacy Rule Format:
            IF ([iitr246] = NULL OR [iitr246] = 0) AND ([iitr247] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR246 = NULL OR ^IITR246 = 0) AND (^IITR247 <> NULL)
    
            Data Elements:
    
            ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
    
            ^IITR247 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Code
            */
            assertion = ((report.IITR246 == null || report.IITR246 == 0) && report.IITR247 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000203",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other deductions relating to amounts shown type is invalid",
                    LongDescription = @"Other deductions relating to amounts shown type has been completed without an amount at Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts.  When the deduction amount includes any deferred non-commercial business losses from a prior year, the code must be given to describe the business loss.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000203" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR247", Value = GetValueOrEmpty(report.IITR247) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000203

            #region VR.ATO.IITR.000204

            /*  VR.ATO.IITR.000204
            Tax withheld for personal services cannot be present without personal services income present.
    
            Legacy Rule Format:
            IF ([iitr111] > 0) AND ([iitr112] = NULL OR [iitr112] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR111 > 0) AND (^IITR112 = NULL OR ^IITR112 = 0)
    
            Data Elements:
    
            ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
    
            ^IITR111 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncome.Amount
            */
            assertion = (report.IITR111.GetValueOrDefault() > 0 && (report.IITR112 == null || report.IITR112 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000204",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Attributed personal services income is incorrect",
                    LongDescription = @"When an amount above zero is provided for 'Tax withheld from attributed personal services income', an amount above zero for 'Attributed personal services income' is required",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000204" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR111", Value = GetValueOrEmpty(report.IITR111) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000204

            #region VR.ATO.IITR.000207

            /*  VR.ATO.IITR.000207
            Where Discount from taxed upfront schemes - eligible for reduction is greater than $1,000 the Total Assessable discount amount must be present.
    
            Legacy Rule Format:
            IF ([iitr123] > 1000) AND ([iitr127] = NULL OR [iitr127] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR123 > 1000) AND (^IITR127 = NULL OR ^IITR127 = 0)
    
            Data Elements:
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
            ^IITR123 = RP:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
            */
            assertion = (report.IITR123.GetValueOrDefault() > 1000 && (report.IITR127 == null || report.IITR127 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000207",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total Assessable discount amount is required",
                    LongDescription = @"Where Discount from taxed upfront schemes - eligible for reduction is greater than $1,000 the Total Assessable discount amount must be present",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DiscountAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000207" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR123", Value = GetValueOrEmpty(report.IITR123) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000207

            #region VR.ATO.IITR.000208

            /*  VR.ATO.IITR.000208
            Where the Total Assessable discount amount is present, there must be an amount in one of the following labels: Discount from taxed upfront schemes - eligible for reduction, Discount from taxed upfront schemes - not eligible for reduction, Discount from deferral schemes, or Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year.
    
            Legacy Rule Format:
            IF ([iitr127] > 0) AND ([iitr123] = NULL OR [iitr123] = 0) AND ([iitr124] = NULL OR [iitr124] = 0) AND ([iitr125] = NULL OR [iitr125] = 0) AND ([iitr126] = NULL OR [iitr126] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR127 > 0) AND (^IITR123 = NULL OR ^IITR123 = 0) AND (^IITR124 = NULL OR ^IITR124 = 0) AND (^IITR125 = NULL OR ^IITR125 = 0) AND (^IITR126 = NULL OR ^IITR126 = 0)
    
            Data Elements:
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
            ^IITR123 = RP:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
    
            ^IITR124 = RP:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount
    
            ^IITR125 = RP:Income.EmployeeShareScheme.DeferralDiscount.Amount
    
            ^IITR126 = RP:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount
            */
            assertion = (report.IITR127.GetValueOrDefault() > 0 && (report.IITR123 == null || report.IITR123 == 0) && (report.IITR124 == null || report.IITR124 == 0) && (report.IITR125 == null || report.IITR125 == 0) && (report.IITR126 == null || report.IITR126 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000208",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A Discount amount is required",
                    LongDescription = @"Where the Total Assessable discount amount is present, there must be an amount in one of the following labels: Discount from taxed upfront schemes - eligible for reduction, Discount from taxed upfront schemes - not eligible for reduction, Discount from deferral schemes, or Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DiscountAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000208" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR123", Value = GetValueOrEmpty(report.IITR123) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR124", Value = GetValueOrEmpty(report.IITR124) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR125", Value = GetValueOrEmpty(report.IITR125) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR126", Value = GetValueOrEmpty(report.IITR126) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000208

            #region VR.ATO.IITR.000209

            /*  VR.ATO.IITR.000209
            Where there is no value present for Discount from taxed upfront schemes - eligible for reduction, the Total Assessable discount amount must equal the sum of Discount from taxed upfront schemes - not eligible for reduction, Discount from deferral schemes, and Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year.
    
            Legacy Rule Format:
            IF ([iitr123] = NULL OR [iitr123] = 0) AND
            (([iitr127] <> NULL AND ([iitr124] + [iitr125] + [iitr126]) <> [iitr127])
               OR ([iitr127] = NULL AND ([iitr124] + [iitr125] + [iitr126]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR123 = NULL OR ^IITR123 = 0) AND ((^IITR127 <> NULL AND (^IITR124 + ^IITR125 + ^IITR126) <> ^IITR127)   OR (^IITR127 = NULL AND (^IITR124 + ^IITR125 + ^IITR126) <> 0))
    
            Data Elements:
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
            ^IITR123 = RP:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
    
            ^IITR124 = RP:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount
    
            ^IITR125 = RP:Income.EmployeeShareScheme.DeferralDiscount.Amount
    
            ^IITR126 = RP:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount
            */
            assertion = ((report.IITR123 == null || report.IITR123 == 0) && (report.IITR127 != null && report.IITR124.GetValueOrDefault() + report.IITR125.GetValueOrDefault() + report.IITR126.GetValueOrDefault() != report.IITR127.GetValueOrDefault() || report.IITR127 == null && report.IITR124.GetValueOrDefault() + report.IITR125.GetValueOrDefault() + report.IITR126.GetValueOrDefault() != 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000209",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"ESS total assessable discount amount must be less than sum of all other ESS discount amounts.",
                    LongDescription = @"Employee share scheme (ESS) total assessable discount amount must be less than the sum of Discount from taxed upfront schemes - eligible for reduction, Discount from taxed upfront schemes - not eligible for reduction, Discount from deferral schemes and Assessable discount on shares acquired pre 1 July 2009- 'cessation time' occurred in 2009-10.",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DiscountAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000209" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR123", Value = GetValueOrEmpty(report.IITR123) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR124", Value = GetValueOrEmpty(report.IITR124) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR125", Value = GetValueOrEmpty(report.IITR125) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR126", Value = GetValueOrEmpty(report.IITR126) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000209

            #region VR.ATO.IITR.000210

            /*  VR.ATO.IITR.000210
            Foreign source discounts cannot be greater than the Total Assessable discount amount
    
            Legacy Rule Format:
            IF ([iitr127] <> NULL AND [iitr129] > [iitr127])
            OR ([iitr127] = NULL AND [iitr129] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR127 <> NULL AND ^IITR129 > ^IITR127) OR (^IITR127 = NULL AND ^IITR129 > 0)
    
            Data Elements:
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
            ^IITR129 = RP:Income.EmployeeShareScheme.ForeignSourceDiscount.Amount
            */
            assertion = (report.IITR127 != null && report.IITR129.GetValueOrDefault() > report.IITR127.GetValueOrDefault() || report.IITR127 == null && report.IITR129.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000210",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Employee share scheme foreign source discounts must be less than total assessable discount amount.",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DiscountAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000210" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR129", Value = GetValueOrEmpty(report.IITR129) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000210

            #region VR.ATO.IITR.000211

            /*  VR.ATO.IITR.000211
            Either Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts or Landcare operations and deduction for decline in value of water facility is present and an amount of Distribution from partnerships or Share of net income from trusts is required
    
            Legacy Rule Format:
            IF ([iitr246] > 0 OR [iitr245] > 0) AND ([iitr242] = NULL AND [iitr243] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR246 > 0 OR ^IITR245 > 0) AND (^IITR242 = NULL AND ^IITR243 = NULL)
    
            Data Elements:
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
    
            ^IITR245 = RP.Partnership:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
            */
            assertion = ((report.IITR246.GetValueOrDefault() > 0 || report.IITR245.GetValueOrDefault() > 0) && (report.IITR242 == null && report.IITR243 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000211",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution from partnerships is invalid",
                    LongDescription = @"When an amount above zero for either 'Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts' or 'Landcare operations and deduction for decline in value of water facility' is provided, at least one amount for 'Distribution from partnerships' or 'Share of net income from trusts' must be provided",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000211" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR245", Value = GetValueOrEmpty(report.IITR245) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000211

            #region VR.ATO.IITR.000214

            /*  VR.ATO.IITR.000214
            Addition of Net income or loss from carrying on a business of investing plus Net income or loss from carrying on a rental property business plus Other income or loss relating to Other income or loss relating to Net income or loss from business is not equal to the amount of Net non-Primary Production income/loss.
    
            Legacy Rule Format:
            IF (([iitr285] <> NULL) AND ([iitr285] <> ([iitr282] + [iitr283] + [iitr284])))
            OR (([iitr285] = NULL ) AND (([iitr282] + [iitr283] + [iitr284]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR285 <> NULL) AND (^IITR285 <> (^IITR282 + ^IITR283 + ^IITR284))) OR ((^IITR285 = NULL) AND ((^IITR282 + ^IITR283 + ^IITR284) <> 0))
    
            Data Elements:
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
    
            ^IITR282 = RP:Income.InvestmentNonPrimaryProductionNet.Amount
    
            ^IITR283 = RP:Income.RentalPropertyNonPrimaryProductionNet.Amount
    
            ^IITR284 = RP:Income.NonPrimaryProductionOtherNet.Amount
            */
            assertion = (report.IITR285 != null && report.IITR285.GetValueOrDefault() != report.IITR282.GetValueOrDefault() + report.IITR283.GetValueOrDefault() + report.IITR284.GetValueOrDefault() || report.IITR285 == null && report.IITR282.GetValueOrDefault() + report.IITR283.GetValueOrDefault() + report.IITR284.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000214",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net non-Primary Production income/loss amount is incorrect",
                    LongDescription = @"The sum of 'Net income or loss from carrying on a business of investing', 'Net income or loss from carrying on a rental property business' and 'Other income or loss relating to Other income or loss relating to Net income or loss from business', must equal the amount provided for 'Net non-Primary Production income/loss'",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000214" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR282", Value = GetValueOrEmpty(report.IITR282) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR283", Value = GetValueOrEmpty(report.IITR283) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR284", Value = GetValueOrEmpty(report.IITR284) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000214

            #region VR.ATO.IITR.000216

            /*  VR.ATO.IITR.000216
            Discount from deferral schemes has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr125] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR125, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR125 = RP:Income.EmployeeShareScheme.DeferralDiscount.Amount
            */
            assertion = NotMonetary(report.IITR125, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000216",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Discount from deferral schemes is not in a valid monetary format",
                    LongDescription = @"Discount from deferral schemes must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DeferralDiscount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000216" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR125", Value = GetValueOrEmpty(report.IITR125) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000216

            #region VR.ATO.IITR.000219

            /*  VR.ATO.IITR.000219
            Dividends - Franking credit cannot be greater than 48% of Dividends - Franked amount.
    
            Legacy Rule Format:
            IF ([iitr120] > 0) AND (([iitr119]*0.48) < ([iitr120] - 1))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR120 > 0) AND ((^IITR119*0.48) < (^IITR120 - 1))
    
            Data Elements:
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
            */
            assertion = (report.IITR120.GetValueOrDefault() > 0 && report.IITR119.GetValueOrDefault() * 0.48M < report.IITR120.GetValueOrDefault() - 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000219",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Franking credit amount is invalid",
                    LongDescription = @"Dividends - Franking credit cannot be greater than 48% of Dividends - Franked amount",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FrankingCredits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000219" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000219

            #region VR.ATO.IITR.000220

            /*  VR.ATO.IITR.000220
            Dividends - Franked amount has a value and Dividends - Franking credit has no value.
    
            Legacy Rule Format:
            IF ([iitr119] > 0) AND ([iitr120] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR119 > 0) AND (^IITR120 = NULL)
    
            Data Elements:
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
            */
            assertion = (report.IITR119.GetValueOrDefault() > 0 && report.IITR120 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000220",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Franking credit is invalid",
                    LongDescription = @"When an amount above zero is provided for 'Dividends - Franked amount', an amount for 'Dividends - Franking credit' must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FrankingCredits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000220" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000220

            #region VR.ATO.IITR.000224

            /*  VR.ATO.IITR.000224
            Tax withheld amounts from Australian government pensions or allowances are greater than or equal to the amount of Australian government pensions.  Check both amounts and correct as necessary.
    
            Legacy Rule Format:
            IF ([iitr88] > 0) AND (([iitr89] = NULL) OR ([iitr89] <= [iitr88]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR88 > 0) AND ((^IITR89 = NULL) OR (^IITR89 <= ^IITR88))
    
            Data Elements:
    
            ^IITR88 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentPensionsAndAllowances.Amount
    
            ^IITR89 = RP:Pension.Total.Amount
            */
            assertion = (report.IITR88.GetValueOrDefault() > 0 && (report.IITR89 == null || report.IITR89.GetValueOrDefault() <= report.IITR88.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000224",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld from Australian Government pensions and allowances incorrect",
                    LongDescription = @"Tax withheld amounts from Australian government pensions or allowances are greater than or equal to the amount of Australian government pensions. Both amounts must be correct.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianGovernmentPensionsAndAllowances.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000224" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR88", Value = GetValueOrEmpty(report.IITR88) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000224

            #region VR.ATO.IITR.000225

            /*  VR.ATO.IITR.000225
            Allowances, earnings, tips, director's fees etc must be greater than the Tax withheld from allowances, earnings, tips, director’s fees etc
    
            Legacy Rule Format:
            IF ([iitr64] > 0) AND (([iitr65] = NULL) OR ([iitr65] <= [iitr64]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR64 > 0) AND ((^IITR65 = NULL) OR (^IITR65 <= ^IITR64))
    
            Data Elements:
    
            ^IITR64 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAllowancesEarningsTipsDirectorsFees.Amount
    
            ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
            */
            assertion = (report.IITR64.GetValueOrDefault() > 0 && (report.IITR65 == null || report.IITR65.GetValueOrDefault() <= report.IITR64.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001225",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld from allowances, earnings, tips, director's fees etc amount incorrect",
                    LongDescription = @"Allowances, earnings, tips, director's fees etc must be greater than the Tax withheld from allowances, earnings, tips, director's fees etc",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAllowancesEarningsTipsDirectorsFees.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000225" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR64", Value = GetValueOrEmpty(report.IITR64) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000225

            #region VR.ATO.IITR.000226

            /*  VR.ATO.IITR.000226
            Share of net income from trusts is greater than zero and Share of net income from trusts action code has not been completed.
    
            Legacy Rule Format:
            IF ([iitr243] > 0) AND ([iitr244] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR243 > 0) AND (^IITR244 = NULL)
    
            Data Elements:
    
            ^IITR244 = RP:Income.TrustPrimaryProductionNetShare.Code
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
            */
            assertion = (report.IITR243.GetValueOrDefault() > 0 && report.IITR244 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000226",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of net income from trusts action code is required",
                    LongDescription = @"When an amount above zero is provided for 'Share of net income from trusts', 'Share of net income from trusts action code' is required",
                    Location = "/xbrli:xbrl/tns:Income.TrustPrimaryProductionNetShare.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000226" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR244", Value = GetValueOrEmpty(report.IITR244) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000226

            #region VR.ATO.IITR.000227

            /*  VR.ATO.IITR.000227
            Share of net income from trusts code is present and the income amount is less than or equal to zero. A code is not required for negative or zero amounts.
    
            Legacy Rule Format:
            IF ([iitr244] <> NULL) AND ([iitr243] = NULL OR [iitr243] <= 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR244 <> NULL) AND (^IITR243 = NULL OR ^IITR243 <= 0)
    
            Data Elements:
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR244 = RP:Income.TrustPrimaryProductionNetShare.Code
            */
            assertion = (report.IITR244 != null && (report.IITR243 == null || report.IITR243.GetValueOrDefault() <= 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000227",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of net income from trusts is invalid",
                    LongDescription = @"When 'Share of net income from trusts code' is present, an amount above zero is required for 'Share of net income from trusts'. If 'Share of net income from trusts' is zero or negative, 'Share of net income from trusts code' must not be provided.",
                    Location = "/xbrli:xbrl/tns:Income.TrustPrimaryProductionNetShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000227" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR244", Value = GetValueOrEmpty(report.IITR244) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000227

            #region VR.ATO.IITR.000234

            /*  VR.ATO.IITR.000234
            There are amounts for either Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts", Landcare operations expenses, Share of franking credit from franked dividends or Share of credit for TFN amounts withheld from interest, dividends and unit trust distributions or Credit for TFN amounts withheld from payments from closely held trusts without any Distribution from partnerships less foreign income and Share of net income from trusts less capital gains, foreign income and franked distributions and Franked distributions from trusts being present.
    
            Legacy Rule Format:
            IF ([iitr265] > 0 OR [iitr260] > 0 OR [iitr269] > 0 OR [iitr270] > 0 OR [iitr271] > 0) AND ([iitr252] = NULL AND [iitr255] = NULL AND [iitr259] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR265 > 0 OR ^IITR260 > 0 OR ^IITR269 > 0 OR ^IITR270 > 0 OR ^IITR271 > 0) AND (^IITR252 = NULL AND ^IITR255 = NULL AND ^IITR259 = NULL)
    
            Data Elements:
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
    
            ^IITR260 = RP:Expense.LandcareOperationsNonPrimaryProduction.Amount
    
            ^IITR269 = RP:IncomeTax.FrankingCreditsShare.Amount
    
            ^IITR270 = RP:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldInvestmentsTFNNotQuotedShare.Amount
    
            ^IITR271 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldCloselyHeldTrustShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
            */
            assertion = ((report.IITR265.GetValueOrDefault() > 0 || report.IITR260.GetValueOrDefault() > 0 || report.IITR269.GetValueOrDefault() > 0 || report.IITR270.GetValueOrDefault() > 0 || report.IITR271.GetValueOrDefault() > 0) && (report.IITR252 == null && report.IITR255 == null && report.IITR259 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000234",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP distribution or share of net income amounts are incorrect",
                    LongDescription = @"There are amounts for either Other deductions relating to amounts shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"", Landcare operations expenses, Share of franking credit from franked dividends or Share of credit for TFN amounts withheld from interest, dividends and unit trust distributions or Credit for TFN amounts withheld from payments from closely held trusts without any Distribution from partnerships less foreign income and Share of net income from trusts less capital gains, foreign income and franked distributions and Franked distributions from trusts being present",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000234" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR265", Value = GetValueOrEmpty(report.IITR265) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR260", Value = GetValueOrEmpty(report.IITR260) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR269", Value = GetValueOrEmpty(report.IITR269) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR270", Value = GetValueOrEmpty(report.IITR270) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR271", Value = GetValueOrEmpty(report.IITR271) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000234

            #region VR.ATO.IITR.000235

            /*  VR.ATO.IITR.000235
            Share of credit for tax withheld where Australian business number not quoted is greater than zero without any Distribution from partnerships and Distribution from partnerships less foreign income and Distribution from partnerships less foreign income and Share of net income from trusts less capital gains, foreign income and franked distributions or Franked distributions from trusts
    
            Legacy Rule Format:
            IF ([iitr268] > 0) AND ([iitr242] = NULL AND [iitr243] = NULL AND [iitr252] = NULL AND [iitr255] = NULL AND [iitr259] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR268 > 0) AND (^IITR242 = NULL AND ^IITR243 = NULL AND ^IITR252 = NULL AND ^IITR255 = NULL AND ^IITR259 = NULL)
    
            Data Elements:
    
            ^IITR268 = RP:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
            */
            assertion = (report.IITR268.GetValueOrDefault() > 0 && (report.IITR242 == null && report.IITR243 == null && report.IITR252 == null && report.IITR255 == null && report.IITR259 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000235",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution and share of net income amounts incorrect",
                    LongDescription = @"Share of credit for tax withheld where Australian business number not quoted is greater than zero without any Distribution from partnerships and Distribution from partnerships less foreign income and Distribution from partnerships less foreign income and Share of net income from trusts less capital gains, foreign income and franked distributions or Franked distributions from trusts",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000235" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR268", Value = GetValueOrEmpty(report.IITR268) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000235

            #region VR.ATO.IITR.000238

            /*  VR.ATO.IITR.000238
            Share of net income from trusts less capital gains, foreign income and franked distributions action code is present and the amount of Share of net income from trusts less capital gains, foreign income and franked distributions is less than or equal to zero.  An action code is not required for negative or zero amounts.
    
            Legacy Rule Format:
            IF ([iitr256] <> NULL) AND ([iitr255] = NULL OR [iitr255] <= 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR256 <> NULL) AND (^IITR255 = NULL OR ^IITR255 <= 0)
    
            Data Elements:
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR256 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Code
            */
            assertion = (report.IITR256 != null && (report.IITR255 == null || report.IITR255.GetValueOrDefault() <= 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000238",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of net income from trusts less capital gains, foreign income and franked distributions is invalid",
                    LongDescription = @"When 'Share of net income from trusts less capital gains, foreign income and franked distributions action code' is present, an amount above zero is required for 'Share of net income from trusts less capital gains, foreign income and franked distributions'. If 'Share of net income from trusts less capital gains, foreign income and franked distributions' is zero or negative, 'Share of net income from trusts less capital gains, foreign income and franked distributions action code' must not be provided.",
                    Location = "/xbrli:xbrl/tns:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000238" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR256", Value = GetValueOrEmpty(report.IITR256) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000238

            #region VR.ATO.IITR.000241

            /*  VR.ATO.IITR.000241
            ESS TFN amounts withheld from discounts cannot be greater than 50% of the sum of Discount from taxed upfront schemes - eligible for reduction, Discount from taxed upfront schemes - not eligible for reduction, and Discount from deferral schemes.
    
            Legacy Rule Format:
            IF ([iitr128] > ([iitr123] + [iitr124] + [iitr125])*0.5)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR128 > (^IITR123 + ^IITR124 + ^IITR125)*0.5)
    
            Data Elements:
    
            ^IITR128 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmployeeShareSchemeDiscountTFNNotQuoted.Amount
    
            ^IITR123 = RP:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
    
            ^IITR124 = RP:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount
    
            ^IITR125 = RP:Income.EmployeeShareScheme.DeferralDiscount.Amount
            */
            assertion = (report.IITR128.GetValueOrDefault() > (report.IITR123.GetValueOrDefault() + report.IITR124.GetValueOrDefault() + report.IITR125.GetValueOrDefault()) * 0.5M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000241",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"ESS TFN amounts withheld from discounts is incorrect",
                    LongDescription = @"ESS TFN amounts withheld from discounts cannot be greater than 50% of the sum of Discount from taxed upfront schemes - eligible for reduction, Discount from taxed upfront schemes - not eligible for reduction, and Discount from deferral schemes",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmployeeShareSchemeDiscountTFNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000241" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR128", Value = GetValueOrEmpty(report.IITR128) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR123", Value = GetValueOrEmpty(report.IITR123) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR124", Value = GetValueOrEmpty(report.IITR124) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR125", Value = GetValueOrEmpty(report.IITR125) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000241

            #region VR.ATO.IITR.000242

            /*  VR.ATO.IITR.000242
            The amount entered for PSI Tax withheld where ABN not quoted is greater than 50% of PSI where ABN not quoted.
    
            Legacy Rule Format:
            IF ([iitr277] > 0) AND ([iitr277] > ([iitr412] * 0.5))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR277 > 0) AND (^IITR277 > (^IITR412 * 0.5))
    
            Data Elements:
    
            ^IITR277 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
            */
            assertion = (report.IITR277.GetValueOrDefault() > 0 && report.IITR277.GetValueOrDefault() > report.IITR412.GetValueOrDefault() * 0.5M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000242",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld where ABN not quoted is incorrect",
                    LongDescription = @"The amount entered for Tax withheld where ABN not quoted, must not be higher than 50% of PSI where ABN not quoted",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000242" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR277", Value = GetValueOrEmpty(report.IITR277) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000242

            #region VR.ATO.IITR.000243

            /*  VR.ATO.IITR.000243
            An amount greater than zero has been entered at PSI where ABN not quoted, and Tax withheld where ABN not quoted is absent or equal to zero.
    
            Legacy Rule Format:
            IF (([iitr277] = NULL) OR ([iitr277] = 0)) AND ([iitr412] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR277 = NULL) OR (^IITR277 = 0)) AND (^IITR412 > 0)
    
            Data Elements:
    
            ^IITR277 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
            */
            assertion = ((report.IITR277 == null || report.IITR277 == 0) && report.IITR412.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000243",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld where ABN not quoted is incorrect",
                    LongDescription = @"Where an amount above zero has been entered at PSI where ABN not quoted, a Tax withheld where ABN not quoted amount above zero must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000243" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR277", Value = GetValueOrEmpty(report.IITR277) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000243

            #region VR.ATO.IITR.000244

            /*  VR.ATO.IITR.000244
            Net income/loss from business tax withheld where Australian business number not quoted is greater than 50% of the sum of PP - Gross payments where Australian Business Number not quoted and Non-PP - Gross payments where Australian Business Number not quoted
    
            Legacy Rule Format:
            IF ([iitr287] > 0) AND ([iitr287] > (([iitr436] + [iitr437])*0.50))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR287 > 0) AND (^IITR287 > ((^IITR436 + ^IITR437)*0.50))
    
            Data Elements:
    
            ^IITR287 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
            */
            assertion = (report.IITR287.GetValueOrDefault() > 0 && report.IITR287.GetValueOrDefault() > (report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault()) * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000244",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld where ABN not quoted is incorrect",
                    LongDescription = @"Net income/loss from business tax withheld where Australian business number not quoted is greater than 50% of the sum of PP - Gross payments where Australian Business Number not quoted and Non-PP - Gross payments where Australian Business Number not quoted",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000244" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR287", Value = GetValueOrEmpty(report.IITR287) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000244

            #region VR.ATO.IITR.000245

            /*  VR.ATO.IITR.000245
            The sum of PP - Gross payments where Australian Business Number not quoted and Non-PP - Gross payments where Australian Business Number not quoted is greater than zero, and Net income/loss from business tax withheld where Australian business number not quoted is absent.
    
            Legacy Rule Format:
            IF (([iitr436] + [iitr437]) > 0) AND ([iitr287] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR436 + ^IITR437) > 0) AND (^IITR287 = NULL)
    
            Data Elements:
    
            ^IITR287 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
            */
            assertion = (report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() > 0 && report.IITR287 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000245",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld where ABN not quoted is required",
                    LongDescription = @"The sum of PP - Gross payments where Australian Business Number not quoted and Non-PP - Gross payments where Australian Business Number not quoted is greater than zero, and Net income/loss from business tax withheld where Australian business number not quoted is absent",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000245" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR287", Value = GetValueOrEmpty(report.IITR287) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000245

            #region VR.ATO.IITR.000246

            /*  VR.ATO.IITR.000246
            The amount at Tax withheld - voluntary agreement is greater than 50% of PSI - voluntary agreement
    
            Legacy Rule Format:
            IF ([iitr276] > 0) AND ([iitr276] > ([iitr411]*0.50))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR276 > 0) AND (^IITR276 > (^IITR411*0.50))
    
            Data Elements:
    
            ^IITR276 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
            */
            assertion = (report.IITR276.GetValueOrDefault() > 0 && report.IITR276.GetValueOrDefault() > report.IITR411.GetValueOrDefault() * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000246",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld - voluntary agreement is incorrect",
                    LongDescription = @"The amount at Tax withheld - voluntary agreement is greater than 50% of PSI - voluntary agreement",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000246" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR276", Value = GetValueOrEmpty(report.IITR276) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000246

            #region VR.ATO.IITR.000247

            /*  VR.ATO.IITR.000247
            An amount greater than zero has been entered at PSI - voluntary agreement and Tax withheld - voluntary agreement is missing or equal to zero
    
            Legacy Rule Format:
            IF [iitr411] > 0 AND ([iitr276] = NULL OR [iitr276] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR411 > 0 AND (^IITR276 = NULL OR ^IITR276 = 0)
    
            Data Elements:
    
            ^IITR276 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
            */
            assertion = (report.IITR411.GetValueOrDefault() > 0 && (report.IITR276 == null || report.IITR276 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000247",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld - voluntary agreement is incorrect",
                    LongDescription = @"An amount greater than zero has been entered at PSI - voluntary agreement and Tax withheld - voluntary agreement is required or equal to zero",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000247" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR276", Value = GetValueOrEmpty(report.IITR276) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000247

            #region VR.ATO.IITR.000248

            /*  VR.ATO.IITR.000248
            The amount entered at Tax withheld - labour hire or other specified payments is greater than 50% of PSI - labour hire or other specified payments
    
            Legacy Rule Format:
            IF ([iitr278] > 0) AND ([iitr278] > ([iitr413]*0.50))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR278 > 0) AND (^IITR278 > (^IITR413*0.50))
    
            Data Elements:
    
            ^IITR278 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
            */
            assertion = (report.IITR278.GetValueOrDefault() > 0 && report.IITR278.GetValueOrDefault() > report.IITR413.GetValueOrDefault() * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000248",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld labour hire or other specified payments incorrect",
                    LongDescription = @"The amount entered at Tax withheld - labour hire or other specified payments is greater than 50% of PSI - labour hire or other specified payments",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000248" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR278", Value = GetValueOrEmpty(report.IITR278) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000248

            #region VR.ATO.IITR.000249

            /*  VR.ATO.IITR.000249
            An amount greater than zero has been entered at PSI - labour hire or other specified payments and Tax withheld - labour hire or other specified payments is missing
    
            Legacy Rule Format:
            IF [iitr413] > 0 AND ([iitr278] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR413 > 0 AND (^IITR278 = NULL)
    
            Data Elements:
    
            ^IITR278 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
            */
            assertion = (report.IITR413.GetValueOrDefault() > 0 && report.IITR278 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000249",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld labour hire or other specified payments is required",
                    LongDescription = @"When a positive amount has been provided for 'PSI - labour hire or other specified payments', an amount for 'Tax withheld - labour hire or other specified payments' is required",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000249" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR278", Value = GetValueOrEmpty(report.IITR278) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000249

            #region VR.ATO.IITR.000250

            /*  VR.ATO.IITR.000250
            Amounts have been entered for PP -  Gross payments voluntary agreement or Non-PP - Gross payments voluntary agreement and Net income/loss from business tax withheld voluntary agreement is missing
    
            Legacy Rule Format:
            IF (([iitr439] + [iitr440]) > 0) AND ([iitr286] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR439 + ^IITR440) > 0) AND (^IITR286 = NULL)
    
            Data Elements:
    
            ^IITR286 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
            */
            assertion = (report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() > 0 && report.IITR286 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000250",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld voluntary agreement required",
                    LongDescription = @"Amounts have been entered for PP -  Gross payments voluntary agreement or Non-PP - Gross payments voluntary agreement and Net income/loss from business tax withheld voluntary agreement is required",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000250" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR286", Value = GetValueOrEmpty(report.IITR286) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000250

            #region VR.ATO.IITR.000251

            /*  VR.ATO.IITR.000251
            Amount entered at Net income/loss from business tax withheld voluntary agreement is greater than 50% of PP -  Gross payments voluntary agreement and Non-PP - Gross payments voluntary agreement
    
            Legacy Rule Format:
            IF ([iitr286] > 0) AND ([iitr286] > ([iitr439] + [iitr440])*0.50)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR286 > 0) AND (^IITR286 > (^IITR439 + ^IITR440)*0.50)
    
            Data Elements:
    
            ^IITR286 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
            */
            assertion = (report.IITR286.GetValueOrDefault() > 0 && report.IITR286.GetValueOrDefault() > (report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault()) * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000251",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld voluntary agreement incorrect",
                    LongDescription = @"Amount entered at Net income/loss from business tax withheld voluntary agreement is greater than 50% of PP -  Gross payments voluntary agreement and Non-PP - Gross payments voluntary agreement",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000251" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR286", Value = GetValueOrEmpty(report.IITR286) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000251

            #region VR.ATO.IITR.000252

            /*  VR.ATO.IITR.000252
            Amounts have been entered at PP - Gross payments labour hire or other specified payments and Non-PP - Gross payments labour hire or other specified payments and Net income/loss from business tax withheld - labour hire or other specified payments is missing
    
            Legacy Rule Format:
            IF (([iitr441] + [iitr442]) > 0) AND ([iitr289] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR441 + ^IITR442) > 0) AND (^IITR289 = NULL)
    
            Data Elements:
    
            ^IITR289 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
            */
            assertion = (report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() > 0 && report.IITR289 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000252",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld labour hire required",
                    LongDescription = @"Amounts have been entered at PP - Gross payments labour hire or other specified payments and Non-PP - Gross payments labour hire or other specified payments and Net income/loss from business tax withheld - labour hire or other specified payments is required",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000252" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR289", Value = GetValueOrEmpty(report.IITR289) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000252

            #region VR.ATO.IITR.000253

            /*  VR.ATO.IITR.000253
            Amounts have been entered at Net income/loss from business tax withheld - labour hire or other specified payments and PP - Gross payments labour hire or other specified payments and Non-PP - Gross payments labour hire or other specified payments are missing or equal to zero
    
            Legacy Rule Format:
            IF ([iitr289] > 0) AND (([iitr441] + [iitr442]) = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR289 > 0) AND ((^IITR441 + ^IITR442) = 0)
    
            Data Elements:
    
            ^IITR289 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
            */
            assertion = (report.IITR289.GetValueOrDefault() > 0 && report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() == 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000253",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross payments labour hire required",
                    LongDescription = @"Amounts have been entered at Net income/loss from business tax withheld - labour hire or other specified payments and PP - Gross payments labour hire or other specified payments and Non-PP - Gross payments labour hire or other specified payments are required or equal to zero",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000253" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR289", Value = GetValueOrEmpty(report.IITR289) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000253

            #region VR.ATO.IITR.000254

            /*  VR.ATO.IITR.000254
            Foreign income tax offset is greater than or equal to total foreign source income. Total foreign source income is the sum of foreign source discounts from the employee share schemes section on the main return form plus Total current year capital gains plus CFC income plus transferor trust income plus other net foreign employment income plus Net foreign pension or annuity income without an undeducted purchase price plus Net foreign pension or annuity income with an undeducted purchase price plus Net foreign rent plus Other net foreign source income plus Net foreign employment income - payment summary plus Primary production deferred losses plus Non-primary production deferred losses.
    
            Legacy Rule Format:
            IF ([iitr331] > 1000) AND ([iitr331] >=  ([iitr129] + [iitr312] + [iitr316] + [iitr318] + [iitr321] + [iitr322] + [iitr323] + [iitr324] + [iitr327] + [iitr329] + [iitr299] + [iitr300]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR331 > 1000) AND (^IITR331 >=  (^IITR129 + ^IITR312 + ^IITR316 + ^IITR318 + ^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327 + ^IITR329 + ^IITR299 + ^IITR300))
    
            Data Elements:
    
            ^IITR331 = RP:Income.InternationalDealings.TaxOffset.Amount
    
            ^IITR129 = RP:Income.EmployeeShareScheme.ForeignSourceDiscount.Amount
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
    
            ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
    
            ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
    
            ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
            ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
    
            ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
    
            ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
            ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
            */
            assertion = (report.IITR331.GetValueOrDefault() > 1000 && report.IITR331.GetValueOrDefault() >= report.IITR129.GetValueOrDefault() + report.IITR312.GetValueOrDefault() + report.IITR316.GetValueOrDefault() + report.IITR318.GetValueOrDefault() + report.IITR321.GetValueOrDefault() + report.IITR322.GetValueOrDefault() + report.IITR323.GetValueOrDefault() + report.IITR324.GetValueOrDefault() + report.IITR327.GetValueOrDefault() + report.IITR329.GetValueOrDefault() + report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000254",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign income tax offset must be less than total foreign income",
                    LongDescription = @"Foreign income tax offset must be less than the sum of total current year capital gains, CFC income, Transferor trust income, Other net foreign employment income, Net foreign pension or annuity income without an undeducted purchase price, Net foreign pension or annuity income with an UPP, Net foreign rent, Other net foreign source income, Net foreign employment income - payment summary, Primary production deferred losses and Non-Primary production deferred losses.",
                    Location = "/xbrli:xbrl/tns:Income.InternationalDealings.TaxOffset.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000254" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR331", Value = GetValueOrEmpty(report.IITR331) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR129", Value = GetValueOrEmpty(report.IITR129) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR329", Value = GetValueOrEmpty(report.IITR329) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000254

            #region VR.ATO.IITR.000255

            /*  VR.ATO.IITR.000255
            Amount entered at Net income/loss from business tax withheld - labour hire or other specified payments is greater than 50% of PP - Gross payments labour hire or other specified payments AND Non-PP - Gross payments labour hire or other specified payments
    
            Legacy Rule Format:
            IF ([iitr289] > 0) AND ([iitr289] > ([iitr441] + [iitr442])*0.50)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR289 > 0) AND (^IITR289 > (^IITR441 + ^IITR442)*0.50)
    
            Data Elements:
    
            ^IITR289 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
            */
            assertion = (report.IITR289.GetValueOrDefault() > 0 && report.IITR289.GetValueOrDefault() > (report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault()) * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000255",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld labour hire incorrect",
                    LongDescription = @"Amount entered at Net income/loss from business tax withheld - labour hire or other specified payments is greater than 50% of PP - Gross payments labour hire or other specified payments AND Non-PP - Gross payments labour hire or other specified payments",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000255" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR289", Value = GetValueOrEmpty(report.IITR289) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000255

            #region VR.ATO.IITR.000256

            /*  VR.ATO.IITR.000256
            PP - Net income or loss from business this year less PP - Deferred non-commercial losses from a prior year does not equal Net Primary Production income/loss
    
            Legacy Rule Format:
            IF ([iitr281] <> NULL AND ([iitr281] <> ([iitr474] - [iitr476])))
            OR ([iitr281] = NULL AND (([iitr474] - [iitr476]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR281 <> NULL AND (^IITR281 <> (^IITR474 - ^IITR476))) OR (^IITR281 = NULL AND ((^IITR474 - ^IITR476) <> 0))
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
    
            ^IITR476 = RP:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearPrimaryProduction.Amount
            */
            assertion = (report.IITR281 != null && report.IITR281.GetValueOrDefault() != report.IITR474.GetValueOrDefault() - report.IITR476.GetValueOrDefault() || report.IITR281 == null && report.IITR474.GetValueOrDefault() - report.IITR476.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000256",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Primary Production income/loss is incorrect",
                    LongDescription = @"PP - Net income or loss from business this year less PP - Deferred non-commercial losses from a prior year does not equal Net Primary Production income/loss",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000256" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR476", Value = GetValueOrEmpty(report.IITR476) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000256

            #region VR.ATO.IITR.000257

            /*  VR.ATO.IITR.000257
            Non-PP - Net income or loss from business this year less Non-PP - Deferred non-commercial losses from a prior year does not equal Net non-Primary Production income/loss
    
            Legacy Rule Format:
            IF ([iitr285] <> NULL AND ([iitr285] <> ([iitr475] - [iitr477])))
            OR ([iitr285] = NULL AND (([iitr475] - [iitr477]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR285 <> NULL AND (^IITR285 <> (^IITR475 - ^IITR477))) OR (^IITR285 = NULL AND ((^IITR475 - ^IITR477) <> 0))
    
            Data Elements:
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
    
            ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
    
            ^IITR477 = RP:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearNonPrimaryProduction.Amount
            */
            assertion = (report.IITR285 != null && report.IITR285.GetValueOrDefault() != report.IITR475.GetValueOrDefault() - report.IITR477.GetValueOrDefault() || report.IITR285 == null && report.IITR475.GetValueOrDefault() - report.IITR477.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000257",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net non-Primary Production income/loss is incorrect",
                    LongDescription = @"Non-PP - Net income or loss from business this year less Non-PP - Deferred non-commercial losses from a prior year does not equal Net non-Primary Production income/loss",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000257" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR477", Value = GetValueOrEmpty(report.IITR477) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000257

            #region VR.ATO.IITR.000258

            /*  VR.ATO.IITR.000258
            The answer to the question 'Received 80% or more of PSI from one source' is 'yes'; however there are no income amounts provided at Net Personal Services Income and Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)
    
            Legacy Rule Format:
            IF ([iitr407] = TRUE) AND ([iitr279] = NULL) AND ([iitr438] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR407 = TRUE) AND (^IITR279 = NULL) AND (^IITR438 = NULL)
    
            Data Elements:
    
            ^IITR407 = RP:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator
    
            ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
            */
            assertion = (report.IITR407 == true && report.IITR279 == null && report.IITR438 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001258",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Personal Services Income and Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains) are required",
                    LongDescription = @"The answer to the question 'Received 80% or more of PSI from one source' is 'yes'; however there are no income amounts provided at Net Personal Services Income and Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000258" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR407", Value = GetValueOrEmpty(report.IITR407) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000258

            #region VR.ATO.IITR.000259

            /*  VR.ATO.IITR.000259
            Net Personal Services Income is not equal to the sum of all PSI income less deductions.
    
            Legacy Rule Format:
            IF (([iitr279] <> NULL) AND ([iitr279] <> ([iitr411] + [iitr412] + [iitr413] + [iitr414] - [iitr415] - [iitr416])))
            OR (([iitr279] = NULL) AND (([iitr411] + [iitr412] + [iitr413] + [iitr414] - [iitr415] - [iitr416]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR279 <> NULL) AND (^IITR279 <> (^IITR411 + ^IITR412 + ^IITR413 + ^IITR414 - ^IITR415 - ^IITR416))) OR ((^IITR279 = NULL) AND ((^IITR411 + ^IITR412 + ^IITR413 + ^IITR414 - ^IITR415 - ^IITR416) <> 0))
    
            Data Elements:
    
            ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
    
            ^IITR415 = RP:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount
    
            ^IITR416 = RP:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
            */
            assertion = (report.IITR279 != null && report.IITR279.GetValueOrDefault() != report.IITR411.GetValueOrDefault() + report.IITR412.GetValueOrDefault() + report.IITR413.GetValueOrDefault() + report.IITR414.GetValueOrDefault() - report.IITR415.GetValueOrDefault() - report.IITR416.GetValueOrDefault() || report.IITR279 == null && report.IITR411.GetValueOrDefault() + report.IITR412.GetValueOrDefault() + report.IITR413.GetValueOrDefault() + report.IITR414.GetValueOrDefault() - report.IITR415.GetValueOrDefault() - report.IITR416.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000259",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Personal Services Income is incorrect",
                    LongDescription = @"The sum of 'PSI - voluntary agreement', 'PSI where Australian business number not quoted', 'PSI - labour hire or other specified payments', 'PSI - other', 'Deductions for payments to associates for principal work' and 'Total amount of other deductions against PSI', must equal the amount provided for 'Net Personal Services Income'",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000259" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR415", Value = GetValueOrEmpty(report.IITR415) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR416", Value = GetValueOrEmpty(report.IITR416) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000259

            #region VR.ATO.IITR.000260

            /*  VR.ATO.IITR.000260
            Share of credit for foreign resident withholding amounts (excluding capital gains) is greater than zero without any Distribution from partnerships or Share of net income from trusts or Distribution from partnerships less foreign income or an amount at Franked distributions from trusts
    
            Legacy Rule Format:
            IF ([iitr273] > 0) AND ([iitr242] = NULL AND [iitr243] = NULL AND [iitr252] = NULL AND [iitr255] = NULL AND [iitr259] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR273 > 0) AND (^IITR242 = NULL AND ^IITR243 = NULL AND ^IITR252 = NULL AND ^IITR255 = NULL AND ^IITR259 = NULL)
    
            Data Elements:
    
            ^IITR273 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldForeignResidentShare.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
            */
            assertion = (report.IITR273.GetValueOrDefault() > 0 && (report.IITR242 == null && report.IITR243 == null && report.IITR252 == null && report.IITR255 == null && report.IITR259 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001260",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution or share amounts incorrect",
                    LongDescription = @"Share of credit for foreign resident withholding amounts (excluding capital gains) is greater than zero without any Distribution from partnerships or Share of net income from trusts or Distribution from partnerships less foreign income or an amount at Franked distributions from trusts",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldForeignResidentShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000260" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR273", Value = GetValueOrEmpty(report.IITR273) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000260

            #region VR.ATO.IITR.000261

            /*  VR.ATO.IITR.000261
            When an amount above zero has been provided for 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)', an amount for 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)' must be provided
    
            Legacy Rule Format:
            IF ([iitr438] > 0) AND ([iitr288] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR438 > 0) AND (^IITR288 = NULL)
    
            Data Elements:
    
            ^IITR288 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
            */
            assertion = (report.IITR438.GetValueOrDefault() > 0 && report.IITR288 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001261",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains) amount required",
                    LongDescription = @"When an amount above zero has been provided for 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)', an amount for 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)' must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000261" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR288", Value = GetValueOrEmpty(report.IITR288) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000261

            #region VR.ATO.IITR.000262

            /*  VR.ATO.IITR.000262
            When an amount is provided for 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)', it must not be greater than 50% of the 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)' amount
    
            Legacy Rule Format:
            IF ([iitr288] > 0) AND ([iitr288] > ([iitr438]*0.50) + 1)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR288 > 0) AND (^IITR288 > (^IITR438*0.50) + 1)
    
            Data Elements:
    
            ^IITR288 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
            */
            assertion = (report.IITR288.GetValueOrDefault() > 0 && report.IITR288.GetValueOrDefault() > report.IITR438.GetValueOrDefault() * 0.50M + 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001262",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains) amount is incorrect",
                    LongDescription = @"When an amount is provided for 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)', it must not be greater than 50% of the 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)' amount",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000262" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR288", Value = GetValueOrEmpty(report.IITR288) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000262

            #region VR.ATO.IITR.000266

            /*  VR.ATO.IITR.000266
            Net primary production income/loss amount is present without total business income from primary production (Gross payments, Assessable government industry payments, Other business income).
    
            Legacy Rule Format:
            IF ([iitr281] <> NULL) AND ([iitr436] = NULL AND [iitr439] = NULL AND [iitr441] = NULL AND [iitr443] = NULL AND [iitr447] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR281 <> NULL) AND (^IITR436 = NULL AND ^IITR439 = NULL AND ^IITR441 = NULL AND ^IITR443 = NULL AND ^IITR447 = NULL)
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
            */
            assertion = (report.IITR281 != null && (report.IITR436 == null && report.IITR439 == null && report.IITR441 == null && report.IITR443 == null && report.IITR447 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000266",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary Production business income required",
                    LongDescription = @"Net primary production income/loss amount is present without total business income from primary production (Gross payments, Assessable government industry payments, Other business income)",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000266" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000266

            #region VR.ATO.IITR.000267

            /*  VR.ATO.IITR.000267
            Total business income from primary production (Gross payments, Assessable government industry payments, other business income) is present without net primary production income/loss amount.
    
            Legacy Rule Format:
            IF ([iitr436] <> NULL OR [iitr439] <> NULL OR [iitr441] <> NULL OR [iitr443] <> NULL OR [iitr447] <> NULL) AND ([iitr281] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR436 <> NULL OR ^IITR439 <> NULL OR ^IITR441 <> NULL OR ^IITR443 <> NULL OR ^IITR447 <> NULL) AND (^IITR281 = NULL)
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
            */
            assertion = ((report.IITR436 != null || report.IITR439 != null || report.IITR441 != null || report.IITR443 != null || report.IITR447 != null) && report.IITR281 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000267",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Primary Production income/loss must be provided",
                    LongDescription = @"Total business income from primary production (Gross payments, Assessable government industry payments, other business income) is present without net primary production income/loss amount",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000267" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000267

            #region VR.ATO.IITR.000268

            /*  VR.ATO.IITR.000268
            Net non-primary production income/loss amount is present without total business income non-primary production (Gross payments where ABN not quoted, Gross payments subject to foreign resident withholding (excluding capital gains), Gross payments voluntary agreement, Gross payments-labour hire or other payments, Assessable government industry payments, Other business income)
    
            Legacy Rule Format:
            IF ([iitr285] <> NULL) AND ([iitr437] = NULL AND [iitr438] = NULL AND [iitr440] = NULL AND [iitr442] = NULL AND [iitr445] = NULL AND [iitr448] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR285 <> NULL) AND (^IITR437 = NULL AND ^IITR438 = NULL AND ^IITR440 = NULL AND ^IITR442 = NULL AND ^IITR445 = NULL AND ^IITR448 = NULL)
    
            Data Elements:
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
            */
            assertion = (report.IITR285 != null && (report.IITR437 == null && report.IITR438 == null && report.IITR440 == null && report.IITR442 == null && report.IITR445 == null && report.IITR448 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001268",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-Primary Production business income required",
                    LongDescription = @"Net non-primary production income/loss amount is present without total business income non-primary production (Gross payments where ABN not quoted, Gross payments subject to foreign resident withholding (excluding capital gains), Gross payments voluntary agreement, Gross payments-labour hire or other payments, Assessable government industry payments, Other business income)",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000268" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000268

            #region VR.ATO.IITR.000269

            /*  VR.ATO.IITR.000269
            Total business income from non-primary production (Gross payments where ABN not quoted, Gross payments subject to foreign resident withholding (excluding capital gains), Gross payments voluntary agreement, Gross payments-labour hire or other payments, Assessable government industry payments, Other business income) is present without net non-primary production income/loss amount
    
            Legacy Rule Format:
            IF ([iitr285] = NULL) AND ([iitr437] <> NULL OR [iitr438] <> NULL OR [iitr440] <> NULL OR [iitr442] <> NULL OR [iitr445] <> NULL OR [iitr448] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR285 = NULL) AND (^IITR437 <> NULL OR ^IITR438 <> NULL OR ^IITR440 <> NULL OR ^IITR442 <> NULL OR ^IITR445 <> NULL OR ^IITR448 <> NULL)
    
            Data Elements:
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
            */
            assertion = (report.IITR285 == null && (report.IITR437 != null || report.IITR438 != null || report.IITR440 != null || report.IITR442 != null || report.IITR445 != null || report.IITR448 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001269",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net non-Primary Production income/loss is required",
                    LongDescription = @"Total business income from non-primary production (Gross payments where ABN not quoted, Gross payments subject to foreign resident withholding (excluding capital gains), Gross payments voluntary agreement, Gross payments-labour hire or other payments, Assessable government industry payments, Other business income) is present without net non-primary production income/loss amount",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000269" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000269

            #region VR.ATO.IITR.000270

            /*  VR.ATO.IITR.000270
            When an amount has been provided for 'Net income/loss from business tax withheld voluntary agreement', 'Net income/loss from business tax withheld where Australian business number not quoted', 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)', or 'Net income/loss from business tax withheld - labour hire or other specified payments', an amount must be provided for 'Net Primary Production income/loss' or 'Net non-Primary Production income/loss'
    
            Legacy Rule Format:
            IF ([iitr286] > 0 OR [iitr287] > 0 OR [iitr288] > 0 OR [iitr289] > 0) AND ([iitr281] = NULL AND [iitr285] = NULL )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR286 > 0 OR ^IITR287 > 0 OR ^IITR288 > 0 OR ^IITR289 > 0) AND (^IITR281 = NULL AND ^IITR285 = NULL)
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR286 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount
    
            ^IITR287 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount
    
            ^IITR288 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount
    
            ^IITR289 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
            */
            assertion = ((report.IITR286.GetValueOrDefault() > 0 || report.IITR287.GetValueOrDefault() > 0 || report.IITR288.GetValueOrDefault() > 0 || report.IITR289.GetValueOrDefault() > 0) && (report.IITR281 == null && report.IITR285 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001270",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income or loss from business is required",
                    LongDescription = @"When an amount has been provided for 'Net income/loss from business tax withheld voluntary agreement', 'Net income/loss from business tax withheld where Australian business number not quoted', 'Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains)', or 'Net income/loss from business tax withheld - labour hire or other specified payments', an amount must be provided for 'Net Primary Production income/loss' or 'Net non-Primary Production income/loss'",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000270" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR286", Value = GetValueOrEmpty(report.IITR286) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR287", Value = GetValueOrEmpty(report.IITR287) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR288", Value = GetValueOrEmpty(report.IITR288) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR289", Value = GetValueOrEmpty(report.IITR289) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000270

            #region VR.ATO.IITR.000271

            /*  VR.ATO.IITR.000271
            Taxpayer's Net farm management deposits or repayments must equal the sum of Early repayments - natural disaster and drought and Other repayments, less Deductible deposits
    
            Legacy Rule Format:
            IF [iitr306] <> NULL AND [iitr306] <> ([iitr304] + [iitr305] - [iitr302])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR306 <> NULL AND ^IITR306 <> (^IITR304 + ^IITR305 - ^IITR302)
    
            Data Elements:
    
            ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
    
            ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount
            */
            assertion = (report.IITR306 != null && report.IITR306.GetValueOrDefault() != report.IITR304.GetValueOrDefault() + report.IITR305.GetValueOrDefault() - report.IITR302.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.021002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net farm management deposits or repayments is incorrect",
                    LongDescription = @"Taxpayer's Net farm management deposits or repayments must equal the sum of Early repayments - natural disaster and drought and Other repayments, less Deductible deposits",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementDepositsOrRepaymentsNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000271" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR306", Value = GetValueOrEmpty(report.IITR306) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR302", Value = GetValueOrEmpty(report.IITR302) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000271

            #region VR.ATO.IITR.000272

            /*  VR.ATO.IITR.000272
            Landcare operations expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr260] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR260, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR260 = RP:Expense.LandcareOperationsNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR260, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000272",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Landcare operations expenses is not in a valid monetary format",
                    LongDescription = @"Landcare operations expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.LandcareOperationsNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000272" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR260", Value = GetValueOrEmpty(report.IITR260) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000272

            #region VR.ATO.IITR.000277

            /*  VR.ATO.IITR.000277
            There is an amount entered in Deductible deposits and it should not exceed taxable primary production income.
    
            Legacy Rule Format:
            IF [iitr302] > 0 AND [iitr302] > ([iitr242] + [iitr243] - [iitr245] - [iitr246] + [iitr281] + [iitr299] + [iitr304] + [iitr305])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR302 > 0 AND ^IITR302 > (^IITR242 + ^IITR243 - ^IITR245 - ^IITR246 + ^IITR281 + ^IITR299 + ^IITR304 + ^IITR305)
    
            Data Elements:
    
            ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR245 = RP.Partnership:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
            */
            assertion = (report.IITR302.GetValueOrDefault() > 0 && report.IITR302.GetValueOrDefault() > report.IITR242.GetValueOrDefault() + report.IITR243.GetValueOrDefault() - report.IITR245.GetValueOrDefault() - report.IITR246.GetValueOrDefault() + report.IITR281.GetValueOrDefault() + report.IITR299.GetValueOrDefault() + report.IITR304.GetValueOrDefault() + report.IITR305.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.021001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductible deposits amount has exceeded the taxable primary production amount",
                    LongDescription = @"When an amount has been entered for 'Deductible deposits', it must not exceed the total amount of taxable primary production income. Taxable primary production income is the sum of 'Distribution from partnerships', 'Share of net income from trusts', 'Net Primary Production income/loss', 'Primary production deferred losses', 'Early repayments - natural disaster and drought' and 'Other repayments', less 'Landcare operations and deduction for decline in value of water facility' and 'Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts'.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.FarmManagementDeposits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000277" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR302", Value = GetValueOrEmpty(report.IITR302) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR245", Value = GetValueOrEmpty(report.IITR245) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000277

            #region VR.ATO.IITR.000280

            /*  VR.ATO.IITR.000280
            Addition of Distribution from partnerships relating to financial investments, less foreign income plus Share of net rental property income or loss from partnerships plus Other distributions from partnerships is not equal to the amount of Distribution from partnerships less foreign income.
    
            Legacy Rule Format:
            IF (([iitr252] <> NULL) AND ([iitr252] <> ([iitr249] + [iitr250] + [iitr251])))
            OR (([iitr252] = NULL) AND (([iitr249] + [iitr250] + [iitr251]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR252 <> NULL) AND (^IITR252 <> (^IITR249 + ^IITR250 + ^IITR251))) OR ((^IITR252 = NULL) AND ((^IITR249 + ^IITR250 + ^IITR251) <> 0))
    
            Data Elements:
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR249 = RP:Income.PartnershipInvestmentLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR250 = RP:Income.PartnershipRentalNonPrimaryProductionShare.Amount
    
            ^IITR251 = RP:Income.PartnershipNonPrimaryProductionOtherShare.Amount
            */
            assertion = (report.IITR252 != null && report.IITR252.GetValueOrDefault() != report.IITR249.GetValueOrDefault() + report.IITR250.GetValueOrDefault() + report.IITR251.GetValueOrDefault() || report.IITR252 == null && report.IITR249.GetValueOrDefault() + report.IITR250.GetValueOrDefault() + report.IITR251.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000280",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution from partnerships less foreign income amount is incorrect",
                    LongDescription = @"The sum of 'Distribution from partnerships relating to financial investments, less foreign income', 'Share of net rental property income or loss from partnerships', 'Other distributions from partnerships' must equal the amount for 'Distribution from partnerships less foreign income'",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000280" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR249", Value = GetValueOrEmpty(report.IITR249) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR250", Value = GetValueOrEmpty(report.IITR250) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR251", Value = GetValueOrEmpty(report.IITR251) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000280

            #region VR.ATO.IITR.000283

            /*  VR.ATO.IITR.000283
            Addition of Managed investment scheme deductions relating to amounts shown at "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" and Partnership deductions relating to financial investment amounts shown at "Distribution from partnerships less foreign income" and Partnership deductions relating to rental property income or loss shown at "Distribution from partnerships less foreign income" and Other deductions relating to distributions shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" is not equal to the amount of Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts".
    
            Legacy Rule Format:
            IF ([iitr265] <> NULL AND ([iitr265] <> ([iitr261] + [iitr262] + [iitr263] + [iitr264])))
            OR ([iitr265] = NULL AND (([iitr261] + [iitr262] + [iitr263] + [iitr264]) <> 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR265 <> NULL AND (^IITR265 <> (^IITR261 + ^IITR262 + ^IITR263 + ^IITR264))) OR (^IITR265 = NULL AND ((^IITR261 + ^IITR262 + ^IITR263 + ^IITR264) <> 0))
    
            Data Elements:
    
            ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
    
            ^IITR261 = RP:IncomeTax.Deduction.TrustExcludingCapitalGainsAndForeignIncomeNonPrimaryProduction.Amount
    
            ^IITR262 = RP:IncomeTax.Deduction.PartnershipExcludingForeignIncomeNonPrimaryProduction.Amount
    
            ^IITR263 = RP:IncomeTax.Deduction.PartnershipRentalNonPrimaryProduction.Amount
    
            ^IITR264 = RP:IncomeTax.Deduction.TrustsPartnershipsOtherAllowableNonPrimaryProduction.Amount
            */
            assertion = (report.IITR265 != null && report.IITR265.GetValueOrDefault() != report.IITR261.GetValueOrDefault() + report.IITR262.GetValueOrDefault() + report.IITR263.GetValueOrDefault() + report.IITR264.GetValueOrDefault() || report.IITR265 == null && report.IITR261.GetValueOrDefault() + report.IITR262.GetValueOrDefault() + report.IITR263.GetValueOrDefault() + report.IITR264.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000283",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other deductions relating to amounts shown is incorrect",
                    LongDescription = @"Addition of Managed investment scheme deductions relating to amounts shown at ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" and Partnership deductions relating to financial investment amounts shown at ""Distribution from partnerships less foreign income"" and Partnership deductions relating to rental property income or loss shown at ""Distribution from partnerships less foreign income"" and Other deductions relating to distributions shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" is not equal to the amount of Other deductions relating to amounts shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts""",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000283" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR265", Value = GetValueOrEmpty(report.IITR265) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR261", Value = GetValueOrEmpty(report.IITR261) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR262", Value = GetValueOrEmpty(report.IITR262) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR263", Value = GetValueOrEmpty(report.IITR263) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR264", Value = GetValueOrEmpty(report.IITR264) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000283

            #region VR.ATO.IITR.000284

            /*  VR.ATO.IITR.000284
            The sum of Share of net income from trusts plus Share of net income from trusts less capital gains, foreign income and franked distributions plus Franked distributions from trusts plus Total current year capital gains plus foreign source income is less than zero which indicates that an overall trust loss is being distributed from a trust to an individual. Adjust distributed amounts at Share of net income from trusts and Share of net income from trusts less capital gains, foreign income and franked distributions until the overall negative amount no longer exists (i.e. make the sum equal to zero). Please note, where there is a negative amount at any of the foreign source income fields, the amount of zero will be used in that field.
    
            Legacy Rule Format:
            IF ([iitr243] + [iitr255] + [iitr259] + [iitr312] + ConditionalValue([iitr321] > 0,[iitr321],0) + ConditionalValue([iitr322] > 0,[iitr322],0) + ConditionalValue([iitr323] > 0, [iitr323],0) + ConditionalValue([iitr324] > 0, [iitr324],0) + ConditionalValue([iitr327] > 0, [iitr327],0) + [iitr328] + ConditionalValue([iitr329] > 0, [iitr329],0) < 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR243 + ^IITR255 + ^IITR259 + ^IITR312 + ConditionalValue(^IITR321 > 0,^IITR321,0) + ConditionalValue(^IITR322 > 0,^IITR322,0) + ConditionalValue(^IITR323 > 0, ^IITR323,0) + ConditionalValue(^IITR324 > 0, ^IITR324,0) + ConditionalValue(^IITR327 > 0, ^IITR327,0) + ^IITR328 + ConditionalValue(^IITR329 > 0, ^IITR329,0) < 0)
    
            Data Elements:
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
    
            ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
            ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
    
            ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount
    
            ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = (report.IITR243.GetValueOrDefault() + report.IITR255.GetValueOrDefault() + report.IITR259.GetValueOrDefault() + report.IITR312.GetValueOrDefault() + ConditionalValue(report.IITR321.GetValueOrDefault() > 0, report.IITR321.GetValueOrDefault(), 0) + ConditionalValue(report.IITR322.GetValueOrDefault() > 0, report.IITR322.GetValueOrDefault(), 0) + ConditionalValue(report.IITR323.GetValueOrDefault() > 0, report.IITR323.GetValueOrDefault(), 0) + ConditionalValue(report.IITR324.GetValueOrDefault() > 0, report.IITR324.GetValueOrDefault(), 0) + ConditionalValue(report.IITR327.GetValueOrDefault() > 0, report.IITR327.GetValueOrDefault(), 0) + report.IITR328.GetValueOrDefault() + ConditionalValue(report.IITR329.GetValueOrDefault() > 0, report.IITR329.GetValueOrDefault(), 0) < 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000284",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"An overall trust loss cannot be distributed to an individual",
                    LongDescription = @"When the sum of 'Share of net income from trusts', 'Share of net income from trusts less capital gains, foreign income and franked distributions', 'Franked distributions from trusts', 'Total current year capital gains', 'Other net foreign employment income', 'Net foreign pension or annuity income without an undeducted purchase price', 'Net foreign pension or annuity income with an undeducted purchase price', 'Net foreign rent', 'Other net foreign source income', 'Australian franking credits from a New Zealand franking company', and 'Net foreign employment income - payment summary' is negative, which indicates that an overall trust loss is being distributed from a trust to an individual, adjust distributed amounts at 'Share of net income from trusts' and 'Share of net income from trusts less capital gains, foreign income and franked distributions' until the overall negative amount no longer exists (i.e. make the sum equal to zero). Note: Where there is a negative amount at any of the foreign source income fields, an amount of zero is used in the summation of that field.",
                    Location = "/xbrli:xbrl/tns:Income.TrustPrimaryProductionNetShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000284" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR328", Value = GetValueOrEmpty(report.IITR328) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR329", Value = GetValueOrEmpty(report.IITR329) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000284

            #region VR.ATO.IITR.000294

            /*  VR.ATO.IITR.000294
            Main salary or wage occupation description has a maximum length of 100
    
            Legacy Rule Format:
            IF LENGTH([iitr58]) > 100
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR58) > 100
    
            Data Elements:
    
            ^IITR58 = RP:PersonDemographicDetails.Occupation.Description
            */
            assertion = (Length(report.IITR58) > 100);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000294",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Main salary or wage occupation description must not exceed 100 characters",
                    LongDescription = @"For Main salary or wage occupation description, the maximum allowable characters for this form is 100",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000294" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR58", Value = GetValueOrEmpty(report.IITR58) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000294

            #region VR.ATO.IITR.000295

            /*  VR.ATO.IITR.000295
            Individual total income or loss amount is mandatory
    
            Legacy Rule Format:
            IF ([iitr131] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR131 = NULL
    
            Data Elements:
    
            ^IITR131 = RP:Income.Net.Amount
            */
            assertion = (report.IITR131 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000295",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual total income or loss amount must be present",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000295" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000295

            #region VR.ATO.IITR.000300

            /*  VR.ATO.IITR.000300
            Amount of allowances, earnings, tips, director's fees, etc has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr65] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR65, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
            */
            assertion = NotMonetary(report.IITR65, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000300",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Amount of allowances, earnings, tips, director's fees, etc is not in a valid monetary format",
                    LongDescription = @"Amount of allowances, earnings, tips, director's fees, etc must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.AllowancesEarningsTipsDirectorsFees.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000300" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000300

            #region VR.ATO.IITR.000309

            /*  VR.ATO.IITR.000309
            Attributed personal services income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr112] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR112, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
            */
            assertion = NotMonetary(report.IITR112, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000309",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Attributed personal services income is not in a valid monetary format",
                    LongDescription = @"Attributed personal services income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000309" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000309

            #region VR.ATO.IITR.000312

            /*  VR.ATO.IITR.000312
            Australian Government allowances and payments like Newstart, youth allowance and austudy payment has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr86] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR86, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
            */
            assertion = NotMonetary(report.IITR86, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000312",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Australian Government allowances and payments..."" is not in a valid monetary format",
                    LongDescription = @"Australian Government allowances and payments like Newstart, youth allowance and austudy payment must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.AustralianGovernmentAllowancesAndPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000312" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000312

            #region VR.ATO.IITR.000314

            /*  VR.ATO.IITR.000314
            Amount of Australian Government pensions and allowances has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr89] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR89, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR89 = RP:Pension.Total.Amount
            */
            assertion = NotMonetary(report.IITR89, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000314",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Amount of Australian Government pensions and allowances is not in a valid monetary format",
                    LongDescription = @"Amount of Australian Government pensions and allowances must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Pension.Total.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000314" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000314

            #region VR.ATO.IITR.000316

            /*  VR.ATO.IITR.000316
            Australian annuities and superannuation income streams Taxable component "Taxed element" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr92] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR92, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
            */
            assertion = NotMonetary(report.IITR92, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000316",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable ""Taxed element"" of Australian annuities and superannuation is not in a valid monetary format",
                    LongDescription = @"Australian annuities and superannuation income streams Taxable component ""Taxed element"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000316" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000316

            #region VR.ATO.IITR.000317

            /*  VR.ATO.IITR.000317
            Australian annuities and superannuation income streams Taxable component "Untaxed element" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr93] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR93, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
            */
            assertion = NotMonetary(report.IITR93, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000317",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable ""Untaxed element"" of Australian annuities and superannuation is not in a valid monetary format",
                    LongDescription = @"Australian annuities and superannuation income streams Taxable component ""Untaxed element"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000317" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000317

            #region VR.ATO.IITR.000318

            /*  VR.ATO.IITR.000318
            Australian annuities and superannuation income streams Lump sum in arrears "Taxed element" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr94] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR94, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
            */
            assertion = NotMonetary(report.IITR94, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000318",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Lump sum ""Taxed element"" of Australian annuities and superannuation is not in a valid monetary format",
                    LongDescription = @"Australian annuities and superannuation income streams Lump sum in arrears ""Taxed element"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000318" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000318

            #region VR.ATO.IITR.000319

            /*  VR.ATO.IITR.000319
            Australian annuities and superannuation income streams Lump sum in arrears "Untaxed element" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr95] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR95, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
            */
            assertion = NotMonetary(report.IITR95, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000319",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Lump sum ""Untaxed element"" of Australian annuities and superannuation is not in a valid monetary format",
                    LongDescription = @"Australian annuities and superannuation income streams Lump sum in arrears ""Untaxed element"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000319" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000319

            #region VR.ATO.IITR.000320

            /*  VR.ATO.IITR.000320
            Gross interest has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr115] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR115, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR115 = RP:Income.Interest.Gross.Amount
            */
            assertion = NotMonetary(report.IITR115, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000320",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross interest is not in a valid monetary format",
                    LongDescription = @"Gross interest must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Interest.Gross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000320" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR115", Value = GetValueOrEmpty(report.IITR115) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000320

            #region VR.ATO.IITR.000321

            /*  VR.ATO.IITR.000321
            TFN amounts withheld from gross interest has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr116] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR116, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR116 = RP:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount
            */
            assertion = NotMonetary(report.IITR116, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000321",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"TFN amounts withheld from gross interest is not in a valid monetary format",
                    LongDescription = @"TFN amounts withheld from gross interest must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000321" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR116", Value = GetValueOrEmpty(report.IITR116) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000321

            #region VR.ATO.IITR.000322

            /*  VR.ATO.IITR.000322
            Dividends - Unfranked amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr118] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR118, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR118 = RP:Income.DividendsUnfranked.Amount
            */
            assertion = NotMonetary(report.IITR118, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000322",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Unfranked amount is not in a valid monetary format",
                    LongDescription = @"Dividends - Unfranked amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.DividendsUnfranked.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000322" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000322

            #region VR.ATO.IITR.000323

            /*  VR.ATO.IITR.000323
            Dividends - Franked amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr119] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR119, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
            */
            assertion = NotMonetary(report.IITR119, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000323",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Franked amount is not in a valid monetary format",
                    LongDescription = @"Dividends - Franked amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.DividendsFranked.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000323" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000323

            #region VR.ATO.IITR.000324

            /*  VR.ATO.IITR.000324
            Dividends - Franking credit has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr120] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR120, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
            */
            assertion = NotMonetary(report.IITR120, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000324",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Franking credit is not in a valid monetary format",
                    LongDescription = @"Dividends - Franking credit must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FrankingCredits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000324" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000324

            #region VR.ATO.IITR.000325

            /*  VR.ATO.IITR.000325
            TFN amounts withheld from dividends has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr121] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR121, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR121 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR121, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000325",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"TFN amounts withheld from dividends is not in a valid monetary format",
                    LongDescription = @"TFN amounts withheld from dividends must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000325" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR121", Value = GetValueOrEmpty(report.IITR121) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000325

            #region VR.ATO.IITR.000326

            /*  VR.ATO.IITR.000326
            Discount from taxed upfront schemes - eligible for reduction has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr123] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR123, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR123 = RP:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount
            */
            assertion = NotMonetary(report.IITR123, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000326",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Discount from taxed upfront schemes - eligible for reduction is not in a valid monetary format",
                    LongDescription = @"Discount from taxed upfront schemes - eligible for reduction must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.TaxUpfrontReducibleDiscount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000326" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR123", Value = GetValueOrEmpty(report.IITR123) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000326

            #region VR.ATO.IITR.000327

            /*  VR.ATO.IITR.000327
            Discount from taxed upfront schemes - not eligible for reduction has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr124] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR124, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR124 = RP:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount
            */
            assertion = NotMonetary(report.IITR124, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000327",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Discount from taxed upfront schemes - not eligible for reduction is not in a valid monetary format",
                    LongDescription = @"Discount from taxed upfront schemes - not eligible for reduction must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.TaxUpfrontNonReducibleDiscount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000327" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR124", Value = GetValueOrEmpty(report.IITR124) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000327

            #region VR.ATO.IITR.000328

            /*  VR.ATO.IITR.000328
            Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr126] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR126, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR126 = RP:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount
            */
            assertion = NotMonetary(report.IITR126, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000328",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Discount on ESS Interests acquired pre 1 July 2009..."" is not in a valid monetary format",
                    LongDescription = @"Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000328" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR126", Value = GetValueOrEmpty(report.IITR126) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000328

            #region VR.ATO.IITR.000329

            /*  VR.ATO.IITR.000329
            Total Assessable discount amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr127] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR127, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
            */
            assertion = NotMonetary(report.IITR127, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000329",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total Assessable discount amount is not in a valid monetary format",
                    LongDescription = @"Total Assessable discount amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.DiscountAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000329" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000329

            #region VR.ATO.IITR.000330

            /*  VR.ATO.IITR.000330
            ESS TFN amounts withheld from discounts has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr128] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR128, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR128 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmployeeShareSchemeDiscountTFNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR128, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000330",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"ESS TFN amounts withheld from discounts is not in a valid monetary format",
                    LongDescription = @"ESS TFN amounts withheld from discounts must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldEmployeeShareSchemeDiscountTFNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000330" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR128", Value = GetValueOrEmpty(report.IITR128) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000330

            #region VR.ATO.IITR.000331

            /*  VR.ATO.IITR.000331
            Foreign source discounts has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr129] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR129, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR129 = RP:Income.EmployeeShareScheme.ForeignSourceDiscount.Amount
            */
            assertion = NotMonetary(report.IITR129, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000331",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign source discounts is not in a valid monetary format",
                    LongDescription = @"Foreign source discounts must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.ForeignSourceDiscount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000331" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR129", Value = GetValueOrEmpty(report.IITR129) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000331

            #region VR.ATO.IITR.000332

            /*  VR.ATO.IITR.000332
            Individual total income or loss amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr131] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR131, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR131 = RP:Income.Net.Amount
            */
            assertion = NotMonetary(report.IITR131, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000332",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual total income or loss amount is not in a valid monetary format",
                    LongDescription = @"Individual total income or loss amount may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000332" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000332

            #region VR.ATO.IITR.000333

            /*  VR.ATO.IITR.000333
            Distribution from partnerships has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr242] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR242, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR242, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000333",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution from partnerships is not in a valid monetary format",
                    LongDescription = @"Distribution from partnerships may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000333" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000333

            #region VR.ATO.IITR.000334

            /*  VR.ATO.IITR.000334
            Share of net income from trusts has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr243] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR243, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
            */
            assertion = NotMonetary(report.IITR243, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000334",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of net income from trusts is not in a valid monetary format",
                    LongDescription = @"Share of net income from trusts may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.TrustPrimaryProductionNetShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000334" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000334

            #region VR.ATO.IITR.000336

            /*  VR.ATO.IITR.000336
            Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr246] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR246, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR246, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000336",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Deductions relating to amounts shown at Distribution from partnerships..."" is not in a valid monetary format",
                    LongDescription = @"Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000336" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000336

            #region VR.ATO.IITR.000337

            /*  VR.ATO.IITR.000337
            Distribution from partnerships relating to financial investments, less foreign income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr249] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR249, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR249 = RP:Income.PartnershipInvestmentLessForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR249, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000337",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Distribution from partnerships relating to financial investments..."" is not in a valid monetary format",
                    LongDescription = @"Distribution from partnerships relating to financial investments, less foreign income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipInvestmentLessForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000337" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR249", Value = GetValueOrEmpty(report.IITR249) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000337

            #region VR.ATO.IITR.000338

            /*  VR.ATO.IITR.000338
            Share of net rental property income or loss from partnerships has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr250] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR250, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR250 = RP:Income.PartnershipRentalNonPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR250, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000338",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of net rental property income or loss from partnerships is not in a valid monetary format",
                    LongDescription = @"Share of net rental property income or loss from partnerships may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipRentalNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000338" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR250", Value = GetValueOrEmpty(report.IITR250) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000338

            #region VR.ATO.IITR.000339

            /*  VR.ATO.IITR.000339
            Other distributions from partnerships has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr251] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR251, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR251 = RP:Income.PartnershipNonPrimaryProductionOtherShare.Amount
            */
            assertion = NotMonetary(report.IITR251, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000339",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other distributions from partnerships is not in a valid monetary format",
                    LongDescription = @"Other distributions from partnerships may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipNonPrimaryProductionOtherShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000339" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR251", Value = GetValueOrEmpty(report.IITR251) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000339

            #region VR.ATO.IITR.000340

            /*  VR.ATO.IITR.000340
            Distribution from partnerships less foreign income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr252] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR252, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR252, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000340",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Distribution from partnerships less foreign income is not in a valid monetary format",
                    LongDescription = @"Distribution from partnerships less foreign income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000340" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000340

            #region VR.ATO.IITR.000343

            /*  VR.ATO.IITR.000343
            Share of net income from trusts less capital gains, foreign income and franked distributions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr255] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR255, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR255, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000343",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Share of net income from trusts less... franked distributions"" is not in a valid monetary format",
                    LongDescription = @"Share of net income from trusts less capital gains, foreign income and franked distributions may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000343" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000343

            #region VR.ATO.IITR.000346

            /*  VR.ATO.IITR.000346
            Franked distributions from trusts has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr259] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR259, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
            */
            assertion = NotMonetary(report.IITR259, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000346",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Franked distributions from trusts is not in a valid monetary format",
                    LongDescription = @"Franked distributions from trusts must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.TrustFrankedNonPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000346" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000346

            #region VR.ATO.IITR.000347

            /*  VR.ATO.IITR.000347
            Managed investment scheme deductions relating to amounts shown at "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr261] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR261, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR261 = RP:IncomeTax.Deduction.TrustExcludingCapitalGainsAndForeignIncomeNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR261, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000347",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Managed investment scheme deductions relating to amounts shown is not in a valid monetary format",
                    LongDescription = @"Managed investment scheme deductions relating to amounts shown at ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TrustExcludingCapitalGainsAndForeignIncomeNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000347" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR261", Value = GetValueOrEmpty(report.IITR261) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000347

            #region VR.ATO.IITR.000348

            /*  VR.ATO.IITR.000348
            Partnership deductions relating to financial investment amounts shown at "Distribution from partnerships less foreign income" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr262] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR262, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR262 = RP:IncomeTax.Deduction.PartnershipExcludingForeignIncomeNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR262, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000348",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Partnership deductions relating to financial investment amounts..."" is not in a valid monetary format",
                    LongDescription = @"Partnership deductions relating to financial investment amounts shown at ""Distribution from partnerships less foreign income"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.PartnershipExcludingForeignIncomeNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000348" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR262", Value = GetValueOrEmpty(report.IITR262) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000348

            #region VR.ATO.IITR.000349

            /*  VR.ATO.IITR.000349
            Partnership deductions relating to rental property income or loss shown at "Distribution from partnerships less foreign income" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr263] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR263, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR263 = RP:IncomeTax.Deduction.PartnershipRentalNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR263, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000349",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Partnership deductions relating to rental property income..."" is not in a valid monetary format",
                    LongDescription = @"Partnership deductions relating to rental property income or loss shown at ""Distribution from partnerships less foreign income"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.PartnershipRentalNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000349" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR263", Value = GetValueOrEmpty(report.IITR263) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000349

            #region VR.ATO.IITR.000350

            /*  VR.ATO.IITR.000350
            Other deductions relating to distributions shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr264] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR264, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR264 = RP:IncomeTax.Deduction.TrustsPartnershipsOtherAllowableNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR264, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000350",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Other deductions relating to distributions shown at..."" is not in a valid monetary format",
                    LongDescription = @"Other deductions relating to distributions shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TrustsPartnershipsOtherAllowableNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000350" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR264", Value = GetValueOrEmpty(report.IITR264) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000350

            #region VR.ATO.IITR.000351

            /*  VR.ATO.IITR.000351
            Other deductions relating to amounts shown at "Distribution from partnerships less foreign income", "Share of net income from trusts less capital gains, foreign income and franked distributions" and "Franked distributions from trusts" has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr265] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR265, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR265 = RP:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR265, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000351",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Other deductions relating to amounts shown at..."" is not in a valid monetary format",
                    LongDescription = @"Other deductions relating to amounts shown at ""Distribution from partnerships less foreign income"", ""Share of net income from trusts less capital gains, foreign income and franked distributions"" and ""Franked distributions from trusts"" must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TrustPartnershipOtherNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000351" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR265", Value = GetValueOrEmpty(report.IITR265) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000351

            #region VR.ATO.IITR.000353

            /*  VR.ATO.IITR.000353
            Share of credit for tax withheld where Australian business number not quoted has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr268] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR268, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR268 = RP:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR268, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000353",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of credit for tax withheld where ABN not quoted is not in a valid monetary format",
                    LongDescription = @"Share of credit for tax withheld where Australian business number not quoted must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000353" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR268", Value = GetValueOrEmpty(report.IITR268) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000353

            #region VR.ATO.IITR.000354

            /*  VR.ATO.IITR.000354
            Share of franking credit from franked dividends has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr269] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR269, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR269 = RP:IncomeTax.FrankingCreditsShare.Amount
            */
            assertion = NotMonetary(report.IITR269, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000354",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of franking credit from franked dividends is not in a valid monetary format",
                    LongDescription = @"Share of franking credit from franked dividends must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FrankingCreditsShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000354" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR269", Value = GetValueOrEmpty(report.IITR269) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000354

            #region VR.ATO.IITR.000355

            /*  VR.ATO.IITR.000355
            Share of credit for TFN amounts withheld from interest, dividends and unit trust distributions has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr270] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR270, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR270 = RP:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldInvestmentsTFNNotQuotedShare.Amount
            */
            assertion = NotMonetary(report.IITR270, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000355",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Share of credit for TFN amounts withheld from interest..."" is not in a valid monetary format",
                    LongDescription = @"Share of credit for TFN amounts withheld from interest, dividends and unit trust distributions must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldInvestmentsTFNNotQuotedShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000355" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR270", Value = GetValueOrEmpty(report.IITR270) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000355

            #region VR.ATO.IITR.000356

            /*  VR.ATO.IITR.000356
            Credit for TFN amounts withheld from payments from closely held trusts has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr271] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR271, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR271 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldCloselyHeldTrustShare.Amount
            */
            assertion = NotMonetary(report.IITR271, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000356",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Credit for TFN amounts withheld from payments from closely held trusts is not in a valid monetary format",
                    LongDescription = @"Credit for TFN amounts withheld from payments from closely held trusts must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldCloselyHeldTrustShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000356" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR271", Value = GetValueOrEmpty(report.IITR271) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000356

            #region VR.ATO.IITR.000357

            /*  VR.ATO.IITR.000357
            Share of credit for tax paid by trustee has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr272] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR272, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR272 = RP:IncomeTax.CreditTrusteeTaxPaidShare.Amount
            */
            assertion = NotMonetary(report.IITR272, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000357",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of credit for tax paid by trustee is not in a valid monetary format",
                    LongDescription = @"Share of credit for tax paid by trustee must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.CreditTrusteeTaxPaidShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000357" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR272", Value = GetValueOrEmpty(report.IITR272) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000357

            #region VR.ATO.IITR.000358

            /*  VR.ATO.IITR.000358
            Share of credit for foreign resident withholding amounts (excluding capital gains) has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr273] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR273, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR273 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldForeignResidentShare.Amount
            */
            assertion = NotMonetary(report.IITR273, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001358",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of credit for foreign resident withholding amounts (excluding capital gains) is not in a valid monetary format",
                    LongDescription = @"Share of credit for foreign resident withholding amounts (excluding capital gains) must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldForeignResidentShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000358" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR273", Value = GetValueOrEmpty(report.IITR273) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000358

            #region VR.ATO.IITR.000359

            /*  VR.ATO.IITR.000359
            Share of National rental affordability scheme tax offset has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr274] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR274, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR274 = RP:TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlementShare.Amount
            */
            assertion = NotMonetary(report.IITR274, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000359",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Share of National rental affordability scheme tax offset is not in a valid monetary format",
                    LongDescription = @"Share of National rental affordability scheme tax offset must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlementShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000359" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR274", Value = GetValueOrEmpty(report.IITR274) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000359

            #region VR.ATO.IITR.000360

            /*  VR.ATO.IITR.000360
            Tax withheld - voluntary agreement has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr276] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR276, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR276 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount
            */
            assertion = NotMonetary(report.IITR276, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000360",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld - voluntary agreement is not in a valid monetary format",
                    LongDescription = @"Tax withheld - voluntary agreement must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000360" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR276", Value = GetValueOrEmpty(report.IITR276) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000360

            #region VR.ATO.IITR.000361

            /*  VR.ATO.IITR.000361
            Tax withheld where Australian business number not quoted has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr277] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR277, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR277 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR277, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000361",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld where Australian business number not quoted is not in a valid monetary format",
                    LongDescription = @"Tax withheld where Australian business number not quoted must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000361" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR277", Value = GetValueOrEmpty(report.IITR277) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000361

            #region VR.ATO.IITR.000362

            /*  VR.ATO.IITR.000362
            Tax withheld - labour hire or other specified payments has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr278] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR278, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR278 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount
            */
            assertion = NotMonetary(report.IITR278, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000362",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld - labour hire or other specified payments is not in a valid monetary format",
                    LongDescription = @"Tax withheld - labour hire or other specified payments must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldPersonalServicesIncomeLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000362" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR278", Value = GetValueOrEmpty(report.IITR278) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000362

            #region VR.ATO.IITR.000363

            /*  VR.ATO.IITR.000363
            Net Personal Services Income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr279] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR279, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
            */
            assertion = NotMonetary(report.IITR279, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000363",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Personal Services Income is not in a valid monetary format",
                    LongDescription = @"Net Personal Services Income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000363" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000363

            #region VR.ATO.IITR.000364

            /*  VR.ATO.IITR.000364
            Net Primary Production income/loss has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr281] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR281, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR281, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000364",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net Primary Production income/loss is not in a valid monetary format",
                    LongDescription = @"Net Primary Production income/loss may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000364" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000364

            #region VR.ATO.IITR.000365

            /*  VR.ATO.IITR.000365
            Net income or loss from carrying on a business of investing has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr282] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR282, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR282 = RP:Income.InvestmentNonPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR282, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000365",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income or loss from carrying on a business of investing is not in a valid monetary format",
                    LongDescription = @"Net income or loss from carrying on a business of investing may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.InvestmentNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000365" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR282", Value = GetValueOrEmpty(report.IITR282) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000365

            #region VR.ATO.IITR.000366

            /*  VR.ATO.IITR.000366
            Net income or loss from carrying on a rental property business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr283] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR283, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR283 = RP:Income.RentalPropertyNonPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR283, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000366",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income or loss from carrying on a rental property business is not in a valid monetary format",
                    LongDescription = @"Net income or loss from carrying on a rental property business may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.RentalPropertyNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000366" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR283", Value = GetValueOrEmpty(report.IITR283) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000366

            #region VR.ATO.IITR.000367

            /*  VR.ATO.IITR.000367
            Other income or loss relating to Other income or loss relating to Net income or loss from business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr284] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR284, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR284 = RP:Income.NonPrimaryProductionOtherNet.Amount
            */
            assertion = NotMonetary(report.IITR284, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000367",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Other income or loss relating to Other income or loss..."" is not in a valid monetary format",
                    LongDescription = @"Other income or loss relating to Other income or loss relating to Net income or loss from business may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionOtherNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000367" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR284", Value = GetValueOrEmpty(report.IITR284) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000367

            #region VR.ATO.IITR.000368

            /*  VR.ATO.IITR.000368
            Net non-Primary Production income/loss has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr285] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR285, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR285, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000368",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net non-Primary Production income/loss is not in a valid monetary format",
                    LongDescription = @"Net non-Primary Production income/loss may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.NonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000368" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000368

            #region VR.ATO.IITR.000369

            /*  VR.ATO.IITR.000369
            Net income/loss from business tax withheld voluntary agreement has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr286] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR286, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR286 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount
            */
            assertion = NotMonetary(report.IITR286, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000369",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income/loss from business tax withheld voluntary agreement is not in a valid monetary format",
                    LongDescription = @"Net income/loss from business tax withheld voluntary agreement must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessVoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000369" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR286", Value = GetValueOrEmpty(report.IITR286) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000369

            #region VR.ATO.IITR.000370

            /*  VR.ATO.IITR.000370
            Net income/loss from business tax withheld where Australian business number not quoted has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr287] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR287, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR287 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR287, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000370",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income/loss from business tax withheld where ABN not quoted is not in a valid monetary format",
                    LongDescription = @"Net income/loss from business tax withheld where Australian business number not quoted must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000370" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR287", Value = GetValueOrEmpty(report.IITR287) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000370

            #region VR.ATO.IITR.000371

            /*  VR.ATO.IITR.000371
            Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains) has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr288] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR288, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR288 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount
            */
            assertion = NotMonetary(report.IITR288, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001371",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains) is not in a valid monetary format",
                    LongDescription = @"Net income/loss from business tax withheld - foreign resident withholding (excluding capital gains) must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessForeignResident.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000371" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR288", Value = GetValueOrEmpty(report.IITR288) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000371

            #region VR.ATO.IITR.000372

            /*  VR.ATO.IITR.000372
            Net income/loss from business tax withheld - labour hire or other specified payments has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr289] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR289, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR289 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount
            */
            assertion = NotMonetary(report.IITR289, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000372",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Net income/loss from business tax withheld... other specified payments"" is not in a valid monetary format",
                    LongDescription = @"Net income/loss from business tax withheld - labour hire or other specified payments must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldBusinessLabourHireOrOtherPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000372" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR289", Value = GetValueOrEmpty(report.IITR289) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000372

            #region VR.ATO.IITR.000373

            /*  VR.ATO.IITR.000373
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr58] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr58] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR58 <> BLANK) AND (NotCharacterInSet(^IITR58, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR58 = RP:PersonDemographicDetails.Occupation.Description
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR58) != true && !(IsMatch(report.IITR58, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000373",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Main salary or wage occupation description contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Occupation.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000373" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR58", Value = GetValueOrEmpty(report.IITR58) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000373

            #region VR.ATO.IITR.000376

            /*  VR.ATO.IITR.000376
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF([iitr310]) = SET("G - Inter-company roll-over", "H - Demerger exemption", "Q - Trust restructure roll-over")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR310, InSet(^IITR310, '"G - Inter-company roll-over", "H - Demerger exemption", "Q - Trust restructure roll-over"'))
    
            Data Elements:
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
            */
            assertion = (report.IITR310Collection == null ? false : report.IITR310Collection.Any(IITR310Repeat => IsMatch(IITR310Repeat, @"^(G - Inter-company roll-over|H - Demerger exemption|Q - Trust restructure roll-over)$")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.002376",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Applied exemption or rollover code is invalid",
                    LongDescription = @"Valid Applied exemption or rollover codes are; ""A - Small business active asset reduction"", ""B - Small business retirement exemption"", ""C - Small business roll-over"", ""D - Small business 15 year exemption"", ""E - Foreign resident CGT exemption"", ""F - Scrip for scrip roll-over"", ""I - Main residence exemption"", ""J - Capital gains disregarded as a result of the sale of a pre-CGT asset"", ""K - Disposal or creation of assets in a wholly-owned company"", ""L - Replacement asset roll-overs"", ""M - Exchange of shares or units"", ""N - Exchange of rights or options"", ""O - Exchange of shares in one company for shares in another company"", ""P - Exchange of units in a unit trust for shares in a company"", ""R - Demerger roll-over"", ""S - Same asset roll-overs"", ""T - Small Business Restructure Roll-over"", ""X - Other exemptions and roll-overs"", ""U - Early stage investor = Early stage investor Subdivision 360A"", ""V - Venture capital investment = Venture capital investment Subdivision 118F""",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000376" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR310", Value = "Count(IITR310)" });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000376

            #region VR.ATO.IITR.000380

            /*  VR.ATO.IITR.000380
            The 'Applied exemption or rollover code' of "T - Small Business Restructure Roll-over" is only valid for Australian residents unless otherwise eligible under certain circumstances
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF([iitr310]) = "T - Small Business Restructure Roll-over" AND [iitr19] <> TRUE 
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR310, ^IITR310 = 'T - Small Business Restructure Roll-over') AND ^IITR19 <> TRUE
    
            Data Elements:
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
            */
            assertion = ((report.IITR310Collection == null ? false : report.IITR310Collection.Any(IITR310Repeat => IITR310Repeat == @"T - Small Business Restructure Roll-over")) && report.IITR19 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000380",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Applied exemption or rollover code",
                    LongDescription = @"The 'Applied exemption or rollover code' of ""T - Small Business Restructure Roll-over"" is only valid for Australian residents unless otherwise eligible under certain circumstances",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000380" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR310", Value = "IITR310" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000380

            #region VR.ATO.IITR.000501

            /*  VR.ATO.IITR.000501
            The number of full days medicare levy exemption must be present with the action code.
    
            Legacy Rule Format:
            IF ([iitr173] <> NULL) AND (([iitr172] = NULL) OR ([iitr172] = 0 ))
                    RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR173 <> NULL) AND ((^IITR172 = NULL) OR (^IITR172 = 0))
    
            Data Elements:
    
            ^IITR173 = RP:IncomeTax.MedicareLevy.ExemptionFullDays.Code
    
            ^IITR172 = RP:IncomeTax.MedicareLevy.ExemptionFullDays.Count
            */
            assertion = (report.IITR173 != null && (report.IITR172 == null || report.IITR172 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000501",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of full days medicare levy exemption required",
                    LongDescription = @"The number of full days medicare levy exemption must be present with the action code",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.ExemptionFullDays.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000501" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR173", Value = GetValueOrEmpty(report.IITR173) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR172", Value = report.IITR172.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000501

            #region VR.ATO.IITR.000502

            /*  VR.ATO.IITR.000502
            When it has been indicated that the taxpayer and their dependants have not been covered by private patient hospital cover for the entire income year, the number of days not liable for surcharge must be provided.
    
            Legacy Rule Format:
            IF ([iitr176] <> TRUE AND [iitr177] = NULL)
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR176 <> TRUE AND ^IITR177 = NULL
    
            Data Elements:
    
            ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator
    
            ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count
            */
            assertion = (report.IITR176 != true && report.IITR177 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000502",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Enter number of days NOT liable for Medicare levy surcharge",
                    LongDescription = @"When it has been indicated that the taxpayer and their dependants have not been covered by private patient hospital cover for the entire income year, the number of days not liable for surcharge must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000502" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR176", Value = GetValueOrEmpty(report.IITR176) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR177", Value = report.IITR177.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000502

            #region VR.ATO.IITR.000504

            /*  VR.ATO.IITR.000504
            If private patient hospital cover has been retained for the whole year, the number of days not liable for Medicare levy surcharge must be blank or a valid accounting period.
    
            Legacy Rule Format:
            IF [iitr176] = TRUE AND ([iitr177] <> NULL AND [iitr177] <> (RP:Period.endDate - RP:Period.startDate + 1))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR176 = TRUE AND (^IITR177 <> NULL AND ^IITR177 <> (DaysInDuration(^EndDate - ^StartDate1) + 1))
    
            Data Elements:
    
            ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator
    
            ^EndDate = RP
    
            ^StartDate1 = RP
    
            ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count
            */
            assertion = ((report.RPExists == true) && (report.IITR176 == true && (report.IITR177 != null && report.IITR177.GetValueOrDefault() != (report.RPEndDate.GetValueOrDefault() - report.RPStartDate.GetValueOrDefault()).Days + 1)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000504",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Incorrect value for number of days not liable for Medicare levy surcharge",
                    LongDescription = @"If private patient hospital cover has been retained for the whole year, the number of days not liable for Medicare levy surcharge must be blank or a valid accounting period",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000504" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR176", Value = GetValueOrEmpty(report.IITR176) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR177", Value = report.IITR177.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000504

            #region VR.ATO.IITR.000505

            /*  VR.ATO.IITR.000505
            The number of days full levy exemption and/or the number of days half levy exemption exceed accounting period.
    
            Legacy Rule Format:
            IF [iitr177] > (RP:period.endDate - RP:period.startDate + 1)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR177 > (DaysInDuration(^EndDate - ^StartDate1) + 1)
    
            Data Elements:
    
            ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count
    
            ^EndDate = RP
    
            ^StartDate1 = RP
            */
            assertion = ((report.RPExists == true) && (report.IITR177.GetValueOrDefault() > (report.RPEndDate.GetValueOrDefault() - report.RPStartDate.GetValueOrDefault()).Days + 1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000505",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Levy exemption days exceeds limit",
                    LongDescription = @"The number of days full levy exemption and/or the number of days half levy exemption exceed accounting period",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000505" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR177", Value = report.IITR177.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000505

            #region VR.ATO.IITR.000506

            /*  VR.ATO.IITR.000506
            Seniors and pensioners veteran code is present and Seniors and pensioners tax offset code is required
    
            Legacy Rule Format:
            IF [iitr163] = NULLORBLANK AND [iitr164] <> NULLORBLANK
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR163 = BLANK AND ^IITR164 <> BLANK
    
            Data Elements:
    
            ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code
    
            ^IITR164 = RP:TaxOffsetClaim.Veteran.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR163) == true && string.IsNullOrWhiteSpace(report.IITR164) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000506",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Seniors and pensioners tax offset indicator must be present",
                    LongDescription = @"Seniors and pensioners veteran code is present and Seniors and pensioners tax offset code is required",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SeniorAndPensioner.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000506" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR163", Value = GetValueOrEmpty(report.IITR163) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR164", Value = GetValueOrEmpty(report.IITR164) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000506

            #region VR.ATO.IITR.000507

            /*  VR.ATO.IITR.000507
            Total tax offsets do not equal the sum of all tax offsets including Australian superannuation income stream, Superannuation contributions on behalf of your spouse tax offset, Zone or overseas forces tax offset, Invalid and Invalid Carer tax offset, Landcare and water facility tax offset brought forward from prior years, current and carried forward Early stage venture capital limited partnership (ESVCLP) tax offsets, current and carried forward Early stage investor tax offsets, Other non-refundable tax offsets and Other refundable tax offsets
    
            Legacy Rule Format:
            IF ([iitr168] <> NULL AND [iitr168] <> ([iitr166] + [iitr379]  + [iitr381] + [iitr386] + [iitr388] + [iitr392] + [iitr395] + [iitr495] + [iitr500] + [iitr496] + [iitr501])) OR ([iitr168] = NULL AND ([iitr166] + [iitr379] + [iitr381] + [iitr386] + [iitr388] + [iitr392] + [iitr395] + [iitr495] + [iitr500] + [iitr496] + [iitr501]) <> 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR168 <> NULL AND ^IITR168 <> (^IITR166 + ^IITR379  + ^IITR381 + ^IITR386 + ^IITR388 + ^IITR392 + ^IITR395 + ^IITR495 + ^IITR500 + ^IITR496 + ^IITR501)) OR (^IITR168 = NULL AND (^IITR166 + ^IITR379 + ^IITR381 + ^IITR386 + ^IITR388 + ^IITR392 + ^IITR395 + ^IITR495 + ^IITR500 + ^IITR496 + ^IITR501) <> 0)
    
            Data Elements:
    
            ^IITR168 = RP:TaxOffsetClaim.Total.Amount
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
    
            ^IITR381 = RP:TaxOffsetClaim.ZoneOrOverseasForces.Amount
    
            ^IITR386 = RP:TaxOffsetClaim.DependentInvalidAndCarer.Amount
    
            ^IITR388 = RP:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount
    
            ^IITR392 = RP:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR395 = RP:IncomeTax.TaxOffsetRefundableOther.Amount
    
            ^IITR495 = RP.LimitedPartners:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR500 = RP.LimitedPartners.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR496 = RP.Investor:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR501 = RP.Investor.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = (report.IITR168 != null && report.IITR168.GetValueOrDefault() != report.IITR166.GetValueOrDefault() + report.IITR379.GetValueOrDefault() + report.IITR381.GetValueOrDefault() + report.IITR386.GetValueOrDefault() + report.IITR388.GetValueOrDefault() + report.IITR392.GetValueOrDefault() + report.IITR395.GetValueOrDefault() + report.IITR495.GetValueOrDefault() + report.IITR500.GetValueOrDefault() + report.IITR496.GetValueOrDefault() + report.IITR501.GetValueOrDefault() || report.IITR168 == null && report.IITR166.GetValueOrDefault() + report.IITR379.GetValueOrDefault() + report.IITR381.GetValueOrDefault() + report.IITR386.GetValueOrDefault() + report.IITR388.GetValueOrDefault() + report.IITR392.GetValueOrDefault() + report.IITR395.GetValueOrDefault() + report.IITR495.GetValueOrDefault() + report.IITR500.GetValueOrDefault() + report.IITR496.GetValueOrDefault() + report.IITR501.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001507",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total tax offsets incorrect",
                    LongDescription = @"Total tax offsets do not equal the sum of all tax offsets including Australian superannuation income stream, Superannuation contributions on behalf of your spouse tax offset, Zone or overseas forces tax offset, Invalid and Invalid Carer tax offset, Landcare and water facility tax offset brought forward from prior years, current and carried forward Early stage venture capital limited partnership (ESVCLP) tax offsets, current and carried forward Early stage investor tax offsets, Other non-refundable tax offsets and Other refundable tax offsets",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000507" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR168", Value = GetValueOrEmpty(report.IITR168) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR381", Value = GetValueOrEmpty(report.IITR381) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR386", Value = GetValueOrEmpty(report.IITR386) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR388", Value = GetValueOrEmpty(report.IITR388) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR392", Value = GetValueOrEmpty(report.IITR392) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR395", Value = GetValueOrEmpty(report.IITR395) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR495", Value = GetValueOrEmpty(report.IITR495) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR500", Value = GetValueOrEmpty(report.IITR500) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR496", Value = GetValueOrEmpty(report.IITR496) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR501", Value = GetValueOrEmpty(report.IITR501) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000507

            #region VR.ATO.IITR.000510

            /*  VR.ATO.IITR.000510
            Australian superannuation income stream has a maximum length of 11
    
            Legacy Rule Format:
            IF [iitr166] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR166, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
            */
            assertion = NotMonetary(report.IITR166, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000510",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian superannuation income stream is not in a valid monetary format",
                    LongDescription = @"For Australian superannuation income stream must be unsigned but must not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000510" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000510

            #region VR.ATO.IITR.000511

            /*  VR.ATO.IITR.000511
            Total tax offsets has a maximum length of 11
    
            Legacy Rule Format:
            IF [iitr168] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR168, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR168 = RP:TaxOffsetClaim.Total.Amount
            */
            assertion = NotMonetary(report.IITR168, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000511",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total tax offsets is not in a valid monetary format",
                    LongDescription = @"For Total tax offsets must be unsigned but must not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000511" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR168", Value = GetValueOrEmpty(report.IITR168) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000511

            #region VR.ATO.IITR.000512

            /*  VR.ATO.IITR.000512
            Number of dependent children and students has a maximum length of 2
    
            Legacy Rule Format:
            IF LENGTH([iitr171]) > 2
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR171) > 2
    
            Data Elements:
    
            ^IITR171 = RP:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count
            */
            assertion = (Length(report.IITR171.GetValueOrDefault()) > 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000512",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of dependent children and students must not exceed 2 characters",
                    LongDescription = @"For the Number of dependent children and students, the maximum allowable characters for this form is 2",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000512" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR171", Value = report.IITR171.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000512

            #region VR.ATO.IITR.000513

            /*  VR.ATO.IITR.000513
            Exemption - number of days full levy exemption has a maximum length of 3
    
            Legacy Rule Format:
            IF LENGTH([iitr172]) > 3
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR172) > 3
    
            Data Elements:
    
            ^IITR172 = RP:IncomeTax.MedicareLevy.ExemptionFullDays.Count
            */
            assertion = (Length(report.IITR172.GetValueOrDefault()) > 3);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000513",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Exemption - number of days full levy exemption must not exceed 3 characters",
                    LongDescription = @"For Exemption - number of days full levy exemption, the maximum allowable characters for this form is 3",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.ExemptionFullDays.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000513" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR172", Value = report.IITR172.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000513

            #region VR.ATO.IITR.000514

            /*  VR.ATO.IITR.000514
            Exemption - number of days half levy exemption has a maximum length of 3
    
            Legacy Rule Format:
            IF LENGTH([iitr174]) > 3
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR174) > 3
    
            Data Elements:
    
            ^IITR174 = RP:IncomeTax.MedicareLevy.ExemptionHalfDays.Count
            */
            assertion = (Length(report.IITR174.GetValueOrDefault()) > 3);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000514",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Exemption - number of days half levy exemption must not exceed 3 characters",
                    LongDescription = @"For Exemption - number of days half levy exemption, the maximum allowable characters for this form is 3",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.ExemptionHalfDays.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000514" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR174", Value = report.IITR174.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000514

            #region VR.ATO.IITR.000515

            /*  VR.ATO.IITR.000515
            It is mandatory to specify whether you and all your dependants covered by private patient hospital cover for the whole financial year
    
            Legacy Rule Format:
            IF [iitr176] = NULL
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR176 = NULL
    
            Data Elements:
    
            ^IITR176 = RP:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator
            */
            assertion = (report.IITR176 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000515",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"You and all your dependants covered by private patient hospital cover...' must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.PrivateHospitalCoverWholePeriod.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000515" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR176", Value = GetValueOrEmpty(report.IITR176) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000515

            #region VR.ATO.IITR.000516

            /*  VR.ATO.IITR.000516
            Number of days not liable for surcharge has a maximum length of 3
    
            Legacy Rule Format:
            IF LENGTH([iitr177]) > 3
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR177) > 3
    
            Data Elements:
    
            ^IITR177 = RP:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count
            */
            assertion = (Length(report.IITR177.GetValueOrDefault()) > 3);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000516",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of days not liable for surcharge must not exceed 3 characters",
                    LongDescription = @"For Number of days not liable for surcharge, the maximum allowable characters for this form is 3",
                    Location = "/xbrli:xbrl/tns:IncomeTax.MedicareLevy.SurchargeExemptionDays.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000516" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR177", Value = report.IITR177.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000516

            #region VR.ATO.IITR.000518

            /*  VR.ATO.IITR.000518
            The Sequence Container within the Reporting Party Private Health Insurance Sequence Number context instance must not be duplicated
    
            Legacy Rule Format:
            IF [iitr570] = ANY OTHER OCCURRENCE OF [iitr570]
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^IITR570)
    
            Data Elements:
    
            ^IITR570 = RP.{PHISeqNum}:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPPHISeqNumContextCollection == null ? null : report.RPPHISeqNumContextCollection.Select(f => f.IITR570).Cast<object>().ToArray());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000518",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Reporting Party Private Health Insurance Sequence Number context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPPHISeqNumContextCollection[DuplicateValueIndex(report.RPPHISeqNumContextCollection.Select(f => f.IITR570))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000518" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000518

            #region VR.ATO.IITR.000607

            /*  VR.ATO.IITR.000607
            Where the Taxpayer is a dependent on the Private health insurance policy, and is 25 or older as at 1 July of the accounting period, the Tax claim code or date of birth must be corrected.
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF ([iitr185]) = "Covered as dependent child" AND ([iitr29] <= ConvertToDate(1,7, [iitr10] - 26))
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR185, ^IITR185 = 'Covered as dependent child') AND (^IITR29 <= ConvertToDate(1,7, ^IITR10 - 26))
    
            Data Elements:
    
            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = ((report.RPPHISeqNumContextCollection == null ? false : report.RPPHISeqNumContextCollection.Any(IITR185Repeat => IITR185Repeat.IITR185 == @"Covered as dependent child")) && report.IITR29.GetValueOrDefault() <= ConvertToDate(1, 7, report.IITR10.GetValueOrDefault() - 26));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000607",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dependent must be 25yrs or younger to be on a private health insurance dependent child only policy.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000607" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "IITR185" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000607

            #region VR.ATO.IITR.000608

            /*  VR.ATO.IITR.000608
            When a Contributions paid amount is present, a Superannuation contributions on behalf of your spouse tax offset amount above 0 must be provided.
    
            Legacy Rule Format:
            IF ([iitr378] <> NULL) AND ([iitr378] > 0) AND (([iitr379] = NULL) OR ([iitr379] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR378 <> NULL) AND (^IITR378 > 0) AND ((^IITR379 = NULL) OR (^IITR379 = 0))
    
            Data Elements:
    
            ^IITR378 = RP:SuperannuationContribution.SpouseContributions.Amount
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
            */
            assertion = (report.IITR378 != null && report.IITR378.GetValueOrDefault() > 0 && (report.IITR379 == null || report.IITR379 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000608",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Superannuation contributions on behalf of your spouse's tax offset is required",
                    LongDescription = @"When a Contributions paid amount is present, a Superannuation contributions on behalf of your spouse tax offset amount above 0 must be provided",
                    Location = "/xbrli:xbrl/tns:SuperannuationContribution.SpouseContributions.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000608" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR378", Value = GetValueOrEmpty(report.IITR378) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000608

            #region VR.ATO.IITR.000609

            /*  VR.ATO.IITR.000609
            When a Superannuation contributions paid on behalf of your spouse's tax offset amount is present, a Contributions paid amount above 0 must be provided.
    
            Legacy Rule Format:
            IF ([iitr379] <> NULL) AND ([iitr379] > 0) AND (([iitr378] = NULL) OR ([iitr378] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR379 <> NULL) AND (^IITR379 > 0) AND ((^IITR378 = NULL) OR (^IITR378 = 0))
    
            Data Elements:
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
    
            ^IITR378 = RP:SuperannuationContribution.SpouseContributions.Amount
            */
            assertion = (report.IITR379 != null && report.IITR379.GetValueOrDefault() > 0 && (report.IITR378 == null || report.IITR378 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000609",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Contributions paid amount is required",
                    LongDescription = @"When a Superannuation contributions paid on behalf of your spouse's tax offset amount is present, a Contributions paid amount above 0 must be provided",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000609" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR378", Value = GetValueOrEmpty(report.IITR378) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000609

            #region VR.ATO.IITR.000612

            /*  VR.ATO.IITR.000612
            When Other non-refundable tax offsets action code is present, the amount of other non-refundable tax offsets must be above 0 and also be present.
    
            Legacy Rule Format:
            IF [iitr393] <> NULL AND ([iitr392] = NULL OR [iitr392] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR393 <> NULL AND (^IITR392 = NULL OR ^IITR392 = 0)
    
            Data Elements:
    
            ^IITR393 = RP:TaxOffsetClaim.NonRefundableOther.Code
    
            ^IITR392 = RP:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = (report.IITR393 != null && (report.IITR392 == null || report.IITR392 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000612",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Amount of other non-refundable tax offsets must be above 0",
                    LongDescription = @"When Other non-refundable tax offsets action code is present, the amount of other non-refundable tax offsets must be above 0 and also be present",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000612" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR393", Value = GetValueOrEmpty(report.IITR393) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR392", Value = GetValueOrEmpty(report.IITR392) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000612

            #region VR.ATO.IITR.000613

            /*  VR.ATO.IITR.000613
            When the Other refundable tax offsets amount is above 0, the Other refundable tax offsets code must be present.
    
            Legacy Rule Format:
            IF ([iitr395] <> NULL) AND ([iitr395] > 0) AND ([iitr396] = NULL) 
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR395 <> NULL) AND (^IITR395 > 0) AND (^IITR396 = NULL)
    
            Data Elements:
    
            ^IITR395 = RP:IncomeTax.TaxOffsetRefundableOther.Amount
    
            ^IITR396 = RP:IncomeTax.TaxOffsetRefundableOther.Code
            */
            assertion = (report.IITR395 != null && report.IITR395.GetValueOrDefault() > 0 && report.IITR396 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000613",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other refundable tax offsets code is required",
                    LongDescription = @"When the Other refundable tax offsets amount is above 0, the Other refundable tax offsets code must be present",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TaxOffsetRefundableOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000613" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR395", Value = GetValueOrEmpty(report.IITR395) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR396", Value = GetValueOrEmpty(report.IITR396) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000613

            #region VR.ATO.IITR.000614

            /*  VR.ATO.IITR.000614
            When the Other refundable tax offsets code is present, the amount of Other refundable tax offsets must be above 0. An Other refundable tax offsets code is not required for zero amounts.
    
            Legacy Rule Format:
            IF ([iitr396] <> NULL) AND (([iitr395] = NULL)  OR ([iitr395] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR396 <> NULL) AND ((^IITR395 = NULL)  OR (^IITR395 = 0))
    
            Data Elements:
    
            ^IITR396 = RP:IncomeTax.TaxOffsetRefundableOther.Code
    
            ^IITR395 = RP:IncomeTax.TaxOffsetRefundableOther.Amount
            */
            assertion = (report.IITR396 != null && (report.IITR395 == null || report.IITR395 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000614",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other refundable tax offsets amount is invalid",
                    LongDescription = @"When the Other refundable tax offsets code is present, the amount of Other refundable tax offsets must be above 0. An Other refundable tax offsets code is not required for zero amounts.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TaxOffsetRefundableOther.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000614" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR396", Value = GetValueOrEmpty(report.IITR396) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR395", Value = GetValueOrEmpty(report.IITR395) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000614

            #region VR.ATO.IITR.000621

            /*  VR.ATO.IITR.000621
            Contributions paid has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr378] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR378, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR378 = RP:SuperannuationContribution.SpouseContributions.Amount
            */
            assertion = NotMonetary(report.IITR378, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000621",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Contributions paid is not in a valid monetary format",
                    LongDescription = @"Contributions paid must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:SuperannuationContribution.SpouseContributions.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000621" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR378", Value = GetValueOrEmpty(report.IITR378) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000621

            #region VR.ATO.IITR.000622

            /*  VR.ATO.IITR.000622
            Superannuation contributions on behalf of your spouse tax offset has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr379] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR379, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
            */
            assertion = NotMonetary(report.IITR379, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000622",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Superannuation contributions on behalf of your spouse tax offset is not in a valid monetary format",
                    LongDescription = @"Superannuation contributions on behalf of your spouse tax offset must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000622" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000622

            #region VR.ATO.IITR.000623

            /*  VR.ATO.IITR.000623
            Zone or overseas forces tax offset has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr381] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR381, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR381 = RP:TaxOffsetClaim.ZoneOrOverseasForces.Amount
            */
            assertion = NotMonetary(report.IITR381, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000623",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Zone or overseas forces tax offset is not in a valid monetary format",
                    LongDescription = @"Zone or overseas forces tax offset must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.ZoneOrOverseasForces.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000623" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR381", Value = GetValueOrEmpty(report.IITR381) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000623

            #region VR.ATO.IITR.000625

            /*  VR.ATO.IITR.000625
            Invalid and Invalid Carer tax offset has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr386] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR386, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR386 = RP:TaxOffsetClaim.DependentInvalidAndCarer.Amount
            */
            assertion = NotMonetary(report.IITR386, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.020020",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid and Invalid Carer tax offset is not in a valid monetary format",
                    LongDescription = @"For Invalid and Invalid Carer tax offset must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.DependentInvalidAndCarer.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000625" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR386", Value = GetValueOrEmpty(report.IITR386) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000625

            #region VR.ATO.IITR.000626

            /*  VR.ATO.IITR.000626
            Landcare and water facility tax offset brought forward from prior years has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr388] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR388, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR388 = RP:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount
            */
            assertion = NotMonetary(report.IITR388, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000626",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Landcare and water facility tax offset brought forward from prior years is not in a valid monetary format",
                    LongDescription = @"Landcare and water facility tax offset brought forward from prior years must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000626" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR388", Value = GetValueOrEmpty(report.IITR388) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000626

            #region VR.ATO.IITR.000628

            /*  VR.ATO.IITR.000628
            Other non-refundable tax offsets has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr392] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR392, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR392 = RP:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR392, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000628",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other non-refundable tax offsets is not in a valid monetary format",
                    LongDescription = @"Other non-refundable tax offsets must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000628" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR392", Value = GetValueOrEmpty(report.IITR392) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000628

            #region VR.ATO.IITR.000629

            /*  VR.ATO.IITR.000629
            Other refundable tax offsets has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr395] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR395, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR395 = RP:IncomeTax.TaxOffsetRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR395, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000629",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other refundable tax offsets is not in a valid monetary format",
                    LongDescription = @"Other refundable tax offsets must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TaxOffsetRefundableOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000629" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR395", Value = GetValueOrEmpty(report.IITR395) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000629

            #region VR.ATO.IITR.000631

            /*  VR.ATO.IITR.000631
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr379] <> NULL) AND ([iitr379] < 1 OR [iitr379] > 540)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR379 <> NULL) AND (^IITR379 < 1 OR ^IITR379 > 540)
    
            Data Elements:
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
            */
            assertion = (report.IITR379 != null && (report.IITR379.GetValueOrDefault() < 1 || report.IITR379.GetValueOrDefault() > 540));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000631",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Superannuation contributions on behalf of your spouse tax offset is invalid",
                    LongDescription = @"Valid range for Superannuation contributions on behalf of your spouse tax offset is 1 - 540",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000631" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000631

            #region VR.ATO.IITR.000632

            /*  VR.ATO.IITR.000632
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr388] <> NULL) AND ([iitr388] < 1 OR [iitr388] > 13100)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR388 <> NULL) AND (^IITR388 < 1 OR ^IITR388 > 13100)
    
            Data Elements:
    
            ^IITR388 = RP:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount
            */
            assertion = (report.IITR388 != null && (report.IITR388.GetValueOrDefault() < 1 || report.IITR388.GetValueOrDefault() > 13100));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000632",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Landcare and water facility tax offset is invalid",
                    LongDescription = @"Valid range for Landcare and water facility tax offset is 1 - 13100",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000632" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR388", Value = GetValueOrEmpty(report.IITR388) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000632

            #region VR.ATO.IITR.000636

            /*  VR.ATO.IITR.000636
            Bank Account Details have not been completed. Any refund due may be delayed.
    
            Legacy Rule Format:
            IF [iitr53] = NULL AND [iitr54] = NULLORBLANK AND [iitr55] = NULLORBLANK
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR53 = NULL AND ^IITR54 = BLANK AND ^IITR55 = BLANK
    
            Data Elements:
    
            ^IITR53 = RP:FinancialInstitutionAccount.BankStateBranch.Number
    
            ^IITR54 = RP:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
    
            ^IITR55 = RP:FinancialInstitutionAccount.FinancialInstitutionAccountName.Text
            */
            assertion = (report.IITR53 == null && string.IsNullOrWhiteSpace(report.IITR54) == true && string.IsNullOrWhiteSpace(report.IITR55) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000636",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Bank Account Details have not been completed. Any refund due may be delayed.",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.BankStateBranch.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000636" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR53", Value = GetValueOrEmpty(report.IITR53) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR54", Value = GetValueOrEmpty(report.IITR54) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR55", Value = GetValueOrEmpty(report.IITR55) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000636

            #region VR.ATO.IITR.000637

            /*  VR.ATO.IITR.000637
            Year of return must be either the current or next (future) lodgment year associated with this service. If a future year lodgment is required, then it must be lodged no later than the 15th of June of the current year, unless it is an amendment. After the 15th of June, a return for that lodgment year must be submitted from the 1st of July, using the new service associated to that specific lodgment year.
    
            Legacy Rule Format:
            IF [iitr10] <> SET("2020","2021") OR ([iitr10] = 2021 AND DATE(Today) > 2021-06-15 AND [iitr16] <> TRUE)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotInSet(^IITR10, '"2020","2021"') OR (^IITR10 = 2021 AND Today() > AsDate('2021-06-15') AND ^IITR16 <> TRUE)
    
            Data Elements:
    
            ^IITR10 = RP:Report.TargetFinancial.Year
    
            ^IITR16 = RP:Report.Amendment.Indicator
            */
            assertion = (!(IsMatch(report.IITR10.GetValueOrDefault().ToString(), @"^(2020|2021)$", RegexOptions.IgnoreCase)) || report.IITR10.GetValueOrDefault() == 2021 && DateTime.Now.Date > AsDate(@"2021-06-15") && report.IITR16 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500127",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Year of return is invalid",
                    LongDescription = @"Year of return must be either the current or next (future) lodgment year associated with this service. If a future year lodgment is required, then it must be lodged no later than the 15th of June of the current year, unless it is an amendment. After the 15th of June, a return for that lodgment year must be submitted from the 1st of July, using the new service associated to that specific lodgment year.",
                    Location = "/xbrli:xbrl/tns:Report.TargetFinancial.Year",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000637" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR16", Value = GetValueOrEmpty(report.IITR16) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000637

            #region VR.ATO.IITR.000638

            /*  VR.ATO.IITR.000638
            Non-resident foreign income amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr494] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR494, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR494 = RP.JFOREIGN:Income.Net.Amount
            */
            assertion = NotMonetary(report.IITR494, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000638",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-resident foreign income amount is not in a valid monetary format",
                    LongDescription = @"Non-resident foreign income amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters. When amount is negative, enter zero (0).",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPJFOREIGNId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000638" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR494", Value = GetValueOrEmpty(report.IITR494) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000638

            #region VR.ATO.IITR.000640

            /*  VR.ATO.IITR.000640
            For an Australian resident, Non-resident foreign income amount must not be provided.
    
            Legacy Rule Format:
            IF ([iitr19] = TRUE AND ([iitr666] = NULL AND [iitr667] = NULL) AND [iitr494] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR19 = TRUE AND (^IITR666 = NULL AND ^IITR667 = NULL) AND ^IITR494 <> NULL)
    
            Data Elements:
    
            ^IITR494 = RP.JFOREIGN:Income.Net.Amount
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
            */
            assertion = (report.IITR19 == true && (report.IITR666 == null && report.IITR667 == null) && report.IITR494 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000640",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"For an Australian resident, Non-resident foreign income amount must not be provided",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPJFOREIGNId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000640" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR494", Value = GetValueOrEmpty(report.IITR494) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000640

            #region VR.ATO.IITR.000646

            /*  VR.ATO.IITR.000646
            Early stage venture capital limited partnership (ESVCLP) - Current year tax offset has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr495] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR495, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR495 = RP.LimitedPartners:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR495, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001646",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early stage venture capital limited partnership (ESVCLP) - Current year tax offset is not in a valid monetary format",
                    LongDescription = @"Early stage venture capital limited partnership (ESVCLP) - Current year tax offset must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPLimitedPartnersId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000646" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR495", Value = GetValueOrEmpty(report.IITR495) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000646

            #region VR.ATO.IITR.000647

            /*  VR.ATO.IITR.000647
            Early stage investor - Current year tax offset has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr496] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR496, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR496 = RP.Investor:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR496, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001647",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early stage investor - Current year tax offset is not in a valid monetary format",
                    LongDescription = @"Early stage investor - Current year tax offset must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPInvestorId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000647" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR496", Value = GetValueOrEmpty(report.IITR496) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000647

            #region VR.ATO.IITR.000648

            /*  VR.ATO.IITR.000648
            Only taxpayers who have been a sophisticated investor for at least one early stage innovation company (ESIC) investment in the year, may claim an Early stage investor tax offset amount above $10,000
    
            Legacy Rule Format:
            IF([iitr496] + [iitr501]) > 10000 AND ([iitr496] + [iitr501]) < 200001
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR496 + ^IITR501) > 10000 AND (^IITR496 + ^IITR501) < 200001
    
            Data Elements:
    
            ^IITR496 = RP.Investor:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR501 = RP.Investor.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = (report.IITR496.GetValueOrDefault() + report.IITR501.GetValueOrDefault() > 10000 && report.IITR496.GetValueOrDefault() + report.IITR501.GetValueOrDefault() < 200001);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000648",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Early stage investor tax offset claim amount exceeds $10,000",
                    LongDescription = @"Only taxpayers who have been a sophisticated investor for at least one early stage innovation company (ESIC) investment in the year, may claim an Early stage investor tax offset amount above $10,000",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPInvestorId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000648" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR496", Value = GetValueOrEmpty(report.IITR496) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR501", Value = GetValueOrEmpty(report.IITR501) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000648

            #region VR.ATO.IITR.000649

            /*  VR.ATO.IITR.000649
            The Early stage investor tax offset is capped at $200,000 per investor and their affiliates combined each income year. This $200,000 limit includes the sum of the current year tax offset entitlement and the amount of early stage investor tax offset carried forward from the previous year.
    
            Legacy Rule Format:
            IF ([iitr496] + [iitr501]) > 200000
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR496 + ^IITR501) > 200000
    
            Data Elements:
    
            ^IITR496 = RP.Investor:TaxOffsetClaim.NonRefundableOther.Amount
    
            ^IITR501 = RP.Investor.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = (report.IITR496.GetValueOrDefault() + report.IITR501.GetValueOrDefault() > 200000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.001649",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early stage investor tax offset claim amount must not exceed $200,000",
                    LongDescription = @"The Early stage investor tax offset is capped at $200,000 per investor and their affiliates combined each income year. This $200,000 limit includes the sum of the current year tax offset entitlement and the amount of early stage investor tax offset carried forward from the previous year.",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPInvestorId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000649" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR496", Value = GetValueOrEmpty(report.IITR496) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR501", Value = GetValueOrEmpty(report.IITR501) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000649

            #region VR.ATO.IITR.000652

            /*  VR.ATO.IITR.000652
            The date entered is a future date. Date of birth cannot be any day in advance of the form submission date.
    
            Legacy Rule Format:
            IF ([iitr29] <> NULL) AND ([iitr29] > DATE(TODAY))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR29 <> NULL) AND (^IITR29 > Today())
    
            Data Elements:
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
            */
            assertion = (report.IITR29 != null && report.IITR29.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000652",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Date of birth must be prior to the form submission date",
                    LongDescription = @"The date entered is a future date. Date of birth cannot be any day in advance of the form submission date.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Birth.Date[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000652" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000652

            #region VR.ATO.IITR.000653

            /*  VR.ATO.IITR.000653
            Early stage venture capital limited partnership (ESVCLP) - Tax offset carried forward from previous year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr500] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR500, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR500 = RP.LimitedPartners.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR500, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000653",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early stage venture capital limited partnership (ESVCLP) - Tax offset carried forward from previous year is not in a valid monetary format",
                    LongDescription = @"Early stage venture capital limited partnership (ESVCLP) - Tax offset carried forward from previous year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPLimitedPartnersYPreviousId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000653" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR500", Value = GetValueOrEmpty(report.IITR500) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000653

            #region VR.ATO.IITR.000654

            /*  VR.ATO.IITR.000654
            Early stage investor - Tax offset carried forward from previous year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr501] <> MONETARY(U,11,0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR501, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR501 = RP.Investor.YPrevious:TaxOffsetClaim.NonRefundableOther.Amount
            */
            assertion = NotMonetary(report.IITR501, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000654",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early stage investor - Tax offset carried forward from previous year is not in a valid monetary format",
                    LongDescription = @"Early stage investor - Tax offset carried forward from previous year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Amount[@contextRef='" + report.RPInvestorYPreviousId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000654" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR501", Value = GetValueOrEmpty(report.IITR501) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000654

            #region VR.ATO.IITR.000655

            /*  VR.ATO.IITR.000655
            A text character must be one of the following: A to Z a to z or 0 to 9
    
            Legacy Rule Format:
            IF [iitr54] <> NULLORBLANK AND ANY CHARACTER OF [iitr54] <> SET("a-z","A-Z","0-9")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR54 <> BLANK AND NotCharacterInSet(^IITR54, '"a-z","A-Z","0-9"')
    
            Data Elements:
    
            ^IITR54 = RP:FinancialInstitutionAccount.FinancialInstitutionAccount.Number
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR54) != true && !(IsMatch(report.IITR54, @"^[a-zA-Z0-9]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000655",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Account number contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z or 0 to 9",
                    Location = "/xbrli:xbrl/tns:FinancialInstitutionAccount.FinancialInstitutionAccount.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000655" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR54", Value = GetValueOrEmpty(report.IITR54) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000655

            #region VR.ATO.IITR.000656

            /*  VR.ATO.IITR.000656
            Scheme for Reporting Party Investor must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Investor:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Investor
            */
            assertion = ((report.RPInvestorExists == true) && (report.RPInvestorIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000656",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Investor must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000656" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000656

            #region VR.ATO.IITR.000657

            /*  VR.ATO.IITR.000657
            Scheme for Reporting Party Investor YPrevious must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Investor.YPrevious:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.Investor:RP.Investor.YPrevious
            */
            assertion = ((report.RPInvestorYPreviousExists == true) && (report.RPInvestorYPreviousIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000657",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Investor YPrevious must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPInvestorYPreviousOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000657" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000657

            #region VR.ATO.IITR.000658

            /*  VR.ATO.IITR.000658
            Scheme for Reporting Party Limited Partners must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.LimitedPartners:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.LimitedPartners
            */
            assertion = ((report.RPLimitedPartnersExists == true) && (report.RPLimitedPartnersIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000658",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Limited Partners must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000658" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000658

            #region VR.ATO.IITR.000659

            /*  VR.ATO.IITR.000659
            Scheme for Reporting Party Limited Partners YPrevious must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.LimitedPartners.YPrevious:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.LimitedPartners:RP.LimitedPartners.YPrevious
            */
            assertion = ((report.RPLimitedPartnersYPreviousExists == true) && (report.RPLimitedPartnersYPreviousIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000659",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Limited Partners YPrevious must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLimitedPartnersYPreviousOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000659" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000659

            #region VR.ATO.IITR.000662

            /*  VR.ATO.IITR.000662
            Assessable amount from capped defined benefit income stream has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr505] <> MONETARY(U,11,0)
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR505, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
            */
            assertion = NotMonetary(report.IITR505, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000662",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Assessable amount from capped defined benefit income stream is not in a valid monetary format",
                    LongDescription = @"Assessable amount from capped defined benefit income stream must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000662" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000662

            #region VR.ATO.IITR.000665

            /*  VR.ATO.IITR.000665
            Where the age of the taxpayer is 61 or over on 30 June of the reporting period, then the Australian superannuation income stream offset amount must not exceed $10,000
    
            Legacy Rule Format:
            IF [iitr166] > 10000 AND ([iitr29] <> NULL AND [iitr29] <= ConvertToDate(30,6, [iitr10] - 61))
                  RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR166 > 10000 AND (^IITR29 <> NULL AND ^IITR29 <= ConvertToDate(30,6, ^IITR10 - 61))
    
            Data Elements:
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = (report.IITR166.GetValueOrDefault() > 10000 && (report.IITR29 != null && report.IITR29.GetValueOrDefault() <= ConvertToDate(30, 6, report.IITR10.GetValueOrDefault() - 61)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000665",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian superannuation income stream offset amount exceeds limit",
                    LongDescription = @"Where the age of the taxpayer is 61 or over on 30 June of the reporting period, then the Australian superannuation income stream offset amount must not exceed $10,000",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000665" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000665

            #region VR.ATO.IITR.000666

            /*  VR.ATO.IITR.000666
            Where the age of the taxpayer is 61 or over on 30 June of the reporting period, and the Assessable amount from capped defined benefit income stream provided is greater than zero, then the Australian superannuation income stream offset amount must not be provided
    
            Legacy Rule Format:
            IF [iitr166] > 0 AND ([iitr29] <> NULL AND [iitr29] <= ConvertToDate(30,6, [iitr10] - 61)) AND [iitr505] > 0
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR166 > 0 AND (^IITR29 <> NULL AND ^IITR29 <= ConvertToDate(30,6, ^IITR10 - 61)) AND ^IITR505 > 0
    
            Data Elements:
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
            */
            assertion = (report.IITR166.GetValueOrDefault() > 0 && (report.IITR29 != null && report.IITR29.GetValueOrDefault() <= ConvertToDate(30, 6, report.IITR10.GetValueOrDefault() - 61)) && report.IITR505.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000666",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian superannuation income stream offset amount must not be provided",
                    LongDescription = @"Where the age of the taxpayer is 61 or over on 30 June of the reporting period, and the Assessable amount from capped defined benefit income stream provided is greater than zero, then the Australian superannuation income stream offset amount must not be provided",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000666" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000666

            #region VR.ATO.IITR.000669

            /*  VR.ATO.IITR.000669
            Scheme for Reporting Party Working Holiday Maker must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.WHM:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.WHM
            */
            assertion = ((report.RPWHMExists == true) && (report.RPWHMIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000669",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Working Holiday Makers must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPWHMOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000669" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000669

            #region VR.ATO.IITR.000670

            /*  VR.ATO.IITR.000670
            Scheme for Reporting Party Partnership must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Partnership:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Partnership
            */
            assertion = ((report.RPPartnershipExists == true) && (report.RPPartnershipIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000670",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Partnership must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPartnershipOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000670" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000670

            #region VR.ATO.IITR.000671

            /*  VR.ATO.IITR.000671
            Scheme for Reporting Party Trust must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Trust:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Trust
            */
            assertion = ((report.RPTrustExists == true) && (report.RPTrustIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000671",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Trust must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrustOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000671" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000671

            #region VR.ATO.IITR.000672

            /*  VR.ATO.IITR.000672
            Scheme for Reporting Party Primary Production must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Prim:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Prim
            */
            assertion = ((report.RPPrimExists == true) && (report.RPPrimIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000672",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Primary Production must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPrimOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000672" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000672

            #region VR.ATO.IITR.000673

            /*  VR.ATO.IITR.000673
            Invalid context. The number of Reporting Party Partnership contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.Partnership)) > 1 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Partnership
            */
            assertion = (Count(report.RPPartnershipCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000673",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Partnership contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPartnershipLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000673" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000673

            #region VR.ATO.IITR.000674

            /*  VR.ATO.IITR.000674
            Invalid context. The number of Reporting Party Trust contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.Trust)) > 1 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Trust
            */
            assertion = (Count(report.RPTrustCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000674",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Trust contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPTrustLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000674" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000674

            #region VR.ATO.IITR.000675

            /*  VR.ATO.IITR.000675
            Invalid context. The number of Reporting Party Primary Production contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(CONTEXT(RP.Prim)) > 1 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Prim
            */
            assertion = (Count(report.RPPrimCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000675",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Primary Production contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPrimLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000675" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000675

            #region VR.ATO.IITR.000676

            /*  VR.ATO.IITR.000676
            Daytime phone area code has a maximum field length of 4.
    
            Legacy Rule Format:
            IF LENGTH([iitr579]) > 4
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR579) > 4
    
            Data Elements:
    
            ^IITR579 = RP:ElectronicContact.Telephone.Country.Code
            */
            assertion = (Length(report.IITR579) > 4);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.000676",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Daytime phone area code must not exceed 4 characters",
                    LongDescription = @"For Daytime phone area code, the maximum allowable characters for this form is 4",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000676" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR579", Value = GetValueOrEmpty(report.IITR579) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.000676

            #region VR.ATO.IITR.100009

            /*  VR.ATO.IITR.100009
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
            Legacy Rule Format:
            IF ([iitr533] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr533] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR533 <> BLANK) AND (NotCharacterInSet(^IITR533, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR533 = RP.SPOUSE:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR533) != true && !(IsMatch(report.IITR533, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's Customer reference number contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR533", Value = GetValueOrEmpty(report.IITR533) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100009

            #region VR.ATO.IITR.100010

            /*  VR.ATO.IITR.100010
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * - = _ ' . ? / or a space character
    
            Legacy Rule Format:
            IF ([iitr51] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr51] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","-","_","=","'",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR51 <> BLANK) AND (NotCharacterInSet(^IITR51, 'a-z,A-Z,0-9,"!","@","$","%","&","*","-","_","=","'",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR51 = RP:ElectronicContact.ElectronicMail.Address.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR51) != true && !(IsMatch(report.IITR51, @"^[a-z,A-Z,0-9,""!@\$%&\*\-_='\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100010",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Contact E-mail address contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * - = _ ' . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.ElectronicMail.Address.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100010" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR51", Value = GetValueOrEmpty(report.IITR51) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100010

            #region VR.ATO.IITR.100011

            /*  VR.ATO.IITR.100011
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
            Legacy Rule Format:
            IF ([iitr536] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr536] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR536 <> BLANK) AND (NotCharacterInSet(^IITR536, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR536 = INT.TrueAndCorrect:Identifiers.TaxAgentClientReference.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR536) != true && !(IsMatch(report.IITR536, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100011",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Client's reference contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:Identifiers.TaxAgentClientReference.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100011" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR536", Value = GetValueOrEmpty(report.IITR536) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100011

            #region VR.ATO.IITR.100029

            /*  VR.ATO.IITR.100029
            When the taxpayer is claiming a refund of franking credits for a short form Income Tax Return Type, the taxable income or loss amount must be less than $18,201, the taxpayer must be an Australian resident for tax purposes, the amount of franking credits must be less than $5,461, and the total tax offset amount must be zero.
    
            Legacy Rule Format:
            IF ([iitr13] <> NULL) AND (([iitr157] > 18200) OR ([iitr168] > 0) OR ([iitr19] <> TRUE) OR ([iitr120] > 5460))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR13 <> NULL) AND ((^IITR157 > 18200) OR (^IITR168 > 0) OR (^IITR19 <> TRUE) OR (^IITR120 > 5460))
    
            Data Elements:
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR168 = RP:TaxOffsetClaim.Total.Amount
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
            */
            assertion = (report.IITR13 != null && (report.IITR157.GetValueOrDefault() > 18200 || report.IITR168.GetValueOrDefault() > 0 || report.IITR19 != true || report.IITR120.GetValueOrDefault() > 5460));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100029",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Criteria for a taxpayer to claim a refund of franking credits are not correct",
                    LongDescription = @"When the 'Income Tax Return Type' is provided, implying that the return is to be treated as a short Individual return, and the taxpayer is claiming a refund of franking credits, the 'Taxable income or loss' amount must be below $18,201, the 'Australian resident' indicator must be set to 'yes' (true), the 'Dividends - Franking credit' amount must be below $5,461, and the 'Total tax offsets' amount must be zero",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ReturnType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100029" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR168", Value = GetValueOrEmpty(report.IITR168) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100029

            #region VR.ATO.IITR.100030

            /*  VR.ATO.IITR.100030
            When the taxpayer is claiming a refund of franking credits for a short form Income Tax Return Type, and the taxpayer is younger than 18 years old, they must be an Australian resident for tax purposes, the amount of franking credits must be less than $126, and the taxable income or loss amount must be less than $417.
    
            Legacy Rule Format:
            IF ([iitr13] <> NULL) AND ([iitr29] > ConvertToDate(Day(RP:period.endDate), MonthAsInt(RP:period.endDate), Year(RP:period.endDate) - 18)) AND (([iitr19] <> TRUE) OR ([iitr120] > 125) OR ([iitr157] > 416))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR13 <> NULL) AND (^IITR29 > ConvertToDate(Day(^EndDate), MonthAsInt(^EndDate), Year(^EndDate) - 18)) AND ((^IITR19 <> TRUE) OR (^IITR120 > 125) OR (^IITR157 > 416))
    
            Data Elements:
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^EndDate = RP
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
            ^IITR157 = RP:Income.Taxable.Amount
            */
            assertion = (report.IITR13 != null && report.IITR29.GetValueOrDefault() > ConvertToDate(Day(report.RPEndDate), MonthAsInt(report.RPEndDate), Year(report.RPEndDate) - 18) && (report.IITR19 != true || report.IITR120.GetValueOrDefault() > 125 || report.IITR157.GetValueOrDefault() > 416));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Criteria for a taxpayer to claim a refund of franking credits are not correct",
                    LongDescription = @"When the 'Income Tax Return Type' is provided, implying that the return is to be treated as a short Individual return, the taxpayer is claiming a refund of franking credits, and the taxpayer is younger than 18 years old, the 'Australian resident' indicator must be set to 'yes' (true), the 'Dividends - Franking credit' amount must be below $126, and the 'Taxable income or loss' amount must be below $417",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ReturnType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100030" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100030

            #region VR.ATO.IITR.100046

            /*  VR.ATO.IITR.100046
            The taxpayer was under 18 years of age on the last day of the financial year of the return and under 18 income is missing at Adjustments. If this amount is not completed the taxpayer may be taxed at a higher rate than necessary.
    
            Legacy Rule Format:
            IF ([iitr29] > ConvertToDate(Day(RP:period.endDate), MonthAsInt(RP:period.endDate), Year(RP:period.endDate) - 18)) AND ([iitr188] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR29 > ConvertToDate(Day(^EndDate), MonthAsInt(^EndDate), Year(^EndDate) - 18)) AND (^IITR188 = NULL)
    
            Data Elements:
    
            ^IITR188 = RP:IncomeTax.ExceptedNetIncomeUnder18.Amount
    
            ^EndDate = RP
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
            */
            assertion = (report.IITR29.GetValueOrDefault() > ConvertToDate(Day(report.RPEndDate), MonthAsInt(report.RPEndDate), Year(report.RPEndDate) - 18) && report.IITR188 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100046",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Under 18 excepted net income amount must be provided",
                    LongDescription = @"When the taxpayer is under 18 years of age on the last day of the financial year of the return, the 'Under 18 ' excepted net income amount must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ExceptedNetIncomeUnder18.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100046" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR188", Value = GetValueOrEmpty(report.IITR188) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100046

            #region VR.ATO.IITR.100063

            /*  VR.ATO.IITR.100063
            Where the Spouse's Customer reference number is present, then the Spouse's family name, first name, date of birth and gender code are required.
    
            Legacy Rule Format:
            IF [iitr533] <> NULLORBLANK AND ([iitr213] = NULLORBLANK OR [iitr214] = NULLORBLANK OR [iitr217] = NULL OR [iitr218] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR533 <> BLANK AND (^IITR213 = BLANK OR ^IITR214 = BLANK OR ^IITR217 = NULL OR ^IITR218 = NULL)
    
            Data Elements:
    
            ^IITR533 = RP.SPOUSE:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR218 = RP.SPOUSE:PersonDemographicDetails.Sex.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR533) != true && (string.IsNullOrWhiteSpace(report.IITR213) == true || string.IsNullOrWhiteSpace(report.IITR214) == true || report.IITR217 == null || report.IITR218 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.130063",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse details are required",
                    LongDescription = @"Where the Spouse's Customer reference number is present, then the Spouse's or de facto spouse's family name, first name, date of birth and gender code are required",
                    Location = "/xbrli:xbrl/tns:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100063" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR533", Value = GetValueOrEmpty(report.IITR533) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR218", Value = GetValueOrEmpty(report.IITR218) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100063

            #region VR.ATO.IITR.100070

            /*  VR.ATO.IITR.100070
            Declarer Telephone number has a maximum field length of 15
    
            Legacy Rule Format:
            IF LENGTH([iitr541]) > 15
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR541) > 15
    
            Data Elements:
    
            ^IITR541 = INT.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (Length(report.IITR541) > 15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100070",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Telephone number must not exceed 15 characters",
                    LongDescription = @"For Declarer Telephone number, the maximum allowable characters for this form is 15",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Minimal.Number[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100070" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR541", Value = report.IITR541 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100070

            #region VR.ATO.IITR.100072

            /*  VR.ATO.IITR.100072
            Other given name/s present without the first name.
    
            Legacy Rule Format:
            IF ([iitr24] = NULLORBLANK) AND ([iitr25] <> NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR24 = BLANK) AND (^IITR25 <> BLANK)
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR24) == true && string.IsNullOrWhiteSpace(report.IITR25) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000472",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name is required",
                    LongDescription = @"Other given name is provided without First name",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100072" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100072

            #region VR.ATO.IITR.100073

            /*  VR.ATO.IITR.100073
            Individual name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used.
    
            Legacy Rule Format:
            IF ([iitr24] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR24, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR24, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000437",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100073" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100073

            #region VR.ATO.IITR.100074

            /*  VR.ATO.IITR.100074
            Individual name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used.
    
            Legacy Rule Format:
            IF ([iitr25] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR25, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR25, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000449",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given name cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100074" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100074

            #region VR.ATO.IITR.100075

            /*  VR.ATO.IITR.100075
            Field contains all numeric characters with any combination of spaces; at least one alpha must be present.
    
            Legacy Rule Format:
            IF ([iitr25] <> NULLORBLANK) AND ([iitr25] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR25 <> BLANK) AND (NotContainsSet(^IITR25, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR25) != true && !(IsMatch(report.IITR25, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.410131",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other Given Name must contain at least one alphabetical character",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100075" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100075

            #region VR.ATO.IITR.100076

            /*  VR.ATO.IITR.100076
            Individual or non-individual name field contains repeated hyphen, apostrophe, or space characters.
    
            Legacy Rule Format:
            IF ([iitr25] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR25, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR25, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000451",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given name cannot contain repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100076" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100076

            #region VR.ATO.IITR.100077

            /*  VR.ATO.IITR.100077
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr25] CONTAINS  " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR25, ' - ')
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (report.IITR25 == null ? false : report.IITR25.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000446",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given name cannot contain space hyphen space",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100077" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100077

            #region VR.ATO.IITR.100078

            /*  VR.ATO.IITR.100078
            Individual name field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr25] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR25, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR25, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000450",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100078" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100078

            #region VR.ATO.IITR.100079

            /*  VR.ATO.IITR.100079
            Individual name field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr25] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR25, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR25, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.010448",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given name cannot contain suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100079" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100079

            #region VR.ATO.IITR.100080

            /*  VR.ATO.IITR.100080
            Other given names has a maximum field length of 30
    
            Legacy Rule Format:
            IF LENGTH([iitr25]) > 30
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR25) > 30
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (Length(report.IITR25) > 30);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500041",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other given names must not exceed 30 characters",
                    LongDescription = @"For Other given names, the maximum allowable characters for this form is 30",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100080" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100080

            #region VR.ATO.IITR.100081

            /*  VR.ATO.IITR.100081
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr25] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr25] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR25 <> BLANK) AND (NotCharacterInSet(^IITR25, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR25 = RP:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR25) != true && !(IsMatch(report.IITR25, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500042",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual other given names contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100081" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR25", Value = GetValueOrEmpty(report.IITR25) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100081

            #region VR.ATO.IITR.100082

            /*  VR.ATO.IITR.100082
            Individual First given name has a maximum field length of 15
    
            Legacy Rule Format:
            IF LENGTH([iitr24]) > 15
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR24) > 15
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = (Length(report.IITR24) > 15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500017",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual First given name must not exceed 15 characters",
                    LongDescription = @"For Individual First given name, the maximum allowable characters for this form is 15",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100082" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100082

            #region VR.ATO.IITR.100083

            /*  VR.ATO.IITR.100083
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr24] <> NULLORBLANK) AND ([iitr24] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR24, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR24, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500025",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual First given name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100083" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100083

            #region VR.ATO.IITR.100084

            /*  VR.ATO.IITR.100084
            Field contains all numeric characters with any combination of spaces; at least one alpha must be present.
    
            Legacy Rule Format:
            IF ([iitr24] <> NULLORBLANK) AND ([iitr24] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR24 <> BLANK) AND (NotContainsSet(^IITR24, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR24) != true && !(IsMatch(report.IITR24, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.410063",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Given Name must contain at least one alphabetical character",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100084" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100084

            #region VR.ATO.IITR.100085

            /*  VR.ATO.IITR.100085
            Individual or non-individual name field contains repeated hyphen, apostrophe, or space characters.
    
            Legacy Rule Format:
            IF ([iitr24] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR24, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR24, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000439",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name cannot contain repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100085" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100085

            #region VR.ATO.IITR.100086

            /*  VR.ATO.IITR.100086
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr24] CONTAINS  " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR24, ' - ')
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = (report.IITR24 == null ? false : report.IITR24.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000434",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name cannot contain space hyphen space",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100086" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100086

            #region VR.ATO.IITR.100087

            /*  VR.ATO.IITR.100087
            Individual name field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr24] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR24, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR24, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000438",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100087" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100087

            #region VR.ATO.IITR.100088

            /*  VR.ATO.IITR.100088
            Individual name field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr24] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR24, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR24 = RP:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR24, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.010436",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"First name cannot contain suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100088" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR24", Value = GetValueOrEmpty(report.IITR24) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100088

            #region VR.ATO.IITR.100089

            /*  VR.ATO.IITR.100089
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr538] CONTAINS  " - " )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR538, ' - ')
    
            Data Elements:
    
            ^IITR538 = INT.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = (report.IITR538 == null ? false : report.IITR538.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500057",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name cannot contain space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100089" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR538", Value = report.IITR538 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100089

            #region VR.ATO.IITR.100094

            /*  VR.ATO.IITR.100094
            Reporting Party Declarer Telephone area code has a maximum field length of 4.
    
            Legacy Rule Format:
            IF LENGTH([iitr580]) > 4
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR580) > 4
    
            Data Elements:
    
            ^IITR580 = RP.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
            */
            assertion = (Length(report.IITR580) > 4);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100094",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Declarer Telephone area code must not exceed 4 characters",
                    LongDescription = @"For Reporting Party Declarer Telephone area code, the maximum allowable characters for this form is 4.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100094" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR580", Value = GetValueOrEmpty(report.IITR580) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100094

            #region VR.ATO.IITR.100095

            /*  VR.ATO.IITR.100095
            Intermediary Declarer Telephone area code has a maximum field length of 4.
    
            Legacy Rule Format:
            IF LENGTH([iitr581]) > 4
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR581) > 4
    
            Data Elements:
    
            ^IITR581 = INT.TrueAndCorrect:ElectronicContact.Telephone.Country.Code
            */
            assertion = (Length(report.IITR581) > 4);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100095",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Intermediary Declarer Telephone area code must not exceed 4 characters",
                    LongDescription = @"For Intermediary Declarer Telephone area code, the maximum allowable characters for this form is 4.",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Country.Code[@contextRef='" + report.INTTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.100095" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR581", Value = report.IITR581 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.100095

            #region VR.ATO.IITR.130070

            /*  VR.ATO.IITR.130070
            Declarer Telephone number has a maximum field length of 15
    
            Legacy Rule Format:
            IF LENGTH([iitr553]) > 15
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR553) > 15
    
            Data Elements:
    
            ^IITR553 = RP.TrueAndCorrect:ElectronicContact.Telephone.Minimal.Number
            */
            assertion = (Length(report.IITR553) > 15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.100070",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Telephone number must not exceed 15 characters",
                    LongDescription = @"For Declarer Telephone number, the maximum allowable characters for this form is 15",
                    Location = "/xbrli:xbrl/tns:ElectronicContact.Telephone.Minimal.Number[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.130070" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR553", Value = GetValueOrEmpty(report.IITR553) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.130070

            #region VR.ATO.IITR.130089

            /*  VR.ATO.IITR.130089
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr550] CONTAINS  " - " )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR550, ' - ')
    
            Data Elements:
    
            ^IITR550 = RP.TrueAndCorrect:PersonUnstructuredName.FullName.Text
            */
            assertion = (report.IITR550 == null ? false : report.IITR550.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.500057",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declarer Contact Name cannot contain space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonUnstructuredName.FullName.Text[@contextRef='" + report.RPTrueAndCorrectId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.130089" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR550", Value = GetValueOrEmpty(report.IITR550) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.130089

            #region VR.ATO.IITR.200001

            /*  VR.ATO.IITR.200001
            When there is no electronic claim form indicator present, implying that the return is to be treated as a full Individual return, questions relating to capital gains, foreign entities and foreign source income must be answered.
    
            Legacy Rule Format:
            IF ([iitr13] = NULL) AND (([iitr308] = NULL) OR ([iitr315] = NULL) OR ([iitr317] = NULL) OR ([iitr332] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR13 = NULL) AND ((^IITR308 = NULL) OR (^IITR315 = NULL) OR (^IITR317 = NULL) OR (^IITR332 = NULL))
    
            Data Elements:
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR308 = RP:CapitalGainsTax.Event.Indicator
    
            ^IITR315 = RP:InternationalDealings.DirectOrIndirectOverseasInterest.Indicator
    
            ^IITR317 = RP:Income.InternationalDealings.AttributedForeignIncomeForeignTrustorControlledForeignCompanyorTransferorTrust.Indicator
    
            ^IITR332 = RP:InternationalDealings.AssetsLocatedOutsideAustralia.Indicator
            */
            assertion = (report.IITR13 == null && (report.IITR308 == null || report.IITR315 == null || report.IITR317 == null || report.IITR332 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Questions relating to the full individual return form must be answered",
                    LongDescription = @"When the 'Income Tax Return Type' is not provided, implying that the return is to be treated as a full Individual return, the questions 'Did you have a CGT event during the year', 'Had a direct or indirect interest in a controlled foreign company (CFC)', 'Have you EVER, either directly or indirectly, caused the transfer of property (incl. money) or services to a non-resident trust estate' and 'Owned, or had interest in, assets located outside Australia with total value of AUD $50,000 or more' must all be answered",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ReturnType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR308", Value = GetValueOrEmpty(report.IITR308) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR315", Value = GetValueOrEmpty(report.IITR315) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR317", Value = GetValueOrEmpty(report.IITR317) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR332", Value = GetValueOrEmpty(report.IITR332) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200001

            #region VR.ATO.IITR.200002

            /*  VR.ATO.IITR.200002
            Where the short form Income Tax Return Type is being used, for the claim/application to be valid, certain questions in the return form are not to be answered.  They are: Did you have a CGT event during the year?, Did you have either a direct or indirect interest in a controlled foreign company (CFC)?, Have you ever, either directly or indirectly, caused the transfer of property (incl. money) or services to a non-resident trust estate?, and During the year did you own, or have an interest in, assets located outside Australia which had a total value of AUD $50,000 or more?
    
            Legacy Rule Format:
            IF ([iitr13] <> NULL) AND (([iitr308] <> NULL) OR ([iitr315] <> NULL) OR ([iitr317] <> NULL) OR ([iitr332] <> NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR13 <> NULL) AND ((^IITR308 <> NULL) OR (^IITR315 <> NULL) OR (^IITR317 <> NULL) OR (^IITR332 <> NULL))
    
            Data Elements:
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR308 = RP:CapitalGainsTax.Event.Indicator
    
            ^IITR315 = RP:InternationalDealings.DirectOrIndirectOverseasInterest.Indicator
    
            ^IITR317 = RP:Income.InternationalDealings.AttributedForeignIncomeForeignTrustorControlledForeignCompanyorTransferorTrust.Indicator
    
            ^IITR332 = RP:InternationalDealings.AssetsLocatedOutsideAustralia.Indicator
            */
            assertion = (report.IITR13 != null && (report.IITR308 != null || report.IITR315 != null || report.IITR317 != null || report.IITR332 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Questions relating to a full individual return must not be answered on the short individual return",
                    LongDescription = @"When the 'Income Tax Return Type' is provided, implying that the return is to be treated as a short Individual return, the questions 'Did you have a CGT event during the year', 'Had a direct or indirect interest in a controlled foreign company (CFC)', 'Have you ever, either directly or indirectly, caused the transfer of property (incl. money) or services to a non-resident trust estate' and 'Owned, or had interest in, assets located outside Australia with total value of AUD $50,000 or more' must not be answered",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ReturnType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR308", Value = GetValueOrEmpty(report.IITR308) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR315", Value = GetValueOrEmpty(report.IITR315) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR317", Value = GetValueOrEmpty(report.IITR317) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR332", Value = GetValueOrEmpty(report.IITR332) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200002

            #region VR.ATO.IITR.200003

            /*  VR.ATO.IITR.200003
            The short form Income Tax Return Type is being used, which implies that the return is for a refund of franking credits, and yet the needed amounts for the dividends have not been provided. Unfranked dividends, franked dividends, franking credit or TFN amounts withheld from dividends amounts are needed to make a valid claim.
    
            Legacy Rule Format:
            IF ([iitr13] <> NULL AND ([iitr118] = NULL OR [iitr118] = 0) AND ([iitr119] = NULL OR [iitr119] = 0) AND ([iitr120] = NULL OR [iitr120] = 0) AND ([iitr121] = NULL OR [iitr121] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR13 <> NULL AND (^IITR118 = NULL OR ^IITR118 = 0) AND (^IITR119 = NULL OR ^IITR119 = 0) AND (^IITR120 = NULL OR ^IITR120 = 0) AND (^IITR121 = NULL OR ^IITR121 = 0))
    
            Data Elements:
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR118 = RP:Income.DividendsUnfranked.Amount
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
            ^IITR121 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount
            */
            assertion = (report.IITR13 != null && (report.IITR118 == null || report.IITR118 == 0) && (report.IITR119 == null || report.IITR119 == 0) && (report.IITR120 == null || report.IITR120 == 0) && (report.IITR121 == null || report.IITR121 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividend amounts for the application for the refund of franking credits have not been provided",
                    LongDescription = @"When the 'Income Tax Return Type' is provided, implying that the return is to be treated as a short Individual return, the 'Dividends - Unfranked amount', 'Dividends - Franked amount', 'Dividends - Franking credit' or 'TFN amounts withheld from dividends' amounts must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ReturnType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR121", Value = GetValueOrEmpty(report.IITR121) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200003

            #region VR.ATO.IITR.200016

            /*  VR.ATO.IITR.200016
            Where the 'Seniors and pensioners - Tax offset code' indicates the taxpayer had a spouse during the year, and Spouse's taxable income, Amount of any exempt pension received by your spouse, or Your spouse's tax-free government pensions amounts is zero, check spouse's income for 'Seniors and pensioners - Tax offset code'.
    
            Legacy Rule Format:
            IF ([iitr163] = SET("Eligible spouse lived apart", "Non eligible spouse lived apart", "Eligible spouse lived together", "Non eligible spouse lived together")) AND (([iitr225] <> NULL AND [iitr225] = 0) OR ([iitr230] <> NULL AND [iitr230] = 0) OR ([iitr232] <> NULL AND [iitr232] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (InSet(^IITR163, '"Eligible spouse lived apart", "Non eligible spouse lived apart", "Eligible spouse lived together", "Non eligible spouse lived together"')) AND ((^IITR225 <> NULL AND ^IITR225 = 0) OR (^IITR230 <> NULL AND ^IITR230 = 0) OR (^IITR232 <> NULL AND ^IITR232 = 0))
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code
    
            ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
    
            ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount
            */
            assertion = (IsMatch(report.IITR163, @"^(Eligible spouse lived apart|Non eligible spouse lived apart|Eligible spouse lived together|Non eligible spouse lived together)$") && (report.IITR225 != null && report.IITR225 == 0 || report.IITR230 != null && report.IITR230 == 0 || report.IITR232 != null && report.IITR232 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200016",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check spouse's income for senior and pensioner tax offset",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR163", Value = GetValueOrEmpty(report.IITR163) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = GetValueOrEmpty(report.IITR230) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR232", Value = GetValueOrEmpty(report.IITR232) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200016

            #region VR.ATO.IITR.200018

            /*  VR.ATO.IITR.200018
            Rebate income is required to determine eligibility for Seniors and pensioners tax offset. Spouse's taxable income is part of the rebate income amount and therefore must be present when the Seniors and pensioners tax offset is equal to "Eligible spouse lived apart", "Non eligible spouse lived apart", "Eligible spouse lived together" or "Non eligible spouse lived together."
    
            Legacy Rule Format:
            IF ([iitr163] = SET("Eligible spouse lived apart", "Non eligible spouse lived apart", "Eligible spouse lived together", "Non eligible spouse lived together")) AND ([iitr225] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (InSet(^IITR163, '"Eligible spouse lived apart", "Non eligible spouse lived apart", "Eligible spouse lived together", "Non eligible spouse lived together"')) AND (^IITR225 = NULL)
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code
            */
            assertion = (IsMatch(report.IITR163, @"^(Eligible spouse lived apart|Non eligible spouse lived apart|Eligible spouse lived together|Non eligible spouse lived together)$") && report.IITR225 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable income of spouse must be present for claim of Seniors and pensioners tax offset",
                    LongDescription = @"Rebate income is required to determine eligibility for Seniors and pensioners tax offset. Spouse's taxable income is part of the rebate income amount and therefore must be present when the Seniors and pensioners tax offset is equal to ""Eligible spouse lived apart"", ""Non eligible spouse lived apart"", ""Eligible spouse lived together"" or ""Non eligible spouse lived together.""",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR163", Value = GetValueOrEmpty(report.IITR163) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200018

            #region VR.ATO.IITR.200021

            /*  VR.ATO.IITR.200021
            Where the taxpayer is claiming for the Seniors and pensioners tax offset, and the tax offset code is indicative of the taxpayer having a spouse, the spouse's gender must be provided in the spouse details section of the return form.
    
            Legacy Rule Format:
            IF [iitr163] <> NULL AND [iitr163] <> "Single" AND [iitr218] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR163 <> NULL AND ^IITR163 <> 'Single' AND ^IITR218 = NULL
    
            Data Elements:
    
            ^IITR218 = RP.SPOUSE:PersonDemographicDetails.Sex.Code
    
            ^IITR163 = RP:TaxOffsetClaim.SeniorAndPensioner.Code
            */
            assertion = (report.IITR163 != null && report.IITR163 != @"Single" && report.IITR218 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.230021",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"For the Seniors and pensioners tax offset claim, provide the spouse's gender",
                    LongDescription = @"Where the taxpayer is claiming for the Seniors and pensioners tax offset, and the tax offset code is indicative of the taxpayer having a spouse, the spouse's gender must be provided in the spouse details section of the return form.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Sex.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200021" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR163", Value = GetValueOrEmpty(report.IITR163) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR218", Value = GetValueOrEmpty(report.IITR218) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200021

            #region VR.ATO.IITR.200024

            /*  VR.ATO.IITR.200024
            If Seniors and pensioners - Veteran code is "Spouse Veteran War Widow Widower" or "Both", then details of the taxpayer's spouse is required including Spouse's taxable income, Amount of any Australian Government pensions and allowances received by your spouse in the year of return and Amount of any exempt pension income received by your spouse in the year of the return
    
            Legacy Rule Format:
            IF ([iitr164] = SET("Spouse Veteran War Widow Widower", "Both")) AND ([iitr225] = NULL OR [iitr229] = NULL OR [iitr230] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (InSet(^IITR164, '"Spouse Veteran War Widow Widower", "Both"')) AND (^IITR225 = NULL OR ^IITR229 = NULL OR ^IITR230 = NULL)
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR164 = RP:TaxOffsetClaim.Veteran.Code
    
            ^IITR229 = RP.SPOUSE:Pension.Total.Amount
    
            ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
            */
            assertion = (IsMatch(report.IITR164, @"^(Spouse Veteran War Widow Widower|Both)$") && (report.IITR225 == null || report.IITR229 == null || report.IITR230 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200024",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse details required",
                    LongDescription = @"If Seniors and pensioners - Veteran code is ""Spouse Veteran War Widow Widower"" or ""Both"", then details of the taxpayer's spouse is required including Spouse's taxable income, Amount of any Australian Government pensions and allowances received by your spouse in the year of return and Amount of any exempt pension income received by your spouse in the year of the return",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200024" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR164", Value = GetValueOrEmpty(report.IITR164) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR229", Value = GetValueOrEmpty(report.IITR229) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = GetValueOrEmpty(report.IITR230) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200024

            #region VR.ATO.IITR.200026

            /*  VR.ATO.IITR.200026
            Australian superannuation income stream tax offset amount is greater than zero and the Australian annuities and superannuation income streams income amounts are either missing or equal to zero.
    
            Legacy Rule Format:
            IF ([iitr166] > 0) AND (([iitr92] = NULL) OR ([iitr92] = 0)) AND (([iitr93] = NULL) OR ([iitr93] = 0)) AND (([iitr94] = NULL) OR ([iitr94] = 0)) AND (([iitr95] = NULL) OR ([iitr95] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR166 > 0) AND ((^IITR92 = NULL) OR (^IITR92 = 0)) AND ((^IITR93 = NULL) OR (^IITR93 = 0)) AND ((^IITR94 = NULL) OR (^IITR94 = 0)) AND ((^IITR95 = NULL) OR (^IITR95 = 0))
    
            Data Elements:
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
            */
            assertion = (report.IITR166.GetValueOrDefault() > 0 && (report.IITR92 == null || report.IITR92 == 0) && (report.IITR93 == null || report.IITR93 == 0) && (report.IITR94 == null || report.IITR94 == 0) && (report.IITR95 == null || report.IITR95 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.201026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian superannuation income stream offset amount is invalid",
                    LongDescription = @"Australian superannuation income stream offset amount must either be not provided or zero, when the Australian annuities and superannuation income streams income amounts are either not present or zero. Australian annuities and superannuation income streams income amount fields include the following; Australian annuities and superannuation income streams Taxable component ""Taxed element"", Australian annuities and superannuation income streams Taxable component ""Untaxed element"", Australian annuities and superannuation income streams Lump sum in arrears ""Taxed element"", Australian annuities and superannuation income streams Lump sum in arrears ""Untaxed element"".",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200026

            #region VR.ATO.IITR.200030

            /*  VR.ATO.IITR.200030
            Where the Spouse's family name at Spouse Details is present and Number of dependent children and students is also present, the Spouse's taxable income for the current income year is required.
    
            Legacy Rule Format:
            IF ([iitr213] <> NULLORBLANK AND [iitr171] > 0) AND ([iitr225] = NULL)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR213 <> BLANK AND ^IITR171 > 0) AND (^IITR225 = NULL)
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR171 = RP:IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR213) != true && report.IITR171.GetValueOrDefault() > 0 && report.IITR225 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.200030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouses taxable income is required",
                    LongDescription = @"Where the Spouse's or de facto spouse's family name at Spouse Details is present and Number of dependent children and students is also present, the Spouse's taxable income for the current income year is required",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.200030" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR171", Value = report.IITR171.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.200030

            #region VR.ATO.IITR.210014

            /*  VR.ATO.IITR.210014
            The combined adjusted taxable income of the taxpayer and spouse is used to assess eligibility for the Invalid and Invalid Carer tax offset. The spouse's taxable income is required to determine the combined adjusted taxable income. Where the taxpayer has indicated they have a spouse, please ensure the spouse's taxable income is present.
    
            Legacy Rule Format:
            IF [iitr386] > 0 AND ([iitr220]=TRUE OR ([iitr221] <> NULL AND [iitr222] <> NULL)) AND [iitr225] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR386 > 0 AND (^IITR220=TRUE OR (^IITR221 <> NULL AND ^IITR222 <> NULL)) AND ^IITR225 = NULL
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR386 = RP:TaxOffsetClaim.DependentInvalidAndCarer.Amount
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
            */
            assertion = (report.IITR386.GetValueOrDefault() > 0 && (report.IITR220 == true || report.IITR221 != null && report.IITR222 != null) && report.IITR225 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.020014",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's taxable income required for Invalid and Invalid Carer tax offset claim",
                    LongDescription = @"The combined adjusted taxable income of the taxpayer and spouse is used to assess eligibility for the Invalid and Invalid Carer tax offset. The spouse's taxable income is required to determine the combined adjusted taxable income. Where the taxpayer has indicated they have a spouse, please ensure the spouse's taxable income is present.",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR386", Value = GetValueOrEmpty(report.IITR386) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210014

            #region VR.ATO.IITR.210015

            /*  VR.ATO.IITR.210015
            Where the number of dependent children is above zero, the correct Tax claim code must be provided.
    
            Legacy Rule Format:
            IF (ANY OCCURRENCE OF ([iitr185]) = SET("Covered as dependent child", "No dependants") AND ([iitr207] > 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR185,InSet(^IITR185, '"Covered as dependent child", "No dependants"') AND (^IITR207 > 0))
    
            Data Elements:
    
            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
            ^IITR207 = RP:PersonDemographicDetails.DependentChildren.Count
            */
            assertion = (report.RPPHISeqNumContextCollection == null ? false : report.RPPHISeqNumContextCollection.Any(IITR185Repeat => IsMatch(IITR185Repeat.IITR185, @"^(Covered as dependent child|No dependants)$") && report.IITR207.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210015",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Correct Tax claim code must be provided",
                    LongDescription = @"Where the number of dependent children is above zero, the correct Tax claim code must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "Count(IITR185)" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR207", Value = "IITR207" });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210015

            #region VR.ATO.IITR.210016

            /*  VR.ATO.IITR.210016
            Where the tax claim code is Claiming your share of rebate or Claiming your spouses share of rebate, the Spouse's family name, date of birth, 'Had spouse for the full year' or 'Spouse details - Date had a spouse from' or 'Spouse details - Date had a spouse to' and Spouse's taxable income and number of dependent children must be provided.
    
            Legacy Rule Format:
            IF (ANY OCCURRENCE OF ([iitr185]) = SET("Claiming your share of rebate", "Claiming your spouses share of rebate")) AND (([iitr213] = NULLORBLANK OR [iitr217] = NULL OR ([iitr220] = TRUE AND ([iitr221] <> NULL OR [iitr222] <> NULL))) OR ([iitr220] <> TRUE AND ([iitr221] = NULL OR [iitr222] = NULL)) OR ([iitr225] = NULL OR [iitr207] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR185,InSet(^IITR185, '"Claiming your share of rebate", "Claiming your spouses share of rebate"')) AND ((^IITR213 = BLANK OR ^IITR217 = NULL OR (^IITR220 = TRUE AND (^IITR221 <> NULL OR ^IITR222 <> NULL))) OR (^IITR220 <> TRUE AND (^IITR221 = NULL OR ^IITR222 = NULL)) OR (^IITR225 = NULL OR ^IITR207 = NULL))
    
            Data Elements:
    
            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR207 = RP:PersonDemographicDetails.DependentChildren.Count
            */
            assertion = ((report.RPPHISeqNumContextCollection == null ? false : report.RPPHISeqNumContextCollection.Any(IITR185Repeat => IsMatch(IITR185Repeat.IITR185, @"^(Claiming your share of rebate|Claiming your spouses share of rebate)$"))) && (string.IsNullOrWhiteSpace(report.IITR213) == true || report.IITR217 == null || report.IITR220 == true && (report.IITR221 != null || report.IITR222 != null) || report.IITR220 != true && (report.IITR221 == null || report.IITR222 == null) || (report.IITR225 == null || report.IITR207 == null)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse details required",
                    LongDescription = @"Spouse details required where private health insurance tax claim indicates a spouse during the income year.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "Count(IITR185)" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR207", Value = report.IITR207.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210016

            #region VR.ATO.IITR.210017

            /*  VR.ATO.IITR.210017
            Where the Tax claim code selected is 'Spouse claiming your share of rebate', Spouse's family name, date of birth, 'Had spouse for the full year' or part year must be provided.
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF ([iitr185] = "Spouse claiming your share of rebate") AND ([iitr213] = NULLORBLANK OR [iitr217] = NULL OR ([iitr220] = TRUE AND ([iitr221] <> NULL OR [iitr222] <> NULL)) OR ([iitr220] <> TRUE AND ([iitr221] = NULL OR [iitr222] = NULL)))
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (AnyOccurrence(^IITR185, ^IITR185 = 'Spouse claiming your share of rebate')) AND (^IITR213 = BLANK OR ^IITR217 = NULL OR (^IITR220 = TRUE AND (^IITR221 <> NULL OR ^IITR222 <> NULL)) OR (^IITR220 <> TRUE AND (^IITR221 = NULL OR ^IITR222 = NULL)))
    
            Data Elements:
    
            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
            */
            assertion = ((report.RPPHISeqNumContextCollection == null ? false : report.RPPHISeqNumContextCollection.Any(IITR185Repeat => IITR185Repeat.IITR185 == @"Spouse claiming your share of rebate")) && (string.IsNullOrWhiteSpace(report.IITR213) == true || report.IITR217 == null || report.IITR220 == true && (report.IITR221 != null || report.IITR222 != null) || report.IITR220 != true && (report.IITR221 == null || report.IITR222 == null)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210017",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse details are required",
                    LongDescription = @"Where the Tax claim code selected is 'Spouse claiming your share of rebate', Spouse's or de facto spouse's family name, date of birth, 'Had spouse for the full year' or part year must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210017" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "IITR185" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210017

            #region VR.ATO.IITR.210018

            /*  VR.ATO.IITR.210018
            When Superannuation contributions paid on behalf of your spouse tax offset amount is present, the Spouse's or de facto spouse's family name and taxable income are required
    
            Legacy Rule Format:
            IF ([iitr379] > 0 AND ([iitr213] = NULLORBLANK OR [iitr225] = NULL))
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR379 > 0 AND (^IITR213 = BLANK OR ^IITR225 = NULL))
    
            Data Elements:
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
            */
            assertion = (report.IITR379.GetValueOrDefault() > 0 && (string.IsNullOrWhiteSpace(report.IITR213) == true || report.IITR225 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.211018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name and Spouse's taxable income are required",
                    LongDescription = @"When Superannuation contributions paid on behalf of your spouse tax offset amount is present, the Spouse's or de facto spouse's family name and taxable income are required",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210018

            #region VR.ATO.IITR.210019

            /*  VR.ATO.IITR.210019
            Where the taxpayer has had a spouse for the full year and the Spouse's taxable income is $40,000 or above, Superannuation contributions on behalf of your spouse tax offset must not be provided
    
            Legacy Rule Format:
            IF [iitr220] = TRUE AND [iitr225] >= 40000 AND [iitr379] > 0
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR220 = TRUE AND ^IITR225 >= 40000 AND ^IITR379 > 0
    
            Data Elements:
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
            */
            assertion = (report.IITR220 == true && report.IITR225.GetValueOrDefault() >= 40000 && report.IITR379.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210019",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Superannuation contributions on behalf of your spouse tax offset must not be provided",
                    LongDescription = @"Where the taxpayer has had a spouse for the full year and the Spouse's taxable income is $40,000 or above, Superannuation contributions on behalf of your spouse tax offset must not be provided",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.SuperannuationContributionSpouse.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210019" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210019

            #region VR.ATO.IITR.210022

            /*  VR.ATO.IITR.210022
            Value entered is not a valid code/value for that field. 
            Valid Other refundable tax offsets codes for this form are "BeneficiarySpecialDisabilityTrust", "MultipleTaxOffsets" or "ExplorationCreditRefundableTaxOffset".
    
            Legacy Rule Format:
            IF ([iitr396] <> NULLORBLANK) AND ([iitr396]  <> SET("BeneficiarySpecialDisabilityTrust","MultipleTaxOffsets","ExplorationCreditRefundableTaxOffset"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR396 <> BLANK) AND (NotInSet(^IITR396, '"BeneficiarySpecialDisabilityTrust","MultipleTaxOffsets","ExplorationCreditRefundableTaxOffset"'))
    
            Data Elements:
    
            ^IITR396 = RP:IncomeTax.TaxOffsetRefundableOther.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR396) != true && !(IsMatch(report.IITR396, @"^(BeneficiarySpecialDisabilityTrust|MultipleTaxOffsets|ExplorationCreditRefundableTaxOffset)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210022",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Other refundable tax offsets code provided",
                    LongDescription = @"Valid Other refundable tax offsets codes for this form are ""BeneficiarySpecialDisabilityTrust"", ""MultipleTaxOffsets"" or ""ExplorationCreditRefundableTaxOffset""",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TaxOffsetRefundableOther.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210022" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR396", Value = GetValueOrEmpty(report.IITR396) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210022

            #region VR.ATO.IITR.210023

            /*  VR.ATO.IITR.210023
            Other refundable tax offsets codes "MultipleTaxOffsets" and "ExplorationCreditRefundableTaxOffset" are only valid if the taxpayer was an Australian resident for the full year for tax purposes
    
            Legacy Rule Format:
            IF ([iitr396] = SET("MultipleTaxOffsets","ExplorationCreditRefundableTaxOffset")) AND (([iitr19] = FALSE) OR ([iitr666] <> NULL AND [iitr667] <> NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (InSet(^IITR396, '"MultipleTaxOffsets","ExplorationCreditRefundableTaxOffset"')) AND ((^IITR19 = FALSE) OR (^IITR666 <> NULL AND ^IITR667 <> NULL))
    
            Data Elements:
    
            ^IITR396 = RP:IncomeTax.TaxOffsetRefundableOther.Code
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
            */
            assertion = (IsMatch(report.IITR396, @"^(MultipleTaxOffsets|ExplorationCreditRefundableTaxOffset)$") && (report.IITR19 == false || report.IITR666 != null && report.IITR667 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other refundable tax offsets code is incorrect",
                    LongDescription = @"Other refundable tax offsets codes ""MultipleTaxOffsets"" and ""ExplorationCreditRefundableTaxOffset"" are only valid if the taxpayer was an Australian resident for the full year for tax purposes",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TaxOffsetRefundableOther.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210023" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR396", Value = GetValueOrEmpty(report.IITR396) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210023

            #region VR.ATO.IITR.210046

            /*  VR.ATO.IITR.210046
            Partnership share of 'net small business income' less deductions attributable to that share has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr558] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR558, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR558 = RP.Partnership:Income.SmallBusinessEntityNet.Amount
            */
            assertion = NotMonetary(report.IITR558, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210046",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Partnership share of 'net small business income' less deductions attributable to that share is not in a valid monetary format",
                    LongDescription = @"Partnership share of 'net small business income' less deductions attributable to that share must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPPartnershipId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210046" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR558", Value = GetValueOrEmpty(report.IITR558) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210046

            #region VR.ATO.IITR.210047

            /*  VR.ATO.IITR.210047
            Trust share of 'net small business income' less deductions attributable to that share has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr559] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR559, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR559 = RP.Trust:Income.SmallBusinessEntityNet.Amount
            */
            assertion = NotMonetary(report.IITR559, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210047",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Trust share of 'net small business income' less deductions attributable to that share is not in a valid monetary format",
                    LongDescription = @"Trust share of 'net small business income' less deductions attributable to that share must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPTrustId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210047" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR559", Value = GetValueOrEmpty(report.IITR559) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210047

            #region VR.ATO.IITR.210048

            /*  VR.ATO.IITR.210048
            Net small business income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr557] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR557, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR557 = RP:Income.SmallBusinessEntityNet.Amount
            */
            assertion = NotMonetary(report.IITR557, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210048",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net small business income is not in a valid monetary format",
                    LongDescription = @"Net small business income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210048" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR557", Value = GetValueOrEmpty(report.IITR557) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210048

            #region VR.ATO.IITR.210050

            /*  VR.ATO.IITR.210050
            Where 'Superannuation contributions on behalf of your spouse tax offset' is present, and 'Your spouse's total reportable fringe benefits amounts from employers exempt under section 57A', 'Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A' and 'Spouse reportable superannuation contributions' are not present, check the applicable spouse income amount details
    
            Legacy Rule Format:
            IF [iitr379] > 0 AND [iitr492] = NULL AND [iitr493] = NULL AND [iitr231] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR379 > 0 AND ^IITR492 = NULL AND ^IITR493 = NULL AND ^IITR231 = NULL
    
            Data Elements:
    
            ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR379 = RP:TaxOffsetClaim.SuperannuationContributionSpouse.Amount
    
            ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount
            */
            assertion = (report.IITR379.GetValueOrDefault() > 0 && report.IITR492 == null && report.IITR493 == null && report.IITR231 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210050",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check spouse income from payment summaries",
                    LongDescription = @"When claiming the Spouse superannuation contribution tax offset, if the taxpayer's spouse has Reportable fringe benefits or Reportable employer superannuation contributions on their payment summaries, complete the applicable fields in Spouse details - married or de facto.",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPSPOUSEEligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210050" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR379", Value = GetValueOrEmpty(report.IITR379) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR492", Value = GetValueOrEmpty(report.IITR492) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR493", Value = GetValueOrEmpty(report.IITR493) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR231", Value = GetValueOrEmpty(report.IITR231) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210050

            #region VR.ATO.IITR.210051

            /*  VR.ATO.IITR.210051
            The 'Applied exemption or rollover code' of "T - Small Business Restructure Roll-over" is only applicable for a small business entity, or an entity that is either (a) an affiliate, (b) connected with an entity, or (c) a partner in a partnership, that is a small business entity
    
            Legacy Rule Format:
            IF (([iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + [iitr447] + [iitr448]) > 10000000) AND (ANY OCCURRENCE OF([iitr310]) = "T - Small Business Restructure Roll-over")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ^IITR447 + ^IITR448) > 10000000) AND (AnyOccurrence(^IITR310, ^IITR310 = 'T - Small Business Restructure Roll-over'))
    
            Data Elements:
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
            */
            assertion = (report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 10000000 && (report.IITR310Collection == null ? false : report.IITR310Collection.Any(IITR310Repeat => IITR310Repeat == @"T - Small Business Restructure Roll-over")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.210051",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Total business income exceeds threshold",
                    LongDescription = @"The 'Applied exemption or rollover code' of ""T - Small Business Restructure Roll-over"" is only applicable for a small business entity, or an entity that is either (a) an affiliate, (b) connected with an entity, or (c) a partner in a partnership, that is a small business entity",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210051" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR310", Value = "IITR310" });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.210051

            #region VR.ATO.IITR.300000

            /*  VR.ATO.IITR.300000
            Net capital gain and Net capital losses carried forward to later income years are both greater than zero. This is only correct when all of the Net capital losses carried forward relate to Collectables.
    
            Legacy Rule Format:
            IF ([iitr311] > 0) AND ([iitr313] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR311 > 0) AND (^IITR313 > 0)
    
            Data Elements:
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
    
            ^IITR313 = RP(Instant):Capital.Losses.CarriedForward.Net.Amount
            */
            assertion = (report.IITR311.GetValueOrDefault() > 0 && report.IITR313.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300000",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check net capital gains and net capital losses carried forward relate to Collectables.",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300000" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR313", Value = GetValueOrEmpty(report.IITR313) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300000

            #region VR.ATO.IITR.300001

            /*  VR.ATO.IITR.300001
            Primary production (PP) averaging will be applied to this assessment as there is a zero at one or more of the PP amount fields.  PP fields include; Distribution from partnerships, Share of net income from trusts, Deductions relating to amounts shown at Distribution from partnerships and Share of net income from trusts, Net Primary Production income/loss, and Net farm management deposits or repayments. These amount fields may have been completed as a result of information supplied in the main partnership or trust returns or the business income and expense sections. If PP averaging is not to apply to this assessment, PP amount fields must be left blank. Note a zero at the Share of net income from trusts is acceptable where the beneficiary is presently entitled to the income of a trust that is carrying on a primary production business that resulted in a loss.
    
            Legacy Rule Format:
            IF ([iitr242] <> NULL AND [iitr242] = 0) OR ([iitr243] <> NULL AND [iitr243] = 0) OR ([iitr246] <> NULL AND [iitr246] = 0) OR ([iitr281] <> NULL AND [iitr281] = 0) OR ([iitr306] <> NULL AND [iitr306] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR242 <> NULL AND ^IITR242 = 0) OR (^IITR243 <> NULL AND ^IITR243 = 0) OR (^IITR246 <> NULL AND ^IITR246 = 0) OR (^IITR281 <> NULL AND ^IITR281 = 0) OR (^IITR306 <> NULL AND ^IITR306 = 0)
    
            Data Elements:
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR246 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Amount
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount
            */
            assertion = (report.IITR242 != null && report.IITR242 == 0 || report.IITR243 != null && report.IITR243 == 0 || report.IITR246 != null && report.IITR246 == 0 || report.IITR281 != null && report.IITR281 == 0 || report.IITR306 != null && report.IITR306 == 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300001",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Primary production averaging will be applied as there is a zero at one or more of the labels",
                    LongDescription = @"Primary production (PP) averaging will be applied to this assessment as there is a zero at one or more of the PP labels.  PP Labels are the PP Partnership distributions and trust share of net income and related deductions, net income or loss from business - PP and net farm management deposits or repayments. These labels may have been completed as a result of information supplied in the main partnership or trust returns or the business income and expense labels.  If PP averaging is not to apply to this assessment, PP labels must be left blank. Note a zero at the share of net income from trust label is acceptable where the beneficiary is presently entitled to the income of a trust that is carrying on a primary production business that resulted in a loss.",
                    Location = "/xbrli:xbrl/tns:Income.PartnershipPrimaryProductionShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR246", Value = GetValueOrEmpty(report.IITR246) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR306", Value = GetValueOrEmpty(report.IITR306) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300001

            #region VR.ATO.IITR.300003

            /*  VR.ATO.IITR.300003
            Where Tax-free government pensions is greater than zero and either Australian Government allowances and payments, Australian Government pensions and allowances, or Australian annuities and Superannuation income streams are greater than zero, check Tax-free government pensions.
    
            Legacy Rule Format:
            IF ([iitr202] > 0) AND ([iitr86] > 0 OR [iitr89] > 0 OR [iitr92] > 0 OR [iitr93] > 0 OR [iitr505] > 0 OR [iitr94] > 0 OR [iitr95] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR202 > 0) AND (^IITR86 > 0 OR ^IITR89 > 0 OR ^IITR92 > 0 OR ^IITR93 > 0 OR ^IITR505 > 0 OR ^IITR94 > 0 OR ^IITR95 > 0)
    
            Data Elements:
    
            ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
    
            ^IITR202 = RP:Pension.TaxFree.Amount
    
            ^IITR89 = RP:Pension.Total.Amount
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
            */
            assertion = (report.IITR202.GetValueOrDefault() > 0 && (report.IITR86.GetValueOrDefault() > 0 || report.IITR89.GetValueOrDefault() > 0 || report.IITR92.GetValueOrDefault() > 0 || report.IITR93.GetValueOrDefault() > 0 || report.IITR505.GetValueOrDefault() > 0 || report.IITR94.GetValueOrDefault() > 0 || report.IITR95.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300003",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check tax free pension amounts",
                    LongDescription = @"Ensure only tax-free pensions paid by Centrelink or Department of Veterans Affairs are included in Tax-free government pensions; and NOT taxable payments shown at Australian Government allowances and payments, Australian Government pensions and allowances or Australian annuities and superannuation income streams",
                    Location = "/xbrli:xbrl/tns:Income.AustralianGovernmentAllowancesAndPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR202", Value = GetValueOrEmpty(report.IITR202) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300003

            #region VR.ATO.IITR.300004

            /*  VR.ATO.IITR.300004
            Where Target foreign income is greater than zero, and either CFC income, Transferor trust income, Other net foreign employment income, Net foreign pension or annuity income without an undeducted purchase price, Net foreign pension or annuity income with an undeducted purchase price, Net foreign rent, Other net foreign source income, or Australian franking credits from a New Zealand franking company, are greater than zero, check foreign income amounts.
    
            Legacy Rule Format:
            IF ([iitr203] > 0) AND ([iitr316] > 0 OR [iitr318] > 0 OR [iitr321] > 0 OR [iitr322] > 0 OR [iitr323] > 0 OR [iitr324] > 0 OR [iitr327] > 0 OR [iitr328] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR203 > 0) AND (^IITR316 > 0 OR ^IITR318 > 0 OR ^IITR321 > 0 OR ^IITR322 > 0 OR ^IITR323 > 0 OR ^IITR324 > 0 OR ^IITR327 > 0 OR ^IITR328 > 0)
    
            Data Elements:
    
            ^IITR203 = RP:InternationalDealings.ForeignIncomeTarget.Amount
    
            ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
    
            ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
    
            ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
            ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
    
            ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount
            */
            assertion = (report.IITR203.GetValueOrDefault() > 0 && (report.IITR316.GetValueOrDefault() > 0 || report.IITR318.GetValueOrDefault() > 0 || report.IITR321.GetValueOrDefault() > 0 || report.IITR322.GetValueOrDefault() > 0 || report.IITR323.GetValueOrDefault() > 0 || report.IITR324.GetValueOrDefault() > 0 || report.IITR327.GetValueOrDefault() > 0 || report.IITR328.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300004",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check foreign income amounts",
                    LongDescription = @"Do not include in Target foreign income amounts of foreign income that will be included in taxable income. Amounts reported in the Supplementary section at CFC income, Transferor trust income, Net foreign pension or annuity income without an undeducted purchase price, Net foreign pension or annuity income with an undeducted purchase price, Net foreign rent, Other net foreign source income or Australian franking credits from a New Zealand franking company should not be included in Target foreign income.",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeTarget.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR203", Value = GetValueOrEmpty(report.IITR203) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR328", Value = GetValueOrEmpty(report.IITR328) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300004

            #region VR.ATO.IITR.300008

            /*  VR.ATO.IITR.300008
            Where Early repayments - natural disaster and drought and Other repayments are greater than zero with identical amounts, check net farm management repayments.
    
            Legacy Rule Format:
            IF [iitr304] > 0 AND [iitr305] > 0 AND [iitr304] = [iitr305]
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR304 > 0 AND ^IITR305 > 0 AND ^IITR304 = ^IITR305
    
            Data Elements:
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
            */
            assertion = (report.IITR304.GetValueOrDefault() > 0 && report.IITR305.GetValueOrDefault() > 0 && report.IITR304.GetValueOrDefault() == report.IITR305.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300008",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check net farm management repayments where identical amounts have been entered",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300008" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300008

            #region VR.ATO.IITR.300010

            /*  VR.ATO.IITR.300010
            Where Adjusted taxable income is less than or equal to $37,000 or Taxable income or loss is less than $53,564; and primary production Distribution from partnerships or non-primary Production distributions from partnerships less foreign income are greater than zero, and there is no amount for Income from investment, partnership and other sources, check criteria as Government super contributions should be completed where a low income super contribution or a co-contribution may be entitled so any business partnership income will be recorded as business income.
    
            Legacy Rule Format:
            IF ((([iitr208] = NULL OR [iitr208] <= 37000) OR (([iitr157] = NULL) OR ([iitr157] < 53564))) AND (([iitr242] > 0) OR ([iitr252] > 0)) AND ([iitr194] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (((^IITR208 = NULL OR ^IITR208 <= 37000) OR ((^IITR157 = NULL) OR (^IITR157 < 53564))) AND ((^IITR242 > 0) OR (^IITR252 > 0)) AND (^IITR194 = NULL))
    
            Data Elements:
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
            */
            assertion = ((report.IITR208 == null || report.IITR208.GetValueOrDefault() <= 37000 || (report.IITR157 == null || report.IITR157.GetValueOrDefault() < 53564)) && (report.IITR242.GetValueOrDefault() > 0 || report.IITR252.GetValueOrDefault() > 0) && report.IITR194 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.302010",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check completion of Government super contributions",
                    LongDescription = @"Government super contributions should be completed where a low income super contribution or a co-contribution may be entitled so any business partnership income will be recorded as business income",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300010" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300010

            #region VR.ATO.IITR.300011

            /*  VR.ATO.IITR.300011
            Where Adjusted taxable income is less than or equal to $37,000, and primary production Distribution from partnerships is not present, and non-primary Production distributions from partnerships less foreign income is not present, and Estimated eligible income is less than 10% of Estimated total income, check criteria as Government super contributions fields do not need to be completed for low income super contribution purposes, unless employment or business income has been disclosed that relates to an earlier income year at Salary and wages, Allowances, earnings, tips, director's fees, Total assessable discount amount, Total reportable fringe benefits amount, Reportable employer superannuation contributions, or Business income and expenses.
    
            Legacy Rule Format:
            IF ([iitr208] = NULL OR [iitr208] <= 37000) AND ([iitr242] = NULL OR [iitr242] = 0) AND ([iitr252] = NULL OR [iitr252] = 0) AND (([iitr210] <> NULL AND [iitr210] < ([iitr209] * 0.1)) OR ([iitr210] = NULL AND ([iitr209] * 0.1) > 0)) 
              RETURN VALIDATION MESSAGE 
            ENDIF

            Technical Business Rule Format:
            (^IITR208 = NULL OR ^IITR208 <= 37000) AND (^IITR242 = NULL OR ^IITR242 = 0) AND (^IITR252 = NULL OR ^IITR252 = 0) AND ((^IITR210 <> NULL AND ^IITR210 < (^IITR209 * 0.1)) OR (^IITR210 = NULL AND (^IITR209 * 0.1) > 0))
    
            Data Elements:
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR210 = RP:Income.LowIncomeSuperannuationContributionEligible.Amount
    
            ^IITR209 = RP:Income.Estimated.Amount
            */
            assertion = ((report.IITR208 == null || report.IITR208.GetValueOrDefault() <= 37000) && (report.IITR242 == null || report.IITR242 == 0) && (report.IITR252 == null || report.IITR252 == 0) && (report.IITR210 != null && report.IITR210.GetValueOrDefault() < report.IITR209.GetValueOrDefault() * 0.1M || report.IITR210 == null && report.IITR209.GetValueOrDefault() * 0.1M > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300011",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check completion of Government super contributions",
                    LongDescription = @"Government super contributions fields do not need to be completed for low income super contribution purposes, unless employment or business income has been disclosed that relates to an earlier income year at Salary and Wages; Allowances, earnings, tips, director's fees; total assessable discount amount; Total reportable fringe benefits amount; Reportable employer superannuation contributions or Business income and expenses.",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300011" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR210", Value = GetValueOrEmpty(report.IITR210) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR209", Value = GetValueOrEmpty(report.IITR209) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300011

            #region VR.ATO.IITR.300012

            /*  VR.ATO.IITR.300012
            Where Adjusted taxable income is less than $37,000, and primary production Distribution from partnerships is not present, and non-primary Production distributions from partnerships less foreign income is not present, and Estimated eligible income is greater than or equal to 10% of Estimated total income, check criteria as Government super contributions fields may need to be completed for low income super contribution purposes, where employment or business income that relates to an earlier income year for Salary and wages, Allowances, earnings, tips, director's fees, Total assessable discount amount, Total reportable fringe benefits amount, Reportable employer superannuation contributions, or Business income and expenses has been disclosed.
    
            Legacy Rule Format:
            IF (([iitr19] = TRUE) AND ([iitr208] = NULL OR [iitr208] < 37000) AND ([iitr242] = NULL OR [iitr242] = 0) AND ([iitr252] = NULL OR [iitr252] = 0) AND (([iitr210] <> NULL AND [iitr210] >= ([iitr209] * 0.1)) OR ([iitr210] = NULL AND ([iitr209] * 0.1) <= 0)))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR19 = TRUE) AND (^IITR208 = NULL OR ^IITR208 < 37000) AND (^IITR242 = NULL OR ^IITR242 = 0) AND (^IITR252 = NULL OR ^IITR252 = 0) AND ((^IITR210 <> NULL AND ^IITR210 >= (^IITR209 * 0.1)) OR (^IITR210 = NULL AND (^IITR209 * 0.1) <= 0)))
    
            Data Elements:
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR19 = RP:Residency.TaxPurposesPersonStatus.Indicator
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR210 = RP:Income.LowIncomeSuperannuationContributionEligible.Amount
    
            ^IITR209 = RP:Income.Estimated.Amount
            */
            assertion = (report.IITR19 == true && (report.IITR208 == null || report.IITR208.GetValueOrDefault() < 37000) && (report.IITR242 == null || report.IITR242 == 0) && (report.IITR252 == null || report.IITR252 == 0) && (report.IITR210 != null && report.IITR210.GetValueOrDefault() >= report.IITR209.GetValueOrDefault() * 0.1M || report.IITR210 == null && report.IITR209.GetValueOrDefault() * 0.1M <= 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300012",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Government super contribution fields may need to be completed",
                    LongDescription = @"Government super contributions fields may need to be completed for low income super contribution purposes, where employment or business income that relates to an earlier income year for Salary and Wages; Allowances, earnings, tips, director's fees; total assessable discount amount; Total reportable fringe benefits amount; Reportable employer superannuation contributions or Business income and expenses has been disclosed.",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR19", Value = GetValueOrEmpty(report.IITR19) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR210", Value = GetValueOrEmpty(report.IITR210) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR209", Value = GetValueOrEmpty(report.IITR209) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300012

            #region VR.ATO.IITR.300030

            /*  VR.ATO.IITR.300030
            There are amounts reporting for either primary production or non-primary production income in the Business income and expenses section; or Net Personal Services Income is present however there is no Industry code.
    
            Legacy Rule Format:
            IF ([iitr436] <> NULL OR [iitr437] <> NULL OR [iitr438] <> NULL OR [iitr439] <> NULL OR [iitr440] <> NULL OR [iitr441] <> NULL OR [iitr442] <> NULL OR [iitr443] <> NULL OR [iitr445] <> NULL OR [iitr447] <> NULL OR [iitr448] <> NULL OR [iitr279] <> NULL) AND [iitr419] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR436 <> NULL OR ^IITR437 <> NULL OR ^IITR438 <> NULL OR ^IITR439 <> NULL OR ^IITR440 <> NULL OR ^IITR441 <> NULL OR ^IITR442 <> NULL OR ^IITR443 <> NULL OR ^IITR445 <> NULL OR ^IITR447 <> NULL OR ^IITR448 <> NULL OR ^IITR279 <> NULL) AND ^IITR419 = BLANK
    
            Data Elements:
    
            ^IITR419 = RP:OrganisationDetails.OrganisationIndustry2006Extended.Code
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
            */
            assertion = ((report.IITR436 != null || report.IITR437 != null || report.IITR438 != null || report.IITR439 != null || report.IITR440 != null || report.IITR441 != null || report.IITR442 != null || report.IITR443 != null || report.IITR445 != null || report.IITR447 != null || report.IITR448 != null || report.IITR279 != null) && string.IsNullOrWhiteSpace(report.IITR419) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"ATO Australian and New Zealand Standard Industrial Classification code required",
                    LongDescription = @"There are amounts reporting for either primary production or non-primary production income in the Business income and expenses section; or Net Personal Services Income is present however there is no Industry code",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationIndustry2006Extended.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300030" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR419", Value = GetValueOrEmpty(report.IITR419) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300030

            #region VR.ATO.IITR.300031

            /*  VR.ATO.IITR.300031
            Where there is an industry code is present, there must be a description of main business activity or amounts at primary production or non-primary production income in the Business income and expenses section; or Net Personal Services Income.
    
            Legacy Rule Format:
            IF [iitr419] <> NULLORBLANK AND ([iitr418] = NULLORBLANK OR ([iitr436] = NULL AND [iitr437] = NULL AND [iitr438] = NULL AND [iitr439] = NULL AND [iitr440] = NULL AND [iitr441] = NULL AND [iitr442] = NULL AND [iitr443] = NULL AND [iitr445] = NULL AND [iitr447] = NULL AND [iitr448] = NULL AND [iitr279] = NULL))
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR419 <> BLANK AND (^IITR418 = BLANK OR (^IITR436 = NULL AND ^IITR437 = NULL AND ^IITR438 = NULL AND ^IITR439 = NULL AND ^IITR440 = NULL AND ^IITR441 = NULL AND ^IITR442 = NULL AND ^IITR443 = NULL AND ^IITR445 = NULL AND ^IITR447 = NULL AND ^IITR448 = NULL AND ^IITR279 = NULL))
    
            Data Elements:
    
            ^IITR419 = RP:OrganisationDetails.OrganisationIndustry2006Extended.Code
    
            ^IITR418 = RP:OrganisationDetails.MainIncomeActivity.Description
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR279 = RP:Income.PersonalServicesIncome.Net.Amount
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR419) != true && (string.IsNullOrWhiteSpace(report.IITR418) == true || report.IITR436 == null && report.IITR437 == null && report.IITR438 == null && report.IITR439 == null && report.IITR440 == null && report.IITR441 == null && report.IITR442 == null && report.IITR443 == null && report.IITR445 == null && report.IITR447 == null && report.IITR448 == null && report.IITR279 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300031",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total business or personal services income, and description of main business activity are required",
                    LongDescription = @"Where industry code is present, there must be a description of main business activity, amounts at primary production or non-primary production income in the Business income and expenses section; or Net Personal Services Income",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationIndustry2006Extended.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300031" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR419", Value = GetValueOrEmpty(report.IITR419) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR418", Value = GetValueOrEmpty(report.IITR418) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR279", Value = GetValueOrEmpty(report.IITR279) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300031

            #region VR.ATO.IITR.300032

            /*  VR.ATO.IITR.300032
            Where there are amounts for Other business and professional items, there must be amounts at either Net income or loss from business primary production or Net income or loss from business non-primary production.
    
            Legacy Rule Format:
            IF ([iitr510] > 0 OR [iitr512] > 0 OR [iitr514] > 0 OR [iitr518] > 0 OR [iitr520] > 0 OR [iitr522] > 0 OR [iitr524] > 0 OR [iitr526] > 0) AND ([iitr281] = NULL AND [iitr285] = NULL)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR510 > 0 OR ^IITR512 > 0 OR ^IITR514 > 0 OR ^IITR518 > 0 OR ^IITR520 > 0 OR ^IITR522 > 0 OR ^IITR524 > 0 OR ^IITR526 > 0) AND (^IITR281 = NULL AND ^IITR285 = NULL)
    
            Data Elements:
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR510 = RP(Instant):Assets.TradeandReceivablesOther.Amount
    
            ^IITR512 = RP(Instant):Liabilities.TradeAndOtherPayablesTotal.Amount
    
            ^IITR514 = RP:Remuneration.WagesAndSalaries.Total.Amount
    
            ^IITR518 = RP:Remuneration.PaymentToRelatedPartiesGross.Amount
    
            ^IITR520 = RP:Expense.DepreciatingAssets.IntangibleFirstDeducted.Amount
    
            ^IITR522 = RP:Expense.DepreciatingAssets.OtherFirstDeducted.Amount
    
            ^IITR524 = RP:Assets.DepreciatingAssets.IntangibleTerminationValue.Amount
    
            ^IITR526 = RP:Assets.DepreciatingAssets.OtherTerminationValue.Amount
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
            */
            assertion = ((report.IITR510.GetValueOrDefault() > 0 || report.IITR512.GetValueOrDefault() > 0 || report.IITR514.GetValueOrDefault() > 0 || report.IITR518.GetValueOrDefault() > 0 || report.IITR520.GetValueOrDefault() > 0 || report.IITR522.GetValueOrDefault() > 0 || report.IITR524.GetValueOrDefault() > 0 || report.IITR526.GetValueOrDefault() > 0) && (report.IITR281 == null && report.IITR285 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300032",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net business income primary production or non-primary production required",
                    LongDescription = @"Where there are amounts for Other business and professional items, there must be amounts at either Net income or loss from business primary production or Net income or loss from business non-primary production",
                    Location = "/xbrli:xbrl/tns:Income.PrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300032" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR510", Value = GetValueOrEmpty(report.IITR510) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR512", Value = GetValueOrEmpty(report.IITR512) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR514", Value = GetValueOrEmpty(report.IITR514) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR518", Value = GetValueOrEmpty(report.IITR518) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR520", Value = GetValueOrEmpty(report.IITR520) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR522", Value = GetValueOrEmpty(report.IITR522) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR524", Value = GetValueOrEmpty(report.IITR524) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR526", Value = GetValueOrEmpty(report.IITR526) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300032

            #region VR.ATO.IITR.300056

            /*  VR.ATO.IITR.300056
            Losses claimed in the current income year cannot be greater than the sum of all income less all allowable deductions.
    
            Legacy Rule Format:
            IF (([iitr131] - [iitr150]) >= 0) AND (([iitr154] + [iitr156]) > ([iitr131] - [iitr150]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR131 - ^IITR150) >= 0) AND ((^IITR154 + ^IITR156) > (^IITR131 - ^IITR150))
    
            Data Elements:
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
    
            ^IITR131 = RP:Income.Net.Amount
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
            */
            assertion = (report.IITR131.GetValueOrDefault() - report.IITR150.GetValueOrDefault() >= 0 && report.IITR154.GetValueOrDefault() + report.IITR156.GetValueOrDefault() > report.IITR131.GetValueOrDefault() - report.IITR150.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300056",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Loss claimed for primary and non-primary production must be less than or equal to assessable income.",
                    LongDescription = @"Total primary and non-primary production losses claimed this income year cannot be greater than assessable income (total income minus total deductions). If the calculated amount is a loss, there is no income to offset prior year losses.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300056" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300056

            #region VR.ATO.IITR.300057

            /*  VR.ATO.IITR.300057
            Losses claimed in the current income year should be zero when the sum of all income less all allowable deductions is less than zero.
    
            Legacy Rule Format:
            IF (([iitr131] - [iitr150]) < 0) AND (([iitr154] + [iitr156]) > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR131 - ^IITR150) < 0) AND ((^IITR154 + ^IITR156) > 0)
    
            Data Elements:
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
    
            ^IITR131 = RP:Income.Net.Amount
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
            */
            assertion = (report.IITR131.GetValueOrDefault() - report.IITR150.GetValueOrDefault() < 0 && report.IITR154.GetValueOrDefault() + report.IITR156.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300057",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary and Non-primary production losses claimed are incorrect",
                    LongDescription = @"When the sum of 'Individual total income or loss amount' less 'Individual total deductions amount' results in a loss, the sum of 'Primary production losses claimed this income year' and 'Non-primary production losses claimed this income year' must be zero",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300057" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300057

            #region VR.ATO.IITR.300101

            /*  VR.ATO.IITR.300101
            Ensure Estimated total income is correct
    
            Legacy Rule Format:
            IF [iitr13] = NULL AND ((([iitr601] + [iitr65] + [iitr607] + [iitr609] + [iitr626] + [iitr86] + [iitr89] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + [iitr611] + [iitr612] + [iitr112] + [iitr115] + [iitr118] + [iitr119] + [iitr120] + [iitr127] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + ConditionalValue(([iitr242] + [iitr252]) > 0, ([iitr242] + [iitr252]), 0) + [iitr243] + [iitr255] + [iitr259] + [iitr304] + [iitr305] + [iitr311] + [iitr316] + [iitr318] + [iitr320] + [iitr328] + [iitr334] + [iitr339] + [iitr341] + [iitr615] + [iitr616] + [iitr650] + [iitr618] + [iitr411] + [iitr412] + [iitr413] + [iitr414] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0) - [iitr358]) <= 0 AND ([iitr209] <> NULL AND [iitr209] <> 0)) OR (([iitr601] + [iitr65] + [iitr607] + [iitr609] + [iitr626] + [iitr86] + [iitr89] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + [iitr611] + [iitr612] + [iitr112] + [iitr115] + [iitr118] + [iitr119] + [iitr120] + [iitr127] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + ConditionalValue(([iitr242] + [iitr252]) > 0, ([iitr242] + [iitr252]), 0) + [iitr243] + [iitr255] + [iitr259] + [iitr304] + [iitr305] + [iitr311] + [iitr316] + [iitr318] + [iitr320] + [iitr328] + [iitr334] + [iitr339] + [iitr341] + [iitr615] + [iitr616] + [iitr650] + [iitr618] + [iitr411] + [iitr412] + [iitr413] + [iitr414] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0) - [iitr358]) > 0 AND (([iitr209] <> NULL AND [iitr209] <> ([iitr601] + [iitr65] + [iitr607] + [iitr609] + [iitr626] + [iitr86] + [iitr89] + [iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95] + [iitr611] + [iitr612] + [iitr112] + [iitr115] + [iitr118] + [iitr119] + [iitr120] + [iitr127] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + ConditionalValue(([iitr242] + [iitr252]) > 0, ([iitr242] + [iitr252]), 0) + [iitr243] + [iitr255] + [iitr259] + [iitr304] + [iitr305] + [iitr311] + [iitr316] + [iitr318] + [iitr320] + [iitr328] + [iitr334] + [iitr339] + [iitr341] + [iitr615] + [iitr616] + [iitr650] + [iitr618] + [iitr411] + [iitr412] + [iitr413] + [iitr414] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0) - [iitr358])) OR ([iitr209] = NULL))))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR13 = NULL AND (((^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ConditionalValue((^IITR242 + ^IITR252) > 0, (^IITR242 + ^IITR252), 0) + ^IITR243 + ^IITR255 + ^IITR259 + ^IITR304 + ^IITR305 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR320 + ^IITR328 + ^IITR334 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618 + ^IITR411 + ^IITR412 + ^IITR413 + ^IITR414 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0) - ^IITR358) <= 0 AND (^IITR209 <> NULL AND ^IITR209 <> 0)) OR ((^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ConditionalValue((^IITR242 + ^IITR252) > 0, (^IITR242 + ^IITR252), 0) + ^IITR243 + ^IITR255 + ^IITR259 + ^IITR304 + ^IITR305 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR320 + ^IITR328 + ^IITR334 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618 + ^IITR411 + ^IITR412 + ^IITR413 + ^IITR414 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0) - ^IITR358) > 0 AND ((^IITR209 <> NULL AND ^IITR209 <> (^IITR601 + ^IITR65 + ^IITR607 + ^IITR609 + ^IITR626 + ^IITR86 + ^IITR89 + ^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95 + ^IITR611 + ^IITR612 + ^IITR112 + ^IITR115 + ^IITR118 + ^IITR119 + ^IITR120 + ^IITR127 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ConditionalValue((^IITR242 + ^IITR252) > 0, (^IITR242 + ^IITR252), 0) + ^IITR243 + ^IITR255 + ^IITR259 + ^IITR304 + ^IITR305 + ^IITR311 + ^IITR316 + ^IITR318 + ^IITR320 + ^IITR328 + ^IITR334 + ^IITR339 + ^IITR341 + ^IITR615 + ^IITR616 + ^IITR650 + ^IITR618 + ^IITR411 + ^IITR412 + ^IITR413 + ^IITR414 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0) - ^IITR358)) OR (^IITR209 = NULL))))
    
            Data Elements:
    
            ^IITR209 = RP:Income.Estimated.Amount
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
    
            ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
    
            ^IITR607 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount
    
            ^IITR609 = RP:Income.UnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount
    
            ^IITR626 = RP:Income.EmploymentTerminationPaymentTaxable.Amount
    
            ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
    
            ^IITR89 = RP:Pension.Total.Amount
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
    
            ^IITR611 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentTaxedElement.Amount
    
            ^IITR612 = RP:Income.Superannuation.LumpSumPaymentTaxableComponentUntaxedElement.Amount
    
            ^IITR112 = RP:Income.PersonalServicesIncome.Total.Amount
    
            ^IITR115 = RP:Income.Interest.Gross.Amount
    
            ^IITR118 = RP:Income.DividendsUnfranked.Amount
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
    
            ^IITR120 = RP:IncomeTax.FrankingCredits.Amount
    
            ^IITR127 = RP:Income.EmployeeShareScheme.DiscountAssessable.Amount
    
            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
    
            ^IITR259 = RP:Income.TrustFrankedNonPrimaryProductionShare.Amount
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
    
            ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
    
            ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
    
            ^IITR320 = RP:InternationalDealings.ForeignIncomeGross.Amount
    
            ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount
    
            ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount
    
            ^IITR339 = RP:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount
    
            ^IITR341 = RP:Income.ForestryManagedInvestmentScheme.Amount
    
            ^IITR615 = RP:IncomeTax.IncomeCategory1Other.Amount
    
            ^IITR616 = RP:IncomeTax.IncomeCategory2Total.Amount
    
            ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
    
            ^IITR618 = RP:IncomeTax.IncomeCategoryMiscellaneousOther.Amount
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR717 = RP.Prim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR737 = RP.NonPrim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
    
            ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
    
            ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
    
            ^IITR358 = RP:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
            */
            assertion = (report.IITR13 == null && (report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR609.GetValueOrDefault() + report.IITR626.GetValueOrDefault() + report.IITR86.GetValueOrDefault() + report.IITR89.GetValueOrDefault() + report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault() + report.IITR611.GetValueOrDefault() + report.IITR612.GetValueOrDefault() + report.IITR112.GetValueOrDefault() + report.IITR115.GetValueOrDefault() + report.IITR118.GetValueOrDefault() + report.IITR119.GetValueOrDefault() + report.IITR120.GetValueOrDefault() + report.IITR127.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + ConditionalValue(report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault() > 0, report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault(), 0) + report.IITR243.GetValueOrDefault() + report.IITR255.GetValueOrDefault() + report.IITR259.GetValueOrDefault() + report.IITR304.GetValueOrDefault() + report.IITR305.GetValueOrDefault() + report.IITR311.GetValueOrDefault() + report.IITR316.GetValueOrDefault() + report.IITR318.GetValueOrDefault() + report.IITR320.GetValueOrDefault() + report.IITR328.GetValueOrDefault() + report.IITR334.GetValueOrDefault() + report.IITR339.GetValueOrDefault() + report.IITR341.GetValueOrDefault() + report.IITR615.GetValueOrDefault() + report.IITR616.GetValueOrDefault() + report.IITR650.GetValueOrDefault() + report.IITR618.GetValueOrDefault() + report.IITR411.GetValueOrDefault() + report.IITR412.GetValueOrDefault() + report.IITR413.GetValueOrDefault() + report.IITR414.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0) - report.IITR358.GetValueOrDefault() <= 0 && (report.IITR209 != null && report.IITR209 != 0) || report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR609.GetValueOrDefault() + report.IITR626.GetValueOrDefault() + report.IITR86.GetValueOrDefault() + report.IITR89.GetValueOrDefault() + report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault() + report.IITR611.GetValueOrDefault() + report.IITR612.GetValueOrDefault() + report.IITR112.GetValueOrDefault() + report.IITR115.GetValueOrDefault() + report.IITR118.GetValueOrDefault() + report.IITR119.GetValueOrDefault() + report.IITR120.GetValueOrDefault() + report.IITR127.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + ConditionalValue(report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault() > 0, report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault(), 0) + report.IITR243.GetValueOrDefault() + report.IITR255.GetValueOrDefault() + report.IITR259.GetValueOrDefault() + report.IITR304.GetValueOrDefault() + report.IITR305.GetValueOrDefault() + report.IITR311.GetValueOrDefault() + report.IITR316.GetValueOrDefault() + report.IITR318.GetValueOrDefault() + report.IITR320.GetValueOrDefault() + report.IITR328.GetValueOrDefault() + report.IITR334.GetValueOrDefault() + report.IITR339.GetValueOrDefault() + report.IITR341.GetValueOrDefault() + report.IITR615.GetValueOrDefault() + report.IITR616.GetValueOrDefault() + report.IITR650.GetValueOrDefault() + report.IITR618.GetValueOrDefault() + report.IITR411.GetValueOrDefault() + report.IITR412.GetValueOrDefault() + report.IITR413.GetValueOrDefault() + report.IITR414.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0) - report.IITR358.GetValueOrDefault() > 0 && (report.IITR209 != null && report.IITR209.GetValueOrDefault() != report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + report.IITR607.GetValueOrDefault() + report.IITR609.GetValueOrDefault() + report.IITR626.GetValueOrDefault() + report.IITR86.GetValueOrDefault() + report.IITR89.GetValueOrDefault() + report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault() + report.IITR611.GetValueOrDefault() + report.IITR612.GetValueOrDefault() + report.IITR112.GetValueOrDefault() + report.IITR115.GetValueOrDefault() + report.IITR118.GetValueOrDefault() + report.IITR119.GetValueOrDefault() + report.IITR120.GetValueOrDefault() + report.IITR127.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + ConditionalValue(report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault() > 0, report.IITR242.GetValueOrDefault() + report.IITR252.GetValueOrDefault(), 0) + report.IITR243.GetValueOrDefault() + report.IITR255.GetValueOrDefault() + report.IITR259.GetValueOrDefault() + report.IITR304.GetValueOrDefault() + report.IITR305.GetValueOrDefault() + report.IITR311.GetValueOrDefault() + report.IITR316.GetValueOrDefault() + report.IITR318.GetValueOrDefault() + report.IITR320.GetValueOrDefault() + report.IITR328.GetValueOrDefault() + report.IITR334.GetValueOrDefault() + report.IITR339.GetValueOrDefault() + report.IITR341.GetValueOrDefault() + report.IITR615.GetValueOrDefault() + report.IITR616.GetValueOrDefault() + report.IITR650.GetValueOrDefault() + report.IITR618.GetValueOrDefault() + report.IITR411.GetValueOrDefault() + report.IITR412.GetValueOrDefault() + report.IITR413.GetValueOrDefault() + report.IITR414.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0) - report.IITR358.GetValueOrDefault() || report.IITR209 == null)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.302101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Estimated total income is incorrect",
                    LongDescription = @"When the 'Estimated total income' is above zero, it must equal the sum of 'Salary or wages gross income', 'Amount of allowances, earnings, tips, directors fees, etc', 'Salary or wages lump sum A', 'Salary or wages lump sum B', 'ETP Taxable component', 'Australian Government allowances and payments like Newstart, youth allowance and austudy payment', 'Amount of Australian Government pensions and allowances', 'Australian annuities and superannuation income streams Taxable component' (Taxed and Untaxed), 'Assessable amount from capped defined benefit income stream', 'Australian annuities and superannuation income streams Lump sum in arrears' (Taxed and Untaxed), 'Superannuation lump sum taxed element', 'Superannuation lump sum untaxed element', 'Attributed personal services income', 'Gross interest', 'Dividends - Unfranked amount', 'Dividends - Franked amount', 'Dividends - Franking credit', 'Total Assessable discount amount', combined Total reportable fringe benefits where amount exceeds $3772, 'Reportable employer superannuation contributions', total of 'Distribution from partnerships' when above $0, 'Share of net income from trusts', 'Share of net income from trusts less capital gains, foreign income and franked distributions', 'Franked distributions from trusts', 'Early repayments - natural disaster and drought', 'Other repayments', 'Net capital gain', 'CFC income', 'Transferor trust income', 'Assessable foreign source income', 'Australian franking credits from a New Zealand franking company', 'Gross rent', 'Bonuses from life insurance companies and friendly societies', 'Forestry managed investment scheme income', 'Other income type - Category 1 - Amount', 'Other income type - Category 2 (ATO interest) - Amount', 'Assessable FHSS released amount - Category 3', 'Other income - Category 4 - Amount',  'PSI - voluntary agreement', 'PSI where Australian business number not quoted', 'PSI - labour hire or other specified payments', 'PSI - other', 'PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments subject to foreign resident withholding', 'PP -  Gross payments voluntary agreement', 'Non-PP - Gross payments voluntary agreement', 'PP - Gross payments labour hire or other specified payments', 'Non-PP - Gross payments labour hire or other specified payments', 'PP - Assessable government industry payments', 'Non-PP - Assessable government industry payments', total of 'Other business income' when above $0, 'Primary production income reconciliation adjustments', 'Non-primary production income reconciliation adjustments', and Closing stock less Opening stock when difference is above $0 for primary and non-primary production, less 'Deductible amount of UPP of foreign pension or annuity' - Otherwise, 'Estimated total income' must be set to $0",
                    Location = "/xbrli:xbrl/tns:Income.Estimated.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300101" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR607", Value = GetValueOrEmpty(report.IITR607) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR609", Value = GetValueOrEmpty(report.IITR609) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR626", Value = GetValueOrEmpty(report.IITR626) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR89", Value = GetValueOrEmpty(report.IITR89) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR611", Value = GetValueOrEmpty(report.IITR611) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR612", Value = GetValueOrEmpty(report.IITR612) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR112", Value = GetValueOrEmpty(report.IITR112) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR115", Value = GetValueOrEmpty(report.IITR115) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR120", Value = GetValueOrEmpty(report.IITR120) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR127", Value = GetValueOrEmpty(report.IITR127) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR490", Value = GetValueOrEmpty(report.IITR490) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR491", Value = GetValueOrEmpty(report.IITR491) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR201", Value = GetValueOrEmpty(report.IITR201) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR259", Value = GetValueOrEmpty(report.IITR259) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR320", Value = GetValueOrEmpty(report.IITR320) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR328", Value = GetValueOrEmpty(report.IITR328) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR334", Value = GetValueOrEmpty(report.IITR334) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR339", Value = GetValueOrEmpty(report.IITR339) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR341", Value = GetValueOrEmpty(report.IITR341) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR615", Value = GetValueOrEmpty(report.IITR615) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR616", Value = GetValueOrEmpty(report.IITR616) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR618", Value = GetValueOrEmpty(report.IITR618) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR717", Value = GetValueOrEmpty(report.IITR717) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR737", Value = GetValueOrEmpty(report.IITR737) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR358", Value = GetValueOrEmpty(report.IITR358) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR209", Value = GetValueOrEmpty(report.IITR209) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300101

            #region VR.ATO.IITR.300102

            /*  VR.ATO.IITR.300102
            When the 'Estimated eligible income' is above zero, it must equal the sum of 'Salary or wages gross income', 'Amount of allowances, earnings, tips, directors fees, etc', 'Reportable employer superannuation contributions', 'PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)', 'PP - Gross payments voluntary agreement', 'Non-PP - Gross payments voluntary agreement', 'PP - Gross payments labour hire or other specified payments', 'Non-PP - Gross payments labour hire or other specified payments', 'PP - Assessable government industry payments', 'Non-PP - Assessable government industry payments', combined Total reportable fringe benefits where amount exceeds $3772, combined Other business income for primary and non-primary production when amount is above $0, 'Primary production income reconciliation adjustments', 'Non-primary production income reconciliation adjustments', and Closing stock less Opening stock when difference is above $0 for primary and non-primary production - Otherwise, 'Estimated eligible income' must be set to $0
    
            Legacy Rule Format:
            IF [iitr13] = NULL AND (((([iitr601] + [iitr65] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0)) <= 0) AND ([iitr210] <> NULL AND [iitr210] <> 0)) OR ((([iitr601] + [iitr65] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0)) > 0) AND ([iitr210] = NULL OR ([iitr210] <> ([iitr601] + [iitr65] + ConditionalValue(([iitr490] + [iitr491]) > 3772, ([iitr490] + [iitr491]), 0) + [iitr201] + [iitr436] + [iitr437] + [iitr438] + [iitr439] + [iitr440] + [iitr441] + [iitr442] + [iitr443] + [iitr445] + ConditionalValue(([iitr447] + [iitr448]) > 0, ([iitr447] + [iitr448]), 0) + ([iitr717] + [iitr737]) + ConditionalValue((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0, (([iitr702] + [iitr721]) - ([iitr700] + [iitr719])), 0))))))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR13 = NULL AND ((((^IITR601 + ^IITR65 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0)) <= 0) AND (^IITR210 <> NULL AND ^IITR210 <> 0)) OR (((^IITR601 + ^IITR65 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0)) > 0) AND (^IITR210 = NULL OR (^IITR210 <> (^IITR601 + ^IITR65 + ConditionalValue((^IITR490 + ^IITR491) > 3772, (^IITR490 + ^IITR491), 0) + ^IITR201 + ^IITR436 + ^IITR437 + ^IITR438 + ^IITR439 + ^IITR440 + ^IITR441 + ^IITR442 + ^IITR443 + ^IITR445 + ConditionalValue((^IITR447 + ^IITR448) > 0, (^IITR447 + ^IITR448), 0) + (^IITR717 + ^IITR737) + ConditionalValue(((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0, ((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)), 0))))))
    
            Data Elements:
    
            ^IITR210 = RP:Income.LowIncomeSuperannuationContributionEligible.Amount
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
    
            ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
    
            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR717 = RP.Prim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR737 = RP.NonPrim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
    
            ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
    
            ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
            */
            assertion = (report.IITR13 == null && (report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0) <= 0 && (report.IITR210 != null && report.IITR210 != 0) || report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0) > 0 && (report.IITR210 == null || report.IITR210.GetValueOrDefault() != report.IITR601.GetValueOrDefault() + report.IITR65.GetValueOrDefault() + ConditionalValue(report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 3772, report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault(), 0) + report.IITR201.GetValueOrDefault() + report.IITR436.GetValueOrDefault() + report.IITR437.GetValueOrDefault() + report.IITR438.GetValueOrDefault() + report.IITR439.GetValueOrDefault() + report.IITR440.GetValueOrDefault() + report.IITR441.GetValueOrDefault() + report.IITR442.GetValueOrDefault() + report.IITR443.GetValueOrDefault() + report.IITR445.GetValueOrDefault() + ConditionalValue(report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault() > 0, report.IITR447.GetValueOrDefault() + report.IITR448.GetValueOrDefault(), 0) + (report.IITR717.GetValueOrDefault() + report.IITR737.GetValueOrDefault()) + ConditionalValue(report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0, report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()), 0))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.305102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Estimated eligible income is incorrect",
                    LongDescription = @"When the 'Estimated eligible income' is above zero, it must equal the sum of 'Salary or wages gross income', 'Amount of allowances, earnings, tips, directors fees, etc', 'Reportable employer superannuation contributions', 'PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments where Australian Business Number not quoted', 'Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains)', 'PP - Gross payments voluntary agreement', 'Non-PP - Gross payments voluntary agreement', 'PP - Gross payments labour hire or other specified payments', 'Non-PP - Gross payments labour hire or other specified payments', 'PP - Assessable government industry payments', 'Non-PP - Assessable government industry payments', combined Total reportable fringe benefits where amount exceeds $3772, combined Other business income for primary and non-primary production when amount is above $0, 'Primary production income reconciliation adjustments', 'Non-primary production income reconciliation adjustments', and Closing stock less Opening stock when difference is above $0 for primary and non-primary production - Otherwise, 'Estimated eligible income' must be set to $0",
                    Location = "/xbrli:xbrl/tns:Income.LowIncomeSuperannuationContributionEligible.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300102" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR490", Value = GetValueOrEmpty(report.IITR490) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR491", Value = GetValueOrEmpty(report.IITR491) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR201", Value = GetValueOrEmpty(report.IITR201) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR717", Value = GetValueOrEmpty(report.IITR717) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR737", Value = GetValueOrEmpty(report.IITR737) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR210", Value = GetValueOrEmpty(report.IITR210) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300102

            #region VR.ATO.IITR.300110

            /*  VR.ATO.IITR.300110
            Interest deduction amount is greater than zero and Gross interest amount is missing.
    
            Legacy Rule Format:
            IF ([iitr146] > 0) AND ([iitr115] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR146 > 0) AND (^IITR115 = NULL)
    
            Data Elements:
    
            ^IITR115 = RP:Income.Interest.Gross.Amount
    
            ^IITR146 = RP:IncomeTax.Deduction.Interest.Amount
            */
            assertion = (report.IITR146.GetValueOrDefault() > 0 && report.IITR115 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300110",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross interest amount is invalid",
                    LongDescription = @"When an amount above zero is provided for Interest deduction, the Gross interest amount must be provided",
                    Location = "/xbrli:xbrl/tns:Income.Interest.Gross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300110" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR146", Value = GetValueOrEmpty(report.IITR146) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR115", Value = GetValueOrEmpty(report.IITR115) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300110

            #region VR.ATO.IITR.300111

            /*  VR.ATO.IITR.300111
            Dividend deductions amount is greater than zero and Dividends - Unfranked amount and Dividends - Franked amount are missing.
    
            Legacy Rule Format:
            IF ([iitr147] > 0) AND ([iitr118] = NULL) AND ([iitr119] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR147 > 0) AND (^IITR118 = NULL) AND (^IITR119 = NULL)
    
            Data Elements:
    
            ^IITR118 = RP:Income.DividendsUnfranked.Amount
    
            ^IITR147 = RP:IncomeTax.Deduction.Dividend.Amount
    
            ^IITR119 = RP:Income.DividendsFranked.Amount
            */
            assertion = (report.IITR147.GetValueOrDefault() > 0 && report.IITR118 == null && report.IITR119 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300111",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividends - Unfranked and Dividends - Franked amounts invalid",
                    LongDescription = @"When an amount above zero is provided for 'Dividend deduction', at least one of 'Dividends - Unfranked amount' or 'Dividends - Franked amount' must be provided",
                    Location = "/xbrli:xbrl/tns:Income.DividendsUnfranked.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300111" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR147", Value = GetValueOrEmpty(report.IITR147) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR118", Value = GetValueOrEmpty(report.IITR118) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR119", Value = GetValueOrEmpty(report.IITR119) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300111

            #region VR.ATO.IITR.300112

            /*  VR.ATO.IITR.300112
            Taxable income or loss is not equal to the sum of all income less all allowable deductions less prior year losses claimed this income year.
    
            Legacy Rule Format:
            IF ([iitr157] <> NULL) AND ([iitr157]  +/- 1 <> ([iitr131] - ([iitr150] + [iitr154] + [iitr156])))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR157 <> NULL) AND (OutsideRange(^IITR157,^IITR131 - (^IITR150 + ^IITR154 + ^IITR156),1 ))
    
            Data Elements:
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR131 = RP:Income.Net.Amount
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
            */
            assertion = (report.IITR157 != null && OutsideRange(report.IITR157.GetValueOrDefault(), report.IITR131.GetValueOrDefault() - (report.IITR150.GetValueOrDefault() + report.IITR154.GetValueOrDefault() + report.IITR156.GetValueOrDefault()), 1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.300112",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable income or loss must equal total income or loss, minus deductions and losses.",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300112" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.300112

            #region VR.ATO.IITR.310000

            /*  VR.ATO.IITR.310000
            Assessable foreign income must be greater than or equal to the sum of other net foreign employment income, Net foreign pension or annuity income without UPP, Net foreign pension or annuity with UPP, Net foreign rent, and Other net foreign income.
    
            Legacy Rule Format:
            IF (([iitr320] <> NULL) AND ([iitr320] < ([iitr321] + [iitr322] + [iitr323] + [iitr324] + [iitr327])))
            OR (([iitr320] = NULL) AND (([iitr321] + [iitr322] + [iitr323] + [iitr324] + [iitr327]) > 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR320 <> NULL) AND (^IITR320 < (^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327))) OR ((^IITR320 = NULL) AND ((^IITR321 + ^IITR322 + ^IITR323 + ^IITR324 + ^IITR327) > 0))
    
            Data Elements:
    
            ^IITR320 = RP:InternationalDealings.ForeignIncomeGross.Amount
    
            ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
    
            ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
            ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
            */
            assertion = (report.IITR320 != null && report.IITR320.GetValueOrDefault() < report.IITR321.GetValueOrDefault() + report.IITR322.GetValueOrDefault() + report.IITR323.GetValueOrDefault() + report.IITR324.GetValueOrDefault() + report.IITR327.GetValueOrDefault() || report.IITR320 == null && report.IITR321.GetValueOrDefault() + report.IITR322.GetValueOrDefault() + report.IITR323.GetValueOrDefault() + report.IITR324.GetValueOrDefault() + report.IITR327.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310000",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Assessable foreign income amount is incorrect",
                    LongDescription = @"The 'Assessable foreign source income' amount must not be below the sum of 'Other net foreign employment income', 'Net foreign pension or annuity income without an undeducted purchase price', 'Net foreign pension or annuity income with an undeducted purchase price', 'Net foreign rent' and 'Other net foreign source income'",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310000" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR320", Value = GetValueOrEmpty(report.IITR320) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310000

            #region VR.ATO.IITR.310001

            /*  VR.ATO.IITR.310001
            An amount for Total current year capital gains is present; however the Net capital gain is absent and Net capital losses carried forward to later income years is equal to zero or absent.
    
            Legacy Rule Format:
            IF ([iitr312] > 0) AND ([iitr311] = NULL) AND (([iitr313] = NULL) OR ([iitr313] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR312 > 0) AND (^IITR311 = NULL) AND ((^IITR313 = NULL) OR (^IITR313 = 0))
    
            Data Elements:
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
    
            ^IITR313 = RP(Instant):Capital.Losses.CarriedForward.Net.Amount
            */
            assertion = (report.IITR312.GetValueOrDefault() > 0 && report.IITR311 == null && (report.IITR313 == null || report.IITR313 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total current year capital gains is invalid",
                    LongDescription = @"When an amount for 'Total current year capital gains' is provided, the 'Net capital gain' and/or 'Net capital losses carried forward to later income years' (above zero) amounts must be provided",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR313", Value = GetValueOrEmpty(report.IITR313) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310001

            #region VR.ATO.IITR.310002

            /*  VR.ATO.IITR.310002
            The answer to "Had a CGT event during the year" is No and capital gain amounts have been entered.
    
            Legacy Rule Format:
            IF ([iitr308] = FALSE) AND (([iitr311] > 0) OR ([iitr312] > 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR308 = FALSE) AND ((^IITR311 > 0) OR (^IITR312 > 0))
    
            Data Elements:
    
            ^IITR308 = RP:CapitalGainsTax.Event.Indicator
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
            */
            assertion = (report.IITR308 == false && (report.IITR311.GetValueOrDefault() > 0 || report.IITR312.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Capital Gains Tax amounts incorrect",
                    LongDescription = @"When the answer to the question 'Had a CGT event during the year' is 'no' (false), and capital gain amounts have been entered, either answer question 'Had a CGT event during the year' as 'yes' (true), or remove Net capital gain and Total current year capital gains amounts",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.Event.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR308", Value = GetValueOrEmpty(report.IITR308) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310002

            #region VR.ATO.IITR.310003

            /*  VR.ATO.IITR.310003
            Where an amount has been entered at Net capital gain, the answer to the question "Had a CGT event during the year" must be Yes.
    
            Legacy Rule Format:
            IF ([iitr308] = NULL) AND ([iitr311] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR308 = NULL) AND (^IITR311 > 0)
    
            Data Elements:
    
            ^IITR308 = RP:CapitalGainsTax.Event.Indicator
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
            */
            assertion = (report.IITR308 == null && report.IITR311.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Answer to the 'Had a CGT event during the year' question must be 'yes'",
                    LongDescription = @"When an amount is present at 'Net capital gain', the indicator for 'Had a CGT event during the year' must be set to 'yes' (true)",
                    Location = "/xbrli:xbrl/tns:CapitalGainsTax.Event.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR308", Value = GetValueOrEmpty(report.IITR308) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310003

            #region VR.ATO.IITR.310004

            /*  VR.ATO.IITR.310004
            Where the answer to "Had a direct or indirect interest in a controlled foreign company (CFC)" is No, there should not be a CFC income amount reported.
    
            Legacy Rule Format:
            IF ([iitr316] <> NULL) AND ([iitr315] = FALSE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR316 <> NULL) AND (^IITR315 = FALSE)
    
            Data Elements:
    
            ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
    
            ^IITR315 = RP:InternationalDealings.DirectOrIndirectOverseasInterest.Indicator
            */
            assertion = (report.IITR316 != null && report.IITR315 == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310004",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"CFC income amount invalid",
                    LongDescription = @"Where the 'Had a direct or indirect interest in a controlled foreign company (CFC)' indicator is set to 'no' (false), the CFC income amount must not be present",
                    Location = "/xbrli:xbrl/tns:Income.ControlledForeignCompaniesAttributableIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR315", Value = GetValueOrEmpty(report.IITR315) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310004

            #region VR.ATO.IITR.310005

            /*  VR.ATO.IITR.310005
            Where the answer to "Have you ever, either directly or indirectly, caused the transfer of property (incl. money) or services to a non-resident trust estate?" is No, there should not be a transferor trust income amount reported.
    
            Legacy Rule Format:
            IF ([iitr318] <> NULL) AND ([iitr317] = FALSE) 
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR318 <> NULL) AND (^IITR317 = FALSE)
    
            Data Elements:
    
            ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
    
            ^IITR317 = RP:Income.InternationalDealings.AttributedForeignIncomeForeignTrustorControlledForeignCompanyorTransferorTrust.Indicator
            */
            assertion = (report.IITR318 != null && report.IITR317 == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310005",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Transferor trust income invalid",
                    LongDescription = @"Where the answer to the question 'Have you EVER, either directly or indirectly, caused the transfer of property (incl. money) or services to a non-resident trust estate' is 'no' (false), the Transferor trust income amount must not be present",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310005" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR317", Value = GetValueOrEmpty(report.IITR317) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310005

            #region VR.ATO.IITR.310006

            /*  VR.ATO.IITR.310006
            The sum of Primary production deferred losses and Non-primary production deferred losses is not equal to the sum of Your share of deferred losses from partnership activities and Deferred losses from sole trader activities.
    
            Legacy Rule Format:
            IF ([iitr299] + [iitr300]) <> ([iitr294] + [iitr298])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR299 + ^IITR300) <> (^IITR294 + ^IITR298)
    
            Data Elements:
    
            ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
            ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
    
            ^IITR294 = RP:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount
    
            ^IITR298 = RP:Tax.Losses.DeferredNonCommercialSoleTrader.Amount
            */
            assertion = (report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault() != report.IITR294.GetValueOrDefault() + report.IITR298.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310006",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The sum of deferred losses must equal total deferred losses.",
                    LongDescription = @"The share of deferred losses from partnership activities plus deferred losses from sole trader activities must equal the sum of primary and non-primary production deferred losses.",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310006" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR294", Value = GetValueOrEmpty(report.IITR294) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR298", Value = GetValueOrEmpty(report.IITR298) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310006

            #region VR.ATO.IITR.310017

            /*  VR.ATO.IITR.310017
            Where there amounts for primary production or non-primary production income in the Business income and expenses section, the number of business activities must be supplied.
    
            Legacy Rule Format:
            IF ([iitr436] <> NULL OR [iitr437] <> NULL OR [iitr438] <> NULL OR [iitr439] <> NULL OR [iitr440] <> NULL OR [iitr441] <> NULL OR [iitr442] <> NULL OR [iitr443] <> NULL OR [iitr445] <> NULL OR [iitr447] <> NULL OR [iitr448] <> NULL) AND [iitr421] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR436 <> NULL OR ^IITR437 <> NULL OR ^IITR438 <> NULL OR ^IITR439 <> NULL OR ^IITR440 <> NULL OR ^IITR441 <> NULL OR ^IITR442 <> NULL OR ^IITR443 <> NULL OR ^IITR445 <> NULL OR ^IITR447 <> NULL OR ^IITR448 <> NULL) AND ^IITR421 = NULL
    
            Data Elements:
    
            ^IITR421 = RP:Income.PersonalServicesIncome.BusinessActivities.Count
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
            */
            assertion = ((report.IITR436 != null || report.IITR437 != null || report.IITR438 != null || report.IITR439 != null || report.IITR440 != null || report.IITR441 != null || report.IITR442 != null || report.IITR443 != null || report.IITR445 != null || report.IITR447 != null || report.IITR448 != null) && report.IITR421 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310017",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of business activities required",
                    LongDescription = @"Where there amounts for primary production or non-primary production income in the Business income and expenses section, the number of business activities must be supplied",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.BusinessActivities.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310017" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR421", Value = report.IITR421.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310017

            #region VR.ATO.IITR.310018

            /*  VR.ATO.IITR.310018
            Total business income (primary production or non-primary production) is present at business income and expenses and either the business name or business street address is required.
    
            Legacy Rule Format:
            IF ([iitr436] <> NULL OR [iitr437] <> NULL OR [iitr438] <> NULL OR [iitr439] <> NULL OR [iitr440] <> NULL OR [iitr441] <> NULL OR [iitr442] <> NULL OR [iitr443] <> NULL OR [iitr445] <> NULL OR [iitr447] <> NULL OR [iitr448] <> NULL) AND ([iitr425] = NULLORBLANK OR [iitr428] = NULLORBLANK)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR436 <> NULL OR ^IITR437 <> NULL OR ^IITR438 <> NULL OR ^IITR439 <> NULL OR ^IITR440 <> NULL OR ^IITR441 <> NULL OR ^IITR442 <> NULL OR ^IITR443 <> NULL OR ^IITR445 <> NULL OR ^IITR447 <> NULL OR ^IITR448 <> NULL) AND (^IITR425 = BLANK OR ^IITR428 = BLANK)
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
    
            ^IITR425 = RP:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = ((report.IITR436 != null || report.IITR437 != null || report.IITR438 != null || report.IITR439 != null || report.IITR440 != null || report.IITR441 != null || report.IITR442 != null || report.IITR443 != null || report.IITR445 != null || report.IITR447 != null || report.IITR448 != null) && (string.IsNullOrWhiteSpace(report.IITR425) == true || string.IsNullOrWhiteSpace(report.IITR428) == true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Incomplete main business name and address details",
                    LongDescription = @"When the 'Total business income' (primary production or non-primary production) is present at business income and expenses and either the business name or business street address is required",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR425", Value = GetValueOrEmpty(report.IITR425) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310018

            #region VR.ATO.IITR.310026

            /*  VR.ATO.IITR.310026
            A Business loss code of 8 has been entered at Description of activity for Activity 1, 2 or 3, but no amount has been entered at primary production deferred losses and/or non-primary production deferred losses. The sum of net losses associated with Activity 1, 2 or 3 must also be reflected in the deferred non-commercial business losses items.
    
            Legacy Rule Format:
            IF ANY OCCURRENCE OF([iitr482]) = 8 AND ([iitr299] + [iitr300]) = 0
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^IITR482, ^IITR482 = 8) AND (^IITR299 + ^IITR300) = 0
    
            Data Elements:
    
            ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
    
            ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
    
            ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
            */
            assertion = ((report.RPLOSSSeqNumContextCollection == null ? false : report.RPLOSSSeqNumContextCollection.Any(IITR482Repeat => AsNumeric(IITR482Repeat.IITR482) == 8)) && report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault() == 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary production and/or Non-primary production deferred losses amount required",
                    LongDescription = @"A Business loss code of 8 has been entered at Description of activity for Activity 1, 2 or 3, but no amount has been entered at primary production deferred losses and/or non-primary production deferred losses. The sum of net losses associated with Activity 1, 2 or 3 must also be reflected in the deferred non-commercial business losses items.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesType.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR482", Value = "IITR482" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310026

            #region VR.ATO.IITR.310030

            /*  VR.ATO.IITR.310030
            Net capital gain is greater than Total current year capital gains.
    
            Legacy Rule Format:
            IF ([iitr311] > 0) AND ([iitr312] <> NULL) AND ([iitr311] > [iitr312])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR311 > 0) AND (^IITR312 <> NULL) AND (^IITR311 > ^IITR312)
    
            Data Elements:
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
            */
            assertion = (report.IITR311.GetValueOrDefault() > 0 && report.IITR312 != null && report.IITR311.GetValueOrDefault() > report.IITR312.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net capital gain is incorrect",
                    LongDescription = @"The amount entered for Net capital gain must not be higher than Total current year capital gains",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310030" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310030

            #region VR.ATO.IITR.310031

            /*  VR.ATO.IITR.310031
            Net capital gain present. Total current year capital gains absent.
    
            Legacy Rule Format:
            IF ([iitr311] > 0) AND ([iitr312] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR311 > 0) AND (^IITR312 = NULL)
    
            Data Elements:
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
            */
            assertion = (report.IITR311.GetValueOrDefault() > 0 && report.IITR312 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310031",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total current year capital gains required",
                    LongDescription = @"When Net capital gain is present, Total current year capital gains must be provided",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310031" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310031

            #region VR.ATO.IITR.310032

            /*  VR.ATO.IITR.310032
            Personal Services Income amounts are not required if the taxpayer satisfies the results test or received a personal services business determination that was in force for the whole period or satisfies one of the other business tests.
    
            Legacy Rule Format:
            IF (([iitr405] = TRUE) OR ([iitr406] = TRUE) OR ([iitr408] = TRUE) OR ([iitr409] = TRUE) OR ([iitr410] = TRUE)) AND (([iitr411] > 0) OR ([iitr412] > 0) OR ([iitr413] > 0) OR ([iitr414] > 0) OR ([iitr415] > 0) OR ([iitr416] > 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR405 = TRUE) OR (^IITR406 = TRUE) OR (^IITR408 = TRUE) OR (^IITR409 = TRUE) OR (^IITR410 = TRUE)) AND ((^IITR411 > 0) OR (^IITR412 > 0) OR (^IITR413 > 0) OR (^IITR414 > 0) OR (^IITR415 > 0) OR (^IITR416 > 0))
    
            Data Elements:
    
            ^IITR405 = RP:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
    
            ^IITR406 = RP:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator
    
            ^IITR408 = RP:IncomeTax.PersonalServicesIncome.UnrelatedClientsTestSatisfied.Indicator
    
            ^IITR409 = RP:IncomeTax.PersonalServicesIncome.EmploymentTestSatisfied.Indicator
    
            ^IITR410 = RP:IncomeTax.PersonalServicesIncome.BusinessPremisesTestSatisfied.Indicator
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
    
            ^IITR415 = RP:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount
    
            ^IITR416 = RP:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
            */
            assertion = ((report.IITR405 == true || report.IITR406 == true || report.IITR408 == true || report.IITR409 == true || report.IITR410 == true) && (report.IITR411.GetValueOrDefault() > 0 || report.IITR412.GetValueOrDefault() > 0 || report.IITR413.GetValueOrDefault() > 0 || report.IITR414.GetValueOrDefault() > 0 || report.IITR415.GetValueOrDefault() > 0 || report.IITR416.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310032",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PSI amounts not required",
                    LongDescription = @"Personal Services Income amounts are not required if the taxpayer satisfies the results test, or received a personal services business determination that was in force for the whole period, or satisfies one of the other business tests",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310032" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR405", Value = GetValueOrEmpty(report.IITR405) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR406", Value = GetValueOrEmpty(report.IITR406) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR408", Value = GetValueOrEmpty(report.IITR408) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR409", Value = GetValueOrEmpty(report.IITR409) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR410", Value = GetValueOrEmpty(report.IITR410) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR415", Value = GetValueOrEmpty(report.IITR415) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR416", Value = GetValueOrEmpty(report.IITR416) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310032

            #region VR.ATO.IITR.310033

            /*  VR.ATO.IITR.310033
            Personal Services Income amounts are not required if taxpayer did not receive more than 80% of PSI income from one source and satisfied any of the business tests.
    
            Legacy Rule Format:
            IF (([iitr407] = NULL) OR ([iitr407] = FALSE)) AND (([iitr408] <> NULL) OR ([iitr409] <> NULL) OR ([iitr410] <> NULL)) AND (([iitr411] <> NULL) OR ([iitr412] <> NULL) OR ([iitr413] <> NULL) OR ([iitr414] <> NULL) OR ([iitr415] <> NULL) OR ([iitr416] <> NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR407 = NULL) OR (^IITR407 = FALSE)) AND ((^IITR408 <> NULL) OR (^IITR409 <> NULL) OR (^IITR410 <> NULL)) AND ((^IITR411 <> NULL) OR (^IITR412 <> NULL) OR (^IITR413 <> NULL) OR (^IITR414 <> NULL) OR (^IITR415 <> NULL) OR (^IITR416 <> NULL))
    
            Data Elements:
    
            ^IITR407 = RP:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator
    
            ^IITR408 = RP:IncomeTax.PersonalServicesIncome.UnrelatedClientsTestSatisfied.Indicator
    
            ^IITR409 = RP:IncomeTax.PersonalServicesIncome.EmploymentTestSatisfied.Indicator
    
            ^IITR410 = RP:IncomeTax.PersonalServicesIncome.BusinessPremisesTestSatisfied.Indicator
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
    
            ^IITR415 = RP:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount
    
            ^IITR416 = RP:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
            */
            assertion = ((report.IITR407 == null || report.IITR407 == false) && (report.IITR408 != null || report.IITR409 != null || report.IITR410 != null) && (report.IITR411 != null || report.IITR412 != null || report.IITR413 != null || report.IITR414 != null || report.IITR415 != null || report.IITR416 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Personal Services Income (PSI) amounts not required",
                    LongDescription = @"Personal Services Income amounts are not required when the answer to the question 'Received 80% or more of PSI from one source' is not 'yes' (not true), and any of the business tests are satisfied",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310033" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR407", Value = GetValueOrEmpty(report.IITR407) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR408", Value = GetValueOrEmpty(report.IITR408) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR409", Value = GetValueOrEmpty(report.IITR409) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR410", Value = GetValueOrEmpty(report.IITR410) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR415", Value = GetValueOrEmpty(report.IITR415) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR416", Value = GetValueOrEmpty(report.IITR416) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310033

            #region VR.ATO.IITR.310034

            /*  VR.ATO.IITR.310034
            The answer to "Received 80% or more of PSI from one source" is Yes, no business tests have been satisfied, and nothing has been entered in Personal Services Income or Gross payments subject to FRW. At least one PSI amount or Gross payments subject to FRW must be completed.
    
            Legacy Rule Format:
            IF ([iitr407] = TRUE) AND (([iitr408] = NULL) AND ([iitr409] = NULL) AND ([iitr410] = NULL)) AND (([iitr411] = NULL) AND ([iitr412] = NULL) AND ([iitr413] = NULL) AND ([iitr414] = NULL)) AND ([iitr438] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR407 = TRUE) AND ((^IITR408 = NULL) AND (^IITR409 = NULL) AND (^IITR410 = NULL)) AND ((^IITR411 = NULL) AND (^IITR412 = NULL) AND (^IITR413 = NULL) AND (^IITR414 = NULL)) AND (^IITR438 = NULL)
    
            Data Elements:
    
            ^IITR407 = RP:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator
    
            ^IITR408 = RP:IncomeTax.PersonalServicesIncome.UnrelatedClientsTestSatisfied.Indicator
    
            ^IITR409 = RP:IncomeTax.PersonalServicesIncome.EmploymentTestSatisfied.Indicator
    
            ^IITR410 = RP:IncomeTax.PersonalServicesIncome.BusinessPremisesTestSatisfied.Indicator
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
            */
            assertion = (report.IITR407 == true && (report.IITR408 == null && report.IITR409 == null && report.IITR410 == null) && (report.IITR411 == null && report.IITR412 == null && report.IITR413 == null && report.IITR414 == null) && report.IITR438 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310034",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Personal Services Income (PSI) amount or Gross payments subject to FRW amount required",
                    LongDescription = @"Where the answer to the question 'Received 80% or more of PSI from one source' is 'yes' (true) and no business tests have been satisfied, at least one Personal Services Income (PSI) amount or Gross payments subject to FRW amount must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310034" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR407", Value = GetValueOrEmpty(report.IITR407) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR408", Value = GetValueOrEmpty(report.IITR408) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR409", Value = GetValueOrEmpty(report.IITR409) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR410", Value = GetValueOrEmpty(report.IITR410) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310034

            #region VR.ATO.IITR.310051

            /*  VR.ATO.IITR.310051
            Net foreign pension or annuity income with an undeducted purchase price must accompany a claim for an undeducted purchase price of foreign pension or annuity.  The undeducted purchase price, the deduction, must not exceed the net foreign pension or annuity income.
    
            Legacy Rule Format:
            IF ([iitr358] > 0) AND (([iitr323] = NULL OR [iitr323] = 0) OR ([iitr323] <> NULL AND ([iitr358] > [iitr323])))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR358 > 0) AND ((^IITR323 = NULL OR ^IITR323 = 0) OR (^IITR323 <> NULL AND (^IITR358 > ^IITR323)))
    
            Data Elements:
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
    
            ^IITR358 = RP:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
            */
            assertion = (report.IITR358.GetValueOrDefault() > 0 && (report.IITR323 == null || report.IITR323 == 0 || report.IITR323 != null && report.IITR358.GetValueOrDefault() > report.IITR323.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310051",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Pension or annuity income required where UPP deduction claimed.",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310051" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR358", Value = GetValueOrEmpty(report.IITR358) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310051

            #region VR.ATO.IITR.310052

            /*  VR.ATO.IITR.310052
            When there are amounts in either Total expenses non-primary production, Total expenses primary production, Net income from business this year non-primary production or Net income from business this year primary production, a response is required for "Did you receive any personal service income?"
    
            Legacy Rule Format:
            IF ([iitr467] > 0 OR [iitr468] > 0 OR [iitr474] > 0 OR [iitr475] > 0) AND ([iitr404] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR467 > 0 OR ^IITR468 > 0 OR ^IITR474 > 0 OR ^IITR475 > 0) AND (^IITR404 = NULL)
    
            Data Elements:
    
            ^IITR404 = RP:Income.PersonalServicesIncomeIncluded.Indicator
    
            ^IITR467 = RP:Expense.Operating.BusinessPrimaryProduction.Amount
    
            ^IITR468 = RP:Expense.Operating.BusinessNonPrimaryProduction.Amount
    
            ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
    
            ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
            */
            assertion = ((report.IITR467.GetValueOrDefault() > 0 || report.IITR468.GetValueOrDefault() > 0 || report.IITR474.GetValueOrDefault() > 0 || report.IITR475.GetValueOrDefault() > 0) && report.IITR404 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310052",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Response to 'Did you receive any personal service Income?' is required",
                    LongDescription = @"When there are amounts in either Total expenses non-primary production, Total expenses primary production, Net income from business this year non-primary production or Net income from business this year primary production, a response is required for ""Did you receive any personal service income?""",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncomeIncluded.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310052" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR467", Value = GetValueOrEmpty(report.IITR467) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR468", Value = GetValueOrEmpty(report.IITR468) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR404", Value = GetValueOrEmpty(report.IITR404) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310052

            #region VR.ATO.IITR.310053

            /*  VR.ATO.IITR.310053
            The answer to "Received personal services income" is Yes and no answer has been provided to the "Satisfied the results test" question.
    
            Legacy Rule Format:
            IF ([iitr405] = NULL) AND ([iitr404] = TRUE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR405 = NULL) AND (^IITR404 = TRUE)
    
            Data Elements:
    
            ^IITR405 = RP:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
    
            ^IITR404 = RP:Income.PersonalServicesIncomeIncluded.Indicator
            */
            assertion = (report.IITR405 == null && report.IITR404 == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310053",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Answer to the 'Satisfied the results test' question required",
                    LongDescription = @"Where the answer to the question 'Received personal services income' is 'yes' (true), the question 'Satisfied the results test' must be answered",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310053" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR405", Value = GetValueOrEmpty(report.IITR405) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR404", Value = GetValueOrEmpty(report.IITR404) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310053

            #region VR.ATO.IITR.310054

            /*  VR.ATO.IITR.310054
            The sum of the deduction amounts at small business entity depreciating deductions is greater than the depreciation expenses plus total amount of other deductions against personal service income
    
            Legacy Rule Format:
            IF ([iitr710] + [iitr730] + [iitr416]) < ([iitr507] + [iitr508])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR710 + ^IITR730 + ^IITR416) < (^IITR507 + ^IITR508)
    
            Data Elements:
    
            ^IITR710 = RP.Prim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR730 = RP.NonPrim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR416 = RP:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
    
            ^IITR507 = RP:IncomeTax.Deduction.LowCostAssetDepreciation.Amount
    
            ^IITR508 = RP:IncomeTax.Deduction.SmallBusinessPoolDepreciation.Amount
            */
            assertion = (report.IITR710.GetValueOrDefault() + report.IITR730.GetValueOrDefault() + report.IITR416.GetValueOrDefault() < report.IITR507.GetValueOrDefault() + report.IITR508.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.311054",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Depreciation expenses and Total amount of other deductions against personal service income incorrect",
                    LongDescription = @"The sum of the deduction amounts at small business entity depreciating deductions is greater than the depreciation expenses plus total amount of other deductions against personal service income.",
                    Location = "/xbrli:xbrl/tns:Expense.DepreciationandAmortisation.Amount[@contextRef='" + report.RPPrimId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310054" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR710", Value = GetValueOrEmpty(report.IITR710) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR730", Value = GetValueOrEmpty(report.IITR730) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR416", Value = GetValueOrEmpty(report.IITR416) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR507", Value = GetValueOrEmpty(report.IITR507) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR508", Value = GetValueOrEmpty(report.IITR508) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310054


            #region VR.ATO.IITR.310062

            /*  VR.ATO.IITR.310062
            The answer to "Received a personal services business determination(s) for the whole of the period PSI earned" is No, and no answer has been provided to the "Received 80% or more of PSI from one source" question.
    
            Legacy Rule Format:
            IF ([iitr407] = NULL) AND ([iitr404] = TRUE) AND ([iitr405] = FALSE) AND ([iitr406] = FALSE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR407 = NULL) AND (^IITR404 = TRUE) AND (^IITR405 = FALSE) AND (^IITR406 = FALSE)
    
            Data Elements:
    
            ^IITR407 = RP:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator
    
            ^IITR404 = RP:Income.PersonalServicesIncomeIncluded.Indicator
    
            ^IITR405 = RP:IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator
    
            ^IITR406 = RP:IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator
            */
            assertion = (report.IITR407 == null && report.IITR404 == true && report.IITR405 == false && report.IITR406 == false);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310062",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Answer to the 'Received 80% or more of PSI from one source' question required",
                    LongDescription = @"Where the answer to the question 'Received personal services income' is 'yes' (true), and the answer to the questions 'Satisfied the results test' and 'Received a personal services business determination(s) for the whole of the period PSI earned' are both 'no' (false), the question 'Received 80% or more of PSI from one source' must be answered",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PersonalServicesIncome.OneSourceBenchmark.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310062" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR407", Value = GetValueOrEmpty(report.IITR407) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR404", Value = GetValueOrEmpty(report.IITR404) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR405", Value = GetValueOrEmpty(report.IITR405) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR406", Value = GetValueOrEmpty(report.IITR406) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310062

            #region VR.ATO.IITR.310064

            /*  VR.ATO.IITR.310064
            There is an amount entered in deductible farm management deposits and it should not exceed 800,000.
    
            Legacy Rule Format:
            IF ([iitr302] > 800000)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR302 > 800000
    
            Data Elements:
    
            ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount
            */
            assertion = (report.IITR302.GetValueOrDefault() > 800000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.311064",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductible deposits amount for farm management must not exceed AUD $800,000",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.FarmManagementDeposits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310064" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR302", Value = GetValueOrEmpty(report.IITR302) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310064

            #region VR.ATO.IITR.310065

            /*  VR.ATO.IITR.310065
            If an amount at Net farm management deposits or repayments is present, then Deductible deposits and/or one or more of the repayment amounts should be present and vice versa.
    
            Legacy Rule Format:
            IF ([iitr306] <> NULL AND [iitr302] = NULL AND [iitr304] = NULL AND [iitr305] = NULL) OR ([iitr306] = NULL AND ([iitr302] <> NULL OR [iitr304] <> NULL OR [iitr305] <> NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR306 <> NULL AND ^IITR302 = NULL AND ^IITR304 = NULL AND ^IITR305 = NULL) OR (^IITR306 = NULL AND (^IITR302 <> NULL OR ^IITR304 <> NULL OR ^IITR305 <> NULL))
    
            Data Elements:
    
            ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount
    
            ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
            */
            assertion = (report.IITR306 != null && report.IITR302 == null && report.IITR304 == null && report.IITR305 == null || report.IITR306 == null && (report.IITR302 != null || report.IITR304 != null || report.IITR305 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.021016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductible deposits or repayment amount required where net amount has been entered.",
                    LongDescription = @"Where an amount is present for net farm management deposits or repayments, an amount must be present in Deductible deposits, Early repayments - natural disaster and drought or Other repayments",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementDepositsOrRepaymentsNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310065" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR306", Value = GetValueOrEmpty(report.IITR306) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR302", Value = GetValueOrEmpty(report.IITR302) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310065

            #region VR.ATO.IITR.310074

            /*  VR.ATO.IITR.310074
            Addition of components for Your share of deferred losses from partnership activities amount is not equal to the total amount of Your share of deferred losses from partnership activities.
    
            Legacy Rule Format:
            IF (([iitr294] = NULL) AND ([iitr291] + [iitr292] + [iitr293] <> 0)) OR (([iitr294] <> NULL) AND ([iitr294] <> [iitr291] + [iitr292] + [iitr293]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR294 = NULL) AND (^IITR291 + ^IITR292 + ^IITR293 <> 0)) OR ((^IITR294 <> NULL) AND (^IITR294 <> ^IITR291 + ^IITR292 + ^IITR293))
    
            Data Elements:
    
            ^IITR294 = RP:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount
    
            ^IITR291 = RP:Tax.Losses.DeferredNonCommercialPartnershipInvestmentShare.Amount
    
            ^IITR292 = RP:Tax.Losses.DeferredNonCommercialPartnershipRentalShare.Amount
    
            ^IITR293 = RP:Tax.Losses.DeferredNonCommercialPartnershipOtherShare.Amount
            */
            assertion = (report.IITR294 == null && report.IITR291.GetValueOrDefault() + report.IITR292.GetValueOrDefault() + report.IITR293.GetValueOrDefault() != 0 || report.IITR294 != null && report.IITR294.GetValueOrDefault() != report.IITR291.GetValueOrDefault() + report.IITR292.GetValueOrDefault() + report.IITR293.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310074",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your share of deferred losses from partnership activities amount is incorrect",
                    LongDescription = @"Addition of components for Your share of deferred losses from partnership activities amount must equal the total amount of Your share of deferred losses from partnership activities. Components for Your share of deferred losses from partnership activities are; 'Your share of deferred losses from partnership activities - from carrying on a business of investing', 'Your share of deferred losses from partnership activities - from carrying on a rental property business' and 'Your share of deferred losses from partnership activities - other'.",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310074" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR294", Value = GetValueOrEmpty(report.IITR294) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR291", Value = GetValueOrEmpty(report.IITR291) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR292", Value = GetValueOrEmpty(report.IITR292) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR293", Value = GetValueOrEmpty(report.IITR293) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310074

            #region VR.ATO.IITR.310075

            /*  VR.ATO.IITR.310075
            Addition of components for Deferred losses from sole trader activities amount is not equal to the total amount of Deferred losses from sole trader activities.
    
            Legacy Rule Format:
            IF (([iitr298] = NULL) AND ([iitr295] + [iitr296] + [iitr297] <> 0)) OR (([iitr298] <> NULL) AND ([iitr298] <> [iitr295] + [iitr296] + [iitr297]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR298 = NULL) AND (^IITR295 + ^IITR296 + ^IITR297 <> 0)) OR ((^IITR298 <> NULL) AND (^IITR298 <> ^IITR295 + ^IITR296 + ^IITR297))
    
            Data Elements:
    
            ^IITR298 = RP:Tax.Losses.DeferredNonCommercialSoleTrader.Amount
    
            ^IITR295 = RP:Tax.Losses.DeferredNonCommercialSoleTraderInvestment.Amount
    
            ^IITR296 = RP:Tax.Losses.DeferredNonCommercialSoleTraderRental.Amount
    
            ^IITR297 = RP:Tax.Losses.DeferredNonCommercialSoleTraderOther.Amount
            */
            assertion = (report.IITR298 == null && report.IITR295.GetValueOrDefault() + report.IITR296.GetValueOrDefault() + report.IITR297.GetValueOrDefault() != 0 || report.IITR298 != null && report.IITR298.GetValueOrDefault() != report.IITR295.GetValueOrDefault() + report.IITR296.GetValueOrDefault() + report.IITR297.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310075",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deferred losses from sole trader activities amount is incorrect",
                    LongDescription = @"Addition of components for Deferred losses from sole trader activities amount must equal the total amount of Deferred losses from sole trader activities. Components for Deferred losses from sole trader activities are; 'Deferred losses from sole trader activities - from carrying on a business of investing', 'Deferred losses from sole trader activities - from carrying on a rental property business' and 'Deferred losses from sole trader activities - other'.",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTrader.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310075" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR298", Value = GetValueOrEmpty(report.IITR298) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR295", Value = GetValueOrEmpty(report.IITR295) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR296", Value = GetValueOrEmpty(report.IITR296) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR297", Value = GetValueOrEmpty(report.IITR297) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310075

            #region VR.ATO.IITR.310076

            /*  VR.ATO.IITR.310076
            Addition of components for Other net foreign source income amount is not equal to the total amount of Other net foreign source income.
    
            Legacy Rule Format:
            IF (([iitr327] = NULL) AND ([iitr325] + [iitr326] <> 0)) OR (([iitr327] <> NULL) AND ([iitr327] <> [iitr325] + [iitr326]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR327 = NULL) AND (^IITR325 + ^IITR326 <> 0)) OR ((^IITR327 <> NULL) AND (^IITR327 <> ^IITR325 + ^IITR326))
    
            Data Elements:
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
    
            ^IITR325 = RP:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
    
            ^IITR326 = RP:InternationalDealings.ForeignSourceIncomeOther.Amount
            */
            assertion = (report.IITR327 == null && report.IITR325.GetValueOrDefault() + report.IITR326.GetValueOrDefault() != 0 || report.IITR327 != null && report.IITR327.GetValueOrDefault() != report.IITR325.GetValueOrDefault() + report.IITR326.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310076",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other net foreign source income amount is incorrect",
                    LongDescription = @"Addition of components for Other net foreign source income amount must equal the total amount of Other net foreign source income. Components for Other net foreign source income are; 'Other net foreign source income - dividend income or managed investment scheme income from foreign companies - including from foreign partnerships' and 'Other foreign source income'.",
                    Location = "/xbrli:xbrl/tns:Income.InternationalDealings.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310076" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR325", Value = GetValueOrEmpty(report.IITR325) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR326", Value = GetValueOrEmpty(report.IITR326) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310076

            #region VR.ATO.IITR.310079

            /*  VR.ATO.IITR.310079
            The primary production assessable government industry payments action code is present; however, the primary production assessable government industry payment amount is missing.
    
            Legacy Rule Format:
            IF ([iitr444] <> NULL) AND (([iitr443] = NULL) OR ([iitr443] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR444 <> NULL) AND ((^IITR443 = NULL) OR (^IITR443 = 0))
    
            Data Elements:
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR444 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Indicator
            */
            assertion = (report.IITR444 != null && (report.IITR443 == null || report.IITR443 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310079",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Assessable government industry payments amount must be provided",
                    LongDescription = @"When the 'PP - Assessable government industry payments action code' is present, the 'PP - Assessable government industry payments' amount must be provided",
                    Location = "/xbrli:xbrl/tns:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310079" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR444", Value = GetValueOrEmpty(report.IITR444) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310079

            #region VR.ATO.IITR.310080

            /*  VR.ATO.IITR.310080
            The non-primary production Assessable government industry payments action code is present; however, the non-primary production Assessable government industry payment amount is missing.
    
            Legacy Rule Format:
            IF ([iitr446] <> NULL) AND (([iitr445] = NULL) OR ([iitr445] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR446 <> NULL) AND ((^IITR445 = NULL) OR (^IITR445 = 0))
    
            Data Elements:
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR446 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Indicator
            */
            assertion = (report.IITR446 != null && (report.IITR445 == null || report.IITR445 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310080",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Assessable non-PP government industry payments amount must be provided",
                    LongDescription = @"When the 'Non-PP - Assessable government industry payments action code' is present, the 'Non-PP - Assessable government industry payments' amount must be provided",
                    Location = "/xbrli:xbrl/tns:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310080" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR446", Value = GetValueOrEmpty(report.IITR446) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310080

            #region VR.ATO.IITR.310081

            /*  VR.ATO.IITR.310081
            Interest deductions, capital works deductions or other rental deductions are greater than zero AND gross rent is absent.
    
            Legacy Rule Format:
            IF ([iitr335] > 0 OR [iitr336] > 0 OR [iitr337] > 0) AND ([iitr334] = NULL) 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR335 > 0 OR ^IITR336 > 0 OR ^IITR337 > 0) AND (^IITR334 = NULL)
    
            Data Elements:
    
            ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount
    
            ^IITR335 = RP:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount
    
            ^IITR336 = RP:IncomeTax.Deduction.CapitalWorksDeductions.Amount
    
            ^IITR337 = RP:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount
            */
            assertion = ((report.IITR335.GetValueOrDefault() > 0 || report.IITR336.GetValueOrDefault() > 0 || report.IITR337.GetValueOrDefault() > 0) && report.IITR334 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430079",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross rent must be present",
                    LongDescription = @"If Interest deductions, Capital works deductions, or Other rental deductions are greater than zero, Gross rent must be present",
                    Location = "/xbrli:xbrl/tns:Income.RealEstateProperty.Rental.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310081" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR335", Value = GetValueOrEmpty(report.IITR335) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR336", Value = GetValueOrEmpty(report.IITR336) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR337", Value = GetValueOrEmpty(report.IITR337) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR334", Value = GetValueOrEmpty(report.IITR334) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310081

            #region VR.ATO.IITR.310082

            /*  VR.ATO.IITR.310082
            Gross rent is greater than zero AND no rental expense items are present. (Rental expense items are interest deductions, capital works deductions AND other rental deductions). If there are no rental expenses then zero is acceptable in one of these fields.
    
            Legacy Rule Format:
            IF ([iitr334] > 0) AND ([iitr335] = NULL AND [iitr336] = NULL AND [iitr337] = NULL) 
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR334 > 0) AND (^IITR335 = NULL AND ^IITR336 = NULL AND ^IITR337 = NULL)
    
            Data Elements:
    
            ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount
    
            ^IITR335 = RP:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount
    
            ^IITR336 = RP:IncomeTax.Deduction.CapitalWorksDeductions.Amount
    
            ^IITR337 = RP:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount
            */
            assertion = (report.IITR334.GetValueOrDefault() > 0 && (report.IITR335 == null && report.IITR336 == null && report.IITR337 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430080",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Rent deductions must be present",
                    LongDescription = @"If Gross rent is greater than zero, then there must be an amount at Interest deductions, Capital works deductions or Other rental deductions. If there are no rental deductions, then zero must be present in at least one of these fields",
                    Location = "/xbrli:xbrl/tns:Income.RealEstateProperty.Rental.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310082" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR334", Value = GetValueOrEmpty(report.IITR334) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR335", Value = GetValueOrEmpty(report.IITR335) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR336", Value = GetValueOrEmpty(report.IITR336) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR337", Value = GetValueOrEmpty(report.IITR337) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310082

            #region VR.ATO.IITR.310092

            /*  VR.ATO.IITR.310092
            Credit for foreign resident capital gains withholding amounts has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr497] <> MONETARY(U,13,2)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR497, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR497 = RP:IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount
            */
            assertion = NotMonetary(report.IITR497, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310092",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Credit for foreign resident capital gains withholding amounts is not in a valid monetary format",
                    LongDescription = @"Credit for foreign resident capital gains withholding amounts must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310092" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR497", Value = GetValueOrEmpty(report.IITR497) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310092

            #region VR.ATO.IITR.310143

            /*  VR.ATO.IITR.310143
            Your share of deferred losses from partnership activities - from carrying on a business of investing has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr291] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR291, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR291 = RP:Tax.Losses.DeferredNonCommercialPartnershipInvestmentShare.Amount
            */
            assertion = NotMonetary(report.IITR291, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310143",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Your share of deferred losses from partnership... business of investing"" is not in a valid monetary format",
                    LongDescription = @"Your share of deferred losses from partnership activities - from carrying on a business of investing must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipInvestmentShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310143" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR291", Value = GetValueOrEmpty(report.IITR291) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310143

            #region VR.ATO.IITR.310144

            /*  VR.ATO.IITR.310144
            Your share of deferred losses from partnership activities - from carrying on a rental property business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr292] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR292, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR292 = RP:Tax.Losses.DeferredNonCommercialPartnershipRentalShare.Amount
            */
            assertion = NotMonetary(report.IITR292, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310144",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Your share of deferred losses from partnership... rental property business"" is not in a valid monetary format",
                    LongDescription = @"Your share of deferred losses from partnership activities - from carrying on a rental property business must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipRentalShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310144" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR292", Value = GetValueOrEmpty(report.IITR292) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310144

            #region VR.ATO.IITR.310145

            /*  VR.ATO.IITR.310145
            Your share of deferred losses from partnership activities - other has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr293] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR293, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR293 = RP:Tax.Losses.DeferredNonCommercialPartnershipOtherShare.Amount
            */
            assertion = NotMonetary(report.IITR293, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310145",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your share of deferred losses from partnership activities - other is not in a valid monetary format",
                    LongDescription = @"Your share of deferred losses from partnership activities - other must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipOtherShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310145" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR293", Value = GetValueOrEmpty(report.IITR293) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310145

            #region VR.ATO.IITR.310146

            /*  VR.ATO.IITR.310146
            Your share of deferred losses from partnership activities has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr294] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR294, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR294 = RP:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount
            */
            assertion = NotMonetary(report.IITR294, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310146",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your share of deferred losses from partnership activities is not in a valid monetary format",
                    LongDescription = @"Your share of deferred losses from partnership activities must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310146" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR294", Value = GetValueOrEmpty(report.IITR294) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310146

            #region VR.ATO.IITR.310147

            /*  VR.ATO.IITR.310147
            Your share of deferred losses from sole trader activities - from carrying on a business of investing has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr295] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR295, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR295 = RP:Tax.Losses.DeferredNonCommercialSoleTraderInvestment.Amount
            */
            assertion = NotMonetary(report.IITR295, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310147",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Deferred losses from sole trader activities... business of investing"" is not in a valid monetary format",
                    LongDescription = @"Deferred losses from sole trader activities - from carrying on a business of investing must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTraderInvestment.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310147" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR295", Value = GetValueOrEmpty(report.IITR295) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310147

            #region VR.ATO.IITR.310148

            /*  VR.ATO.IITR.310148
            Your share of deferred losses from sole trader activities - from carrying on a rental property business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr296] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR296, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR296 = RP:Tax.Losses.DeferredNonCommercialSoleTraderRental.Amount
            */
            assertion = NotMonetary(report.IITR296, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310148",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Deferred losses from sole trader activities... rental property business"" is not in a valid monetary format",
                    LongDescription = @"Deferred losses from sole trader activities - from carrying on a rental property business must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTraderRental.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310148" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR296", Value = GetValueOrEmpty(report.IITR296) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310148

            #region VR.ATO.IITR.310149

            /*  VR.ATO.IITR.310149
            Your share of deferred losses from sole trader activities - other has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr297] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR297, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR297 = RP:Tax.Losses.DeferredNonCommercialSoleTraderOther.Amount
            */
            assertion = NotMonetary(report.IITR297, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310149",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deferred losses from sole trader activities - other is not in a valid monetary format",
                    LongDescription = @"Deferred losses from sole trader activities - other must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTraderOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310149" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR297", Value = GetValueOrEmpty(report.IITR297) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310149

            #region VR.ATO.IITR.310150

            /*  VR.ATO.IITR.310150
            Deferred losses from sole trader activities has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr298] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR298, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR298 = RP:Tax.Losses.DeferredNonCommercialSoleTrader.Amount
            */
            assertion = NotMonetary(report.IITR298, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310150",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deferred losses from sole trader activities is not in a valid monetary format",
                    LongDescription = @"Deferred losses from sole trader activities must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTrader.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310150" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR298", Value = GetValueOrEmpty(report.IITR298) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310150

            #region VR.ATO.IITR.310151

            /*  VR.ATO.IITR.310151
            Primary production deferred losses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr299] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR299, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR299, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310151",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary production deferred losses is not in a valid monetary format",
                    LongDescription = @"Primary production deferred losses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310151" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310151

            #region VR.ATO.IITR.310152

            /*  VR.ATO.IITR.310152
            Non-primary production deferred losses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr300] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR300, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR300, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310152",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-primary production deferred losses is not in a valid monetary format",
                    LongDescription = @"Non-primary production deferred losses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310152" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310152

            #region VR.ATO.IITR.310153

            /*  VR.ATO.IITR.310153
            Deductible deposits has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr302] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR302, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR302 = RP:IncomeTax.Deduction.FarmManagementDeposits.Amount
            */
            assertion = NotMonetary(report.IITR302, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310153",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductible deposits is not in a valid monetary format",
                    LongDescription = @"Deductible deposits must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.FarmManagementDeposits.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310153" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR302", Value = GetValueOrEmpty(report.IITR302) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310153

            #region VR.ATO.IITR.310155

            /*  VR.ATO.IITR.310155
            Early repayments - natural disaster and drought has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr304] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR304, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR304 = RP:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount
            */
            assertion = NotMonetary(report.IITR304, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.311155",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Early repayments - natural disaster and drought is not in a valid monetary format",
                    LongDescription = @"Early repayments - natural disaster and drought must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementEarlyRepaymentsNaturalDisaster.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310155" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR304", Value = GetValueOrEmpty(report.IITR304) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310155

            #region VR.ATO.IITR.310156

            /*  VR.ATO.IITR.310156
            Other repayments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr305] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR305, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR305 = RP:Income.FarmManagementOtherRepayments.Amount
            */
            assertion = NotMonetary(report.IITR305, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310156",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other repayments is not in a valid monetary format",
                    LongDescription = @"Other repayments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementOtherRepayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310156" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR305", Value = GetValueOrEmpty(report.IITR305) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310156

            #region VR.ATO.IITR.310157

            /*  VR.ATO.IITR.310157
            Net farm management deposits or repayments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr306] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR306, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR306 = RP:Income.FarmManagementDepositsOrRepaymentsNet.Amount
            */
            assertion = NotMonetary(report.IITR306, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310157",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net farm management deposits or repayments is not in a valid monetary format",
                    LongDescription = @"Net farm management deposits or repayments may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.FarmManagementDepositsOrRepaymentsNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310157" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR306", Value = GetValueOrEmpty(report.IITR306) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310157

            #region VR.ATO.IITR.310161

            /*  VR.ATO.IITR.310161
            Net capital gain has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr311] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR311, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR311 = RP:Capital.Gains.Net.Amount
            */
            assertion = NotMonetary(report.IITR311, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310161",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net capital gain is not in a valid monetary format",
                    LongDescription = @"Net capital gain must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310161" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310161

            #region VR.ATO.IITR.310162

            /*  VR.ATO.IITR.310162
            Total current year capital gains has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr312] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR312, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR312 = RP:Capital.Gains.Total.Amount
            */
            assertion = NotMonetary(report.IITR312, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310162",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total current year capital gains is not in a valid monetary format",
                    LongDescription = @"Total current year capital gains must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Capital.Gains.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310162" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR312", Value = GetValueOrEmpty(report.IITR312) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310162

            #region VR.ATO.IITR.310163

            /*  VR.ATO.IITR.310163
            Net capital losses carried forward to later income years has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr313] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR313, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR313 = RP(Instant):Capital.Losses.CarriedForward.Net.Amount
            */
            assertion = NotMonetary(report.IITR313, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310163",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net capital losses carried forward to later income years is not in a valid monetary format",
                    LongDescription = @"Net capital losses carried forward to later income years must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Capital.Losses.CarriedForward.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310163" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR313", Value = GetValueOrEmpty(report.IITR313) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310163

            #region VR.ATO.IITR.310165

            /*  VR.ATO.IITR.310165
            CFC income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr316] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR316, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR316 = RP:Income.ControlledForeignCompaniesAttributableIncome.Amount
            */
            assertion = NotMonetary(report.IITR316, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310165",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"CFC income is not in a valid monetary format",
                    LongDescription = @"CFC income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.ControlledForeignCompaniesAttributableIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310165" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR316", Value = GetValueOrEmpty(report.IITR316) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310165

            #region VR.ATO.IITR.310167

            /*  VR.ATO.IITR.310167
            Transferor trust income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr318] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR318, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR318 = RP:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount
            */
            assertion = NotMonetary(report.IITR318, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310167",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Transferor trust income is not in a valid monetary format",
                    LongDescription = @"Transferor trust income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.TransferorTrustAttributedForeignIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310167" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR318", Value = GetValueOrEmpty(report.IITR318) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310167

            #region VR.ATO.IITR.310168

            /*  VR.ATO.IITR.310168
            Assessable foreign source income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr320] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR320, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR320 = RP:InternationalDealings.ForeignIncomeGross.Amount
            */
            assertion = NotMonetary(report.IITR320, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310168",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Assessable foreign source income is not in a valid monetary format",
                    LongDescription = @"Assessable foreign source income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310168" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR320", Value = GetValueOrEmpty(report.IITR320) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310168

            #region VR.ATO.IITR.310169

            /*  VR.ATO.IITR.310169
            Other net foreign employment income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr321] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR321, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR321 = RP:InternationalDealings.ForeignEmploymentIncomeOther.Amount
            */
            assertion = NotMonetary(report.IITR321, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310169",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other net foreign employment income is not in a valid monetary format",
                    LongDescription = @"Other net foreign employment income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignEmploymentIncomeOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310169" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR321", Value = GetValueOrEmpty(report.IITR321) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310169

            #region VR.ATO.IITR.310170

            /*  VR.ATO.IITR.310170
            Net foreign pension or annuity income without an undeducted purchase price has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr322] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR322, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR322 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount
            */
            assertion = NotMonetary(report.IITR322, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310170",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net foreign pension or annuity income without an undeducted purchase price is not in a valid monetary format",
                    LongDescription = @"Net foreign pension or annuity income without an undeducted purchase price may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignPensionOrAnnuityIncomeWithoutUndeductedPurchasePrice.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310170" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR322", Value = GetValueOrEmpty(report.IITR322) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310170

            #region VR.ATO.IITR.310171

            /*  VR.ATO.IITR.310171
            Net foreign pension or annuity income with an undeducted purchase price has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr323] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR323, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR323 = RP:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount
            */
            assertion = NotMonetary(report.IITR323, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310171",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net foreign pension or annuity income with an undeducted purchase price is not in a valid monetary format",
                    LongDescription = @"Net foreign pension or annuity income with an undeducted purchase price may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignPensionOrAnnuityIncomeUndeductedPurchasePrice.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310171" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR323", Value = GetValueOrEmpty(report.IITR323) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310171

            #region VR.ATO.IITR.310172

            /*  VR.ATO.IITR.310172
            Net foreign rent has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr324] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR324, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR324 = RP:InternationalDealings.ForeignRent.Amount
            */
            assertion = NotMonetary(report.IITR324, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310172",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net foreign rent is not in a valid monetary format",
                    LongDescription = @"Net foreign rent may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignRent.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310172" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR324", Value = GetValueOrEmpty(report.IITR324) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310172

            #region VR.ATO.IITR.310173

            /*  VR.ATO.IITR.310173
            Other net foreign source income - dividend income or managed investment scheme income from foreign companies - including from foreign partnerships has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr325] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR325, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR325 = RP:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount
            */
            assertion = NotMonetary(report.IITR325, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310173",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"""Other net foreign source income - dividend income..."" is not in a valid monetary format",
                    LongDescription = @"Other net foreign source income - dividend income or managed investment scheme income from foreign companies - including from foreign partnerships may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignSourceCompanyIncomeOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310173" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR325", Value = GetValueOrEmpty(report.IITR325) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310173

            #region VR.ATO.IITR.310174

            /*  VR.ATO.IITR.310174
            Other foreign source income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr326] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR326, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR326 = RP:InternationalDealings.ForeignSourceIncomeOther.Amount
            */
            assertion = NotMonetary(report.IITR326, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310174",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other foreign source income is not in a valid monetary format",
                    LongDescription = @"Other foreign source income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignSourceIncomeOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310174" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR326", Value = GetValueOrEmpty(report.IITR326) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310174

            #region VR.ATO.IITR.310175

            /*  VR.ATO.IITR.310175
            Other net foreign source income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr327] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR327, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR327 = RP:Income.InternationalDealings.Net.Amount
            */
            assertion = NotMonetary(report.IITR327, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310175",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other net foreign source income is not in a valid monetary format",
                    LongDescription = @"Other net foreign source income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.InternationalDealings.Net.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310175" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR327", Value = GetValueOrEmpty(report.IITR327) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310175

            #region VR.ATO.IITR.310176

            /*  VR.ATO.IITR.310176
            Australian franking credits from a New Zealand franking company has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr328] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR328, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR328 = RP:IncomeTax.FrankingCreditsNewZealand.Amount
            */
            assertion = NotMonetary(report.IITR328, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310176",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian franking credits from a New Zealand franking company is not in a valid monetary format",
                    LongDescription = @"Australian franking credits from a New Zealand franking company must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FrankingCreditsNewZealand.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310176" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR328", Value = GetValueOrEmpty(report.IITR328) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310176

            #region VR.ATO.IITR.310177

            /*  VR.ATO.IITR.310177
            Net foreign employment income - payment summary has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr329] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR329, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = NotMonetary(report.IITR329, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310177",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net foreign employment income - payment summary is not in a valid monetary format",
                    LongDescription = @"Net foreign employment income - payment summary may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310177" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR329", Value = GetValueOrEmpty(report.IITR329) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310177

            #region VR.ATO.IITR.310178

            /*  VR.ATO.IITR.310178
            Exempt foreign employment income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr330] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR330, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR330 = RP:InternationalDealings.ExemptForeignEmploymentIncome.Amount
            */
            assertion = NotMonetary(report.IITR330, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310178",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Exempt foreign employment income is not in a valid monetary format",
                    LongDescription = @"Exempt foreign employment income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ExemptForeignEmploymentIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310178" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR330", Value = GetValueOrEmpty(report.IITR330) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310178

            #region VR.ATO.IITR.310179

            /*  VR.ATO.IITR.310179
            Foreign income tax offset has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr331] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR331, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR331 = RP:Income.InternationalDealings.TaxOffset.Amount
            */
            assertion = NotMonetary(report.IITR331, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310179",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Foreign income tax offset is not in a valid monetary format",
                    LongDescription = @"Foreign income tax offset must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:Income.InternationalDealings.TaxOffset.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310179" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR331", Value = GetValueOrEmpty(report.IITR331) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310179

            #region VR.ATO.IITR.310181

            /*  VR.ATO.IITR.310181
            Gross rent has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr334] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR334, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR334 = RP:Income.RealEstateProperty.Rental.Amount
            */
            assertion = NotMonetary(report.IITR334, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310181",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gross rent is not in a valid monetary format",
                    LongDescription = @"Gross rent must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.RealEstateProperty.Rental.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310181" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR334", Value = GetValueOrEmpty(report.IITR334) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310181

            #region VR.ATO.IITR.310182

            /*  VR.ATO.IITR.310182
            Interest deductions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr335] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR335, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR335 = RP:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount
            */
            assertion = NotMonetary(report.IITR335, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310182",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Interest deductions is not in a valid monetary format",
                    LongDescription = @"Interest deductions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.RentalIncomeInterestDeductions.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310182" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR335", Value = GetValueOrEmpty(report.IITR335) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310182

            #region VR.ATO.IITR.310183

            /*  VR.ATO.IITR.310183
            Capital works deductions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr336] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR336, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR336 = RP:IncomeTax.Deduction.CapitalWorksDeductions.Amount
            */
            assertion = NotMonetary(report.IITR336, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310183",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Capital works deductions is not in a valid monetary format",
                    LongDescription = @"Capital works deductions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CapitalWorksDeductions.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310183" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR336", Value = GetValueOrEmpty(report.IITR336) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310183

            #region VR.ATO.IITR.310184

            /*  VR.ATO.IITR.310184
            Other rental deductions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr337] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR337, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR337 = RP:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount
            */
            assertion = NotMonetary(report.IITR337, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310184",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other rental deductions is not in a valid monetary format",
                    LongDescription = @"Other rental deductions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310184" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR337", Value = GetValueOrEmpty(report.IITR337) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310184

            #region VR.ATO.IITR.310185

            /*  VR.ATO.IITR.310185
            Bonuses from life insurance companies and friendly societies has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr339] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR339, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR339 = RP:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount
            */
            assertion = NotMonetary(report.IITR339, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310185",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Bonuses from life insurance companies and friendly societies is not in a valid monetary format",
                    LongDescription = @"Bonuses from life insurance companies and friendly societies must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LifeInsuranceCompaniesAndFriendlySocietiesBonuses.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310185" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR339", Value = GetValueOrEmpty(report.IITR339) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310185

            #region VR.ATO.IITR.310186

            /*  VR.ATO.IITR.310186
            Forestry managed investment scheme income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr341] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR341, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR341 = RP:Income.ForestryManagedInvestmentScheme.Amount
            */
            assertion = NotMonetary(report.IITR341, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310186",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Forestry managed investment scheme income is not in a valid monetary format",
                    LongDescription = @"Forestry managed investment scheme income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.ForestryManagedInvestmentScheme.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310186" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR341", Value = GetValueOrEmpty(report.IITR341) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310186

            #region VR.ATO.IITR.310198

            /*  VR.ATO.IITR.310198
            Tax withheld - lump sum payments in arrears has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr354] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR354, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR354 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldLumpSumPaymentsInArrears.Amount
            */
            assertion = NotMonetary(report.IITR354, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310198",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld - lump sum payments in arrears is not in a valid monetary format",
                    LongDescription = @"Tax withheld - lump sum payments in arrears must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldLumpSumPaymentsInArrears.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310198" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR354", Value = GetValueOrEmpty(report.IITR354) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310198

            #region VR.ATO.IITR.310199

            /*  VR.ATO.IITR.310199
            Taxable professional income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr355] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR355, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR355 = RP:Income.SpecialProfessional.Amount
            */
            assertion = NotMonetary(report.IITR355, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310199",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable professional income is not in a valid monetary format",
                    LongDescription = @"Taxable professional income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.SpecialProfessional.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310199" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR355", Value = GetValueOrEmpty(report.IITR355) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310199

            #region VR.ATO.IITR.310207

            /*  VR.ATO.IITR.310207
            PSI - voluntary agreement has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr411] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR411, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR411 = RP:Income.PersonalServicesIncome.VoluntaryAgreement.Amount
            */
            assertion = NotMonetary(report.IITR411, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310207",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PSI - voluntary agreement is not in a valid monetary format",
                    LongDescription = @"PSI - voluntary agreement must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.VoluntaryAgreement.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310207" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR411", Value = GetValueOrEmpty(report.IITR411) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310207

            #region VR.ATO.IITR.310208

            /*  VR.ATO.IITR.310208
            PSI where Australian business number not quoted has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr412] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR412, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR412 = RP:Income.PersonalServicesIncome.ABNNotQuoted.Amount
            */
            assertion = NotMonetary(report.IITR412, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310208",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PSI where Australian business number not quoted is not in a valid monetary format",
                    LongDescription = @"PSI where Australian business number not quoted must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.ABNNotQuoted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310208" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR412", Value = GetValueOrEmpty(report.IITR412) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310208

            #region VR.ATO.IITR.310209

            /*  VR.ATO.IITR.310209
            PSI - labour hire or other specified payments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr413] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR413, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR413 = RP:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount
            */
            assertion = NotMonetary(report.IITR413, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310209",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PSI - labour hire or other specified payments is not in a valid monetary format",
                    LongDescription = @"PSI - labour hire or other specified payments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.LabourHireOrOtherSpecifiedPayment.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310209" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR413", Value = GetValueOrEmpty(report.IITR413) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310209

            #region VR.ATO.IITR.310210

            /*  VR.ATO.IITR.310210
            PSI - other has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr414] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR414, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR414 = RP:Income.PersonalServicesIncome.Other.Amount
            */
            assertion = NotMonetary(report.IITR414, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310210",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PSI - other is not in a valid monetary format",
                    LongDescription = @"PSI - other must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.Other.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310210" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR414", Value = GetValueOrEmpty(report.IITR414) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310210

            #region VR.ATO.IITR.310211

            /*  VR.ATO.IITR.310211
            Deductions for payments to associates for principal work has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr415] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR415, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR415 = RP:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount
            */
            assertion = NotMonetary(report.IITR415, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310211",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductions for payments to associates for principal work is not in a valid monetary format",
                    LongDescription = @"Deductions for payments to associates for principal work must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.PersonalServicesIncome.PrincipalWorkPaymentsToAssociates.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310211" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR415", Value = GetValueOrEmpty(report.IITR415) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310211

            #region VR.ATO.IITR.310212

            /*  VR.ATO.IITR.310212
            Total amount of other deductions against PSI has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr416] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR416, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR416 = RP:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount
            */
            assertion = NotMonetary(report.IITR416, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310212",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total amount of other deductions against PSI is not in a valid monetary format",
                    LongDescription = @"Total amount of other deductions against PSI must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.PersonalServicesIncome.OtherDeductionsTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310212" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR416", Value = GetValueOrEmpty(report.IITR416) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310212

            #region VR.ATO.IITR.310213

            /*  VR.ATO.IITR.310213
            PP - Gross payments where Australian Business Number not quoted has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr436] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR436, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
            */
            assertion = NotMonetary(report.IITR436, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310213",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Gross payments where Australian Business Number not quoted is not in a valid monetary format",
                    LongDescription = @"PP - Gross payments where Australian Business Number not quoted must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310213" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310213

            #region VR.ATO.IITR.310214

            /*  VR.ATO.IITR.310214
            Non-PP - Gross payments where Australian Business Number not quoted has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr437] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR437, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
            */
            assertion = NotMonetary(report.IITR437, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310214",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Gross payments where Australian Business Number not quoted is not in a valid monetary format",
                    LongDescription = @"Non-PP - Gross payments where Australian Business Number not quoted must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310214" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310214

            #region VR.ATO.IITR.310215

            /*  VR.ATO.IITR.310215
            Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains) has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr438] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR438, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR438, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.311215",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains) is not in a valid monetary format",
                    LongDescription = @"Non-PP - Gross payments subject to foreign resident withholding (excluding capital gains) must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310215" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310215

            #region VR.ATO.IITR.310216

            /*  VR.ATO.IITR.310216
            PP -  Gross payments voluntary agreement has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr439] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR439, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
            */
            assertion = NotMonetary(report.IITR439, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310216",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP -  Gross payments voluntary agreement is not in a valid monetary format",
                    LongDescription = @"PP -  Gross payments voluntary agreement must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.VoluntaryAgreementPrimaryProductionGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310216" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310216

            #region VR.ATO.IITR.310217

            /*  VR.ATO.IITR.310217
            Non-PP - Gross payments voluntary agreement has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr440] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR440, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
            */
            assertion = NotMonetary(report.IITR440, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310217",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Gross payments voluntary agreement is not in a valid monetary format",
                    LongDescription = @"Non-PP - Gross payments voluntary agreement must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310217" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310217

            #region VR.ATO.IITR.310218

            /*  VR.ATO.IITR.310218
            PP - Gross payments labour hire or other specified payments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr441] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR441, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
            */
            assertion = NotMonetary(report.IITR441, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310218",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Gross payments labour hire or other specified payments is not in a valid monetary format",
                    LongDescription = @"PP - Gross payments labour hire or other specified payments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310218" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310218

            #region VR.ATO.IITR.310219

            /*  VR.ATO.IITR.310219
            Non-PP - Gross payments labour hire or other specified payments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr442] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR442, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
            */
            assertion = NotMonetary(report.IITR442, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310219",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Gross payments labour hire or other specified payments is not in a valid monetary format",
                    LongDescription = @"Non-PP - Gross payments labour hire or other specified payments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310219" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310219

            #region VR.ATO.IITR.310220

            /*  VR.ATO.IITR.310220
            PP - Assessable government industry payments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr443] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR443, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
            */
            assertion = NotMonetary(report.IITR443, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310220",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Assessable government industry payments is not in a valid monetary format",
                    LongDescription = @"PP - Assessable government industry payments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310220" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310220

            #region VR.ATO.IITR.310222

            /*  VR.ATO.IITR.310222
            Non-PP - Assessable government industry payments has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr445] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR445, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
            */
            assertion = NotMonetary(report.IITR445, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310222",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Assessable government industry payments is not in a valid monetary format",
                    LongDescription = @"Non-PP - Assessable government industry payments must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310222" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310222

            #region VR.ATO.IITR.310224

            /*  VR.ATO.IITR.310224
            PP - Other business income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr447] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR447, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
            */
            assertion = NotMonetary(report.IITR447, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310224",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Other business income is not in a valid monetary format",
                    LongDescription = @"PP - Other business income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.BusinessPrimaryProductionOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310224" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310224

            #region VR.ATO.IITR.310225

            /*  VR.ATO.IITR.310225
            Non-PP - Other business income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr448] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR448, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
            */
            assertion = NotMonetary(report.IITR448, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310225",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Other business income is not in a valid monetary format",
                    LongDescription = @"Non-PP - Other business income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.BusinessNonPrimaryProductionOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310225" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310225

            #region VR.ATO.IITR.310227

            /*  VR.ATO.IITR.310227
            PP - Net income or loss from business this year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr474] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR474, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR474, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310227",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Net income or loss from business this year is not in a valid monetary format",
                    LongDescription = @"PP - Net income or loss from business this year may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.BusinessPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310227" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310227

            #region VR.ATO.IITR.310228

            /*  VR.ATO.IITR.310228
            Non-PP - Net income or loss from business this year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr475] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR475, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
            */
            assertion = NotMonetary(report.IITR475, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310228",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Net income or loss from business this year is not in a valid monetary format",
                    LongDescription = @"Non-PP - Net income or loss from business this year may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.BusinessNonPrimaryProductionNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310228" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310228

            #region VR.ATO.IITR.310229

            /*  VR.ATO.IITR.310229
            PP - Deferred non-commercial losses from a prior year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr476] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR476, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR476 = RP:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR476, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310229",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Deferred non-commercial losses from a prior year is not in a valid monetary format",
                    LongDescription = @"PP - Deferred non-commercial losses from a prior year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310229" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR476", Value = GetValueOrEmpty(report.IITR476) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310229

            #region VR.ATO.IITR.310230

            /*  VR.ATO.IITR.310230
            Non-PP - Deferred non-commercial losses from a prior year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr477] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR477, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR477 = RP:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR477, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.310230",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Deferred non-commercial losses from a prior year is not in a valid monetary format",
                    LongDescription = @"Non-PP - Deferred non-commercial losses from a prior year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.BusinessDeferredNonCommercialLossPriorYearNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310230" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR477", Value = GetValueOrEmpty(report.IITR477) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.310230

            #region VR.ATO.IITR.400006

            /*  VR.ATO.IITR.400006
            Super co-contributions is not available because taxable income is more than $53,564 and low income super contribution is not available because adjusted taxable income is $37,000 or more so Government super contributions must not be completed.
    
            Legacy Rule Format:
            IF (([iitr157] > 53564) AND ([iitr208] > 37000) AND ([iitr194] > 0 OR ([iitr196] <> NULL AND [iitr196] <> 0) OR [iitr197] > 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR157 > 53564) AND (^IITR208 > 37000) AND (^IITR194 > 0 OR (^IITR196 <> NULL AND ^IITR196 <> 0) OR ^IITR197 > 0))
    
            Data Elements:
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
            */
            assertion = (report.IITR157.GetValueOrDefault() > 53564 && report.IITR208.GetValueOrDefault() > 37000 && (report.IITR194.GetValueOrDefault() > 0 || report.IITR196 != null && report.IITR196 != 0 || report.IITR197.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.403006",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Government super contribution amounts incorrect",
                    LongDescription = @"When the 'Taxable income or loss' amount is above $53,564, and the 'Adjusted taxable income' amount is above $37,000, the amounts for 'Income from investment, partnership and other sources amount', 'Other income from employment and business' and 'Other deductions from business income' must be zero or not provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.InvestmentPartnershipOtherSource.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400006" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400006

            #region VR.ATO.IITR.400007

            /*  VR.ATO.IITR.400007
            The Spouse's family name or first name is required when the first name or other given names is provided.
    
            Legacy Rule Format:
            IF ([iitr214] <> NULLORBLANK OR [iitr215] <> NULLORBLANK) AND ([iitr213] = NULLORBLANK OR [iitr214]  =NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR214 <> BLANK OR ^IITR215 <> BLANK) AND (^IITR213 = BLANK OR ^IITR214  =BLANK)
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = ((string.IsNullOrWhiteSpace(report.IITR214) != true || string.IsNullOrWhiteSpace(report.IITR215) != true) && (string.IsNullOrWhiteSpace(report.IITR213) == true || string.IsNullOrWhiteSpace(report.IITR214) == true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name and first name is required",
                    LongDescription = @"The Spouse's or de facto spouse's family name or first name is required when the first name or other given names is provided",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400007

            #region VR.ATO.IITR.400008

            /*  VR.ATO.IITR.400008
            Spouse's family name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used.
    
            Legacy Rule Format:
            IF ([iitr213] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR213, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR213, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400008",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400008" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400008

            #region VR.ATO.IITR.400009

            /*  VR.ATO.IITR.400009
            Spouse's family name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used.
    
            Legacy Rule Format:
            IF ([iitr214] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR214, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR214, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400009

            #region VR.ATO.IITR.400010

            /*  VR.ATO.IITR.400010
            Spouse's family name field contains 'Exec for', 'Rep for' or 'Trustee for' at the beginning of the name field with a space after, in the field with a space before and after or at the end of the field with a space before. These abbreviations cannot be used.
    
            Legacy Rule Format:
            IF ([iitr215] = FOUND("Exec for","Rep for","Trustee for"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR215, '"Exec for","Rep for","Trustee for"'))
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR215, @"(^(Exec for|Rep for|Trustee for)$)|(^(.*)( Exec for | Rep for | Trustee for )(.*)$)|(^(Exec for |Rep for |Trustee for )(.*)$)|(^(.*)( Exec for| Rep for| Trustee for)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400010",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names cannot contain ""Exec for"", ""Rep for"" or ""Trustee for""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400010" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400010

            #region VR.ATO.IITR.400011

            /*  VR.ATO.IITR.400011
            Spouse's family name field contains all numeric characters with any combination of spaces; at least one alpha must be present.
    
            Legacy Rule Format:
            IF ([iitr213] <> NULLORBLANK) AND ([iitr213] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR213 <> BLANK) AND (NotContainsSet(^IITR213, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR213) != true && !(IsMatch(report.IITR213, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400011",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name field cannot contain all numeric characters including any spaces",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400011" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400011

            #region VR.ATO.IITR.400012

            /*  VR.ATO.IITR.400012
            Spouse's first name field contains all numeric characters with any combination of spaces; at least one alpha must be present.
    
            Legacy Rule Format:
            IF ([iitr214] <> NULLORBLANK) AND ([iitr214] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR214 <> BLANK) AND (NotContainsSet(^IITR214, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR214) != true && !(IsMatch(report.IITR214, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name field cannot contain all numeric characters including any spaces",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400012

            #region VR.ATO.IITR.400013

            /*  VR.ATO.IITR.400013
            Spouse's other given names field contains all numeric characters with any combination of spaces; at least one alpha must be present.
    
            Legacy Rule Format:
            IF ([iitr215] <> NULLORBLANK) AND ([iitr215] DOES NOT CONTAIN SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR215 <> BLANK) AND (NotContainsSet(^IITR215, '"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR215) != true && !(IsMatch(report.IITR215, @"[A-Z]|[a-z]", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400013",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names field cannot contain all numeric characters including any spaces",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400013" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400013

            #region VR.ATO.IITR.400014

            /*  VR.ATO.IITR.400014
            Spouse's family name field contains repeated hyphen, apostrophe, or space characters.
    
            Legacy Rule Format:
            IF ([iitr213] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR213, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR213, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400014",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name field contains repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400014

            #region VR.ATO.IITR.400015

            /*  VR.ATO.IITR.400015
            Spouse's first name field contains repeated hyphen, apostrophe, or space characters.
    
            Legacy Rule Format:
            IF ([iitr214] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR214, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR214, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400015",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name field contains repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400015

            #region VR.ATO.IITR.400016

            /*  VR.ATO.IITR.400016
            Spouse's other given names field contains repeated hyphen, apostrophe, or space characters.
    
            Legacy Rule Format:
            IF ([iitr215] CONTAINS SET("--","''","  ") )
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (ContainsSet(^IITR215, '"--","''","  "'))
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR215, @"--|''|  ", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names field contains repeated hyphen, apostrophe, or space characters",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400016

            #region VR.ATO.IITR.400017

            /*  VR.ATO.IITR.400017
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr213] CONTAINS " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR213, ' - ')
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = (report.IITR213 == null ? false : report.IITR213.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400017",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name field must not have space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400017" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400017

            #region VR.ATO.IITR.400018

            /*  VR.ATO.IITR.400018
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr214] CONTAINS " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR214, ' - ')
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = (report.IITR214 == null ? false : report.IITR214.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400018",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name field must not have space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400018" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400018

            #region VR.ATO.IITR.400019

            /*  VR.ATO.IITR.400019
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr215] CONTAINS " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR215, ' - ')
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (report.IITR215 == null ? false : report.IITR215.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400019",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names field must not have space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400019" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400019

            #region VR.ATO.IITR.400020

            /*  VR.ATO.IITR.400020
            Name field cannot contain 'space hyphen space'.
    
            Legacy Rule Format:
            IF ([iitr425] CONTAINS " - ")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR425, ' - ')
    
            Data Elements:
    
            ^IITR425 = RP:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = (report.IITR425 == null ? false : report.IITR425.ToUpperInvariant().Contains(@" - "));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400020",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business name of main business field must not have space hyphen space combinations",
                    Location = "/xbrli:xbrl/tns:OrganisationNameDetails.OrganisationalName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400020" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR425", Value = GetValueOrEmpty(report.IITR425) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400020

            #region VR.ATO.IITR.400021

            /*  VR.ATO.IITR.400021
            Spouse's family name field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field
    
            Legacy Rule Format:
            IF ([iitr213] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR213, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR213, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400021",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400021" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400021

            #region VR.ATO.IITR.400022

            /*  VR.ATO.IITR.400022
            Spouse's first name field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr214] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR214, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR214, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400022",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400022" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400022

            #region VR.ATO.IITR.400023

            /*  VR.ATO.IITR.400023
            Spouse's other given names field contains titles MR, MRS, MISS or MS at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr215] = FOUND("MR","MRS","MISS","MS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR215, '"MR","MRS","MISS","MS"'))
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR215, @"(^(MR|MRS|MISS|MS)$)|(^(.*)( MR | MRS | MISS | MS )(.*)$)|(^(MR |MRS |MISS |MS )(.*)$)|(^(.*)( MR| MRS| MISS| MS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400023",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given name cannot contain ""MR"", ""MRS"", ""MISS"" or ""MS""",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400023" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400023

            #region VR.ATO.IITR.400024

            /*  VR.ATO.IITR.400024
            Spouse's family name field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field
    
            Legacy Rule Format:
            IF ([iitr213] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR213, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR213, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400024",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name is invalid",
                    LongDescription = @"Spouse's or de facto spouse's family name field must not contain the suffixes ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400024" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400024

            #region VR.ATO.IITR.400025

            /*  VR.ATO.IITR.400025
            Spouse's first name field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr214] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR214, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR214, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400025",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name is invalid",
                    LongDescription = @"Spouse's or de facto spouse's first name field must not contain the suffixes ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400025" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400025

            #region VR.ATO.IITR.400026

            /*  VR.ATO.IITR.400026
            Spouse's other given names field contains suffix ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR at the beginning of the field with a space after, in the field with a space before and after, at the end of the field with a space before or alone in the field. These abbreviations cannot be used in the individual name field.
    
            Legacy Rule Format:
            IF ([iitr215] = FOUND("ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR215, '"ESQ","JNR","JP","MHA","MHR","MLA","MLC","MP","QC","SNR"'))
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR215, @"(^(ESQ|JNR|JP|MHA|MHR|MLA|MLC|MP|QC|SNR)$)|(^(.*)( ESQ | JNR | JP | MHA | MHR | MLA | MLC | MP | QC | SNR )(.*)$)|(^(ESQ |JNR |JP |MHA |MHR |MLA |MLC |MP |QC |SNR )(.*)$)|(^(.*)( ESQ| JNR| JP| MHA| MHR| MLA| MLC| MP| QC| SNR)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names is invalid",
                    LongDescription = @"Spouse's or de facto spouse's other given names field must not contain the suffixes ESQ, JNR, JP, MHA, MHR, MLA, MLC, MP, QC or SNR",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400026

            #region VR.ATO.IITR.400027

            /*  VR.ATO.IITR.400027
            The taxpayer has indicated that they did not have a spouse for part of the year or for the full year, however other spouse details are provided.
    
            Legacy Rule Format:
            IF [iitr220] = FALSE AND [iitr221] = NULL AND [iitr222] = NULL AND ([iitr217] <> NULL OR [iitr225] <> NULL OR [iitr226] <> NULL OR [iitr227] <> NULL OR [iitr492] <> NULL OR [iitr493] <> NULL OR [iitr229] <> NULL OR [iitr230] <> NULL OR [iitr213] <> NULLORBLANK OR [iitr231] <> NULL OR [iitr232] <> NULL OR [iitr233] <> NULL OR [iitr234] <> NULL OR [iitr235] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR220 = FALSE AND ^IITR221 = NULL AND ^IITR222 = NULL AND (^IITR217 <> NULL OR ^IITR225 <> NULL OR ^IITR226 <> NULL OR ^IITR227 <> NULL OR ^IITR492 <> NULL OR ^IITR493 <> NULL OR ^IITR229 <> NULL OR ^IITR230 <> NULL OR ^IITR213 <> BLANK OR ^IITR231 <> NULL OR ^IITR232 <> NULL OR ^IITR233 <> NULL OR ^IITR234 <> NULL OR ^IITR235 <> NULL)
    
            Data Elements:
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR226 = RP.SPOUSE:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount
    
            ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
    
            ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR229 = RP.SPOUSE:Pension.Total.Amount
    
            ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount
    
            ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount
    
            ^IITR233 = RP.SPOUSE:InternationalDealings.ForeignIncomeTarget.Amount
    
            ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount
    
            ^IITR235 = RP.SPOUSE:ChildSupport.Payment.Amount
            */
            assertion = (report.IITR220 == false && report.IITR221 == null && report.IITR222 == null && (report.IITR217 != null || report.IITR225 != null || report.IITR226 != null || report.IITR227 != null || report.IITR492 != null || report.IITR493 != null || report.IITR229 != null || report.IITR230 != null || string.IsNullOrWhiteSpace(report.IITR213) != true || report.IITR231 != null || report.IITR232 != null || report.IITR233 != null || report.IITR234 != null || report.IITR235 != null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400027",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse details provided for taxpayer without spouse",
                    LongDescription = @"The taxpayer has indicated that they did not have a spouse for part of the year or for the full year, however other spouse details are provided",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.SpouseFullYear.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400027" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR226", Value = GetValueOrEmpty(report.IITR226) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR227", Value = GetValueOrEmpty(report.IITR227) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR492", Value = GetValueOrEmpty(report.IITR492) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR493", Value = GetValueOrEmpty(report.IITR493) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR229", Value = GetValueOrEmpty(report.IITR229) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = GetValueOrEmpty(report.IITR230) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR231", Value = GetValueOrEmpty(report.IITR231) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR232", Value = GetValueOrEmpty(report.IITR232) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR233", Value = GetValueOrEmpty(report.IITR233) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR234", Value = GetValueOrEmpty(report.IITR234) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR235", Value = GetValueOrEmpty(report.IITR235) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400027

            #region VR.ATO.IITR.400028

            /*  VR.ATO.IITR.400028
            Where the taxpayer has had a spouse for the full year or part of the year, the Spouse's or de facto spouse's family name and taxable income are required
    
            Legacy Rule Format:
            IF ([iitr220] = TRUE OR ([iitr221] <> NULL OR [iitr222] <> NULL)) AND ([iitr213] = NULLORBLANK OR [iitr225] = NULL)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR220 = TRUE OR (^IITR221 <> NULL OR ^IITR222 <> NULL)) AND (^IITR213 = BLANK OR ^IITR225 = NULL)
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
            */
            assertion = ((report.IITR220 == true || (report.IITR221 != null || report.IITR222 != null)) && (string.IsNullOrWhiteSpace(report.IITR213) == true || report.IITR225 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.401028",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name and taxable income are required",
                    LongDescription = @"Where the taxpayer has had a spouse for the full year or part of the year, the Spouse's or de facto spouse's family name and taxable income are required",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400028" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400028

            #region VR.ATO.IITR.400029

            /*  VR.ATO.IITR.400029
            Spouse's first name must begin with an alpha character in the range 'A to Z' or 'a to z'.
    
            Legacy Rule Format:
            IF ([iitr214] <> NULLORBLANK) AND ([iitr214] DOES NOT STARTWITH SET("A-Z","a-z"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR214 <> BLANK) AND (NOT StartsWithSet(^IITR214,'"A-Z","a-z"'))
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR214) != true && !(IsMatch(report.IITR214, @"^([A-Z]|[a-z])", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400029",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name must begin with an alpha character in the range 'A to Z' or 'a to z'",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400029" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400029

            #region VR.ATO.IITR.400030

            /*  VR.ATO.IITR.400030
            Where details have been provided for Spouse's date of birth, 'Spouse details - Date had a spouse from', 'Spouse details - Date had a spouse to', 'Amount of any Australian Government pensions and allowances received by your spouse in the year of the return' and 'Your spouse's Adjustable Tax Income total amount',  the question, 'Had spouse for the full year' must be answered.
    
            Legacy Rule Format:
            IF ([iitr217] <> NULL OR [iitr221] <> NULL OR [iitr222] <> NULL OR [iitr229] <> NULL OR [iitr237] <> NULL) AND ([iitr220] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR217 <> NULL OR ^IITR221 <> NULL OR ^IITR222 <> NULL OR ^IITR229 <> NULL OR ^IITR237 <> NULL) AND (^IITR220 = NULL)
    
            Data Elements:
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
    
            ^IITR229 = RP.SPOUSE:Pension.Total.Amount
    
            ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount
            */
            assertion = ((report.IITR217 != null || report.IITR221 != null || report.IITR222 != null || report.IITR229 != null || report.IITR237 != null) && report.IITR220 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400030",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Had spouse for the full year must be answered",
                    LongDescription = @"Where details have been provided for Spouse's date of birth, 'Spouse details - Date had a spouse from', 'Spouse details - Date had a spouse to', 'Amount of any Australian Government pensions and allowances received by your spouse in the year of the return' and 'Your spouse's Adjustable Tax Income total amount', the question, 'Had spouse for the full year' must be answered",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.SpouseFullYear.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400030" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR229", Value = GetValueOrEmpty(report.IITR229) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR237", Value = GetValueOrEmpty(report.IITR237) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400030

            #region VR.ATO.IITR.400031

            /*  VR.ATO.IITR.400031
            The Spouse's date of birth cannot be a future date.
    
            Legacy Rule Format:
            IF ([iitr217] > DATE(TODAY))
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR217 > Today())
    
            Data Elements:
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
            */
            assertion = (report.IITR217.GetValueOrDefault() > DateTime.Now.Date);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400031",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's date of birth cannot be a future date",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Birth.Date[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400031" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400031

            #region VR.ATO.IITR.400033

            /*  VR.ATO.IITR.400033
            Reportable employer superannuation contributions has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr201] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR201, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
            */
            assertion = NotMonetary(report.IITR201, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reportable employer superannuation contributions is not in a valid monetary format",
                    LongDescription = @"Reportable employer superannuation contributions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:SuperannuationContribution.EmployerReportable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400033" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR201", Value = GetValueOrEmpty(report.IITR201) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400033

            #region VR.ATO.IITR.400034

            /*  VR.ATO.IITR.400034
            Tax-free government pensions has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr202] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR202, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR202 = RP:Pension.TaxFree.Amount
            */
            assertion = NotMonetary(report.IITR202, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400034",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax-free government pensions is not in a valid monetary format",
                    LongDescription = @"Tax-free government pensions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Pension.TaxFree.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400034" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR202", Value = GetValueOrEmpty(report.IITR202) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400034

            #region VR.ATO.IITR.400035

            /*  VR.ATO.IITR.400035
            Target foreign income has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr203] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR203, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR203 = RP:InternationalDealings.ForeignIncomeTarget.Amount
            */
            assertion = NotMonetary(report.IITR203, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400035",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Target foreign income is not in a valid monetary format",
                    LongDescription = @"Target foreign income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeTarget.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400035" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR203", Value = GetValueOrEmpty(report.IITR203) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400035

            #region VR.ATO.IITR.400036

            /*  VR.ATO.IITR.400036
            Net financial investment loss has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr204] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR204, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount
            */
            assertion = NotMonetary(report.IITR204, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400036",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net financial investment loss is not in a valid monetary format",
                    LongDescription = @"Net financial investment loss must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.FinancialInvestmentNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400036" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR204", Value = GetValueOrEmpty(report.IITR204) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400036

            #region VR.ATO.IITR.400037

            /*  VR.ATO.IITR.400037
            Net rental property loss has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr205] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR205, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount
            */
            assertion = NotMonetary(report.IITR205, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400037",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Net rental property loss is not in a valid monetary format",
                    LongDescription = @"Net rental property loss must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.RentalPropertyNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400037" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR205", Value = GetValueOrEmpty(report.IITR205) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400037

            #region VR.ATO.IITR.400038

            /*  VR.ATO.IITR.400038
            Child support you paid has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr206] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR206, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR206 = RP:ChildSupport.Payment.Amount
            */
            assertion = NotMonetary(report.IITR206, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400038",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Child support you paid is not in a valid monetary format",
                    LongDescription = @"Child support you paid must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:ChildSupport.Payment.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400038" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR206", Value = GetValueOrEmpty(report.IITR206) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400038

            #region VR.ATO.IITR.400039

            /*  VR.ATO.IITR.400039
            Number of dependent children and students has a maximum length of 2.
    
            Legacy Rule Format:
            IF LENGTH([iitr207]) > 2
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR207) > 2
    
            Data Elements:
    
            ^IITR207 = RP:PersonDemographicDetails.DependentChildren.Count
            */
            assertion = (Length(report.IITR207.GetValueOrDefault()) > 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400039",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of dependent children and students must not exceed 2 characters",
                    LongDescription = @"For the Number of dependent children and students, the maximum allowable characters for this form is 2",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.DependentChildren.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400039" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR207", Value = report.IITR207.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400039

            #region VR.ATO.IITR.400040

            /*  VR.ATO.IITR.400040
            Adjusted taxable income has a maximum field length of 11.
    
            Legacy Rule Format:
            IF [iitr208] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR208, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
            */
            assertion = NotMonetary(report.IITR208, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400040",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Adjusted taxable income is not in a valid monetary format",
                    LongDescription = @"Adjusted taxable income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400040" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400040

            #region VR.ATO.IITR.400041

            /*  VR.ATO.IITR.400041
            Estimated total income has a maximum field length of 11.
    
            Legacy Rule Format:
            IF [iitr209] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR209, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR209 = RP:Income.Estimated.Amount
            */
            assertion = NotMonetary(report.IITR209, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400041",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Estimated total income is not in a valid monetary format",
                    LongDescription = @"Estimated total income may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.Estimated.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400041" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR209", Value = GetValueOrEmpty(report.IITR209) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400041

            #region VR.ATO.IITR.400042

            /*  VR.ATO.IITR.400042
            Estimated eligible income has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr210] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR210, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR210 = RP:Income.LowIncomeSuperannuationContributionEligible.Amount
            */
            assertion = NotMonetary(report.IITR210, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400042",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Estimated eligible income is not in a valid monetary format",
                    LongDescription = @"Estimated eligible income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.LowIncomeSuperannuationContributionEligible.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400042" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR210", Value = GetValueOrEmpty(report.IITR210) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400042

            #region VR.ATO.IITR.400043

            /*  VR.ATO.IITR.400043
            Spouse's family name has a maximum field length of 30.
    
            Legacy Rule Format:
            IF LENGTH([iitr213]) > 30
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR213) > 30
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = (Length(report.IITR213) > 30);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400043",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name must not exceed 30 characters",
                    LongDescription = @"For Spouse's or de facto spouse's family name, the maximum allowable characters for this form is 30",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400043" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400043

            #region VR.ATO.IITR.400044

            /*  VR.ATO.IITR.400044
            Spouse's first name has a maximum field length of 15.
    
            Legacy Rule Format:
            IF LENGTH([iitr214]) > 15
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR214) > 15
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = (Length(report.IITR214) > 15);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400044",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name must not exceed 15 characters",
                    LongDescription = @"For Spouse's or de facto spouse's first name, the maximum allowable characters for this form is 15",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400044" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400044

            #region VR.ATO.IITR.400045

            /*  VR.ATO.IITR.400045
            Spouse's other given names has a maximum field length of 30.
    
            Legacy Rule Format:
            IF LENGTH([iitr215]) > 30
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR215) > 30
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = (Length(report.IITR215) > 30);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400045",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names must not exceed 30 characters",
                    LongDescription = @"For Spouse's or de facto spouse's other given names, the maximum allowable characters for this form is 30",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400045" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400045

            #region VR.ATO.IITR.400047

            /*  VR.ATO.IITR.400047
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr213] <> NULLORBLANK) AND ([iitr213] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR213, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = IsMatch(report.IITR213, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400047",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's family name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400047" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400047

            #region VR.ATO.IITR.400048

            /*  VR.ATO.IITR.400048
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr214] <> NULLORBLANK) AND ([iitr214] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR214, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
            */
            assertion = IsMatch(report.IITR214, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400048",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's first name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400048" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400048

            #region VR.ATO.IITR.400049

            /*  VR.ATO.IITR.400049
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr215] <> NULLORBLANK) AND ([iitr215] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR215, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
            */
            assertion = IsMatch(report.IITR215, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400049",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's or de facto spouse's other given names contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.OtherGivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400049" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400049

            #region VR.ATO.IITR.400050

            /*  VR.ATO.IITR.400050
            The number of Reporting Party Business contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.BUS) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.BUS
            */
            assertion = (Count(report.RPBUSCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400050",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Business contexts must not exceed 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPBUSLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400050" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400050

            #region VR.ATO.IITR.400051

            /*  VR.ATO.IITR.400051
            Scheme for Reporting Party Business must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP.BUS:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.BUS
            */
            assertion = ((report.RPBUSExists == true) && (report.RPBUSIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400051",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Business must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPBUSOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400051" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400051

            #region VR.ATO.IITR.400052

            /*  VR.ATO.IITR.400052
            The number of Reporting Party Loss contexts must not exceed 10
    
            Legacy Rule Format:
            IF COUNT(RP.{LOSSSeqNum}) > 10
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 10
    
            Data Elements:
    
            ^Context = RP:RP.{LOSSSeqNum}
            */
            assertion = (Count(report.RPLOSSSeqNumContextCollection) > 10);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.401052",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Loss contexts must not exceed 10.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLOSSSeqNumContextCollection == null ? 0 : (report.RPLOSSSeqNumContextCollection.Count() == 0 ? 0 : report.RPLOSSSeqNumContextCollection.Last().LastOccurrenceIndex)),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400052" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400052

            #region VR.ATO.IITR.400054

            /*  VR.ATO.IITR.400054
            The Sequence Container within the Reporting Party Loss context must not be duplicated
    
            Legacy Rule Format:
            IF [iitr573] = ANY OTHER OCCURRENCE OF [iitr573]
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^IITR573)
    
            Data Elements:
    
            ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPLOSSSeqNumContextCollection == null ? null : report.RPLOSSSeqNumContextCollection.Select(f => f.IITR573).Cast<object>().ToArray());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400054",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Sequence Container must not be duplicated for Reporting Party Loss",
                    LongDescription = @"The Sequence Container within the Reporting Party Loss context must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPLOSSSeqNumContextCollection[DuplicateValueIndex(report.RPLOSSSeqNumContextCollection.Select(f => f.IITR573))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400054" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400054

            #region VR.ATO.IITR.400055

            /*  VR.ATO.IITR.400055
            Scheme for Reporting Party Spouse must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP.SPOUSE:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.SPOUSE
            */
            assertion = ((report.RPSPOUSEExists == true) && (report.RPSPOUSEIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400055",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity Identifier scheme for Reporting Party Spouse must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400055" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400055

            #region VR.ATO.IITR.400056

            /*  VR.ATO.IITR.400056
            The number of Reporting Party Spouse contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.SPOUSE) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.SPOUSE
            */
            assertion = (Count(report.RPSPOUSECount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400056",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Spouse contexts must not exceed 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSELastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400056" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400056

            #region VR.ATO.IITR.400065

            /*  VR.ATO.IITR.400065
            Where taxable income is greater than or equal to $53,564 and adjusted taxable income is less than or equal to $37,000; and government super contribution fields are present, check criteria as Government super contributions should only be completed if you may be entitled to a low income super contribution.
    
            Legacy Rule Format:
            IF ([iitr157] >= 53564) AND ([iitr208] = NULL OR [iitr208] <= 37000) AND ([iitr194] > 0 OR ([iitr196] <> NULL AND [iitr196] <> 0) OR [iitr197] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR157 >= 53564) AND (^IITR208 = NULL OR ^IITR208 <= 37000) AND (^IITR194 > 0 OR (^IITR196 <> NULL AND ^IITR196 <> 0) OR ^IITR197 > 0)
    
            Data Elements:
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
            */
            assertion = (report.IITR157.GetValueOrDefault() >= 53564 && (report.IITR208 == null || report.IITR208.GetValueOrDefault() <= 37000) && (report.IITR194.GetValueOrDefault() > 0 || report.IITR196 != null && report.IITR196 != 0 || report.IITR197.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.403065",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check criteria for the completion of Government super contributions",
                    LongDescription = @"Where taxable income is $53,564 or more Government super contributions should not be completed for co-contributions. Adjusted taxable income is $37,000 or less so Government super contributions should only be completed if you may be entitled to a low income super contribution.",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400065" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400065

            #region VR.ATO.IITR.400066

            /*  VR.ATO.IITR.400066
            Where adjusted taxable income exceeds $37,000 low income super contribution will not be permitted. As taxable income is $53,564 or less Government super contributions should only be completed where a personal contribution is made to the super fund for which a deduction was not claimed.
    
            Legacy Rule Format:
            IF ([iitr157] = NULL OR ([iitr157] - [iitr650]) < 53564) AND ([iitr208] > 37000) AND ([iitr194] > 0 OR ([iitr196] <> NULL AND [iitr196] <> 0) OR [iitr197] > 0) AND ([iitr242] = NULL OR [iitr242] <= 0) AND ([iitr252] = NULL OR [iitr252] <= 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR157 = NULL OR (^IITR157 - ^IITR650) < 53564) AND (^IITR208 > 37000) AND (^IITR194 > 0 OR (^IITR196 <> NULL AND ^IITR196 <> 0) OR ^IITR197 > 0) AND (^IITR242 = NULL OR ^IITR242 <= 0) AND (^IITR252 = NULL OR ^IITR252 <= 0)
    
            Data Elements:
    
            ^IITR208 = RP:Income.TaxableAdjusted.Amount
    
            ^IITR157 = RP:Income.Taxable.Amount
    
            ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = ((report.IITR157 == null || report.IITR157.GetValueOrDefault() - report.IITR650.GetValueOrDefault() < 53564) && report.IITR208.GetValueOrDefault() > 37000 && (report.IITR194.GetValueOrDefault() > 0 || report.IITR196 != null && report.IITR196 != 0 || report.IITR197.GetValueOrDefault() > 0) && (report.IITR242 == null || report.IITR242.GetValueOrDefault() <= 0) && (report.IITR252 == null || report.IITR252.GetValueOrDefault() <= 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.403066",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check criteria for the completion of Government super contributions",
                    LongDescription = @"Where adjusted taxable income exceeds $37,000 low income super contribution will not be permitted. As taxable income is $53,564 or less Government super contributions should only be completed where a personal contribution is made to the super fund for which a deduction was not claimed.",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400066" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR208", Value = GetValueOrEmpty(report.IITR208) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400066

            #region VR.ATO.IITR.400070

            /*  VR.ATO.IITR.400070
            Where Estimated total income is less than $38,564, and Estimated eligible income is greater than or equal to 10% of Estimated total income, and Government super contribution amounts are present, check criteria as there is no need to complete Government super contributions for either co-contribution or low income super contribution purposes unless employment or business income that relates to an earlier income year for Salary and wages, Allowances, earnings, tips, director's fees, Total assessable discount amount, Total reportable fringe benefits amount; Reportable employer superannuation contributions, or Business income and expenses, has been disclosed.
    
            Legacy Rule Format:
            IF ([iitr209] = NULL OR [iitr209] < 38564) AND (([iitr210] <> NULL AND [iitr210] >= ([iitr209] * 0.1)) OR ([iitr210] = NULL AND ([iitr209] * 0.1) <= 0)) AND ([iitr194] > 0 OR ([iitr196] <> NULL AND [iitr196] <> 0) OR [iitr197] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR209 = NULL OR ^IITR209 < 38564) AND ((^IITR210 <> NULL AND ^IITR210 >= (^IITR209 * 0.1)) OR (^IITR210 = NULL AND (^IITR209 * 0.1) <= 0)) AND (^IITR194 > 0 OR (^IITR196 <> NULL AND ^IITR196 <> 0) OR ^IITR197 > 0)
    
            Data Elements:
    
            ^IITR209 = RP:Income.Estimated.Amount
    
            ^IITR210 = RP:Income.LowIncomeSuperannuationContributionEligible.Amount
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
            */
            assertion = ((report.IITR209 == null || report.IITR209.GetValueOrDefault() < 38564) && (report.IITR210 != null && report.IITR210.GetValueOrDefault() >= report.IITR209.GetValueOrDefault() * 0.1M || report.IITR210 == null && report.IITR209.GetValueOrDefault() * 0.1M <= 0) && (report.IITR194.GetValueOrDefault() > 0 || report.IITR196 != null && report.IITR196 != 0 || report.IITR197.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.403070",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check completion of Government super contributions",
                    LongDescription = @"As estimated total income is below $38,564 there is no need to complete Government super contributions for either co-contribution or low income super contribution purposes unless employment or business income that relates to an earlier income year for Salary and Wages; Allowances, earnings, tips, director's fees; total assessable discount amount; Total reportable fringe benefits amount; Reportable employer superannuation contributions or Business income and expenses has been disclosed.",
                    Location = "/xbrli:xbrl/tns:Income.Estimated.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400070" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR209", Value = GetValueOrEmpty(report.IITR209) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR210", Value = GetValueOrEmpty(report.IITR210) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400070

            #region VR.ATO.IITR.400073

            /*  VR.ATO.IITR.400073
            When Family name is provided, First name must also be provided.
    
            Legacy Rule Format:
            IF ([iitr214] = NULLORBLANK) AND ([iitr213] <> NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR214 = BLANK) AND (^IITR213 <> BLANK)
    
            Data Elements:
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR214) == true && string.IsNullOrWhiteSpace(report.IITR213) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400073",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check name is complete where Spouse's or de facto spouse's first name field is blank",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.GivenName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400073" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400073

            #region VR.ATO.IITR.400077

            /*  VR.ATO.IITR.400077
            Total reportable fringe benefits amount from employers exempt under section 57A has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr490] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR490, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount
            */
            assertion = NotMonetary(report.IITR490, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400077",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total reportable fringe benefits amount from employers exempt under section 57A is not in a valid monetary format",
                    LongDescription = @"Total reportable fringe benefits amount from employers exempt under section 57A must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPEligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400077" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR490", Value = GetValueOrEmpty(report.IITR490) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400077

            #region VR.ATO.IITR.400078

            /*  VR.ATO.IITR.400078
            When no amount is present for Total reportable fringe benefits amount from employers exempt under section 57A, Total reportable fringe benefits amount from employers not exempt under section 57A, Reportable employer superannuation contributions, Tax-free government pensions, Target foreign income, Net financial investment loss, or Net rental property loss and Child support you paid, an amount must be provided for each or set to zero (0)
    
            Legacy Rule Format:
            IF [iitr13] <> "Short" AND ([iitr490] = NULL OR [iitr491] = NULL OR [iitr201] = NULL OR [iitr202] = NULL OR [iitr203] = NULL OR [iitr204] = NULL OR [iitr205] = NULL OR [iitr206] =  NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR13 <> 'Short' AND (^IITR490 = NULL OR ^IITR491 = NULL OR ^IITR201 = NULL OR ^IITR202 = NULL OR ^IITR203 = NULL OR ^IITR204 = NULL OR ^IITR205 = NULL OR ^IITR206 =  NULL)
    
            Data Elements:
    
            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR13 = RP:IncomeTax.ReturnType.Code
    
            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR201 = RP:SuperannuationContribution.EmployerReportable.Amount
    
            ^IITR202 = RP:Pension.TaxFree.Amount
    
            ^IITR203 = RP:InternationalDealings.ForeignIncomeTarget.Amount
    
            ^IITR204 = RP:Tax.Losses.FinancialInvestmentNet.Amount
    
            ^IITR205 = RP:Tax.Losses.RentalPropertyNet.Amount
    
            ^IITR206 = RP:ChildSupport.Payment.Amount
            */
            assertion = (report.IITR13 != @"Short" && (report.IITR490 == null || report.IITR491 == null || report.IITR201 == null || report.IITR202 == null || report.IITR203 == null || report.IITR204 == null || report.IITR205 == null || report.IITR206 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400078",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Amounts not present must be provided or set to zero",
                    LongDescription = @"When no amount is present for Total reportable fringe benefits amount from employers exempt under section 57A, Total reportable fringe benefits amount from employers not exempt under section 57A, Reportable employer superannuation contributions, Tax-free government pensions, Target foreign income, Net financial investment loss, or Net rental property loss and Child support you paid, an amount must be provided for each or set to zero (0)",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPEligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400078" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR13", Value = GetValueOrEmpty(report.IITR13) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR490", Value = GetValueOrEmpty(report.IITR490) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR491", Value = GetValueOrEmpty(report.IITR491) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR201", Value = GetValueOrEmpty(report.IITR201) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR202", Value = GetValueOrEmpty(report.IITR202) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR203", Value = GetValueOrEmpty(report.IITR203) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR204", Value = GetValueOrEmpty(report.IITR204) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR205", Value = GetValueOrEmpty(report.IITR205) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR206", Value = GetValueOrEmpty(report.IITR206) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400078

            #region VR.ATO.IITR.400079

            /*  VR.ATO.IITR.400079
            Total reportable fringe benefits amount from employers not exempt under section 57A amount has a maximum length of 11.
    
            Legacy Rule Format:
            IF [iitr491] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR491, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount
            */
            assertion = NotMonetary(report.IITR491, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400079",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total reportable fringe benefits amount from employers not exempt under section 57A amount is not in a valid monetary format",
                    LongDescription = @"Total reportable fringe benefits amount from employers not exempt under section 57A amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPIneligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400079" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR491", Value = GetValueOrEmpty(report.IITR491) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400079

            #region VR.ATO.IITR.400080

            /*  VR.ATO.IITR.400080
            The number of Reporting Party Eligible contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.Eligible) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Eligible
            */
            assertion = (Count(report.RPEligibleCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400080",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Eligible contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPEligibleLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400080" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400080

            #region VR.ATO.IITR.400081

            /*  VR.ATO.IITR.400081
            Scheme for Reporting Party Eligible must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Eligible:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Eligible
            */
            assertion = ((report.RPEligibleExists == true) && (report.RPEligibleIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400081",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Eligible must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPEligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400081" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400081

            #region VR.ATO.IITR.400082

            /*  VR.ATO.IITR.400082
            The number of Reporting Party Ineligible contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.Ineligible) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.Ineligible
            */
            assertion = (Count(report.RPIneligibleCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400082",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Ineligible contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPIneligibleLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400082" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400082

            #region VR.ATO.IITR.400083

            /*  VR.ATO.IITR.400083
            Scheme for Reporting Party Ineligible must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Ineligible:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.Ineligible
            */
            assertion = ((report.RPIneligibleExists == true) && (report.RPIneligibleIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400083",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Ineligible must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPIneligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400083" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400083

            #region VR.ATO.IITR.400084

            /*  VR.ATO.IITR.400084
            The number of Reporting Party Spouse Eligible contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.SPOUSE.Eligible) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.SPOUSE:RP.SPOUSE.Eligible
            */
            assertion = (Count(report.RPSPOUSEEligibleCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400084",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Spouse Eligible contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEEligibleLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400084" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400084

            #region VR.ATO.IITR.400085

            /*  VR.ATO.IITR.400085
            Scheme for Reporting Party Spouse Eligible must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.SPOUSE.Eligible:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.SPOUSE:RP.SPOUSE.Eligible
            */
            assertion = ((report.RPSPOUSEEligibleExists == true) && (report.RPSPOUSEEligibleIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400085",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Spouse Eligible must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEEligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400085" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400085

            #region VR.ATO.IITR.400086

            /*  VR.ATO.IITR.400086
            The number of Reporting Party Spouse Ineligible contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.SPOUSE.Ineligible) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.SPOUSE:RP.SPOUSE.Ineligible
            */
            assertion = (Count(report.RPSPOUSEIneligibleCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400086",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Spouse Ineligible contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEIneligibleLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400086" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400086

            #region VR.ATO.IITR.400087

            /*  VR.ATO.IITR.400087
            Scheme for Reporting Party Spouse Ineligible must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.SPOUSE.Ineligible:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.SPOUSE:RP.SPOUSE.Ineligible
            */
            assertion = ((report.RPSPOUSEIneligibleExists == true) && (report.RPSPOUSEIneligibleIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400087",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Spouse Ineligible must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPSPOUSEIneligibleOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400087" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400087

            #region VR.ATO.IITR.400088

            /*  VR.ATO.IITR.400088
            The number of Reporting Party Private Health Insurance contexts must not exceed 25
    
            Legacy Rule Format:
            IF COUNT(RP.{PHISeqNum}) > 25
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 25
    
            Data Elements:
    
            ^Context = RP:RP.{PHISeqNum}
            */
            assertion = (Count(report.RPPHISeqNumContextCollection) > 25);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400088",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Private Health Insurance contexts must not exceed 25.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPHISeqNumContextCollection == null ? 0 : (report.RPPHISeqNumContextCollection.Count() == 0 ? 0 : report.RPPHISeqNumContextCollection.Last().LastOccurrenceIndex)),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400088" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400088

            #region VR.ATO.IITR.400096

            /*  VR.ATO.IITR.400096
            Scheme for Reporting Party Foreign must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.JFOREIGN:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.JFOREIGN
            */
            assertion = ((report.RPJFOREIGNExists == true) && (report.RPJFOREIGNIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400096",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity Identifier scheme for Reporting Party Foreign must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPJFOREIGNOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400096" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400096

            #region VR.ATO.IITR.400097

            /*  VR.ATO.IITR.400097
            The number of Reporting Party Foreign contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.JFOREIGN) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.JFOREIGN
            */
            assertion = (Count(report.RPJFOREIGNCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400097",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Foreign contexts must not exceed 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPJFOREIGNLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400097" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400097

            #region VR.ATO.IITR.400100

            /*  VR.ATO.IITR.400100
            The number of Reporting Party Working Holiday Maker contexts must not exceed 1
    
            Legacy Rule Format:
            IF COUNT(RP.WHM) > 1
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.WHM
            */
            assertion = (Count(report.RPWHMCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Working Holiday Maker contexts must not exceed 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPWHMLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400100" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400100

            #region VR.ATO.IITR.400151

            /*  VR.ATO.IITR.400151
            Since the dates the taxpayer had a spouse are for the full financial year, either the date from or date to require adjustment. If the taxpayer had a spouse for the full year, a 'yes' response is required to the question 'Did you have a spouse for the full year' and the part year dates must be deleted.
    
            Legacy Rule Format:
            IF [iitr221] = RP:Period.startDate AND [iitr222] = RP:Period.endDate
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR221 = ^StartDate1 AND ^IITR222 = ^EndDate
    
            Data Elements:
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^EndDate = RP
    
            ^StartDate1 = RP
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
            */
            assertion = (report.IITR221.GetValueOrDefault() == report.RPStartDate && report.IITR222.GetValueOrDefault() == report.RPEndDate);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.400151",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Ensure dates taxpayer had a spouse are for part of the year",
                    LongDescription = @"Since the dates the taxpayer had a spouse are for the full financial year, either the date from or date to require adjustment. If the taxpayer had a spouse for the full year, a 'yes' response is required to the question 'Did you have a spouse for the full year' and the part year dates must be deleted.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.SpouseRelationshipStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400151" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.400151

            #region VR.ATO.IITR.410000

            /*  VR.ATO.IITR.410000
            When Australian and New Zealand Standard Industrial Classification code has been entered, Number of business activities is required.
    
            Legacy Rule Format:
            IF [iitr419] <> NULLORBLANK AND [iitr421] = NULL
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR419 <> BLANK AND ^IITR421 = NULL
    
            Data Elements:
    
            ^IITR419 = RP:OrganisationDetails.OrganisationIndustry2006Extended.Code
    
            ^IITR421 = RP:Income.PersonalServicesIncome.BusinessActivities.Count
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR419) != true && report.IITR421 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410000",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of business activities is required",
                    LongDescription = @"When Australian and New Zealand Standard Industrial Classification code has been entered, Number of business activities is required",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationIndustry2006Extended.Code[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410000" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR419", Value = GetValueOrEmpty(report.IITR419) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR421", Value = report.IITR421.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410000

            #region VR.ATO.IITR.410001

            /*  VR.ATO.IITR.410001
            Address details must be complete with street name and number, suburb/town, State, and postcode.
    
            Legacy Rule Format:
            IF ([iitr428] <> NULLORBLANK OR [iitr429] <> NULLORBLANK OR [iitr430] <> NULLORBLANK OR [iitr431] <> NULL OR [iitr432] <> NULLORBLANK)
            AND ([iitr428] = NULLORBLANK OR [iitr430] = NULLORBLANK OR [iitr431] = NULLORBLANK OR [iitr432] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR428 <> BLANK OR ^IITR429 <> BLANK OR ^IITR430 <> BLANK OR ^IITR431 <> NULL OR ^IITR432 <> BLANK) AND (^IITR428 = BLANK OR ^IITR430 = BLANK OR ^IITR431 = BLANK OR ^IITR432 = BLANK)
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
    
            ^IITR429 = RP.BUS:AddressDetails.Line2.Text
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
    
            ^IITR431 = RP.BUS:AddressDetails.StateOrTerritory.Code
    
            ^IITR432 = RP.BUS:AddressDetails.Postcode.Text
            */
            assertion = ((string.IsNullOrWhiteSpace(report.IITR428) != true || string.IsNullOrWhiteSpace(report.IITR429) != true || string.IsNullOrWhiteSpace(report.IITR430) != true || report.IITR431 != null || string.IsNullOrWhiteSpace(report.IITR432) != true) && (string.IsNullOrWhiteSpace(report.IITR428) == true || string.IsNullOrWhiteSpace(report.IITR430) == true || string.IsNullOrWhiteSpace(report.IITR431) == true || string.IsNullOrWhiteSpace(report.IITR432) == true));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Address details must be present",
                    LongDescription = @"Address details must be complete with Street name and Number, Suburb/town, State and Postcode",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR429", Value = GetValueOrEmpty(report.IITR429) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR431", Value = GetValueOrEmpty(report.IITR431) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR432", Value = GetValueOrEmpty(report.IITR432) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410001

            #region VR.ATO.IITR.410002

            /*  VR.ATO.IITR.410002
            Numerics [0 to 9] are not allowed in the suburb/town field.
    
            Legacy Rule Format:
            IF [iitr430] CONTAINS NUMERICS SET(0-9)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR430, '0-9')
    
            Data Elements:
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
            */
            assertion = IsMatch(report.IITR430, @"[0-9]", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000410",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City cannot contain numeric characters",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410002

            #region VR.ATO.IITR.410003

            /*  VR.ATO.IITR.410003
            When the sum of primary and non-primary production cost of sales at Business income and expenses is positive, then the Total salary and wage expenses must not exceed total business expenses
    
            Legacy Rule Format:
            IF ((([iitr700] + [iitr701] + [iitr719] + [iitr720]) - ([iitr702] + [iitr721])) > 0) AND (([iitr514] <> NULL AND ([iitr514] > ([iitr703] + [iitr704] + [iitr705] + [iitr706] + [iitr707] + [iitr708] + [iitr709] + [iitr710] + [iitr711] + [iitr712] + [iitr713] + [iitr722] + [iitr723] + [iitr724] + [iitr725] + [iitr726] + [iitr727] + [iitr728] + [iitr729] + [iitr730] + [iitr731] + [iitr732] + [iitr733]))))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (((^IITR700 + ^IITR701 + ^IITR719 + ^IITR720) - (^IITR702 + ^IITR721)) > 0) AND ((^IITR514 <> NULL AND (^IITR514 > (^IITR703 + ^IITR704 + ^IITR705 + ^IITR706 + ^IITR707 + ^IITR708 + ^IITR709 + ^IITR710 + ^IITR711 + ^IITR712 + ^IITR713 + ^IITR722 + ^IITR723 + ^IITR724 + ^IITR725 + ^IITR726 + ^IITR727 + ^IITR728 + ^IITR729 + ^IITR730 + ^IITR731 + ^IITR732 + ^IITR733))))
    
            Data Elements:
    
            ^IITR514 = RP:Remuneration.WagesAndSalaries.Total.Amount
    
            ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
    
            ^IITR701 = RP.Prim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
    
            ^IITR720 = RP.NonPrim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
    
            ^IITR703 = RP.Prim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR704 = RP.Prim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR705 = RP.Prim:Expense.Operating.BadDebts.Amount
    
            ^IITR706 = RP.Prim:Expense.Operating.Lease.Amount
    
            ^IITR707 = RP.Prim:Expense.Operating.Rent.Amount
    
            ^IITR708 = RP.Prim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR709 = RP.Prim:Expense.Operating.InterestForeign.Amount
    
            ^IITR710 = RP.Prim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR712 = RP.Prim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR713 = RP.Prim:Expense.Operating.Other.Amount
    
            ^IITR722 = RP.NonPrim:Expense.ForeignResidentWithholding.Amount
    
            ^IITR723 = RP.NonPrim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR724 = RP.NonPrim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR725 = RP.NonPrim:Expense.Operating.BadDebts.Amount
    
            ^IITR726 = RP.NonPrim:Expense.Operating.Lease.Amount
    
            ^IITR727 = RP.NonPrim:Expense.Operating.Rent.Amount
    
            ^IITR728 = RP.NonPrim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR729 = RP.NonPrim:Expense.Operating.InterestForeign.Amount
    
            ^IITR730 = RP.NonPrim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR732 = RP.NonPrim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR733 = RP.NonPrim:Expense.Operating.Other.Amount
            */
            assertion = (report.IITR700.GetValueOrDefault() + report.IITR701.GetValueOrDefault() + report.IITR719.GetValueOrDefault() + report.IITR720.GetValueOrDefault() - (report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault()) > 0 && (report.IITR514 != null && report.IITR514.GetValueOrDefault() > report.IITR703.GetValueOrDefault() + report.IITR704.GetValueOrDefault() + report.IITR705.GetValueOrDefault() + report.IITR706.GetValueOrDefault() + report.IITR707.GetValueOrDefault() + report.IITR708.GetValueOrDefault() + report.IITR709.GetValueOrDefault() + report.IITR710.GetValueOrDefault() + report.IITR711.GetValueOrDefault() + report.IITR712.GetValueOrDefault() + report.IITR713.GetValueOrDefault() + report.IITR722.GetValueOrDefault() + report.IITR723.GetValueOrDefault() + report.IITR724.GetValueOrDefault() + report.IITR725.GetValueOrDefault() + report.IITR726.GetValueOrDefault() + report.IITR727.GetValueOrDefault() + report.IITR728.GetValueOrDefault() + report.IITR729.GetValueOrDefault() + report.IITR730.GetValueOrDefault() + report.IITR731.GetValueOrDefault() + report.IITR732.GetValueOrDefault() + report.IITR733.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.411003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total salary and wage expenses or total business expenses is incorrect",
                    LongDescription = @"When the sum of primary and non-primary production cost of sales at Business income and expenses is positive, then the Total salary and wage expenses must not exceed total business expenses",
                    Location = "/xbrli:xbrl/tns:Remuneration.WagesAndSalaries.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR701", Value = GetValueOrEmpty(report.IITR701) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR720", Value = GetValueOrEmpty(report.IITR720) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR514", Value = GetValueOrEmpty(report.IITR514) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR703", Value = GetValueOrEmpty(report.IITR703) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR704", Value = GetValueOrEmpty(report.IITR704) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR705", Value = GetValueOrEmpty(report.IITR705) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR706", Value = GetValueOrEmpty(report.IITR706) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR707", Value = GetValueOrEmpty(report.IITR707) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR708", Value = GetValueOrEmpty(report.IITR708) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR709", Value = GetValueOrEmpty(report.IITR709) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR710", Value = GetValueOrEmpty(report.IITR710) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR712", Value = GetValueOrEmpty(report.IITR712) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR713", Value = GetValueOrEmpty(report.IITR713) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR722", Value = GetValueOrEmpty(report.IITR722) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR723", Value = GetValueOrEmpty(report.IITR723) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR724", Value = GetValueOrEmpty(report.IITR724) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR725", Value = GetValueOrEmpty(report.IITR725) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR726", Value = GetValueOrEmpty(report.IITR726) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR727", Value = GetValueOrEmpty(report.IITR727) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR728", Value = GetValueOrEmpty(report.IITR728) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR729", Value = GetValueOrEmpty(report.IITR729) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR730", Value = GetValueOrEmpty(report.IITR730) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR732", Value = GetValueOrEmpty(report.IITR732) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR733", Value = GetValueOrEmpty(report.IITR733) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410003

            #region VR.ATO.IITR.410005

            /*  VR.ATO.IITR.410005
            In other business and professional items, total salary and wage expenses amount is present; however, the type code indicating the expense component where the salary and wage expenses have been reported is required.
    
            Legacy Rule Format:
            IF [iitr514] > 0 AND [iitr516] = NULLORBLANK
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR514 > 0 AND ^IITR516 = BLANK
    
            Data Elements:
    
            ^IITR514 = RP:Remuneration.WagesAndSalaries.Total.Amount
    
            ^IITR516 = RP:Remuneration.WagesAndSalariesAction.Code
            */
            assertion = (report.IITR514.GetValueOrDefault() > 0 && string.IsNullOrWhiteSpace(report.IITR516) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410005",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total salary and wage expenses action code required",
                    LongDescription = @"In other business and professional items, 'Total salary and wage expenses' amount is present; therefore 'Total salary and wage expenses action code' indicating the expense component is required",
                    Location = "/xbrli:xbrl/tns:Remuneration.WagesAndSalaries.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410005" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR514", Value = GetValueOrEmpty(report.IITR514) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR516", Value = GetValueOrEmpty(report.IITR516) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410005

            #region VR.ATO.IITR.410007

            /*  VR.ATO.IITR.410007
            In other business and professional items, the type code indicating the expense component where the salary and wage expenses for total salary and wage expenses is present, however, total salary and wage expenses amount is required.
    
            Legacy Rule Format:
            IF [iitr516] <> NULLORBLANK AND ([iitr514] = NULL OR [iitr514] = 0)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR516 <> BLANK AND (^IITR514 = NULL OR ^IITR514 = 0)
    
            Data Elements:
    
            ^IITR514 = RP:Remuneration.WagesAndSalaries.Total.Amount
    
            ^IITR516 = RP:Remuneration.WagesAndSalariesAction.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR516) != true && (report.IITR514 == null || report.IITR514 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"When Total salary and wage expenses action code is provided the Total salary and wage expenses amount is required",
                    LongDescription = @"In other business and professional items, when the 'Total salary and wage expenses action code' is present, the 'Total salary and wage expenses' is required",
                    Location = "/xbrli:xbrl/tns:Remuneration.WagesAndSalaries.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR516", Value = GetValueOrEmpty(report.IITR516) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR514", Value = GetValueOrEmpty(report.IITR514) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410007

            #region VR.ATO.IITR.410008

            /*  VR.ATO.IITR.410008
            State code [QLD,NSW,VIC,SA,WA,NT,ACT,TAS] or a leading space or combination of spaces with a State code is present in the suburb/town field.
    
            Legacy Rule Format:
            IF ([iitr430] = FOUND("QLD","NSW","VIC","SA","WA","NT","ACT","TAS"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (FoundSet(^IITR430, '"QLD","NSW","VIC","SA","WA","NT","ACT","TAS"'))
    
            Data Elements:
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
            */
            assertion = IsMatch(report.IITR430, @"(^(QLD|NSW|VIC|SA|WA|NT|ACT|TAS)$)|(^(.*)( QLD | NSW | VIC | SA | WA | NT | ACT | TAS )(.*)$)|(^(QLD |NSW |VIC |SA |WA |NT |ACT |TAS )(.*)$)|(^(.*)( QLD| NSW| VIC| SA| WA| NT| ACT| TAS)$)", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.000411",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City cannot contain state code",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410008" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410008

            #region VR.ATO.IITR.410009

            /*  VR.ATO.IITR.410009
            If the Business name of main business or street address of main business is present, then the total business income (primary production or non-primary production) is required at business income and expenses.
    
            Legacy Rule Format:
            IF ([iitr425] <> NULLORBLANK OR [iitr428] <> NULLORBLANK) AND ([iitr436] = NULL AND [iitr437] = NULL AND [iitr438] = NULL AND [iitr439] = NULL AND [iitr440] = NULL AND [iitr441] = NULL AND [iitr442] = NULL AND [iitr443] = NULL AND [iitr445] = NULL AND [iitr447] = NULL AND [iitr448] = NULL)
              RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR425 <> BLANK OR ^IITR428 <> BLANK) AND (^IITR436 = NULL AND ^IITR437 = NULL AND ^IITR438 = NULL AND ^IITR439 = NULL AND ^IITR440 = NULL AND ^IITR441 = NULL AND ^IITR442 = NULL AND ^IITR443 = NULL AND ^IITR445 = NULL AND ^IITR447 = NULL AND ^IITR448 = NULL)
    
            Data Elements:
    
            ^IITR425 = RP:OrganisationNameDetails.OrganisationalName.Text
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
    
            ^IITR436 = RP:Income.ABNNotQuotedPrimaryProductionPaymentGross.Amount
    
            ^IITR437 = RP:Income.ABNNotQuotedNonPrimaryProductionPaymentGross.Amount
    
            ^IITR438 = RP:Income.ForeignResidentWithholdingNonPrimaryProduction.Amount
    
            ^IITR439 = RP:Income.VoluntaryAgreementPrimaryProductionGross.Amount
    
            ^IITR440 = RP:Income.VoluntaryAgreementNonPrimaryProductionGross.Amount
    
            ^IITR441 = RP:Income.LabourHireArrangementPrimaryProductionPaymentGross.Amount
    
            ^IITR442 = RP:Income.LabourHireArrangementNonPrimaryProductionPaymentGross.Amount
    
            ^IITR443 = RP:Income.GovernmentIndustryPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR445 = RP:Income.GovernmentIndustryNonPrimaryProductionPaymentsAssessable.Amount
    
            ^IITR447 = RP:Income.BusinessPrimaryProductionOther.Amount
    
            ^IITR448 = RP:Income.BusinessNonPrimaryProductionOther.Amount
            */
            assertion = ((string.IsNullOrWhiteSpace(report.IITR425) != true || string.IsNullOrWhiteSpace(report.IITR428) != true) && (report.IITR436 == null && report.IITR437 == null && report.IITR438 == null && report.IITR439 == null && report.IITR440 == null && report.IITR441 == null && report.IITR442 == null && report.IITR443 == null && report.IITR445 == null && report.IITR447 == null && report.IITR448 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total business income amount required",
                    LongDescription = @"If the Business name of main business or street address of main business is present, then the total business income (primary production or non-primary production) is required at business income and expenses",
                    Location = "/xbrli:xbrl/tns:OrganisationNameDetails.OrganisationalName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR425", Value = GetValueOrEmpty(report.IITR425) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR436", Value = GetValueOrEmpty(report.IITR436) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR437", Value = GetValueOrEmpty(report.IITR437) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR438", Value = GetValueOrEmpty(report.IITR438) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR439", Value = GetValueOrEmpty(report.IITR439) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR440", Value = GetValueOrEmpty(report.IITR440) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR441", Value = GetValueOrEmpty(report.IITR441) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR442", Value = GetValueOrEmpty(report.IITR442) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR443", Value = GetValueOrEmpty(report.IITR443) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR445", Value = GetValueOrEmpty(report.IITR445) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR447", Value = GetValueOrEmpty(report.IITR447) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR448", Value = GetValueOrEmpty(report.IITR448) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410009

            #region VR.ATO.IITR.410026

            /*  VR.ATO.IITR.410026
            Spouse's gender codes are: '1' - Male; '2' - Female or '3' - Intersex or Indeterminate.
    
            Legacy Rule Format:
            IF [iitr218] <> NULL AND [iitr218] <> SET("1","2","3")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR218 <> NULL AND NotInSet(^IITR218, '"1","2","3"')
    
            Data Elements:
    
            ^IITR218 = RP.SPOUSE:PersonDemographicDetails.Sex.Code
            */
            assertion = (report.IITR218 != null && !(IsMatch(report.IITR218, @"^(1|2|3)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.430026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's gender code details provided is incorrect",
                    LongDescription = @"Valid Spouse's gender codes are '1' (male), '2' (female) or '3' - Intersex or Indeterminate",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Sex.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR218", Value = GetValueOrEmpty(report.IITR218) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410026

            #region VR.ATO.IITR.410064

            /*  VR.ATO.IITR.410064
            Valid range for Number of business activities is 1 - 99.
    
            Legacy Rule Format:
            IF ([iitr421] <> NULL) AND ([iitr421] < 1 OR [iitr421] > 99)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR421 <> NULL) AND (^IITR421 < 1 OR ^IITR421 > 99)
    
            Data Elements:
    
            ^IITR421 = RP:Income.PersonalServicesIncome.BusinessActivities.Count
            */
            assertion = (report.IITR421 != null && (report.IITR421.GetValueOrDefault() < 1 || report.IITR421.GetValueOrDefault() > 99));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410064",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Number of business activities provided is in correct",
                    LongDescription = @"Number of business activities must be between 1 - 99",
                    Location = "/xbrli:xbrl/tns:Income.PersonalServicesIncome.BusinessActivities.Count",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410064" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR421", Value = report.IITR421.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410064

            #region VR.ATO.IITR.410066

            /*  VR.ATO.IITR.410066
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr431] <> NULLORBLANK) AND ([iitr431] <> SET("NSW", "VIC", "ACT", "QLD", "TAS", "SA", "WA", "NT"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR431 <> BLANK) AND (NotInSet(^IITR431, '"NSW", "VIC", "ACT", "QLD", "TAS", "SA", "WA", "NT"'))
    
            Data Elements:
    
            ^IITR431 = RP.BUS:AddressDetails.StateOrTerritory.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR431) != true && !(IsMatch(report.IITR431, @"^(NSW|VIC|ACT|QLD|TAS|SA|WA|NT)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410066",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid state code",
                    LongDescription = @"The State code in the Business address of main business is not Valid (Valid States are ""QLD"",""NSW"",""VIC"",""SA"",""WA"",""NT"",""ACT"",""TAS"")",
                    Location = "/xbrli:xbrl/tns:AddressDetails.StateOrTerritory.Code[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410066" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR431", Value = GetValueOrEmpty(report.IITR431) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410066

            #region VR.ATO.IITR.410067

            /*  VR.ATO.IITR.410067
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr432] <> NULLORBLANK) AND ([iitr432] < 0200 OR [iitr432] > 9999)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR432 <> BLANK) AND (^IITR432 < 0200 OR ^IITR432 > 9999)
    
            Data Elements:
    
            ^IITR432 = RP.BUS:AddressDetails.Postcode.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR432) != true && (AsNumeric(report.IITR432) < 200 || AsNumeric(report.IITR432) > 9999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.428041",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"For an Australian address, postcode is invalid. Valid range is 0200 - 9999",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Postcode.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410067" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR432", Value = GetValueOrEmpty(report.IITR432) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410067

            #region VR.ATO.IITR.410075

            /*  VR.ATO.IITR.410075
            Valid range for Hours taken to prepare and complete the BPI section is 1 - 999.
    
            Legacy Rule Format:
            IF ([iitr530] <> NULL) AND ([iitr530] < 1 OR [iitr530] > 999)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR530 <> NULL) AND (^IITR530 < 1 OR ^IITR530 > 999)
    
            Data Elements:
    
            ^IITR530 = RP:Report.CompletionHours.Number
            */
            assertion = (report.IITR530 != null && (report.IITR530.GetValueOrDefault() < 1 || report.IITR530.GetValueOrDefault() > 999));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410075",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Hours taken to prepare and complete the BPI section provided is in correct",
                    LongDescription = @"Hours taken to prepare and complete the BPI section must be between 1 - 999",
                    Location = "/xbrli:xbrl/tns:Report.CompletionHours.Number",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410075" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR530", Value = report.IITR530.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410075

            #region VR.ATO.IITR.410081

            /*  VR.ATO.IITR.410081
            Spouse's taxable income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr225] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR225, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
            */
            assertion = NotMonetary(report.IITR225, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410081",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse's taxable income is not in a valid monetary format",
                    LongDescription = @"Spouse's taxable income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410081" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410081

            #region VR.ATO.IITR.410082

            /*  VR.ATO.IITR.410082
            Your spouse's section 98 trust income - not included in spouse's taxable income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr226] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR226, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR226 = RP.SPOUSE:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount
            */
            assertion = NotMonetary(report.IITR226, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410082",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's section 98 trust income - not included in spouse's taxable income is not in a valid monetary format",
                    LongDescription = @"Your spouse's section 98 trust income - not included in spouse's taxable income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410082" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR226", Value = GetValueOrEmpty(report.IITR226) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410082

            #region VR.ATO.IITR.410087

            /*  VR.ATO.IITR.410087
            Spouse reportable superannuation contributions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr231] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR231, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount
            */
            assertion = NotMonetary(report.IITR231, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410087",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Spouse reportable superannuation contributions is not in a valid monetary format",
                    LongDescription = @"Spouse reportable superannuation contributions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:SuperannuationContribution.EmployerReportable.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410087" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR231", Value = GetValueOrEmpty(report.IITR231) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410087

            #region VR.ATO.IITR.410088

            /*  VR.ATO.IITR.410088
            Other specified exempt payments that your spouse received has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr232] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR232, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount
            */
            assertion = NotMonetary(report.IITR232, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.430088",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other specified exempt payments that your spouse received is not in a valid monetary format",
                    LongDescription = @"Other specified exempt payments that your spouse received must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Pension.TaxFree.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410088" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR232", Value = GetValueOrEmpty(report.IITR232) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410088

            #region VR.ATO.IITR.410089

            /*  VR.ATO.IITR.410089
            Your spouse's target foreign income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr233] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR233, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR233 = RP.SPOUSE:InternationalDealings.ForeignIncomeTarget.Amount
            */
            assertion = NotMonetary(report.IITR233, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410089",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's target foreign income is not in a valid monetary format",
                    LongDescription = @"Your spouse's target foreign income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:InternationalDealings.ForeignIncomeTarget.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410089" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR233", Value = GetValueOrEmpty(report.IITR233) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410089

            #region VR.ATO.IITR.410090

            /*  VR.ATO.IITR.410090
            Your spouse's total net investment loss has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr234] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR234, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount
            */
            assertion = NotMonetary(report.IITR234, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410090",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's total net investment loss is not in a valid monetary format",
                    LongDescription = @"Your spouse's total net investment loss must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Tax.Losses.InvestmentNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410090" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR234", Value = GetValueOrEmpty(report.IITR234) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410090

            #region VR.ATO.IITR.410091

            /*  VR.ATO.IITR.410091
            Child support your spouse paid has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr235] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR235, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR235 = RP.SPOUSE:ChildSupport.Payment.Amount
            */
            assertion = NotMonetary(report.IITR235, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410091",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Child support your spouse paid is not in a valid monetary format",
                    LongDescription = @"Child support your spouse paid must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:ChildSupport.Payment.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410091" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR235", Value = GetValueOrEmpty(report.IITR235) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410091

            #region VR.ATO.IITR.410092

            /*  VR.ATO.IITR.410092
            Your spouse's taxed element of a SLS zero tax rate has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr236] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR236, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount
            */
            assertion = NotMonetary(report.IITR236, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410092",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's taxed element of a SLS zero tax rate is not in a valid monetary format",
                    LongDescription = @"Your spouse's taxed element of a SLS zero tax rate must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410092" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR236", Value = GetValueOrEmpty(report.IITR236) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410092

            #region VR.ATO.IITR.410093

            /*  VR.ATO.IITR.410093
            Your spouse's Adjustable Tax Income total amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr237] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR237, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount
            */
            assertion = NotMonetary(report.IITR237, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410093",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's Adjustable Tax Income total amount is not in a valid monetary format",
                    LongDescription = @"Your spouse's Adjustable Tax Income total amount may be signed, not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.TaxableAdjusted.Amount[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410093" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR237", Value = GetValueOrEmpty(report.IITR237) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410093

            #region VR.ATO.IITR.410094

            /*  VR.ATO.IITR.410094
            Description of main business or professional activity has a maximum length of 100
    
            Legacy Rule Format:
            IF LENGTH([iitr418]) > 100
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR418) > 100
    
            Data Elements:
    
            ^IITR418 = RP:OrganisationDetails.MainIncomeActivity.Description
            */
            assertion = (Length(report.IITR418) > 100);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.411094",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Description of main business or professional activity must not exceed 100 characters",
                    LongDescription = @"For Description of main business or professional activity, the maximum allowable characters for this form is 100",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410094" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR418", Value = GetValueOrEmpty(report.IITR418) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410094


            #region VR.ATO.IITR.410100

            /*  VR.ATO.IITR.410100
            Business address of main business - Street name and number address line 1 has a maximum length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr428]) > 38
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR428) > 38
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
            */
            assertion = (Length(report.IITR428) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business address of main business - Street name and number address line 1 must not exceed 38 characters",
                    LongDescription = @"For Business address of main business - Street name and number address line 1, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410100" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410100

            #region VR.ATO.IITR.410101

            /*  VR.ATO.IITR.410101
            Business address of main business - Street name and number address line 2 has a maximum length of 38
    
            Legacy Rule Format:
            IF LENGTH([iitr429]) > 38
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR429) > 38
    
            Data Elements:
    
            ^IITR429 = RP.BUS:AddressDetails.Line2.Text
            */
            assertion = (Length(report.IITR429) > 38);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business address of main business - Street name and number address line 2 must not exceed 38 characters",
                    LongDescription = @"For Business address of main business - Street name and number address line 2, the maximum allowable characters for this form is 38",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410101" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR429", Value = GetValueOrEmpty(report.IITR429) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410101

            #region VR.ATO.IITR.410102

            /*  VR.ATO.IITR.410102
            Business address of main business - Suburb/Town has a maximum length of 27
    
            Legacy Rule Format:
            IF LENGTH([iitr430]) > 27
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Length(^IITR430) > 27
    
            Data Elements:
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
            */
            assertion = (Length(report.IITR430) > 27);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business address of main business - Suburb/Town must not exceed 27 characters",
                    LongDescription = @"For Business address of main business - Suburb/Town, the maximum allowable characters for this form is 27",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410102" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410102

            #region VR.ATO.IITR.410118

            /*  VR.ATO.IITR.410118
            Trade debtors has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr510] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR510, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR510 = RP(Instant):Assets.TradeandReceivablesOther.Amount
            */
            assertion = NotMonetary(report.IITR510, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410118",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Trade debtors is not in a valid monetary format",
                    LongDescription = @"Trade debtors must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Assets.TradeandReceivablesOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410118" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR510", Value = GetValueOrEmpty(report.IITR510) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410118

            #region VR.ATO.IITR.410119

            /*  VR.ATO.IITR.410119
            Trade creditors has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr512] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR512, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR512 = RP(Instant):Liabilities.TradeAndOtherPayablesTotal.Amount
            */
            assertion = NotMonetary(report.IITR512, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410119",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Trade creditors is not in a valid monetary format",
                    LongDescription = @"Trade creditors must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Liabilities.TradeAndOtherPayablesTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410119" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR512", Value = GetValueOrEmpty(report.IITR512) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410119

            #region VR.ATO.IITR.410120

            /*  VR.ATO.IITR.410120
            Total salary and wage expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr514] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR514, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR514 = RP:Remuneration.WagesAndSalaries.Total.Amount
            */
            assertion = NotMonetary(report.IITR514, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410120",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total salary and wage expenses is not in a valid monetary format",
                    LongDescription = @"Total salary and wage expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Remuneration.WagesAndSalaries.Total.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410120" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR514", Value = GetValueOrEmpty(report.IITR514) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410120

            #region VR.ATO.IITR.410122

            /*  VR.ATO.IITR.410122
            Payments to associated persons has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr518] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR518, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR518 = RP:Remuneration.PaymentToRelatedPartiesGross.Amount
            */
            assertion = NotMonetary(report.IITR518, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410122",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Payments to associated persons is not in a valid monetary format",
                    LongDescription = @"Payments to associated persons must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Remuneration.PaymentToRelatedPartiesGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410122" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR518", Value = GetValueOrEmpty(report.IITR518) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410122

            #region VR.ATO.IITR.410123

            /*  VR.ATO.IITR.410123
            Intangible depreciating assets first deducted has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr520] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR520, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR520 = RP:Expense.DepreciatingAssets.IntangibleFirstDeducted.Amount
            */
            assertion = NotMonetary(report.IITR520, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410123",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Intangible depreciating assets first deducted is not in a valid monetary format",
                    LongDescription = @"Intangible depreciating assets first deducted must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DepreciatingAssets.IntangibleFirstDeducted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410123" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR520", Value = GetValueOrEmpty(report.IITR520) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410123

            #region VR.ATO.IITR.410124

            /*  VR.ATO.IITR.410124
            Other depreciating assets first deducted has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr522] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR522, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR522 = RP:Expense.DepreciatingAssets.OtherFirstDeducted.Amount
            */
            assertion = NotMonetary(report.IITR522, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410124",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other depreciating assets first deducted is not in a valid monetary format",
                    LongDescription = @"Other depreciating assets first deducted must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DepreciatingAssets.OtherFirstDeducted.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410124" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR522", Value = GetValueOrEmpty(report.IITR522) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410124

            #region VR.ATO.IITR.410125

            /*  VR.ATO.IITR.410125
            Termination value of intangible depreciating assets has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr524] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR524, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR524 = RP:Assets.DepreciatingAssets.IntangibleTerminationValue.Amount
            */
            assertion = NotMonetary(report.IITR524, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410125",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Termination value of intangible depreciating assets is not in a valid monetary format",
                    LongDescription = @"Termination value of intangible depreciating assets must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Assets.DepreciatingAssets.IntangibleTerminationValue.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410125" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR524", Value = GetValueOrEmpty(report.IITR524) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410125

            #region VR.ATO.IITR.410126

            /*  VR.ATO.IITR.410126
            Termination value of other depreciating assets has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr526] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR526, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR526 = RP:Assets.DepreciatingAssets.OtherTerminationValue.Amount
            */
            assertion = NotMonetary(report.IITR526, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410126",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Termination value of other depreciating assets is not in a valid monetary format",
                    LongDescription = @"Termination value of other depreciating assets must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Assets.DepreciatingAssets.OtherTerminationValue.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410126" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR526", Value = GetValueOrEmpty(report.IITR526) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410126

            #region VR.ATO.IITR.410152

            /*  VR.ATO.IITR.410152
            The Australian Business Number (ABN) has failed the ABN algorithm check.
    
            Legacy Rule Format:
            IF ([iitr426] <> NULLORBLANK) AND (ABNALGORITHM([iitr426]) = FALSE)
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR426 <> BLANK) AND (FailsABNAlgorithm(^IITR426))
    
            Data Elements:
    
            ^IITR426 = RP:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR426) != true && FailsABNAlgorithm(report.IITR426));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410152",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid ABN",
                    LongDescription = @"The Australian Business Number (ABN) has failed the ABN algorithm check.",
                    Location = "/xbrli:xbrl/tns:Identifiers.AustralianBusinessNumber.Identifier[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410152" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR426", Value = GetValueOrEmpty(report.IITR426) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410152

            #region VR.ATO.IITR.410153

            /*  VR.ATO.IITR.410153
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr428] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr428] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR428 <> BLANK) AND (NotCharacterInSet(^IITR428, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR428) != true && !(IsMatch(report.IITR428, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410153",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business address of main business - Street name and number address line 1 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410153" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410153

            #region VR.ATO.IITR.410154

            /*  VR.ATO.IITR.410154
            Unknown cannot be entered as an Address. Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr428] CONTAINS "UNKNOWN")
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR428, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
            */
            assertion = (report.IITR428 == null ? false : report.IITR428.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410154",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"UNKNOWN is not a valid Address",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410154" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410154

            #region VR.ATO.IITR.410155

            /*  VR.ATO.IITR.410155
            Unknown cannot be entered as an Address. Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr429] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR429, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR429 = RP.BUS:AddressDetails.Line2.Text
            */
            assertion = (report.IITR429 == null ? false : report.IITR429.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410155",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"UNKNOWN is not a valid Address",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410155" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR429", Value = GetValueOrEmpty(report.IITR429) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410155

            #region VR.ATO.IITR.410156

            /*  VR.ATO.IITR.410156
            Unknown cannot be entered as an Address. Tax Agents who do not know client's current postal address will need to contact Registry Division by fax or e-mail to make changes to their client's record.
    
            Legacy Rule Format:
            IF ([iitr430] CONTAINS "UNKNOWN")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Contains(^IITR430, 'UNKNOWN')
    
            Data Elements:
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
            */
            assertion = (report.IITR430 == null ? false : report.IITR430.ToUpperInvariant().Contains(@"UNKNOWN"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410156",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"UNKNOWN is not a valid Address",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410156" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410156

            #region VR.ATO.IITR.410157

            /*  VR.ATO.IITR.410157
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr425] <> NULLORBLANK) AND ([iitr425] CONTAINS SET("{","}","|","_","\","#"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ContainsSet(^IITR425, '"{","}","|","_","\","#"')
    
            Data Elements:
    
            ^IITR425 = RP:OrganisationNameDetails.OrganisationalName.Text
            */
            assertion = IsMatch(report.IITR425, @"\{|\}|\||_|\\|#", RegexOptions.IgnoreCase);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410157",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-Individual Name contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:OrganisationNameDetails.OrganisationalName.Text",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410157" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR425", Value = GetValueOrEmpty(report.IITR425) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410157

            #region VR.ATO.IITR.410158

            /*  VR.ATO.IITR.410158
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr429] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr429] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR429 <> BLANK) AND (NotCharacterInSet(^IITR429, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR429 = RP.BUS:AddressDetails.Line2.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR429) != true && !(IsMatch(report.IITR429, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410158",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Business address of main business - Street name and number address line 2 contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line2.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410158" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR429", Value = GetValueOrEmpty(report.IITR429) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410158

            #region VR.ATO.IITR.410159

            /*  VR.ATO.IITR.410159
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr430] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr430] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR430 <> BLANK) AND (NotCharacterInSet(^IITR430, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR430) != true && !(IsMatch(report.IITR430, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410159",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Suburb/Town/City contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:AddressDetails.LocalityName.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410159" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410159

            #region VR.ATO.IITR.410189

            /*  VR.ATO.IITR.410189
            In the Spouse Details, if date the taxpayer had a spouse from or to are present, then both dates must be present.
    
            Legacy Rule Format:
            IF ([iitr221] <> NULL OR [iitr222] <> NULL) AND ([iitr221] = NULL OR [iitr222] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR221 <> NULL OR ^IITR222 <> NULL) AND (^IITR221 = NULL OR ^IITR222 = NULL)
    
            Data Elements:
    
            ^IITR221 = RP:PersonDemographicDetails.SpouseRelationshipStart.Date
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
            */
            assertion = ((report.IITR221 != null || report.IITR222 != null) && (report.IITR221 == null || report.IITR222 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410189",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dates incomplete for a taxpayer who had a spouse for less than a full year",
                    LongDescription = @"In the Spouse Details, if the date taxpayer had a spouse 'from' or 'to' are present, then both dates must be present",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.SpouseRelationshipStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410189" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR221", Value = GetValueOrEmpty(report.IITR221) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410189

            #region VR.ATO.IITR.410192

            /*  VR.ATO.IITR.410192
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([iitr418] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr418] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR418 <> BLANK) AND (NotCharacterInSet(^IITR418, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
    
            Data Elements:
    
            ^IITR418 = RP:OrganisationDetails.MainIncomeActivity.Description
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR418) != true && !(IsMatch(report.IITR418, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410192",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Additional Information contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character.",
                    Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410192" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR418", Value = GetValueOrEmpty(report.IITR418) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410192

            #region VR.ATO.IITR.410193

            /*  VR.ATO.IITR.410193
            Where a Private health insurance policy entry has a 'Tax claim code' of "Claiming your spouses share of rebate", then a value of "Yes" is required at either 'Did you have a spouse for the full year?' or 'Did your spouse die during the year?'. If you did not have a spouse for the full year, a period ending the last day of the Year of return must be shown.
    
            Legacy Rule Format:
            IF (ANY OCCURRENCE OF ([iitr185]) = "Claiming your spouses share of rebate") AND ([iitr220] <> TRUE) AND ([iitr222] <> RP:period.endDate) AND ([iitr223] <> TRUE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (AnyOccurrence(^IITR185, ^IITR185 = 'Claiming your spouses share of rebate')) AND (^IITR220 <> TRUE) AND (^IITR222 <> ^EndDate) AND (^IITR223 <> TRUE)
    
            Data Elements:
    
            ^IITR222 = RP:PersonDemographicDetails.SpouseRelationshipEnd.Date
    
            ^EndDate = RP
    
            ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
    
            ^IITR220 = RP:PersonDemographicDetails.SpouseFullYear.Indicator
    
            ^IITR223 = RP.SPOUSE:PersonDemographicDetails.Deceased.Indicator
            */
            assertion = ((report.RPPHISeqNumContextCollection == null ? false : report.RPPHISeqNumContextCollection.Any(IITR185Repeat => IITR185Repeat.IITR185 == @"Claiming your spouses share of rebate")) && report.IITR220 != true && report.IITR222.GetValueOrDefault() != report.RPEndDate && report.IITR223 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410193",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Period you had spouse information is incorrect",
                    LongDescription = @"Where a Private health insurance policy entry has a 'Tax claim code' of ""Claiming your spouses share of rebate"", then a value of TRUE ('yes') is required at either 'Had a spouse for the full year' or 'Spouse died during the year'. If you did not have a spouse for the full year, a period ending the last day of the Year of return must be shown.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.SpouseRelationshipEnd.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410193" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR185", Value = "IITR185" });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR220", Value = GetValueOrEmpty(report.IITR220) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR222", Value = GetValueOrEmpty(report.IITR222) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR223", Value = GetValueOrEmpty(report.IITR223) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410193

            #region VR.ATO.IITR.410206

            /*  VR.ATO.IITR.410206
            Your spouse's total reportable fringe benefits amounts from employers exempt under section 57A has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr492] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR492, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount
            */
            assertion = NotMonetary(report.IITR492, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410206",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's total reportable fringe benefits amounts from employers exempt under section 57A is not in a valid monetary format",
                    LongDescription = @"Your spouse's total reportable fringe benefits amounts from employers exempt under section 57A must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPSPOUSEEligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410206" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR492", Value = GetValueOrEmpty(report.IITR492) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410206

            #region VR.ATO.IITR.410207

            /*  VR.ATO.IITR.410207
            Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr493] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR493, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount
            */
            assertion = NotMonetary(report.IITR493, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.410207",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A is not in a valid monetary format",
                    LongDescription = @"Your spouse's total reportable fringe benefits amounts from employers not exempt under section 57A must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPSPOUSEIneligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410207" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR493", Value = GetValueOrEmpty(report.IITR493) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.410207

            #region VR.ATO.IITR.600000

            /*  VR.ATO.IITR.600000
            Where Credit for interest on early payments is greater than $100.00, ensure that the amount is an early payment as defined by the ATO.
    
            Legacy Rule Format:
            IF [iitr401] > 100
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR401 > 100
    
            Data Elements:
    
            ^IITR401 = RP:Income.Interest.EarlyPaymentCredit.Amount
            */
            assertion = (report.IITR401.GetValueOrDefault() > 100);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600000",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check amount of credit for interest on tax paid for an early payment",
                    LongDescription = @"Early Payment Interest Credit is greater than $100.00, please ensure that the amount is an early payment as defined by the ATO.",
                    Location = "/xbrli:xbrl/tns:Income.Interest.EarlyPaymentCredit.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600000" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR401", Value = GetValueOrEmpty(report.IITR401) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600000

            #region VR.ATO.IITR.600001

            /*  VR.ATO.IITR.600001
            Where the amount claimed for work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses is greater than $2,000, check that claim is wholly deductible.
    
            Legacy Rule Format:
            IF [iitr137] > 2000
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR137 > 2000
    
            Data Elements:
    
            ^IITR137 = RP:IncomeTax.Deduction.Clothing.Amount
            */
            assertion = (report.IITR137.GetValueOrDefault() > 2000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600001",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check claim for work related clothing and/or laundry expenses",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Clothing.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR137", Value = GetValueOrEmpty(report.IITR137) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600001

            #region VR.ATO.IITR.600012

            /*  VR.ATO.IITR.600012
            Primary production losses claimed this income year amount cannot be greater than primary production losses carried forward from earlier income years amount.
    
            Legacy Rule Format:
            IF ([iitr154] > 0) AND ([iitr153] = NULL OR [iitr154] > [iitr153])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR154 > 0) AND (^IITR153 = NULL OR ^IITR154 > ^IITR153)
    
            Data Elements:
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
    
            ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount
            */
            assertion = (report.IITR154.GetValueOrDefault() > 0 && (report.IITR153 == null || report.IITR154.GetValueOrDefault() > report.IITR153.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP loss claimed this income year must be less than or equal to PP loss carried forward.",
                    LongDescription = @"Primary production loss claimed this income year cannot be greater than primary production loss carried forward from previous years. Loss from previous years can only reduce taxable income to zero.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR153", Value = GetValueOrEmpty(report.IITR153) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600012

            #region VR.ATO.IITR.600013

            /*  VR.ATO.IITR.600013
            Non-primary production losses claimed this income year amount cannot be greater than non-primary production losses carried forward from earlier income years amount.
    
            Legacy Rule Format:
            IF ([iitr156] > 0) AND ([iitr155] = NULL OR [iitr156] > [iitr155])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR156 > 0) AND (^IITR155 = NULL OR ^IITR156 > ^IITR155)
    
            Data Elements:
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
    
            ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount
            */
            assertion = (report.IITR156.GetValueOrDefault() > 0 && (report.IITR155 == null || report.IITR156.GetValueOrDefault() > report.IITR155.GetValueOrDefault()));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600013",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"NPP loss claimed this income year must be less than or equal to NPP loss carried forward.",
                    LongDescription = @"Non-primary production loss claimed this income year cannot be greater than non-primary production loss carried forward from previous years. Loss from previous years can only reduce taxable income to zero.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600013" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR155", Value = GetValueOrEmpty(report.IITR155) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600013

            #region VR.ATO.IITR.600015

            /*  VR.ATO.IITR.600015
            The Superannuation Co-Contributions indicator must be set to TRUE only when the associated Government super contribution amounts are zero or greater. This is so the co-contributions amount is calculated using the correct figure. The amounts or the indicator need to be corrected.
    
            Legacy Rule Format:
            IF ([iitr195] = TRUE) AND ([iitr194] = NULL AND [iitr196] = NULL AND [iitr197] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR195 = TRUE) AND (^IITR194 = NULL AND ^IITR196 = NULL AND ^IITR197 = NULL)
    
            Data Elements:
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
    
            ^IITR195 = RP:IncomeTax.EligiblePersonalSuperannuationContribution.Indicator
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
            */
            assertion = (report.IITR195 == true && (report.IITR194 == null && report.IITR196 == null && report.IITR197 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600015",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Government super contributions income and deduction amounts are incomplete",
                    LongDescription = @"When the 'Income from investment, partnership and other sources indicator' is set to 'yes' (true), at least one of the Government super contribution amounts 'Income from investment, partnership and other sources amount', 'Other income from employment and business' or 'Other deductions from business income' must be provided and set to zero or greater",
                    Location = "/xbrli:xbrl/tns:IncomeTax.InvestmentPartnershipOtherSource.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR195", Value = GetValueOrEmpty(report.IITR195) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600015

            #region VR.ATO.IITR.600016

            /*  VR.ATO.IITR.600016
            Where the Income from investment, partnership and other sources for the Superannuation Co-Contributions is zero, the indicator must be set to TRUE. This is so the co-contributions amount is calculated using the correct figure. The amount or the indicator needs to be corrected.
    
            Legacy Rule Format:
            IF ([iitr194] = 0) AND ([iitr195] <> TRUE)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR194 = 0) AND (^IITR195 <> TRUE)
    
            Data Elements:
    
            ^IITR195 = RP:IncomeTax.EligiblePersonalSuperannuationContribution.Indicator
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
            */
            assertion = (report.IITR194 == 0 && report.IITR195 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Income from investment, partnership and other sources indicator is required",
                    LongDescription = @"When the 'Income from investment, partnership and other sources' amount is zero, the 'Income from investment, partnership and other sources indicator' must be set to 'yes' (true)",
                    Location = "/xbrli:xbrl/tns:IncomeTax.EligiblePersonalSuperannuationContribution.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR195", Value = GetValueOrEmpty(report.IITR195) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600016

            #region VR.ATO.IITR.600025

            /*  VR.ATO.IITR.600025
            Individual total deductions amount is mandatory
    
            Legacy Rule Format:
            IF [iitr150] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR150 = NULL
    
            Data Elements:
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
            */
            assertion = (report.IITR150 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600025",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual total deductions amount must be present",
                    Location = "/xbrli:xbrl/tns:Expense.DeductionsTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600025" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600025

            #region VR.ATO.IITR.600026

            /*  VR.ATO.IITR.600026
            Taxable income or loss is mandatory
    
            Legacy Rule Format:
            IF [iitr157] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR157 = NULL
    
            Data Elements:
    
            ^IITR157 = RP:Income.Taxable.Amount
            */
            assertion = (report.IITR157 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600026",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable income or loss amount must be present",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600026" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600026

            #region VR.ATO.IITR.600032

            /*  VR.ATO.IITR.600032
            Under 18 excepted net income is greater than or equal to zero and under 18 action code is missing.
    
            Legacy Rule Format:
            IF ([iitr188] <> NULL) AND ([iitr189] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR188 <> NULL) AND (^IITR189 = BLANK)
    
            Data Elements:
    
            ^IITR189 = RP:IncomeTax.ExceptedIncomeUnder18.Code
    
            ^IITR188 = RP:IncomeTax.ExceptedNetIncomeUnder18.Amount
            */
            assertion = (report.IITR188 != null && string.IsNullOrWhiteSpace(report.IITR189) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600032",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Under 18 action code is required",
                    LongDescription = @"When an amount of zero or above is present for 'Under 18' excepted net income, the 'Under 18 action code' must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ExceptedIncomeUnder18.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600032" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR188", Value = GetValueOrEmpty(report.IITR188) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR189", Value = GetValueOrEmpty(report.IITR189) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600032

            #region VR.ATO.IITR.600033

            /*  VR.ATO.IITR.600033
            Under 18 excepted net income action code is present and the amount of under 18 excepted net income is missing.
    
            Legacy Rule Format:
            IF ([iitr189] <> NULLORBLANK) AND ([iitr188] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR189 <> BLANK) AND (^IITR188 = NULL)
    
            Data Elements:
    
            ^IITR188 = RP:IncomeTax.ExceptedNetIncomeUnder18.Amount
    
            ^IITR189 = RP:IncomeTax.ExceptedIncomeUnder18.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR189) != true && report.IITR188 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600033",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Under 18 excepted Income details must be provided where under 18.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ExceptedNetIncomeUnder18.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600033" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR189", Value = GetValueOrEmpty(report.IITR189) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR188", Value = GetValueOrEmpty(report.IITR188) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600033

            #region VR.ATO.IITR.600049

            /*  VR.ATO.IITR.600049
            Work related car expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr134] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR134, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR134 = RP:IncomeTax.Deduction.Car.Amount
            */
            assertion = NotMonetary(report.IITR134, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600049",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Work related car expenses is not in a valid monetary format",
                    LongDescription = @"Work related car expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Car.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600049" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR134", Value = GetValueOrEmpty(report.IITR134) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600049

            #region VR.ATO.IITR.600050

            /*  VR.ATO.IITR.600050
            Work related travel expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr136] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR136, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR136 = RP:IncomeTax.Deduction.Travel.Amount
            */
            assertion = NotMonetary(report.IITR136, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600050",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Work related travel expenses is not in a valid monetary format",
                    LongDescription = @"Work related travel expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Travel.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600050" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR136", Value = GetValueOrEmpty(report.IITR136) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600050

            #region VR.ATO.IITR.600052

            /*  VR.ATO.IITR.600052
            Work related self-education expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr139] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR139, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR139 = RP:IncomeTax.Deduction.EducationNet.Amount
            */
            assertion = NotMonetary(report.IITR139, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600052",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Work related self-education expenses is not in a valid monetary format",
                    LongDescription = @"Work related self-education expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600052" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR139", Value = GetValueOrEmpty(report.IITR139) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600052

            #region VR.ATO.IITR.600053

            /*  VR.ATO.IITR.600053
            Other work related expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr141] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR141, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR141 = RP:IncomeTax.Deduction.WorkRelatedOther.Amount
            */
            assertion = NotMonetary(report.IITR141, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600053",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other work related expenses is not in a valid monetary format",
                    LongDescription = @"Other work related expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600053" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR141", Value = GetValueOrEmpty(report.IITR141) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600053

            #region VR.ATO.IITR.600057

            /*  VR.ATO.IITR.600057
            Low value pool deduction has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr145] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR145, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR145 = RP:IncomeTax.Deduction.LowValuePool.Amount
            */
            assertion = NotMonetary(report.IITR145, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600057",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Low value pool deduction is not in a valid monetary format",
                    LongDescription = @"Low value pool deduction must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.LowValuePool.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600057" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR145", Value = GetValueOrEmpty(report.IITR145) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600057

            #region VR.ATO.IITR.600058

            /*  VR.ATO.IITR.600058
            Interest deductions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr146] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR146, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR146 = RP:IncomeTax.Deduction.Interest.Amount
            */
            assertion = NotMonetary(report.IITR146, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600058",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Interest deductions is not in a valid monetary format",
                    LongDescription = @"Interest deductions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Interest.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600058" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR146", Value = GetValueOrEmpty(report.IITR146) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600058

            #region VR.ATO.IITR.600059

            /*  VR.ATO.IITR.600059
            Dividend deductions has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr147] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR147, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR147 = RP:IncomeTax.Deduction.Dividend.Amount
            */
            assertion = NotMonetary(report.IITR147, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600059",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Dividend deductions is not in a valid monetary format",
                    LongDescription = @"Dividend deductions must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Dividend.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600059" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR147", Value = GetValueOrEmpty(report.IITR147) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600059

            #region VR.ATO.IITR.600060

            /*  VR.ATO.IITR.600060
            Gifts or donations has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr148] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR148, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR148 = RP:IncomeTax.Deduction.GiftDonation.Amount
            */
            assertion = NotMonetary(report.IITR148, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600060",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Gifts or donations is not in a valid monetary format",
                    LongDescription = @"Gifts or donations must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.GiftDonation.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600060" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR148", Value = GetValueOrEmpty(report.IITR148) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600060

            #region VR.ATO.IITR.600062

            /*  VR.ATO.IITR.600062
            Individual total deductions amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr150] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR150, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
            */
            assertion = NotMonetary(report.IITR150, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600062",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual total deductions amount is not in a valid monetary format",
                    LongDescription = @"Individual total deductions amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.DeductionsTotal.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600062" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600062

            #region VR.ATO.IITR.600063

            /*  VR.ATO.IITR.600063
            Primary production losses carried forward from earlier income years has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr153] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR153, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR153 = RP:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR153, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600063",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary production losses carried forward from earlier income years is not in a valid monetary format",
                    LongDescription = @"Primary production losses carried forward from earlier income years must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesBroughtForwardPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600063" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR153", Value = GetValueOrEmpty(report.IITR153) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600063

            #region VR.ATO.IITR.600064

            /*  VR.ATO.IITR.600064
            Primary production losses claimed this income year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr154] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR154, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR154, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600064",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Primary production losses claimed this income year is not in a valid monetary format",
                    LongDescription = @"Primary production losses claimed this income year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600064" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600064

            #region VR.ATO.IITR.600065

            /*  VR.ATO.IITR.600065
            Non-primary production losses carried forward from earlier income years has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr155] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR155, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR155 = RP:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR155, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600065",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-primary production losses carried forward from earlier income years is not in a valid monetary format",
                    LongDescription = @"Non-primary production losses carried forward from earlier income years must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesBroughtForwardNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600065" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR155", Value = GetValueOrEmpty(report.IITR155) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600065

            #region VR.ATO.IITR.600066

            /*  VR.ATO.IITR.600066
            Non-primary production losses claimed this income year has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr156] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR156, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR156, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600066",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-primary production losses claimed this income year is not in a valid monetary format",
                    LongDescription = @"Non-primary production losses claimed this income year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.LossesClaimedNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600066" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600066

            #region VR.ATO.IITR.600067

            /*  VR.ATO.IITR.600067
            Under 18 excepted net income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr188] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR188, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR188 = RP:IncomeTax.ExceptedNetIncomeUnder18.Amount
            */
            assertion = NotMonetary(report.IITR188, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.601067",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Under 18 excepted net income is not in a valid monetary format",
                    LongDescription = @"Under 18 excepted net income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.ExceptedNetIncomeUnder18.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600067" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR188", Value = GetValueOrEmpty(report.IITR188) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600067

            #region VR.ATO.IITR.600068

            /*  VR.ATO.IITR.600068
            Income from investment, partnership and other sources amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr194] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR194, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR194 = RP:IncomeTax.InvestmentPartnershipOtherSource.Amount
            */
            assertion = NotMonetary(report.IITR194, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600068",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Income from investment, partnership and other sources amount is not in a valid monetary format",
                    LongDescription = @"Income from investment, partnership and other sources amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.InvestmentPartnershipOtherSource.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600068" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR194", Value = GetValueOrEmpty(report.IITR194) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600068

            #region VR.ATO.IITR.600069

            /*  VR.ATO.IITR.600069
            Other deductions from business income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr197] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR197, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR197 = RP:IncomeTax.Deduction.BusinessOther.Amount
            */
            assertion = NotMonetary(report.IITR197, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600069",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other deductions from business income is not in a valid monetary format",
                    LongDescription = @"Other deductions from business income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.BusinessOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600069" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR197", Value = GetValueOrEmpty(report.IITR197) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600069

            #region VR.ATO.IITR.600070

            /*  VR.ATO.IITR.600070
            Taxable income or loss has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr157] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR157, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR157 = RP:Income.Taxable.Amount
            */
            assertion = NotMonetary(report.IITR157, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600070",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Taxable income or loss is not in a valid monetary format",
                    LongDescription = @"Taxable income or loss may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600070" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600070

            #region VR.ATO.IITR.600071

            /*  VR.ATO.IITR.600071
            Other income from employment and business has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr196] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR196, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR196 = RP:IncomeTax.EmploymentBusinessOther.Amount
            */
            assertion = NotMonetary(report.IITR196, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600071",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other income from employment and business is not in a valid monetary format",
                    LongDescription = @"Other income from employment and business may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:IncomeTax.EmploymentBusinessOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600071" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR196", Value = GetValueOrEmpty(report.IITR196) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600071

            #region VR.ATO.IITR.600089

            /*  VR.ATO.IITR.600089
            Where a Business Address instance has been provided, at least one of the Business Address details must be provided.
    
            Legacy Rule Format:
            IF COUNT(RP.BUS) <> 0 AND ([iitr428] = NULLORBLANK) AND ([iitr429] = NULLORBLANK) AND ([iitr430] = NULLORBLANK) AND ([iitr431] = NULLORBLANK) AND ([iitr432] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 0 AND (^IITR428 = BLANK) AND (^IITR429 = BLANK) AND (^IITR430 = BLANK) AND (^IITR431 = BLANK) AND (^IITR432 = BLANK)
    
            Data Elements:
    
            ^IITR428 = RP.BUS:AddressDetails.Line1.Text
    
            ^IITR429 = RP.BUS:AddressDetails.Line2.Text
    
            ^IITR430 = RP.BUS:AddressDetails.LocalityName.Text
    
            ^IITR431 = RP.BUS:AddressDetails.StateOrTerritory.Code
    
            ^IITR432 = RP.BUS:AddressDetails.Postcode.Text
    
            ^Context = RP:RP.BUS
            */
            assertion = (Count(report.RPBUSCount) != 0 && string.IsNullOrWhiteSpace(report.IITR428) == true && string.IsNullOrWhiteSpace(report.IITR429) == true && string.IsNullOrWhiteSpace(report.IITR430) == true && string.IsNullOrWhiteSpace(report.IITR431) == true && string.IsNullOrWhiteSpace(report.IITR432) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600089",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one of the Business Address details must be provided",
                    LongDescription = @"Where a Business Address instance has been provided, at least one of the Business Address details must be provided",
                    Location = "/xbrli:xbrl/tns:AddressDetails.Line1.Text[@contextRef='" + report.RPBUSId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600089" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR428", Value = GetValueOrEmpty(report.IITR428) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR429", Value = GetValueOrEmpty(report.IITR429) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR430", Value = GetValueOrEmpty(report.IITR430) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR431", Value = GetValueOrEmpty(report.IITR431) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR432", Value = GetValueOrEmpty(report.IITR432) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600089

            #region VR.ATO.IITR.600090

            /*  VR.ATO.IITR.600090
            Where a Spouse instance has been provided, at least one of the Spouse details must be provided.
    
            Legacy Rule Format:
            IF COUNT(RP.SPOUSE) <> 0 AND [iitr213] = NULLORBLANK AND [iitr214] = NULLORBLANK AND [iitr215] = NULLORBLANK AND [iitr217] = NULL AND [iitr218] = NULL AND [iitr223] = NULL AND [iitr225] = NULL AND [iitr226] = NULL AND [iitr227] = NULL AND [iitr492] = NULL AND [iitr493] = NULL AND [iitr229] = NULL AND [iitr230] = NULL AND [iitr231] = NULL AND [iitr232] = NULL AND [iitr233] = NULL AND [iitr234] = NULL AND [iitr235] = NULL AND [iitr236] = NULL AND [iitr237] = NULL AND [iitr533] = NULLORBLANK
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 0 AND ^IITR213 = BLANK AND ^IITR214 = BLANK AND ^IITR215 = BLANK AND ^IITR217 = NULL AND ^IITR218 = NULL AND ^IITR223 = NULL AND ^IITR225 = NULL AND ^IITR226 = NULL AND ^IITR227 = NULL AND ^IITR492 = NULL AND ^IITR493 = NULL AND ^IITR229 = NULL AND ^IITR230 = NULL AND ^IITR231 = NULL AND ^IITR232 = NULL AND ^IITR233 = NULL AND ^IITR234 = NULL AND ^IITR235 = NULL AND ^IITR236 = NULL AND ^IITR237 = NULL AND ^IITR533 = BLANK
    
            Data Elements:
    
            ^IITR213 = RP.SPOUSE:PersonNameDetails.FamilyName.Text
    
            ^IITR214 = RP.SPOUSE:PersonNameDetails.GivenName.Text
    
            ^IITR215 = RP.SPOUSE:PersonNameDetails.OtherGivenName.Text
    
            ^IITR217 = RP.SPOUSE:PersonDemographicDetails.Birth.Date
    
            ^IITR218 = RP.SPOUSE:PersonDemographicDetails.Sex.Code
    
            ^IITR223 = RP.SPOUSE:PersonDemographicDetails.Deceased.Indicator
    
            ^IITR225 = RP.SPOUSE:Income.Taxable.Amount
    
            ^IITR226 = RP.SPOUSE:IncomeTax.TrustIncomeNotIncludedInTaxableIncome.Amount
    
            ^IITR227 = RP.SPOUSE:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
    
            ^IITR492 = RP.SPOUSE.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR493 = RP.SPOUSE.Ineligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR229 = RP.SPOUSE:Pension.Total.Amount
    
            ^IITR230 = RP.SPOUSE:Pension.SpouseExempt.Amount
    
            ^IITR231 = RP.SPOUSE:SuperannuationContribution.EmployerReportable.Amount
    
            ^IITR232 = RP.SPOUSE:Pension.TaxFree.Amount
    
            ^IITR233 = RP.SPOUSE:InternationalDealings.ForeignIncomeTarget.Amount
    
            ^IITR234 = RP.SPOUSE:Tax.Losses.InvestmentNet.Amount
    
            ^IITR235 = RP.SPOUSE:ChildSupport.Payment.Amount
    
            ^IITR236 = RP.SPOUSE:SuperannuationPayment.BenefitLumpSumZeroTaxRate.Amount
    
            ^IITR237 = RP.SPOUSE:Income.TaxableAdjusted.Amount
    
            ^IITR533 = RP.SPOUSE:Identifiers.FamilyAssistanceOfficeCustomerReferenceNumber.Identifier
    
            ^Context = RP:RP.SPOUSE
            */
            assertion = (Count(report.RPSPOUSECount) != 0 && string.IsNullOrWhiteSpace(report.IITR213) == true && string.IsNullOrWhiteSpace(report.IITR214) == true && string.IsNullOrWhiteSpace(report.IITR215) == true && report.IITR217 == null && report.IITR218 == null && report.IITR223 == null && report.IITR225 == null && report.IITR226 == null && report.IITR227 == null && report.IITR492 == null && report.IITR493 == null && report.IITR229 == null && report.IITR230 == null && report.IITR231 == null && report.IITR232 == null && report.IITR233 == null && report.IITR234 == null && report.IITR235 == null && report.IITR236 == null && report.IITR237 == null && string.IsNullOrWhiteSpace(report.IITR533) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600090",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one of the Spouse details must be provided",
                    LongDescription = @"Where a Spouse instance has been provided, at least one of the Spouse details must be provided",
                    Location = "/xbrli:xbrl/tns:PersonNameDetails.FamilyName.Text[@contextRef='" + report.RPSPOUSEId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600090" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR213", Value = GetValueOrEmpty(report.IITR213) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR214", Value = GetValueOrEmpty(report.IITR214) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR215", Value = GetValueOrEmpty(report.IITR215) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR217", Value = GetValueOrEmpty(report.IITR217) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR218", Value = GetValueOrEmpty(report.IITR218) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR223", Value = GetValueOrEmpty(report.IITR223) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR225", Value = GetValueOrEmpty(report.IITR225) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR226", Value = GetValueOrEmpty(report.IITR226) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR227", Value = GetValueOrEmpty(report.IITR227) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR492", Value = GetValueOrEmpty(report.IITR492) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR493", Value = GetValueOrEmpty(report.IITR493) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR229", Value = GetValueOrEmpty(report.IITR229) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR230", Value = GetValueOrEmpty(report.IITR230) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR231", Value = GetValueOrEmpty(report.IITR231) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR232", Value = GetValueOrEmpty(report.IITR232) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR233", Value = GetValueOrEmpty(report.IITR233) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR234", Value = GetValueOrEmpty(report.IITR234) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR235", Value = GetValueOrEmpty(report.IITR235) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR236", Value = GetValueOrEmpty(report.IITR236) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR237", Value = GetValueOrEmpty(report.IITR237) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR533", Value = GetValueOrEmpty(report.IITR533) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600090

            #region VR.ATO.IITR.600091

            /*  VR.ATO.IITR.600091
            Working holiday maker net income has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr499] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR499, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
            */
            assertion = NotMonetary(report.IITR499, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600091",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker net income is not in a valid monetary format",
                    LongDescription = @"Working holiday maker net income must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600091" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600091

            #region VR.ATO.IITR.600093

            /*  VR.ATO.IITR.600093
            When an amount above zero is provided for Working holiday maker net income, the 'Under 18' excepted net income must not be provided
    
            Legacy Rule Format:
            IF [iitr499] > 0 AND [iitr188] <> NULL
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR499 > 0 AND ^IITR188 <> NULL
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
    
            ^IITR188 = RP:IncomeTax.ExceptedNetIncomeUnder18.Amount
            */
            assertion = (report.IITR499.GetValueOrDefault() > 0 && report.IITR188 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600093",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Under 18 excepted net income must not be provided",
                    LongDescription = @"When an amount above zero is provided for Working holiday maker net income, the 'Under 18' excepted net income must not be provided",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600093" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR188", Value = GetValueOrEmpty(report.IITR188) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600093

            #region VR.ATO.IITR.600094

            /*  VR.ATO.IITR.600094
            The amount entered at Working holiday maker net income must be equal to or less than Taxable income or loss.
    
            Legacy Rule Format:
            IF ([iitr499] > 0) AND ([iitr499] > [iitr157])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR499 > 0) AND (^IITR499 > ^IITR157)
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
    
            ^IITR157 = RP:Income.Taxable.Amount
            */
            assertion = (report.IITR499.GetValueOrDefault() > 0 && report.IITR499.GetValueOrDefault() > report.IITR157.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600094",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker net income amount must not exceed the Taxable income or loss amount",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600094" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600094

            #region VR.ATO.IITR.600098

            /*  VR.ATO.IITR.600098
            Working holiday maker net income must only be provided when the taxpayer is aged between 18 and 35, and earned income under an eligible working holiday visa (417 or 462)
    
            Legacy Rule Format:
            IF [iitr499] > 0 AND (([iitr29] > ConvertToDate(30, 6, [iitr10] – 18)) OR ([iitr29] < ConvertToDate(2, 7, [iitr10] – 37)))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR499 > 0 AND ((^IITR29 > ConvertToDate(30, 6, ^IITR10 - 18)) OR (^IITR29 < ConvertToDate(2, 7, ^IITR10 - 37)))
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
            */
            assertion = (report.IITR499.GetValueOrDefault() > 0 && (report.IITR29.GetValueOrDefault() > ConvertToDate(30, 6, report.IITR10.GetValueOrDefault() - 18) || report.IITR29.GetValueOrDefault() < ConvertToDate(2, 7, report.IITR10.GetValueOrDefault() - 37)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600098",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker net income amount must not be provided",
                    LongDescription = @"Working holiday maker net income must only be provided when the taxpayer is aged between 18 and 35, and earned income under an eligible working holiday visa (417 or 462)",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600098" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600098

            #region VR.ATO.IITR.600100

            /*  VR.ATO.IITR.600100
            Cost of managing tax affairs - Interest charged by the ATO has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr502] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR502, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR502 = RP:IncomeTax.Deduction.TaxAffairManagementATOInterest.Amount
            */
            assertion = NotMonetary(report.IITR502, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600100",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Cost of managing tax affairs - Interest charged by the ATO is not in a valid monetary format",
                    LongDescription = @"Cost of managing tax affairs - Interest charged by the ATO must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TaxAffairManagementATOInterest.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600100" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR502", Value = GetValueOrEmpty(report.IITR502) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600100

            #region VR.ATO.IITR.600101

            /*  VR.ATO.IITR.600101
            Cost of managing tax affairs - Litigation costs has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr503] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR503, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR503 = RP:IncomeTax.Deduction.TaxAffairManagementLitigation.Amount
            */
            assertion = NotMonetary(report.IITR503, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600101",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Cost of managing tax affairs - Litigation costs is not in a valid monetary format",
                    LongDescription = @"Cost of managing tax affairs - Litigation costs must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TaxAffairManagementLitigation.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600101" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR503", Value = GetValueOrEmpty(report.IITR503) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600101

            #region VR.ATO.IITR.600102

            /*  VR.ATO.IITR.600102
            Cost of managing tax affairs - Other expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr504] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR504, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR504 = RP:IncomeTax.Deduction.TaxAffairManagementOther.Amount
            */
            assertion = NotMonetary(report.IITR504, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.600102",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Cost of managing tax affairs - Other expenses is not in a valid monetary format",
                    LongDescription = @"Cost of managing tax affairs - Other expenses must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TaxAffairManagementOther.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600102" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR504", Value = GetValueOrEmpty(report.IITR504) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600102

            #region VR.ATO.IITR.600103

            /*  VR.ATO.IITR.600103
            Working holiday maker net income amount must be equal to the Working holiday maker gross income less Working holiday maker related deductions and business losses, or set to zero when Working holiday maker related deductions exceed Working holiday maker gross income
    
            Legacy Rule Format:
            IF ([iitr499] <> NULL AND ([iitr499] <> ConditionalValue([iitr623] > [iitr622], 0, RoundDown([iitr622] - [iitr623], 0))))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR499 <> NULL AND (^IITR499 <> ConditionalValue(^IITR623 > ^IITR622, 0, RoundDown(^IITR622 - ^IITR623, 0))))
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
    
            ^IITR623 = RP.WHM:IncomeTax.Deduction.WorkingHolidayMaker.Amount
    
            ^IITR622 = RP.WHM:Remuneration.WorkingHolidayMakerGross.Amount
            */
            assertion = (report.IITR499 != null && report.IITR499.GetValueOrDefault() != ConditionalValue(report.IITR623.GetValueOrDefault() > report.IITR622.GetValueOrDefault(), 0, (Math.Floor(report.IITR622.GetValueOrDefault() - report.IITR623.GetValueOrDefault()))));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.601103",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker net income amount is incorrect",
                    LongDescription = @"Working holiday maker net income amount must be equal to the Working holiday maker gross income less Working holiday maker related deductions and business losses, or set to zero when Working holiday maker related deductions exceed Working holiday maker gross income",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600103" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR623", Value = GetValueOrEmpty(report.IITR623) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR622", Value = GetValueOrEmpty(report.IITR622) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.600103

            #region VR.ATO.IITR.610005

            /*  VR.ATO.IITR.610005
            When a positive amount is present for either the primary or non-primary production motor vehicle expenses amount, the Motor vehicle expenses action code must be provided

            Legacy Rule Format:
            IF ([iitr711] > 0 OR [iitr731] > 0) AND ([iitr464] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR711 > 0 OR ^IITR731 > 0) AND (^IITR464 = BLANK)

            Data Elements:

            ^IITR464 = RP:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code

            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount

            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
            */
            assertion = ((report.IITR711.GetValueOrDefault() > 0 || report.IITR731.GetValueOrDefault() > 0) && string.IsNullOrWhiteSpace(report.IITR464) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.611005",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Motor vehicle expenses action code must be provided",
                    LongDescription = @"When a positive amount is present for either the primary or non-primary production motor vehicle expenses amount, the Motor vehicle expenses action code must be provided",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610005" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR464", Value = GetValueOrEmpty(report.IITR464) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610005

            #region VR.ATO.IITR.610006

            /*  VR.ATO.IITR.610006
            When the Motor vehicle expenses action code is present, at least one positive primary or non-primary production motor vehicle expenses amount must be provided
    
            Legacy Rule Format:
            IF ([iitr464] <> NULLORBLANK) AND ([iitr711] = NULL OR [iitr711] = 0) AND ([iitr731] = NULL OR [iitr731] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR464 <> BLANK) AND (^IITR711 = NULL OR ^IITR711 = 0) AND (^IITR731 = NULL OR ^IITR731 = 0)
    
            Data Elements:
    
            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR464 = RP:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code
    
            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR464) != true && (report.IITR711 == null || report.IITR711 == 0) && (report.IITR731 == null || report.IITR731 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.611006",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Motor vehicle expenses required",
                    LongDescription = @"When the Motor vehicle expenses action code is present, at least one positive primary or non-primary production motor vehicle expenses amount must be provided",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.MotorVehicle.Amount[@contextRef='" + report.RPPrimId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610006" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR464", Value = GetValueOrEmpty(report.IITR464) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610006

            #region VR.ATO.IITR.610007

            /*  VR.ATO.IITR.610007
            When the Closing stock action code is present, at least one positive primary or non-primary production closing stock amount must be provided
    
            Legacy Rule Format:
            IF ([iitr453] <> NULLORBLANK) AND (([iitr702] = NULL OR [iitr702] = 0) AND ([iitr721] = NULL OR [iitr721] = 0))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR453 <> BLANK) AND ((^IITR702 = NULL OR ^IITR702 = 0) AND (^IITR721 = NULL OR ^IITR721 = 0))
    
            Data Elements:
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR453 = RP(Instant):Assets.Inventories.ValuationMethod.Code
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR453) != true && ((report.IITR702 == null || report.IITR702 == 0) && (report.IITR721 == null || report.IITR721 == 0)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.611007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Closing stock amount required",
                    LongDescription = @"When the Closing stock action code is present, at least one positive primary or non-primary production closing stock amount must be provided",
                    Location = "/xbrli:xbrl/tns:Assets.ClosingStock.Amount[@contextRef='" + report.RPPrimInstantId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR453", Value = GetValueOrEmpty(report.IITR453) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610007

            #region VR.ATO.IITR.610008

            /*  VR.ATO.IITR.610008
            When a positive amount is present for either the primary or non-primary production closing stock amount, the Closing stock action code must be provided
    
            Legacy Rule Format:
            IF ([iitr702] > 0 OR [iitr721] > 0) AND ([iitr453] = NULLORBLANK)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR702 > 0 OR ^IITR721 > 0) AND (^IITR453 = BLANK)
    
            Data Elements:
    
            ^IITR453 = RP(Instant):Assets.Inventories.ValuationMethod.Code
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
            */
            assertion = ((report.IITR702.GetValueOrDefault() > 0 || report.IITR721.GetValueOrDefault() > 0) && string.IsNullOrWhiteSpace(report.IITR453) == true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.611008",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Closing stock action code must be provided",
                    LongDescription = @"When a positive amount is present for either the primary or non-primary production closing stock amount, the Closing stock action code must be provided",
                    Location = "/xbrli:xbrl/tns:Assets.Inventories.ValuationMethod.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610008" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR453", Value = GetValueOrEmpty(report.IITR453) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610008

            #region VR.ATO.IITR.610009

            /*  VR.ATO.IITR.610009
            Early payment interest credit amount of less than 50 cents cannot be claimed.
    
            Legacy Rule Format:
            IF ([iitr401] <> NULL) AND ([iitr401] < 0.50)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR401 <> NULL) AND (^IITR401 < 0.50)
    
            Data Elements:
    
            ^IITR401 = RP:Income.Interest.EarlyPaymentCredit.Amount
            */
            assertion = (report.IITR401 != null && report.IITR401.GetValueOrDefault() < 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610009",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Claim for early payment interest credit must not be less than 50 cents",
                    LongDescription = @"Early payment interest credit amount of less than 50 cents cannot be claimed",
                    Location = "/xbrli:xbrl/tns:Income.Interest.EarlyPaymentCredit.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610009" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR401", Value = GetValueOrEmpty(report.IITR401) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610009

            #region VR.ATO.IITR.610047

            /*  VR.ATO.IITR.610047
            Deductible amount of UPP of foreign pension or annuity has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr358] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR358, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR358 = RP:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount
            */
            assertion = NotMonetary(report.IITR358, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610047",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Deductible amount of UPP of foreign pension or annuity is not in a valid monetary format",
                    LongDescription = @"Deductible amount of UPP of foreign pension or annuity must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ForeignPensionAnnuityIncomeUndeductedPurchasePrice.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610047" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR358", Value = GetValueOrEmpty(report.IITR358) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610047

            #region VR.ATO.IITR.610054

            /*  VR.ATO.IITR.610054
            Individual - Deduction for project pool has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr366] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR366, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR366 = RP:IncomeTax.Deduction.ProjectPool.Amount
            */
            assertion = NotMonetary(report.IITR366, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610054",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Individual - Deduction for project pool is not in a valid monetary format",
                    LongDescription = @"Individual - Deduction for project pool must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ProjectPool.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610054" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR366", Value = GetValueOrEmpty(report.IITR366) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610054

            #region VR.ATO.IITR.610055

            /*  VR.ATO.IITR.610055
            Forestry managed investment scheme deduction has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr368] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR368, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR368 = RP:Expense.ForestryManagedInvestmentSchemeDeduction.Amount
            */
            assertion = NotMonetary(report.IITR368, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610055",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Forestry managed investment scheme deduction is not in a valid monetary format",
                    LongDescription = @"Forestry managed investment scheme deduction must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:Expense.ForestryManagedInvestmentSchemeDeduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610055" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR368", Value = GetValueOrEmpty(report.IITR368) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610055

            #region VR.ATO.IITR.610076

            /*  VR.ATO.IITR.610076
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF ([iitr464] <> NULLORBLANK) AND ([iitr464] <> SET("B","S","N"))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR464 <> BLANK) AND (NotInSet(^IITR464, '"B","S","N"'))
    
            Data Elements:
    
            ^IITR464 = RP:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code
            */
            assertion = (string.IsNullOrWhiteSpace(report.IITR464) != true && !(IsMatch(report.IITR464, @"^(B|S|N)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630076",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Motor vehicle expenses action code provided",
                    LongDescription = @"Valid Motor vehicle expenses action codes are; ""S"" = Cents per kilometre; ""B"" = Log book; ""N"" = Vehicle is a motorcycle, taxi taken on hire, or a road vehicle designed to carry a load of one tonne or more or nine or more passengers",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.MotorVehicleTypeOrClaimMethod.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610076" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR464", Value = GetValueOrEmpty(report.IITR464) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610076

            #region VR.ATO.IITR.610078

            /*  VR.ATO.IITR.610078
            Non-PP - Total business expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr468] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR468, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR468 = RP:Expense.Operating.BusinessNonPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR468, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610078",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Total business expenses is not in a valid monetary format",
                    LongDescription = @"Non-PP - Total business expenses may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.BusinessNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610078" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR468", Value = GetValueOrEmpty(report.IITR468) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610078

            #region VR.ATO.IITR.610129

            /*  VR.ATO.IITR.610129
            Amount on which family trust distribution tax has been paid has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr399] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR399, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR399 = RP:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount
            */
            assertion = NotMonetary(report.IITR399, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610129",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Amount on which family trust distribution tax has been paid is not in a valid monetary format",
                    LongDescription = @"Amount on which family trust distribution tax has been paid must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.FamilyTrustDistributionWhereTaxPaid.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610129" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR399", Value = GetValueOrEmpty(report.IITR399) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610129

            #region VR.ATO.IITR.610130

            /*  VR.ATO.IITR.610130
            Credit for interest on early payments - amount of interest has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr401] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR401, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR401 = RP:Income.Interest.EarlyPaymentCredit.Amount
            */
            assertion = NotMonetary(report.IITR401, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610130",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Credit for interest on early payments - amount of interest is not in a valid monetary format",
                    LongDescription = @"Credit for interest on early payments - amount of interest must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:Income.Interest.EarlyPaymentCredit.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610130" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR401", Value = GetValueOrEmpty(report.IITR401) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610130

            #region VR.ATO.IITR.610149

            /*  VR.ATO.IITR.610149
            PP - Total business expenses has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr467] <> MONETARY(S,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR467, 'S', 11, 0)
    
            Data Elements:
    
            ^IITR467 = RP:Expense.Operating.BusinessPrimaryProduction.Amount
            */
            assertion = NotMonetary(report.IITR467, @"S", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.610149",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Total business expenses is not in a valid monetary format",
                    LongDescription = @"PP - Total business expenses may be signed but must not exceed 11 digits; no other characters are allowed except for the preceding sign",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.BusinessPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.610149" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR467", Value = GetValueOrEmpty(report.IITR467) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.610149

            #region VR.ATO.IITR.630002

            /*  VR.ATO.IITR.630002
            Where the age of the taxpayer is over 61 on 30 June of the reporting period; and the Australian annuities and superannuation income streams untaxed element, or lump sum in arrears taxable component untaxed element, are greater than zero, and both the Australian superannuation income stream tax offset and Australian annuities and superannuation income streams tax withheld are not present, check Australian annuities and superannuation income stream amounts
    
            Legacy Rule Format:
            IF ([iitr29] <> NULL AND [iitr29] < ConvertToDate(30,6, [iitr10] - 61)) AND ([iitr93] > 0 OR [iitr95] > 0) AND [iitr166] = NULL AND [iitr91] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR29 <> NULL AND ^IITR29 < ConvertToDate(30,6, ^IITR10 - 61)) AND (^IITR93 > 0 OR ^IITR95 > 0) AND ^IITR166 = NULL AND ^IITR91 = NULL
    
            Data Elements:
    
            ^IITR29 = RP:PersonDemographicDetails.Birth.Date
    
            ^IITR10 = RP:Report.TargetFinancial.Year
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
    
            ^IITR166 = RP:TaxOffsetClaim.SuperannuationIncomeStream.Amount
    
            ^IITR91 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount
            */
            assertion = (report.IITR29 != null && report.IITR29.GetValueOrDefault() < ConvertToDate(30, 6, report.IITR10.GetValueOrDefault() - 61) && (report.IITR93.GetValueOrDefault() > 0 || report.IITR95.GetValueOrDefault() > 0) && report.IITR166 == null && report.IITR91 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630002",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Australian superannuation income stream amounts",
                    LongDescription = @"Check Tax withheld from Australian annuities and superannuation income streams and Australian superannuation income stream offset available. The taxpayer is older than 61 years and Australian annuities and superannuation income stream untaxed elements are present.  The tax-free components or the taxed elements of Australian superannuation income streams may have been incorrectly entered as an untaxed element.",
                    Location = "/xbrli:xbrl/tns:PersonDemographicDetails.Birth.Date[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR29", Value = GetValueOrEmpty(report.IITR29) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR10", Value = GetValueOrEmpty(report.IITR10) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR166", Value = GetValueOrEmpty(report.IITR166) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR91", Value = GetValueOrEmpty(report.IITR91) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630002

            #region VR.ATO.IITR.630003

            /*  VR.ATO.IITR.630003
            Check when Australian Government allowances and payments like Newstart, youth allowance and austudy payment amount is greater than $20,995
    
            Legacy Rule Format:
            IF [iitr86] > 20995
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR86 > 20995
    
            Data Elements:
    
            ^IITR86 = RP:Income.AustralianGovernmentAllowancesAndPayments.Amount
            */
            assertion = (report.IITR86.GetValueOrDefault() > 20995);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630003",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Australian government allowances and payments amount",
                    Location = "/xbrli:xbrl/tns:Income.AustralianGovernmentAllowancesAndPayments.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR86", Value = GetValueOrEmpty(report.IITR86) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630003

            #region VR.ATO.IITR.630006

            /*  VR.ATO.IITR.630006
            Check Total Tax Withheld as same as amount claimed for TFN Amounts on Gross Interest or TFN Amounts on Dividends
    
            Legacy Rule Format:
            IF ([iitr113] > 0) AND (([iitr116] > 0 AND [iitr113] = RoundDown([iitr116], 0)) OR ([iitr121] > 0 AND [iitr113] = RoundDown([iitr121], 0)))
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR113 > 0) AND ((^IITR116 > 0 AND ^IITR113 = ^IITR116) OR (^IITR121 > 0 AND ^IITR113 = RoundDown(^IITR121)))
    
            Data Elements:
    
            ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount
    
            ^IITR116 = RP:IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount
    
            ^IITR121 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldDividendsTFNNotQuoted.Amount
            */
            assertion = (report.IITR113.GetValueOrDefault() > 0 && (report.IITR116.GetValueOrDefault() > 0 && report.IITR113.GetValueOrDefault() == Math.Floor(report.IITR116.GetValueOrDefault()) || report.IITR121.GetValueOrDefault() > 0 && report.IITR113.GetValueOrDefault() == Math.Floor(report.IITR121.GetValueOrDefault())));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630006",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Total Tax Withheld against gross interest or dividend withheld amounts",
                    LongDescription = @"Check Total Tax Withheld as the same amount has been claimed for TFN Amounts on Gross Interest or TFN Amounts on Dividends",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630006" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR113", Value = GetValueOrEmpty(report.IITR113) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR116", Value = GetValueOrEmpty(report.IITR116) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR121", Value = GetValueOrEmpty(report.IITR121) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630006

            #region VR.ATO.IITR.630007

            /*  VR.ATO.IITR.630007
            The return lodged is an amendment, and the date the return is being lodged is greater than three years of the reporting period
    
            Legacy Rule Format:
            IF ([iitr16] = TRUE) AND (DATE(TODAY) > ConvertToDate(Day(RP:period.endDate), MonthAsInt(RP:period.endDate), Year(RP:period.endDate) + 3))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR16 = TRUE) AND (Today() > ConvertToDate(Day(^EndDate), MonthAsInt(^EndDate), Year(^EndDate) + 3))
    
            Data Elements:
    
            ^IITR16 = RP:Report.Amendment.Indicator
    
            ^EndDate = RP
            */
            assertion = (report.IITR16 == true && DateTime.Now.Date > ConvertToDate(Day(report.RPEndDate), MonthAsInt(report.RPEndDate), Year(report.RPEndDate) + 3));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630007",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Ensure amendment being lodged is within period of review",
                    Location = "/xbrli:xbrl/tns:Report.Amendment.Indicator",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR16", Value = GetValueOrEmpty(report.IITR16) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630007

            #region VR.ATO.IITR.630014

            /*  VR.ATO.IITR.630014
            Where Australian annuities and superannuation income stream tax withheld is greater than zero; and income at AASIS Taxable component taxed element, AASIS Taxable component untaxed element, Assessable amount from capped defined benefit income stream, AASIS Lump sum in arrears taxable component taxed element and AASIS Lump sum in arrears taxable component untaxed element are all zero or blank, check Australian annuities and superannuation income streams amounts.
    
            Legacy Rule Format:
            IF ([iitr91] > 0) AND ([iitr92] = NULL OR [iitr92] = 0) AND ([iitr93] = NULL OR [iitr93] = 0) AND ([iitr505] = NULL OR [iitr505] = 0) AND ([iitr94] = NULL OR [iitr94] = 0) AND ([iitr95] = NULL OR [iitr95] = 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR91 > 0) AND (^IITR92 = NULL OR ^IITR92 = 0) AND (^IITR93 = NULL OR ^IITR93 = 0) AND (^IITR505 = NULL OR ^IITR505 = 0) AND (^IITR94 = NULL OR ^IITR94 = 0) AND (^IITR95 = NULL OR ^IITR95 = 0)
    
            Data Elements:
    
            ^IITR91 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
            */
            assertion = (report.IITR91.GetValueOrDefault() > 0 && (report.IITR92 == null || report.IITR92 == 0) && (report.IITR93 == null || report.IITR93 == 0) && (report.IITR505 == null || report.IITR505 == 0) && (report.IITR94 == null || report.IITR94 == 0) && (report.IITR95 == null || report.IITR95 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630014",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check tax withheld from Australian superannuation income stream amount",
                    LongDescription = @"Australian annuities and superannuation income stream tax withheld is present without associated Australian annuities and superannuation income stream income. Check and adjust where necessary.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR91", Value = GetValueOrEmpty(report.IITR91) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630014

            #region VR.ATO.IITR.630015

            /*  VR.ATO.IITR.630015
            Where Tax withheld from Australian annuities and superannuation income streams is greater than 50% the sum of AASIS Taxable component taxed element, AASIS Taxable component untaxed element, Assessable amount from capped defined benefit income stream, AASIS Lump sum in arrears taxable component taxed element and AASIS Lump sum in arrears taxable component untaxed element, check Australian annuities and superannuation income stream tax withheld
    
            Legacy Rule Format:
            IF [iitr91] > (([iitr92] + [iitr93] + [iitr505] + [iitr94] + [iitr95]) * 0.50)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR91 > ((^IITR92 + ^IITR93 + ^IITR505 + ^IITR94 + ^IITR95) * 0.50)
    
            Data Elements:
    
            ^IITR91 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount
    
            ^IITR92 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentTaxedElement.Amount
    
            ^IITR93 = RP:Income.Superannuation.AnnuitiesAndSuperannuationTaxableComponentUntaxedElement.Amount
    
            ^IITR505 = RP:Income.Superannuation.AnnuitiesAndSuperannuationAssessableCappedBenefit.Amount
    
            ^IITR94 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentTaxedElement.Amount
    
            ^IITR95 = RP:Income.Superannuation.AnnuitiesAndSuperannuationLumpSumArrearsTaxableComponentUntaxedElement.Amount
            */
            assertion = (report.IITR91.GetValueOrDefault() > (report.IITR92.GetValueOrDefault() + report.IITR93.GetValueOrDefault() + report.IITR505.GetValueOrDefault() + report.IITR94.GetValueOrDefault() + report.IITR95.GetValueOrDefault()) * 0.50M);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.630015",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check tax withheld from Australian superannuation income stream amount",
                    LongDescription = @"Australian annuities and superannuation income streams tax withheld is more than 50% of the Australian annuities and superannuation income streams taxable component.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldAustralianAnnuitiesAndSuperannuationIncomeStream.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR91", Value = GetValueOrEmpty(report.IITR91) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR92", Value = GetValueOrEmpty(report.IITR92) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR93", Value = GetValueOrEmpty(report.IITR93) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR505", Value = GetValueOrEmpty(report.IITR505) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR94", Value = GetValueOrEmpty(report.IITR94) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR95", Value = GetValueOrEmpty(report.IITR95) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630015

            #region VR.ATO.IITR.630016

            /*  VR.ATO.IITR.630016
            When Salary or wage gross income is less than $99,999, and the combined Total reportable fringe benefits amounts are greater than $99,999, check each Total reportable fringe benefits amount
    
            Legacy Rule Format:
            IF [iitr601] < 99999 AND ([iitr490] + [iitr491]) > 99999
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR601 < 99999 AND (^IITR490 + ^IITR491) > 99999
    
            Data Elements:
    
            ^IITR490 = RP.Eligible:Income.FringeBenefitsReportable.Amount
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
    
            ^IITR491 = RP.Ineligible:Income.FringeBenefitsReportable.Amount
            */
            assertion = (report.IITR601.GetValueOrDefault() < 99999 && report.IITR490.GetValueOrDefault() + report.IITR491.GetValueOrDefault() > 99999);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.631016",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check Total reportable fringe benefits amounts",
                    LongDescription = @"Check the Total reportable fringe benefit amounts provided on the income tax return have been transferred correctly from the PAYG payment summaries",
                    Location = "/xbrli:xbrl/tns:Income.FringeBenefitsReportable.Amount[@contextRef='" + report.RPEligibleId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.630016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR490", Value = GetValueOrEmpty(report.IITR490) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR491", Value = GetValueOrEmpty(report.IITR491) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.630016

            #region VR.ATO.IITR.700002

            /*  VR.ATO.IITR.700002
            When 'Net small business income' is completed, 'Net Primary Production income/loss' or 'Net non-Primary Production income/loss' should be declared
    
            Legacy Rule Format:
            IF [iitr557] > 0 AND ([iitr281] = NULL OR [iitr281] = 0) AND ([iitr285] = NULL OR [iitr285] = 0)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR557 > 0 AND (^IITR281 = NULL OR ^IITR281 = 0) AND (^IITR285 = NULL OR ^IITR285 = 0)
    
            Data Elements:
    
            ^IITR557 = RP:Income.SmallBusinessEntityNet.Amount
    
            ^IITR281 = RP:Income.PrimaryProductionNet.Amount
    
            ^IITR285 = RP:Income.NonPrimaryProductionNet.Amount
            */
            assertion = (report.IITR557.GetValueOrDefault() > 0 && (report.IITR281 == null || report.IITR281 == 0) && (report.IITR285 == null || report.IITR285 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.700002",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check the net small business income details",
                    LongDescription = @"You have claimed the small business income tax offset at 'Net small business income', but you have not shown any sole trader business income at 'Net Primary Production income/loss' or 'Net non-Primary Production income/loss'. Business income shown at the offset question does not count towards the calculation of your income. Show your business income at the relevant business income question as well as at the offset question.",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.700002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR557", Value = GetValueOrEmpty(report.IITR557) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR281", Value = GetValueOrEmpty(report.IITR281) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR285", Value = GetValueOrEmpty(report.IITR285) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.700002

            #region VR.ATO.IITR.700003

            /*  VR.ATO.IITR.700003
            When 'Partnership share of net small business income less deductions attributable to that share' is present, 'Distribution from partnerships' or 'Distribution from partnerships less foreign income' should be declared
    
            Legacy Rule Format:
            IF [iitr558] > 0 AND ([iitr242] = NULL OR [iitr242] = 0) AND ([iitr252] = NULL OR [iitr252] = 0)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR558 > 0 AND (^IITR242 = NULL OR ^IITR242 = 0) AND (^IITR252 = NULL OR ^IITR252 = 0)
    
            Data Elements:
    
            ^IITR558 = RP.Partnership:Income.SmallBusinessEntityNet.Amount
    
            ^IITR242 = RP:Income.PartnershipPrimaryProductionShare.Amount
    
            ^IITR252 = RP:Income.PartnershipLessForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = (report.IITR558.GetValueOrDefault() > 0 && (report.IITR242 == null || report.IITR242 == 0) && (report.IITR252 == null || report.IITR252 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.700003",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check the partnership share of net small business income details",
                    LongDescription = @"You have claimed the small business income tax offset at 'Partnership share of net small business income less deductions attributable to that share', but you have not shown a share of partnership business income at 'Distribution from partnerships' or 'Distribution from partnerships less foreign income'. Partnership income shown at the offset question does not count towards the calculation of your income. Show your business income at the relevant partnership income question as well as at the offset question.",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPPartnershipId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.700003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR558", Value = GetValueOrEmpty(report.IITR558) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR242", Value = GetValueOrEmpty(report.IITR242) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR252", Value = GetValueOrEmpty(report.IITR252) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.700003

            #region VR.ATO.IITR.700004

            /*  VR.ATO.IITR.700004
            When 'Trust share of net small business income less deductions attributable to that share' is present, 'Share of net income from trusts' or 'Share of net income from trusts less capital gains, foreign income and franked distributions' should be declared
    
            Legacy Rule Format:
            IF [iitr559] > 0 AND ([iitr243] = NULL OR [iitr243] = 0) AND ([iitr255] = NULL OR [iitr255] = 0)
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR559 > 0 AND (^IITR243 = NULL OR ^IITR243 = 0) AND (^IITR255 = NULL OR ^IITR255 = 0)
    
            Data Elements:
    
            ^IITR559 = RP.Trust:Income.SmallBusinessEntityNet.Amount
    
            ^IITR243 = RP:Income.TrustPrimaryProductionNetShare.Amount
    
            ^IITR255 = RP:Income.TrustLessNetCapitalGainAndForeignIncomeNonPrimaryProductionShare.Amount
            */
            assertion = (report.IITR559.GetValueOrDefault() > 0 && (report.IITR243 == null || report.IITR243 == 0) && (report.IITR255 == null || report.IITR255 == 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.700004",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Check the trust share of net small business income details",
                    LongDescription = @"You have claimed the small business income tax offset at 'Trust share of net small business income less deductions attributable to that share', but you have not shown any trust business income at 'Share of net income from trusts' or 'Share of net income from trusts less capital gains, foreign income and franked distributions'. Trust income shown at the offset question does not count towards the calculation of your income. Show your business income at the relevant trust income question as well as at the offset question.",
                    Location = "/xbrli:xbrl/tns:Income.SmallBusinessEntityNet.Amount[@contextRef='" + report.RPTrustId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.700004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR559", Value = GetValueOrEmpty(report.IITR559) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR243", Value = GetValueOrEmpty(report.IITR243) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR255", Value = GetValueOrEmpty(report.IITR255) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.700004

            #region VR.ATO.IITR.730160

            /*  VR.ATO.IITR.730160
            Where deductions have been claimed for either; Work related car expenses, Work related travel expenses, Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses, Work related self-education expenses, or Other work related expenses; without Salary or wages gross income or Allowance income being declared, check Work related expense deductions as they are normally claimed only if Salary or wages gross income or Allowance income is declared.
    
            Legacy Rule Format:
            IF ([iitr65] = NULL) AND [iitr601] = NULL AND ([iitr134] > 0 OR [iitr136] > 0 OR [iitr137] > 0 OR [iitr139] > 0 OR [iitr141] > 0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR65 = NULL) AND ^IITR601 = NULL AND (^IITR134 > 0 OR ^IITR136 > 0 OR ^IITR137 > 0 OR ^IITR139 > 0 OR ^IITR141 > 0)
    
            Data Elements:
    
            ^IITR65 = RP:Income.AllowancesEarningsTipsDirectorsFees.Amount
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
    
            ^IITR134 = RP:IncomeTax.Deduction.Car.Amount
    
            ^IITR136 = RP:IncomeTax.Deduction.Travel.Amount
    
            ^IITR137 = RP:IncomeTax.Deduction.Clothing.Amount
    
            ^IITR139 = RP:IncomeTax.Deduction.EducationNet.Amount
    
            ^IITR141 = RP:IncomeTax.Deduction.WorkRelatedOther.Amount
            */
            assertion = (report.IITR65 == null && report.IITR601 == null && (report.IITR134.GetValueOrDefault() > 0 || report.IITR136.GetValueOrDefault() > 0 || report.IITR137.GetValueOrDefault() > 0 || report.IITR139.GetValueOrDefault() > 0 || report.IITR141.GetValueOrDefault() > 0));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730160",
                    Severity = ProcessMessageSeverity.Warning,
                    Description = @"Work related expense deductions can only be claimed if salary or allowance income is declared",
                    LongDescription = @"Where deductions have been claimed for either; Work related car expenses, Work related travel expenses, Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses, Work related self-education expenses, or Other work related expenses; without Salary or wages gross income or Allowance income being declared, check Work related expense deductions as they are normally claimed only if Salary or wages gross income or Allowance income is declared.",
                    Location = "/xbrli:xbrl/tns:Income.AllowancesEarningsTipsDirectorsFees.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730160" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR65", Value = GetValueOrEmpty(report.IITR65) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR134", Value = GetValueOrEmpty(report.IITR134) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR136", Value = GetValueOrEmpty(report.IITR136) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR137", Value = GetValueOrEmpty(report.IITR137) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR139", Value = GetValueOrEmpty(report.IITR139) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR141", Value = GetValueOrEmpty(report.IITR141) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730160

            #region VR.ATO.IITR.730161

            /*  VR.ATO.IITR.730161
            Salary or wages gross income is greater than zero and total tax withheld is absent. If no tax was withheld then enter zero.
    
            Legacy Rule Format:
            IF ([iitr113] = NULL) AND ([iitr601] > 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR113 = NULL) AND (^IITR601 > 0)
    
            Data Elements:
    
            ^IITR113 = RP:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
            */
            assertion = (report.IITR113 == null && report.IITR601.GetValueOrDefault() > 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730161",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Total tax withheld is required",
                    LongDescription = @"Salary or wages gross income is greater than zero and total tax withheld is absent. If no tax was withheld then enter zero.",
                    Location = "/xbrli:xbrl/tns:IncomeTax.PayAsYouGoWithholding.CreditTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730161" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR113", Value = GetValueOrEmpty(report.IITR113) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730161

            #region VR.ATO.IITR.730162

            /*  VR.ATO.IITR.730162
            Salary or wages gross income must be greater than $0 where Net foreign employment income - payment summary is reported
    
            Legacy Rule Format:
            IF ([iitr329] <> NULL) AND ([iitr601] = 0 OR [iitr601] = NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR329 <> NULL) AND (^IITR601 = 0 OR ^IITR601 = NULL)
    
            Data Elements:
    
            ^IITR601 = RP:Income.SalaryOrWages.Amount
    
            ^IITR329 = RP:InternationalDealings.ForeignEmploymentIncomePaymentSummary.Amount
            */
            assertion = (report.IITR329 != null && (report.IITR601 == 0 || report.IITR601 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730162",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"A positive Salary or wages gross income must be provided",
                    LongDescription = @"Salary or wages gross income must be greater than $0 where Net foreign employment income - payment summary is reported",
                    Location = "/xbrli:xbrl/tns:Income.SalaryOrWages.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730162" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR329", Value = GetValueOrEmpty(report.IITR329) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR601", Value = GetValueOrEmpty(report.IITR601) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730162

            #region VR.ATO.IITR.730263

            /*  VR.ATO.IITR.730263
            Where Working holiday maker related deductions and business losses is provided, the Working holiday maker related deductions and business losses must not be greater than the sum of Individual total deductions amount, Primary production losses claimed this income year, and Non-primary production losses claimed this income year
    
            Legacy Rule Format:
            IF ([iitr623] <> NULL) AND ([iitr623] > ([iitr150] + [iitr154] + [iitr156]))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR623 <> NULL) AND (^IITR623 > (^IITR150 + ^IITR154 + ^IITR156))
    
            Data Elements:
    
            ^IITR623 = RP.WHM:IncomeTax.Deduction.WorkingHolidayMaker.Amount
    
            ^IITR150 = RP:Expense.DeductionsTotal.Amount
    
            ^IITR154 = RP:IncomeTax.LossesClaimedPrimaryProduction.Amount
    
            ^IITR156 = RP:IncomeTax.LossesClaimedNonPrimaryProduction.Amount
            */
            assertion = (report.IITR623 != null && report.IITR623.GetValueOrDefault() > report.IITR150.GetValueOrDefault() + report.IITR154.GetValueOrDefault() + report.IITR156.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730263",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker related deductions and business losses is incorrect",
                    LongDescription = @"Where Working holiday maker related deductions and business losses is provided, the Working holiday maker related deductions and business losses must not be greater than the sum of Individual total deductions amount, Primary production losses claimed this income year, and Non-primary production losses claimed this income year",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkingHolidayMaker.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730263" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR623", Value = GetValueOrEmpty(report.IITR623) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR154", Value = GetValueOrEmpty(report.IITR154) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR156", Value = GetValueOrEmpty(report.IITR156) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730263

            #region VR.ATO.IITR.730266

            /*  VR.ATO.IITR.730266
            Where Working holiday maker gross income is provided, it must not be greater than Individual total income or loss amount where that amount, is greater than or equal to 0
    
            Legacy Rule Format:
            IF ([iitr622] <> NULL) AND ([iitr131] >= 0) AND ([iitr622] > [iitr131])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR622 <> NULL) AND (^IITR131 >= 0) AND (^IITR622 > ^IITR131)
    
            Data Elements:
    
            ^IITR622 = RP.WHM:Remuneration.WorkingHolidayMakerGross.Amount
    
            ^IITR131 = RP:Income.Net.Amount
            */
            assertion = (report.IITR622 != null && report.IITR131.GetValueOrDefault() >= 0 && report.IITR622.GetValueOrDefault() > report.IITR131.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730266",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker gross income is incorrect",
                    LongDescription = @"Where Working holiday maker gross income is provided, it must not be greater than Individual total income or loss amount, where that amount is greater than or equal to 0",
                    Location = "/xbrli:xbrl/tns:Remuneration.WorkingHolidayMakerGross.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730266" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR622", Value = GetValueOrEmpty(report.IITR622) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR131", Value = GetValueOrEmpty(report.IITR131) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730266

            #region VR.ATO.IITR.730267

            /*  VR.ATO.IITR.730267
            Where Working holiday maker net income is provided, Working holiday maker gross income and Working holiday maker related deductions and business losses must be provided
    
            Legacy Rule Format:
            IF ([iitr499] <> NULL) AND (([iitr622] = NULL) OR ([iitr623] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR499 <> NULL) AND ((^IITR622 = NULL) OR (^IITR623 = NULL))
    
            Data Elements:
    
            ^IITR499 = RP.WHM:Income.Net.Amount
    
            ^IITR622 = RP.WHM:Remuneration.WorkingHolidayMakerGross.Amount
    
            ^IITR623 = RP.WHM:IncomeTax.Deduction.WorkingHolidayMaker.Amount
            */
            assertion = (report.IITR499 != null && (report.IITR622 == null || report.IITR623 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730267",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Working holiday maker gross income and related deductions and business losses must be provided",
                    LongDescription = @"Where Working holiday maker net income is provided, Working holiday maker gross income and Working holiday maker related deductions and business losses must be provided",
                    Location = "/xbrli:xbrl/tns:Income.Net.Amount[@contextRef='" + report.RPWHMId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730267" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR499", Value = GetValueOrEmpty(report.IITR499) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR622", Value = GetValueOrEmpty(report.IITR622) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR623", Value = GetValueOrEmpty(report.IITR623) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730267

            #region VR.ATO.IITR.730268

            /*  VR.ATO.IITR.730268
            The Australian residency start date, if provided, cannot be earlier than the lodgment period start date.
    
            Legacy Rule Format:
            IF ([iitr666] <> NULL AND [iitr666] < [iitr11])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR666 <> NULL AND ^IITR666 < ^IITR11
    
            Data Elements:
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR11 = RP:Lodgment.PeriodStart.Date
            */
            assertion = (report.IITR666 != null && report.IITR666.GetValueOrDefault() < report.IITR11.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730268",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The Australian residency start date, if provided, cannot be earlier than the lodgment period start date",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730268" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR11", Value = GetValueOrEmpty(report.IITR11) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730268

            #region VR.ATO.IITR.730269

            /*  VR.ATO.IITR.730269
            If either the Australian residency start date or Australian residency end date are provided, both dates must be provided.
    
            Legacy Rule Format:
            IF (([iitr666] <> NULL AND [iitr667] = NULL) OR ([iitr667] <> NULL AND [iitr666] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ((^IITR666 <> NULL AND ^IITR667 = NULL) OR (^IITR667 <> NULL AND ^IITR666 = NULL))
    
            Data Elements:
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
            */
            assertion = (report.IITR666 != null && report.IITR667 == null || report.IITR667 != null && report.IITR666 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730269",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"If either Australian residency start date or Australian residency end date are provided, both must be provided",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730269" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730269

            #region VR.ATO.IITR.730270

            /*  VR.ATO.IITR.730270
            If the Number of months eligible for part-year tax-free threshold is provided, both the Australian residency start date and Australian residency end date must also be provided.
    
            Legacy Rule Format:
            IF ([iitr192] <> NULL AND ([iitr666] = NULL OR [iitr667] = NULL))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR192 <> NULL AND (^IITR666 = NULL OR ^IITR667 = NULL))
    
            Data Elements:
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR192 = RP:IncomeTax.PartYearTaxFreeThresholdEligibleMonths.Number
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
            */
            assertion = (report.IITR192 != null && (report.IITR666 == null || report.IITR667 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730270",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Australian residency start date and Australian residency end date must be provided",
                    LongDescription = @"If the Number of months eligible for part-year tax-free threshold is provided, both the Australian residency start date and Australian residency end date must also be provided",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730270" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR192", Value = report.IITR192.GetValueOrDefault().ToString() });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730270

            #region VR.ATO.IITR.730271

            /*  VR.ATO.IITR.730271
            The Australian residency start date cannot be later than or equal to the Australian residency end date.
    
            Legacy Rule Format:
            IF ([iitr666] <> NULL AND [iitr667] <> NULL AND [iitr666] >= [iitr667])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR666 <> NULL AND ^IITR667 <> NULL AND ^IITR666 >= ^IITR667
    
            Data Elements:
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
            */
            assertion = (report.IITR666 != null && report.IITR667 != null && report.IITR666.GetValueOrDefault() >= report.IITR667.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730271",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The Australian residency start date cannot be later than or equal to the Australian residency end date",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730271" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730271

            #region VR.ATO.IITR.730272

            /*  VR.ATO.IITR.730272
            The Australian residency dates cannot be equal to the lodgment period dates. If the individual was an Australian resident for tax purposes for the full year, these fields should not be provided.
    
            Legacy Rule Format:
            IF ([iitr666] = [iitr11] AND [iitr667] = [iitr12])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR666 = ^IITR11 AND ^IITR667 = ^IITR12
    
            Data Elements:
    
            ^IITR666 = RP:Residency.TaxPurposesStart.Date
    
            ^IITR11 = RP:Lodgment.PeriodStart.Date
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
    
            ^IITR12 = RP:Lodgment.PeriodEnd.Date
            */
            assertion = (report.IITR666.GetValueOrDefault() == report.IITR11.GetValueOrDefault() && report.IITR667.GetValueOrDefault() == report.IITR12.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730272",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The Australian residency start date and the Australian residency end date are incorrect",
                    LongDescription = @"The Australian residency dates cannot be equal to the lodgment period dates. If the individual was an Australian resident for tax purposes for the full lodgment period, these fields should not be provided.",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesStart.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730272" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR666", Value = GetValueOrEmpty(report.IITR666) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR11", Value = GetValueOrEmpty(report.IITR11) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR12", Value = GetValueOrEmpty(report.IITR12) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730272

            #region VR.ATO.IITR.730273

            /*  VR.ATO.IITR.730273
            The Australian residency end date, if provided, cannot be later than the lodgment period end date.
    
            Legacy Rule Format:
            IF ([iitr667] <> NULL AND [iitr667] > [iitr12])
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR667 <> NULL AND ^IITR667 > ^IITR12
    
            Data Elements:
    
            ^IITR667 = RP:Residency.TaxPurposesEnd.Date
    
            ^IITR12 = RP:Lodgment.PeriodEnd.Date
            */
            assertion = (report.IITR667 != null && report.IITR667.GetValueOrDefault() > report.IITR12.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730273",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The Australian residency end date, if provided, cannot be later than the lodgment period end date",
                    Location = "/xbrli:xbrl/tns:Residency.TaxPurposesEnd.Date",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730273" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR667", Value = GetValueOrEmpty(report.IITR667) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR12", Value = GetValueOrEmpty(report.IITR12) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730273

            #region VR.ATO.IITR.730320

            /*  VR.ATO.IITR.730320
            Assessable First Home Super Saver (FHSS) released amount - Category 3 has a maximum field length of 11
    
            Legacy Rule Format:
            IF [iitr650] <> MONETARY(U,11,0)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR650, 'U', 11, 0)
    
            Data Elements:
    
            ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
            */
            assertion = NotMonetary(report.IITR650, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730320",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Assessable First Home Super Saver (FHSS) released amount - Category 3 is not in a valid monetary format",
                    LongDescription = @"Assessable First Home Super Saver (FHSS) released amount - Category 3 must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730320" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730320

            #region VR.ATO.IITR.730321

            /*  VR.ATO.IITR.730321
            When either Assessable First Home Super Saver (FHSS) released amount - Category 3 or Tax withheld for First Home Super Saver (FHSS) - Category 3 is present, then both amounts must be provided
    
            Legacy Rule Format:
            IF ([iitr650] <> NULL OR [iitr651] <> NULL) AND ([iitr650] = NULL OR [iitr651] = NULL)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR650 <> NULL OR ^IITR651 <> NULL) AND (^IITR650 = NULL OR ^IITR651 = NULL)
    
            Data Elements:
    
            ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
    
            ^IITR651 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount
            */
            assertion = ((report.IITR650 != null || report.IITR651 != null) && (report.IITR650 == null || report.IITR651 == null));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730321",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"All First Home Super Saver (FHSS) details must be provided",
                    LongDescription = @"When either Assessable First Home Super Saver (FHSS) released amount - Category 3 or Tax withheld for First Home Super Saver (FHSS) - Category 3 is present, then both amounts must be provided",
                    Location = "/xbrli:xbrl/tns:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730321" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR651", Value = GetValueOrEmpty(report.IITR651) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730321

            #region VR.ATO.IITR.730322

            /*  VR.ATO.IITR.730322
            Tax withheld for First Home Super Saver (FHSS) - Category 3 has a maximum field length of 13
    
            Legacy Rule Format:
            IF [iitr651] <> MONETARY(U,13,2)
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotMonetary(^IITR651, 'U', 13, 2)
    
            Data Elements:
    
            ^IITR651 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount
            */
            assertion = NotMonetary(report.IITR651, @"U", 13, 2);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730322",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld for First Home Super Saver (FHSS) - Category 3 is not in a valid monetary format",
                    LongDescription = @"Tax withheld for First Home Super Saver (FHSS) - Category 3 must be unsigned, contain 2 decimals and not exceed 11 significant digits; no other characters are allowed except for the decimal point",
                    Location = "/xbrli:xbrl/tns:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730322" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR651", Value = GetValueOrEmpty(report.IITR651) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730322

            #region VR.ATO.IITR.730323

            /*  VR.ATO.IITR.730323
            Tax withheld for First Home Super Saver (FHSS) - Category 3 must not exceed Assessable First Home Super Saver (FHSS) released amount - Category 3
    
            Legacy Rule Format:
            IF [iitr651] > [iitr650]
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR651 > ^IITR650
    
            Data Elements:
    
            ^IITR651 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount
    
            ^IITR650 = RP:IncomeTax.AssessableFirstHomeSuperSaverReleased.Amount
            */
            assertion = (report.IITR651.GetValueOrDefault() > report.IITR650.GetValueOrDefault());
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730323",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Tax withheld for First Home Super Saver (FHSS) - Category 3 is incorrect",
                    LongDescription = @"Tax withheld for First Home Super Saver (FHSS) - Category 3 must not exceed Assessable First Home Super Saver (FHSS) released amount - Category 3",
                    Location = "/xbrli:xbrl/tns:IncomeTax.AssessableFirstHomeSuperSaverReleasedTaxWithheld.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730323" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR651", Value = GetValueOrEmpty(report.IITR651) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR650", Value = GetValueOrEmpty(report.IITR650) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730323

            #region VR.ATO.IITR.730326

            /*  VR.ATO.IITR.730326
            Value entered is not a valid code/value for that field.
    
            Legacy Rule Format:
            IF [iitr393] <> NULL AND [iitr393] <> SET("Infrastructure Borrowings", "Joint Petroleum Development Area")
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR393 <> NULL AND NotInSet(^IITR393, '"Infrastructure Borrowings", "Joint Petroleum Development Area"')
    
            Data Elements:
    
            ^IITR393 = RP:TaxOffsetClaim.NonRefundableOther.Code
            */
            assertion = (report.IITR393 != null && !(IsMatch(report.IITR393, @"^(Infrastructure Borrowings|Joint Petroleum Development Area)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730326",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other non-refundable tax offsets action code is invalid",
                    LongDescription = @"Valid Other non-refundable tax offsets action codes are; ""Infrastructure Borrowings"", ""Joint Petroleum Development Area""",
                    Location = "/xbrli:xbrl/tns:TaxOffsetClaim.NonRefundableOther.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730326" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR393", Value = GetValueOrEmpty(report.IITR393) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730326

            #region VR.ATO.IITR.730360

            /*  VR.ATO.IITR.730360
            At Business income and expenses, the sum of Primary production expenses is not equal to the Total primary production expenses
    
            Legacy Rule Format:
            IF ([iitr467] <> NULL AND [iitr467] <> ([iitr700] + [iitr701] - [iitr702] + [iitr703] + [iitr704] + [iitr705] + [iitr706] + [iitr707] + [iitr708] + [iitr709] + [iitr710] + [iitr711] + [iitr712] + [iitr713])) OR ([iitr467] = NULL AND ([iitr700] + [iitr701] - [iitr702] + [iitr703] + [iitr704] + [iitr705] + [iitr706] + [iitr707] + [iitr708] + [iitr709] + [iitr710] + [iitr711] + [iitr712] + [iitr713]) <> 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR467 <> NULL AND ^IITR467 <> (^IITR700 + ^IITR701 - ^IITR702 + ^IITR703 + ^IITR704 + ^IITR705 + ^IITR706 + ^IITR707 + ^IITR708 + ^IITR709 + ^IITR710 + ^IITR711 + ^IITR712 + ^IITR713)) OR (^IITR467 = NULL AND (^IITR700 + ^IITR701 - ^IITR702 + ^IITR703 + ^IITR704 + ^IITR705 + ^IITR706 + ^IITR707 + ^IITR708 + ^IITR709 + ^IITR710 + ^IITR711 + ^IITR712 + ^IITR713) <> 0)
    
            Data Elements:
    
            ^IITR467 = RP:Expense.Operating.BusinessPrimaryProduction.Amount
    
            ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
    
            ^IITR701 = RP.Prim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
    
            ^IITR703 = RP.Prim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR704 = RP.Prim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR705 = RP.Prim:Expense.Operating.BadDebts.Amount
    
            ^IITR706 = RP.Prim:Expense.Operating.Lease.Amount
    
            ^IITR707 = RP.Prim:Expense.Operating.Rent.Amount
    
            ^IITR708 = RP.Prim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR709 = RP.Prim:Expense.Operating.InterestForeign.Amount
    
            ^IITR710 = RP.Prim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR712 = RP.Prim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR713 = RP.Prim:Expense.Operating.Other.Amount
            */
            assertion = (report.IITR467 != null && report.IITR467.GetValueOrDefault() != report.IITR700.GetValueOrDefault() + report.IITR701.GetValueOrDefault() - report.IITR702.GetValueOrDefault() + report.IITR703.GetValueOrDefault() + report.IITR704.GetValueOrDefault() + report.IITR705.GetValueOrDefault() + report.IITR706.GetValueOrDefault() + report.IITR707.GetValueOrDefault() + report.IITR708.GetValueOrDefault() + report.IITR709.GetValueOrDefault() + report.IITR710.GetValueOrDefault() + report.IITR711.GetValueOrDefault() + report.IITR712.GetValueOrDefault() + report.IITR713.GetValueOrDefault() || report.IITR467 == null && report.IITR700.GetValueOrDefault() + report.IITR701.GetValueOrDefault() - report.IITR702.GetValueOrDefault() + report.IITR703.GetValueOrDefault() + report.IITR704.GetValueOrDefault() + report.IITR705.GetValueOrDefault() + report.IITR706.GetValueOrDefault() + report.IITR707.GetValueOrDefault() + report.IITR708.GetValueOrDefault() + report.IITR709.GetValueOrDefault() + report.IITR710.GetValueOrDefault() + report.IITR711.GetValueOrDefault() + report.IITR712.GetValueOrDefault() + report.IITR713.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730360",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"PP - Total business expenses is incorrect",
                    LongDescription = @"At Business income and expenses, the sum of Primary production expenses is not equal to the Total primary production expenses",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.BusinessPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730360" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR467", Value = GetValueOrEmpty(report.IITR467) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR701", Value = GetValueOrEmpty(report.IITR701) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR703", Value = GetValueOrEmpty(report.IITR703) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR704", Value = GetValueOrEmpty(report.IITR704) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR705", Value = GetValueOrEmpty(report.IITR705) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR706", Value = GetValueOrEmpty(report.IITR706) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR707", Value = GetValueOrEmpty(report.IITR707) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR708", Value = GetValueOrEmpty(report.IITR708) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR709", Value = GetValueOrEmpty(report.IITR709) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR710", Value = GetValueOrEmpty(report.IITR710) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR712", Value = GetValueOrEmpty(report.IITR712) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR713", Value = GetValueOrEmpty(report.IITR713) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730360

            #region VR.ATO.IITR.730361

            /*  VR.ATO.IITR.730361
            At Business income and expenses, the sum of Non-primary production expenses is not equal to the Total non-primary production expenses
    
            Legacy Rule Format:
            IF ([iitr468] <> NULL AND [iitr468] <> ([iitr719] + [iitr720] - [iitr721] + [iitr723] + [iitr724] + [iitr725] + [iitr726] + [iitr727] + [iitr728] + [iitr729] + [iitr730] + [iitr731] + [iitr732] + [iitr733] + [iitr722])) OR ([iitr468] = NULL AND ([iitr719] + [iitr720] - [iitr721] + [iitr723] + [iitr724] + [iitr725] + [iitr726] + [iitr727] + [iitr728] + [iitr729] + [iitr730] + [iitr731] + [iitr732] + [iitr733] + [iitr722]) <> 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^IITR468 <> NULL AND ^IITR468 <> (^IITR719 + ^IITR720 - ^IITR721 + ^IITR723 + ^IITR724 + ^IITR725 + ^IITR726 + ^IITR727 + ^IITR728 + ^IITR729 + ^IITR730 + ^IITR731 + ^IITR732 + ^IITR733 + ^IITR722)) OR (^IITR468 = NULL AND (^IITR719 + ^IITR720 - ^IITR721 + ^IITR723 + ^IITR724 + ^IITR725 + ^IITR726 + ^IITR727 + ^IITR728 + ^IITR729 + ^IITR730 + ^IITR731 + ^IITR732 + ^IITR733 + ^IITR722) <> 0)
    
            Data Elements:
    
            ^IITR468 = RP:Expense.Operating.BusinessNonPrimaryProduction.Amount
    
            ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
    
            ^IITR720 = RP.NonPrim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
    
            ^IITR723 = RP.NonPrim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR724 = RP.NonPrim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR725 = RP.NonPrim:Expense.Operating.BadDebts.Amount
    
            ^IITR726 = RP.NonPrim:Expense.Operating.Lease.Amount
    
            ^IITR727 = RP.NonPrim:Expense.Operating.Rent.Amount
    
            ^IITR728 = RP.NonPrim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR729 = RP.NonPrim:Expense.Operating.InterestForeign.Amount
    
            ^IITR730 = RP.NonPrim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR732 = RP.NonPrim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR733 = RP.NonPrim:Expense.Operating.Other.Amount
    
            ^IITR722 = RP.NonPrim:Expense.ForeignResidentWithholding.Amount
            */
            assertion = (report.IITR468 != null && report.IITR468.GetValueOrDefault() != report.IITR719.GetValueOrDefault() + report.IITR720.GetValueOrDefault() - report.IITR721.GetValueOrDefault() + report.IITR723.GetValueOrDefault() + report.IITR724.GetValueOrDefault() + report.IITR725.GetValueOrDefault() + report.IITR726.GetValueOrDefault() + report.IITR727.GetValueOrDefault() + report.IITR728.GetValueOrDefault() + report.IITR729.GetValueOrDefault() + report.IITR730.GetValueOrDefault() + report.IITR731.GetValueOrDefault() + report.IITR732.GetValueOrDefault() + report.IITR733.GetValueOrDefault() + report.IITR722.GetValueOrDefault() || report.IITR468 == null && report.IITR719.GetValueOrDefault() + report.IITR720.GetValueOrDefault() - report.IITR721.GetValueOrDefault() + report.IITR723.GetValueOrDefault() + report.IITR724.GetValueOrDefault() + report.IITR725.GetValueOrDefault() + report.IITR726.GetValueOrDefault() + report.IITR727.GetValueOrDefault() + report.IITR728.GetValueOrDefault() + report.IITR729.GetValueOrDefault() + report.IITR730.GetValueOrDefault() + report.IITR731.GetValueOrDefault() + report.IITR732.GetValueOrDefault() + report.IITR733.GetValueOrDefault() + report.IITR722.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730361",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Non-PP - Total business expenses is incorrect",
                    LongDescription = @"At Business income and expenses, the sum of Non-primary production expenses is not equal to the Total non-primary production expenses",
                    Location = "/xbrli:xbrl/tns:Expense.Operating.BusinessNonPrimaryProduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730361" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR468", Value = GetValueOrEmpty(report.IITR468) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR720", Value = GetValueOrEmpty(report.IITR720) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR723", Value = GetValueOrEmpty(report.IITR723) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR724", Value = GetValueOrEmpty(report.IITR724) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR725", Value = GetValueOrEmpty(report.IITR725) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR726", Value = GetValueOrEmpty(report.IITR726) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR727", Value = GetValueOrEmpty(report.IITR727) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR728", Value = GetValueOrEmpty(report.IITR728) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR729", Value = GetValueOrEmpty(report.IITR729) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR730", Value = GetValueOrEmpty(report.IITR730) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR732", Value = GetValueOrEmpty(report.IITR732) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR733", Value = GetValueOrEmpty(report.IITR733) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR722", Value = GetValueOrEmpty(report.IITR722) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730361

            #region VR.ATO.IITR.730364

            /*  VR.ATO.IITR.730364
            Invalid context. The number of Reporting Party Primary Production (Instant) contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(RP.Prim(Instant)) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.Prim(Instant)
            */
            assertion = (Count(report.RPPrimInstantCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730364",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Primary Production (Instant) contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPrimInstantLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730364" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730364

            #region VR.ATO.IITR.730365

            /*  VR.ATO.IITR.730365
            Entity identifier scheme for Reporting Party Primary Production (Instant) must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.Prim(Instant):entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.Prim(Instant)
            */
            assertion = ((report.RPPrimInstantExists == true) && (report.RPPrimInstantIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730365",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Primary Production (Instant) must be set to ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPPrimInstantOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730365" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730365

            #region VR.ATO.IITR.730366

            /*  VR.ATO.IITR.730366
            Invalid context. Period date of Reporting Party Primary Production (Instant) must match period start date of Reporting Party.
    
            Legacy Rule Format:
            IF (RP.Prim(Instant):period.instantDate <> RP:period.startDate)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^InstantDate1 <> ^StartDate1
    
            Data Elements:
    
            ^StartDate1 = RP
    
            ^InstantDate1 = RP.Prim(Instant)
            */
            assertion = ((report.RPPrimInstantExists == true) && (report.RPPrimInstantInstantDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730366",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Primary Production (Instant) period date is invalid",
                    LongDescription = @"Invalid context. Period date of Reporting Party Primary Production (Instant) must match period start date of Reporting Party.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730366" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730366

            #region VR.ATO.IITR.730367

            /*  VR.ATO.IITR.730367
            Invalid context. The number of Reporting Party Non-Primary Production contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(RP.NonPrim) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP:RP.NonPrim
            */
            assertion = (Count(report.RPNonPrimCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730367",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Non-Primary Production contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPNonPrimLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730367" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730367

            #region VR.ATO.IITR.730368

            /*  VR.ATO.IITR.730368
            Entity identifier scheme for Reporting Party Non-Primary Production must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.NonPrim:entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP:RP.NonPrim
            */
            assertion = ((report.RPNonPrimExists == true) && (report.RPNonPrimIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730368",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Non-Primary Production must be set to ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPNonPrimOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730368" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730368

            #region VR.ATO.IITR.730369

            /*  VR.ATO.IITR.730369
            Invalid context. The number of Reporting Party Non-Primary Production (Instant) contexts must not exceed 1.
    
            Legacy Rule Format:
            IF COUNT(RP.NonPrim(Instant)) > 1
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) > 1
    
            Data Elements:
    
            ^Context = RP.NonPrim(Instant)
            */
            assertion = (Count(report.RPNonPrimInstantCount) > 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730369",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting Party Non-Primary Production (Instant) contexts must not exceed 1.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPNonPrimInstantLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730369" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730369

            #region VR.ATO.IITR.730370

            /*  VR.ATO.IITR.730370
            Entity identifier scheme for Reporting Party Non-Primary Production (Instant) must be set to "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF RP.NonPrim(Instant):entity.identifier.scheme <> "http://www.ato.gov.au/tfn"
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP.NonPrim(Instant)
            */
            assertion = ((report.RPNonPrimInstantExists == true) && (report.RPNonPrimInstantIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730370",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for Reporting Party Non-Primary Production (Instant) must be set to ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPNonPrimInstantOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730370" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730370

            #region VR.ATO.IITR.730371

            /*  VR.ATO.IITR.730371
            Invalid context. Period date of Reporting Party Non-Primary Production (Instant) must match period start date of Reporting Party.
    
            Legacy Rule Format:
            IF (RP.NonPrim(Instant):period.instantDate <> RP:period.startDate)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^InstantDate1 <> ^StartDate1
    
            Data Elements:
    
            ^StartDate1 = RP
    
            ^InstantDate1 = RP.NonPrim(Instant)
            */
            assertion = ((report.RPNonPrimInstantExists == true) && (report.RPNonPrimInstantInstantDate != report.RPStartDate));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730371",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Non-Primary Production (Instant) period date is invalid",
                    LongDescription = @"Invalid context. Period date of Reporting Party Non-Primary Production (Instant) must match period start date of Reporting Party.",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730371" } },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730371

            #region VR.ATO.IITR.730372

            /*  VR.ATO.IITR.730372
            Where a Primary production instance has been provided, at least one of the Primary production details must be provided
    
            Legacy Rule Format:
            IF COUNT(RP.Prim) <> 0 AND [iitr701] = NULL AND [iitr703] = NULL AND [iitr704] = NULL AND [iitr705] = NULL AND [iitr706] = NULL AND [iitr707] = NULL AND [iitr708] = NULL AND [iitr709] = NULL AND [iitr710] = NULL AND [iitr711] = NULL AND [iitr712] = NULL AND [iitr713] = NULL AND [iitr714] = NULL AND [iitr715] = NULL AND [iitr716] = NULL AND [iitr717] = NULL AND [iitr718] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 0 AND ^IITR701 = NULL AND ^IITR703 = NULL AND ^IITR704 = NULL AND ^IITR705 = NULL AND ^IITR706 = NULL AND ^IITR707 = NULL AND ^IITR708 = NULL AND ^IITR709 = NULL AND ^IITR710 = NULL AND ^IITR711 = NULL AND ^IITR712 = NULL AND ^IITR713 = NULL AND ^IITR714 = NULL AND ^IITR715 = NULL AND ^IITR716 = NULL AND ^IITR717 = NULL AND ^IITR718 = NULL
    
            Data Elements:
    
            ^IITR701 = RP.Prim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR703 = RP.Prim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR704 = RP.Prim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR705 = RP.Prim:Expense.Operating.BadDebts.Amount
    
            ^IITR706 = RP.Prim:Expense.Operating.Lease.Amount
    
            ^IITR707 = RP.Prim:Expense.Operating.Rent.Amount
    
            ^IITR708 = RP.Prim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR709 = RP.Prim:Expense.Operating.InterestForeign.Amount
    
            ^IITR710 = RP.Prim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR711 = RP.Prim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR712 = RP.Prim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR713 = RP.Prim:Expense.Operating.Other.Amount
    
            ^IITR714 = RP.Prim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
    
            ^IITR715 = RP.Prim:Expense.ProjectPoolAllowableDeduction.Amount
    
            ^IITR716 = RP.Prim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR717 = RP.Prim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR718 = RP.Prim:Expense.ReconciliationAdjustments.Amount
    
            ^Context = RP:RP.Prim
            */
            assertion = (Count(report.RPPrimCount) != 0 && report.IITR701 == null && report.IITR703 == null && report.IITR704 == null && report.IITR705 == null && report.IITR706 == null && report.IITR707 == null && report.IITR708 == null && report.IITR709 == null && report.IITR710 == null && report.IITR711 == null && report.IITR712 == null && report.IITR713 == null && report.IITR714 == null && report.IITR715 == null && report.IITR716 == null && report.IITR717 == null && report.IITR718 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730372",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one of the Primary production details must be provided",
                    LongDescription = @"Where a Primary production instance has been provided, at least one of the Primary production details must be provided",
                    Location = "/xbrli:xbrl/tns:Expense.Purchases.AndOtherCosts.Amount[@contextRef='" + report.RPPrimId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730372" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR701", Value = GetValueOrEmpty(report.IITR701) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR703", Value = GetValueOrEmpty(report.IITR703) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR704", Value = GetValueOrEmpty(report.IITR704) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR705", Value = GetValueOrEmpty(report.IITR705) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR706", Value = GetValueOrEmpty(report.IITR706) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR707", Value = GetValueOrEmpty(report.IITR707) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR708", Value = GetValueOrEmpty(report.IITR708) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR709", Value = GetValueOrEmpty(report.IITR709) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR710", Value = GetValueOrEmpty(report.IITR710) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR711", Value = GetValueOrEmpty(report.IITR711) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR712", Value = GetValueOrEmpty(report.IITR712) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR713", Value = GetValueOrEmpty(report.IITR713) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR714", Value = GetValueOrEmpty(report.IITR714) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR715", Value = GetValueOrEmpty(report.IITR715) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR716", Value = GetValueOrEmpty(report.IITR716) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR717", Value = GetValueOrEmpty(report.IITR717) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR718", Value = GetValueOrEmpty(report.IITR718) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730372

            #region VR.ATO.IITR.730373

            /*  VR.ATO.IITR.730373
            Where a Non-primary production instance has been provided, at least one of the Non-primary production details must be provided
    
            Legacy Rule Format:
            IF COUNT(RP.NonPrim) <> 0 AND [iitr720] = NULL AND [iitr722] = NULL AND [iitr723] = NULL AND [iitr724] = NULL AND [iitr725] = NULL AND [iitr726] = NULL AND [iitr727] = NULL AND [iitr728] = NULL AND [iitr729] = NULL AND [iitr730] = NULL AND [iitr731] = NULL AND [iitr732] = NULL AND [iitr733] = NULL AND [iitr734] = NULL AND [iitr735] = NULL AND [iitr736] = NULL AND [iitr737] = NULL AND [iitr738] = NULL
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 0 AND ^IITR720 = NULL AND ^IITR722 = NULL AND ^IITR723 = NULL AND ^IITR724 = NULL AND ^IITR725 = NULL AND ^IITR726 = NULL AND ^IITR727 = NULL AND ^IITR728 = NULL AND ^IITR729 = NULL AND ^IITR730 = NULL AND ^IITR731 = NULL AND ^IITR732 = NULL AND ^IITR733 = NULL AND ^IITR734 = NULL AND ^IITR735 = NULL AND ^IITR736 = NULL AND ^IITR737 = NULL AND ^IITR738 = NULL
    
            Data Elements:
    
            ^IITR720 = RP.NonPrim:Expense.Purchases.AndOtherCosts.Amount
    
            ^IITR722 = RP.NonPrim:Expense.ForeignResidentWithholding.Amount
    
            ^IITR723 = RP.NonPrim:Expense.Operating.EmploymentCostsTotal.Amount
    
            ^IITR724 = RP.NonPrim:SuperannuationContribution.EmployerContributions.Amount
    
            ^IITR725 = RP.NonPrim:Expense.Operating.BadDebts.Amount
    
            ^IITR726 = RP.NonPrim:Expense.Operating.Lease.Amount
    
            ^IITR727 = RP.NonPrim:Expense.Operating.Rent.Amount
    
            ^IITR728 = RP.NonPrim:Expense.Operating.InterestAustralia.Amount
    
            ^IITR729 = RP.NonPrim:Expense.Operating.InterestForeign.Amount
    
            ^IITR730 = RP.NonPrim:Expense.DepreciationandAmortisation.Amount
    
            ^IITR731 = RP.NonPrim:Expense.Operating.MotorVehicle.Amount
    
            ^IITR732 = RP.NonPrim:Expense.Operating.RepairsAndMaintenance.Amount
    
            ^IITR733 = RP.NonPrim:Expense.Operating.Other.Amount
    
            ^IITR734 = RP.NonPrim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
    
            ^IITR735 = RP.NonPrim:Expense.ProjectPoolAllowableDeduction.Amount
    
            ^IITR736 = RP.NonPrim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
    
            ^IITR737 = RP.NonPrim:Income.ReconciliationAdjustmentTotal.Amount
    
            ^IITR738 = RP.NonPrim:Expense.ReconciliationAdjustments.Amount
    
            ^Context = RP:RP.NonPrim
            */
            assertion = (Count(report.RPNonPrimCount) != 0 && report.IITR720 == null && report.IITR722 == null && report.IITR723 == null && report.IITR724 == null && report.IITR725 == null && report.IITR726 == null && report.IITR727 == null && report.IITR728 == null && report.IITR729 == null && report.IITR730 == null && report.IITR731 == null && report.IITR732 == null && report.IITR733 == null && report.IITR734 == null && report.IITR735 == null && report.IITR736 == null && report.IITR737 == null && report.IITR738 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730373",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"At least one of the Non-primary production details must be provided",
                    LongDescription = @"Where a Non-primary production instance has been provided, at least one of the Non-primary production details must be provided",
                    Location = "/xbrli:xbrl/tns:Expense.Purchases.AndOtherCosts.Amount[@contextRef='" + report.RPNonPrimId + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730373" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR720", Value = GetValueOrEmpty(report.IITR720) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR722", Value = GetValueOrEmpty(report.IITR722) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR723", Value = GetValueOrEmpty(report.IITR723) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR724", Value = GetValueOrEmpty(report.IITR724) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR725", Value = GetValueOrEmpty(report.IITR725) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR726", Value = GetValueOrEmpty(report.IITR726) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR727", Value = GetValueOrEmpty(report.IITR727) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR728", Value = GetValueOrEmpty(report.IITR728) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR729", Value = GetValueOrEmpty(report.IITR729) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR730", Value = GetValueOrEmpty(report.IITR730) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR731", Value = GetValueOrEmpty(report.IITR731) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR732", Value = GetValueOrEmpty(report.IITR732) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR733", Value = GetValueOrEmpty(report.IITR733) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR734", Value = GetValueOrEmpty(report.IITR734) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR735", Value = GetValueOrEmpty(report.IITR735) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR736", Value = GetValueOrEmpty(report.IITR736) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR737", Value = GetValueOrEmpty(report.IITR737) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR738", Value = GetValueOrEmpty(report.IITR738) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730373

            #region VR.ATO.IITR.730489

            /*  VR.ATO.IITR.730489
            Where Other deductions relating to amounts shown type is provided it must be set to either "All" or "Part".
    
            Legacy Rule Format:
            IF ((([iitr247] <> NULL) AND NOT InSet([iitr247], '"All", "Part"')))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (((^IITR247 <> NULL) AND NOT InSet(^IITR247, '"All", "Part"')))
    
            Data Elements:
    
            ^IITR247 = RP:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Code
            */
            assertion = (report.IITR247 != null && !(IsMatch(report.IITR247, @"^(All|Part)$")));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730489",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Other deductions relating to amounts shown type is incorrect",
                    LongDescription = "Where Other deductions relating to amounts shown type is provided it must be set to either \"All\" or \"Part\".",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.PartnershipsAndTrustPrimaryProductionShare.Code",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730489" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR247", Value = GetValueOrEmpty(report.IITR247) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730489

            #region VR.ATO.IITR.730490

            /*  VR.ATO.IITR.730490
            Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year amount must not be provided
    
            Legacy Rule Format:
            IF ([iitr126] <> NULL)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IITR126 <> NULL
    
            Data Elements:
    
            ^IITR126 = RP:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount
            */
            assertion = (report.IITR126 != null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.IITR.730490",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Discount on ESS Interests acquired pre 1 July 2009 and 'cessation time' occurred during financial year amount must not be provided",
                    Location = "/xbrli:xbrl/tns:Income.EmployeeShareScheme.AcquiredBeforeJuly2009Discount.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.730490" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "IITR126", Value = GetValueOrEmpty(report.IITR126) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.IITR.730490

            #region Repeating RPLOSSSeqNumContext

            if (report.RPLOSSSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (IITR2020.RPLOSSSeqNumContext rplossSeqNumContext in report.RPLOSSSeqNumContextCollection)
                {
                    itemIndexContext2++;

                    #region VR.ATO.GEN.001023

                    /*  VR.ATO.GEN.001023
                    TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
                    Legacy Rule Format:
                    IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^Context <> NULL AND ^OtherTFN <> ^TFN
            
                    Data Elements:
            
                    ^Context = RP:RP.{LOSSSeqNum}
            
                    ^OtherTFN = RP:RP.{LOSSSeqNum}
            
                    ^TFN = RP
                    */
                    assertion = (rplossSeqNumContext.Exists != false && rplossSeqNumContext.IdentifierTFN != report.RPIdentifierTFN);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.001023",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Unexpected TFN mismatch with Reporting Party",
                            LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(rplossSeqNumContext.OccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.001023

                    #region VR.ATO.GEN.500030

                    /*  VR.ATO.GEN.500030
                    Invalid context. Period start date must be the same across all duration contexts.
    
                    Legacy Rule Format:
                    IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
            
                    Data Elements:
            
                    ^StartDate = RP
            
                    ^StartDate1 = RP:RP.{LOSSSeqNum}
                    */
                    assertion = (rplossSeqNumContext.StartDate != null && rplossSeqNumContext.StartDate != report.RPStartDate);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500030",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.500030

                    #region VR.ATO.GEN.500033

                    /*  VR.ATO.GEN.500033
                    Invalid context. Period end date must be the same across all duration contexts.
    
                    Legacy Rule Format:
                    IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
            
                    Data Elements:
            
                    ^EndDate = RP
            
                    ^EndDate1 = RP:RP.{LOSSSeqNum}
                    */
                    assertion = (rplossSeqNumContext.EndDate != null && rplossSeqNumContext.EndDate != report.RPEndDate);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500033",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.500033

                    #region VR.ATO.IITR.300037

                    /*  VR.ATO.IITR.300037
                    The Business loss activity details indicates that the business activity carried on in a partnership with others and that the loss is to be deferred; but no amount has been recorded at Deferred losses from partnership activities.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr481] = "161" AND [iitr482] = 8) AND [iitr294] = NULL 
                      RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR481 = '161' AND ^IITR482 = 8) AND ^IITR294 = NULL
            
                    Data Elements:
            
                    ^IITR294 = RP:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
                    */
                    assertion = (rplossSeqNumContext.IITR481 == @"161" && AsNumeric(rplossSeqNumContext.IITR482) == 8 && report.IITR294 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.300037",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Deferred losses from partnership activities is required",
                            LongDescription = @"The Business loss activity details indicates that the business activity carried on in a partnership with others and that the loss is to be deferred; but no amount has been recorded at Deferred losses from partnership activities",
                            Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialPartnershipShare.Amount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.300037" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR294", Value = GetValueOrEmpty(report.IITR294) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.300037

                    #region VR.ATO.IITR.310023

                    /*  VR.ATO.IITR.310023
                    The Business loss activity details indicates that the business activity carried out as a sole trader and that the loss is to be deferred; but no amount has been recorded at Deferred losses from sole trader activities.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr481] = "006" AND [iitr482] = 8) AND [iitr298] = NULL 
                      RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR481 = '006' AND ^IITR482 = 8) AND ^IITR298 = NULL
            
                    Data Elements:
            
                    ^IITR298 = RP:Tax.Losses.DeferredNonCommercialSoleTrader.Amount
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
                    */
                    assertion = (rplossSeqNumContext.IITR481 == @"006" && AsNumeric(rplossSeqNumContext.IITR482) == 8 && report.IITR298 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.310023",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Deferred losses from sole trader activities is required",
                            LongDescription = @"The Business loss activity details indicates that the business activity carried out as a sole trader and that the loss is to be deferred; but no amount has been recorded at Deferred losses from sole trader activities",
                            Location = "/xbrli:xbrl/tns:Tax.Losses.DeferredNonCommercialSoleTrader.Amount",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310023" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR298", Value = GetValueOrEmpty(report.IITR298) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.310023

                    #region VR.ATO.IITR.310042

                    /*  VR.ATO.IITR.310042
                    When Loss type '1' (Assessable income test) has been selected in Business loss activity details and the Status of business is not 'Commenced' or 'Ceased.' The total business income is less than $20,000 and this code only applies where business income exceeds $20,000.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr481] = "006") AND ([iitr482] = 1) AND ([iitr423] = NULLORBLANK) AND ((([iitr700] + [iitr719]) - ([iitr702] + [iitr721])) >= 0) AND ((([iitr474] + [iitr475] + [iitr467] + [iitr468]) + ([iitr714] + [iitr715] + [iitr716] + [iitr734] + [iitr735] + [iitr736]) - ([iitr718] + [iitr738])) < 20000)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR481 = '006') AND (^IITR482 = 1) AND (^IITR423 = BLANK) AND (((^IITR700 + ^IITR719) - (^IITR702 + ^IITR721)) >= 0) AND (((^IITR474 + ^IITR475 + ^IITR467 + ^IITR468) + (^IITR714 + ^IITR715 + ^IITR716 + ^IITR734 + ^IITR735 + ^IITR736) - (^IITR718 + ^IITR738)) < 20000)
            
                    Data Elements:
            
                    ^IITR423 = RP:OrganisationDetails.ActivityEvent.Code
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
            
                    ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
            
                    ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
            
                    ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
            
                    ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
            
                    ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
            
                    ^IITR467 = RP:Expense.Operating.BusinessPrimaryProduction.Amount
            
                    ^IITR468 = RP:Expense.Operating.BusinessNonPrimaryProduction.Amount
            
                    ^IITR714 = RP.Prim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
            
                    ^IITR715 = RP.Prim:Expense.ProjectPoolAllowableDeduction.Amount
            
                    ^IITR716 = RP.Prim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
            
                    ^IITR734 = RP.NonPrim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
            
                    ^IITR735 = RP.NonPrim:Expense.ProjectPoolAllowableDeduction.Amount
            
                    ^IITR736 = RP.NonPrim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
            
                    ^IITR718 = RP.Prim:Expense.ReconciliationAdjustments.Amount
            
                    ^IITR738 = RP.NonPrim:Expense.ReconciliationAdjustments.Amount
                    */
                    assertion = (rplossSeqNumContext.IITR481 == @"006" && AsNumeric(rplossSeqNumContext.IITR482) == 1 && string.IsNullOrWhiteSpace(report.IITR423) == true && report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault() - (report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault()) >= 0 && report.IITR474.GetValueOrDefault() + report.IITR475.GetValueOrDefault() + report.IITR467.GetValueOrDefault() + report.IITR468.GetValueOrDefault() + (report.IITR714.GetValueOrDefault() + report.IITR715.GetValueOrDefault() + report.IITR716.GetValueOrDefault() + report.IITR734.GetValueOrDefault() + report.IITR735.GetValueOrDefault() + report.IITR736.GetValueOrDefault()) - (report.IITR718.GetValueOrDefault() + report.IITR738.GetValueOrDefault()) < 20000);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.310042",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Assessable income in Business loss activity details must be at least $20,000",
                            LongDescription = @"When Loss type '1' (Assessable income test) has been selected in Business loss activity details and the Status of business is not 'Commenced' or 'Ceased.' The total business income is less than $20,000 and this code only applies where business income exceeds $20,000.",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.ActivityEvent.Code",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310042" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR423", Value = GetValueOrEmpty(report.IITR423) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR467", Value = GetValueOrEmpty(report.IITR467) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR468", Value = GetValueOrEmpty(report.IITR468) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR714", Value = GetValueOrEmpty(report.IITR714) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR715", Value = GetValueOrEmpty(report.IITR715) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR716", Value = GetValueOrEmpty(report.IITR716) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR734", Value = GetValueOrEmpty(report.IITR734) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR735", Value = GetValueOrEmpty(report.IITR735) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR736", Value = GetValueOrEmpty(report.IITR736) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR718", Value = GetValueOrEmpty(report.IITR718) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR738", Value = GetValueOrEmpty(report.IITR738) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.310042

                    #region VR.ATO.IITR.310045

                    /*  VR.ATO.IITR.310045
                    When Loss type '1' (Assessable income test) has been selected in Business loss activity details and the Status of business is not 'Commenced' or 'Ceased.' The total business income is less than $20,000 and this code only applies where business income exceeds $20,000.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr481] = "006") AND ([iitr482] = 1) AND ([iitr423] = NULLORBLANK) AND (((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) > 0) AND ((([iitr702] + [iitr721]) - ([iitr700] + [iitr719])) + ([iitr474] + [iitr475] + [iitr467] + [iitr468]) + ([iitr714] + [iitr715] + [iitr716] + [iitr734] + [iitr735] + [iitr736]) - ([iitr718] + [iitr738])) < 20000)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR481 = '006') AND (^IITR482 = 1) AND (^IITR423 = BLANK) AND ((((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) > 0) AND (((^IITR702 + ^IITR721) - (^IITR700 + ^IITR719)) + (^IITR474 + ^IITR475 + ^IITR467 + ^IITR468) + (^IITR714 + ^IITR715 + ^IITR716 + ^IITR734 + ^IITR735 + ^IITR736) - (^IITR718 + ^IITR738)) < 20000)
            
                    Data Elements:
            
                    ^IITR423 = RP:OrganisationDetails.ActivityEvent.Code
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR702 = RP.Prim(Instant):Assets.ClosingStock.Amount
            
                    ^IITR721 = RP.NonPrim(Instant):Assets.ClosingStock.Amount
            
                    ^IITR700 = RP.Prim(Instant):Assets.OpeningStock.Amount
            
                    ^IITR719 = RP.NonPrim(Instant):Assets.OpeningStock.Amount
            
                    ^IITR474 = RP:Income.BusinessPrimaryProductionNet.Amount
            
                    ^IITR475 = RP:Income.BusinessNonPrimaryProductionNet.Amount
            
                    ^IITR467 = RP:Expense.Operating.BusinessPrimaryProduction.Amount
            
                    ^IITR468 = RP:Expense.Operating.BusinessNonPrimaryProduction.Amount
            
                    ^IITR714 = RP.Prim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
            
                    ^IITR715 = RP.Prim:Expense.ProjectPoolAllowableDeduction.Amount
            
                    ^IITR716 = RP.Prim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
            
                    ^IITR734 = RP.NonPrim:Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount
            
                    ^IITR735 = RP.NonPrim:Expense.ProjectPoolAllowableDeduction.Amount
            
                    ^IITR736 = RP.NonPrim:Expense.LandcareOperationsAcceleratedDepreciation.Amount
            
                    ^IITR718 = RP.Prim:Expense.ReconciliationAdjustments.Amount
            
                    ^IITR738 = RP.NonPrim:Expense.ReconciliationAdjustments.Amount
                    */
                    assertion = (rplossSeqNumContext.IITR481 == @"006" && AsNumeric(rplossSeqNumContext.IITR482) == 1 && string.IsNullOrWhiteSpace(report.IITR423) == true && (report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) > 0 && report.IITR702.GetValueOrDefault() + report.IITR721.GetValueOrDefault() - (report.IITR700.GetValueOrDefault() + report.IITR719.GetValueOrDefault()) + (report.IITR474.GetValueOrDefault() + report.IITR475.GetValueOrDefault() + report.IITR467.GetValueOrDefault() + report.IITR468.GetValueOrDefault()) + (report.IITR714.GetValueOrDefault() + report.IITR715.GetValueOrDefault() + report.IITR716.GetValueOrDefault() + report.IITR734.GetValueOrDefault() + report.IITR735.GetValueOrDefault() + report.IITR736.GetValueOrDefault()) - (report.IITR718.GetValueOrDefault() + report.IITR738.GetValueOrDefault()) < 20000));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.310045",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Assessable income in Business loss activity details must be at least $20,000",
                            LongDescription = @"When Loss type '1' (Assessable income test) has been selected in Business loss activity details and the Status of business is not 'Commenced' or 'Ceased.' The total business income is less than $20,000 and this code only applies where business income exceeds $20,000.",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.ActivityEvent.Code",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310045" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR423", Value = GetValueOrEmpty(report.IITR423) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR702", Value = GetValueOrEmpty(report.IITR702) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR721", Value = GetValueOrEmpty(report.IITR721) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR700", Value = GetValueOrEmpty(report.IITR700) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR719", Value = GetValueOrEmpty(report.IITR719) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR474", Value = GetValueOrEmpty(report.IITR474) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR475", Value = GetValueOrEmpty(report.IITR475) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR467", Value = GetValueOrEmpty(report.IITR467) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR468", Value = GetValueOrEmpty(report.IITR468) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR714", Value = GetValueOrEmpty(report.IITR714) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR715", Value = GetValueOrEmpty(report.IITR715) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR716", Value = GetValueOrEmpty(report.IITR716) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR734", Value = GetValueOrEmpty(report.IITR734) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR735", Value = GetValueOrEmpty(report.IITR735) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR736", Value = GetValueOrEmpty(report.IITR736) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR718", Value = GetValueOrEmpty(report.IITR718) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR738", Value = GetValueOrEmpty(report.IITR738) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.310045

                    #region VR.ATO.IITR.310048

                    /*  VR.ATO.IITR.310048
                    Where Type of Loss of either '6' or '7' has been selected in Business loss activity details, the sum of Taxable income or loss plus Net loss plus Individual total deductions, less Net capital gain, must be under $40,000. Loss type '6' or '7' can only be used when the assessable income is less than $40,000.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr482] = 6 OR [iitr482] = 7) AND (([iitr157] + [iitr487] + [iitr150] - [iitr311]) >= 40000)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR482 = 6 OR ^IITR482 = 7) AND ((^IITR157 + ^IITR487 + ^IITR150 - ^IITR311) >= 40000)
            
                    Data Elements:
            
                    ^IITR157 = RP:Income.Taxable.Amount
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount
            
                    ^IITR150 = RP:Expense.DeductionsTotal.Amount
            
                    ^IITR311 = RP:Capital.Gains.Net.Amount
                    */
                    assertion = ((AsNumeric(rplossSeqNumContext.IITR482) == 6 || AsNumeric(rplossSeqNumContext.IITR482) == 7) && report.IITR157.GetValueOrDefault() + rplossSeqNumContext.IITR487.GetValueOrDefault() + report.IITR150.GetValueOrDefault() - report.IITR311.GetValueOrDefault() >= 40000);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.311048",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Assessable income from other sources must be less than $40,000",
                            LongDescription = @"Where Type of Loss of either '6' or '7' has been selected in Business loss activity details, the sum of Taxable income or loss plus Net loss plus Individual total deductions, less Net capital gain, must be under $40,000. Loss type '6' or '7' can only be used when the assessable income is less than $40,000.",
                            Location = "/xbrli:xbrl/tns:Income.Taxable.Amount[@contextRef='" + report.RPId + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.310048" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR157", Value = GetValueOrEmpty(report.IITR157) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR487", Value = GetValueOrEmpty(rplossSeqNumContext.IITR487) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR150", Value = GetValueOrEmpty(report.IITR150) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR311", Value = GetValueOrEmpty(report.IITR311) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.310048

                    #region VR.ATO.IITR.400053

                    /*  VR.ATO.IITR.400053
                    Scheme for Reporting Party Loss must be set to "http://www.ato.gov.au/tfn"
    
                    Legacy Rule Format:
                    IF (RP.{LOSSSeqNum}:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
            
                    Data Elements:
            
                    ^IdentifierScheme = RP:RP.{LOSSSeqNum}
                    */
                    assertion = (rplossSeqNumContext.IdentifierScheme != @"http://www.ato.gov.au/tfn");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.400053",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Entity Identifier scheme for Reporting Party Loss must be ""http://www.ato.gov.au/tfn""",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(rplossSeqNumContext.OccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400053" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.400053

                    #region VR.ATO.IITR.410006

                    /*  VR.ATO.IITR.410006
                    In Business loss activity details, all details must be correctly completed including 'Description of activity', 'Industry code', 'Partnership or sole trader', 'Type of loss code' and 'Net loss'
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr479] <> NULLORBLANK OR [iitr480] <> NULL OR [iitr481] <> NULL OR [iitr482] <> NULL OR [iitr487] <> NULL) AND ([iitr479] = NULLORBLANK OR [iitr480] = NULL OR [iitr481] = NULL OR [iitr482] = NULL OR [iitr487] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR479 <> BLANK OR ^IITR480 <> NULL OR ^IITR481 <> NULL OR ^IITR482 <> NULL OR ^IITR487 <> NULL) AND (^IITR479 = BLANK OR ^IITR480 = NULL OR ^IITR481 = NULL OR ^IITR482 = NULL OR ^IITR487 = NULL)
            
                    Data Elements:
            
                    ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
            
                    ^IITR480 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationIndustry2006Extended.Code
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount
                    */
                    assertion = ((string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR479) != true || rplossSeqNumContext.IITR480 != null || rplossSeqNumContext.IITR481 != null || rplossSeqNumContext.IITR482 != null || rplossSeqNumContext.IITR487 != null) && (string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR479) == true || rplossSeqNumContext.IITR480 == null || rplossSeqNumContext.IITR481 == null || rplossSeqNumContext.IITR482 == null || rplossSeqNumContext.IITR487 == null));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410006",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business loss activity details is required",
                            LongDescription = @"In Business loss activity details, all details must be correctly completed including 'Description of activity', 'Industry code', 'Partnership or sole trader', 'Type of loss code' and 'Net loss'",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410006" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR479", Value = GetValueOrEmpty(rplossSeqNumContext.IITR479) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR480", Value = GetValueOrEmpty(rplossSeqNumContext.IITR480) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR487", Value = GetValueOrEmpty(rplossSeqNumContext.IITR487) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410006

                    #region VR.ATO.IITR.410011

                    /*  VR.ATO.IITR.410011
                    If label 'Type of loss' equals '5' then label 'Business loss activity - Number' is required
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr482] = 5 AND ([iitr489] = NULL AND [iitr485] = NULL))
                          RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR482 = 5 AND (^IITR489 = NULL AND ^IITR485 = NULL))
            
                    Data Elements:
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
                    */
                    assertion = (AsNumeric(rplossSeqNumContext.IITR482) == 5 && (rplossSeqNumContext.IITR489 == null && rplossSeqNumContext.IITR485 == null));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410011",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business Loss Activity - Number is required",
                            LongDescription = @"If label 'Type of loss' equals '5' then label 'Business loss activity - Number' is required",
                            Location = "/xbrli:xbrl/tns:IncomeTax.LossesType.Code[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410011" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410011

                    #region VR.ATO.IITR.410014

                    /*  VR.ATO.IITR.410014
                    If label 'Business loss activity - Number' is present then label 'Type of loss' must equal '5'
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF (([iitr482] <> 5) AND ([iitr489] <> NULL OR [iitr485] <> NULL))
                      RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ((^IITR482 <> 5) AND (^IITR489 <> NULL OR ^IITR485 <> NULL))
            
                    Data Elements:
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
                    */
                    assertion = (AsNumeric(rplossSeqNumContext.IITR482) != 5 && (rplossSeqNumContext.IITR489 != null || rplossSeqNumContext.IITR485 != null));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410014",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid or required reference for 'Type of loss'",
                            LongDescription = @"If label 'Business loss activity - Number' is present then label 'Type of loss' must equal '5'",
                            Location = "/xbrli:xbrl/tns:IncomeTax.LossesType.Code[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410014" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410014

                    #region VR.ATO.IITR.410016

                    /*  VR.ATO.IITR.410016
                    Product Ruling Year (Income year) and Number (Product Ruling number) details are required.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr488] <> NULL AND [iitr489] = NULL) OR ([iitr489] <> NULL AND [iitr488] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR488 <> NULL AND ^IITR489 = NULL) OR (^IITR489 <> NULL AND ^IITR488 = NULL)
            
                    Data Elements:
            
                    ^IITR488 = RP.{LOSSSeqNum}:Tax.ProductRuling.Year
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
                    */
                    assertion = (rplossSeqNumContext.IITR488 != null && rplossSeqNumContext.IITR489 == null || rplossSeqNumContext.IITR489 != null && rplossSeqNumContext.IITR488 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410016",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Product ruling year and number details are required",
                            LongDescription = @"When either Product ruling year or Product ruling number are provided, both fields must be provided",
                            Location = "/xbrli:xbrl/tns:Tax.ProductRuling.Year[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410016" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR488", Value = GetValueOrEmpty(rplossSeqNumContext.IITR488) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410016

                    #region VR.ATO.IITR.410071

                    /*  VR.ATO.IITR.410071
                    Product Ruling year is not valid. Valid values include: 1998 through to current lodgment year (inclusive).
    
                    Legacy Rule Format:
                    IF [iitr488] <> NULL AND ([iitr488] < 1998 OR [iitr488] > 2020)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^IITR488 <> NULL AND (^IITR488 < 1998 OR ^IITR488 > 2020)
            
                    Data Elements:
            
                    ^IITR488 = RP.{LOSSSeqNum}:Tax.ProductRuling.Year
                    */
                    assertion = (rplossSeqNumContext.IITR488 != null && (rplossSeqNumContext.IITR488.GetValueOrDefault() < 1998 || rplossSeqNumContext.IITR488.GetValueOrDefault() > 2020));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.411071",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Product Ruling year is not valid. Valid values include: 1998 through to current lodgment year (inclusive).",
                            Location = "/xbrli:xbrl/tns:Tax.ProductRuling.Year[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410071" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR488", Value = GetValueOrEmpty(rplossSeqNumContext.IITR488) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410071

                    #region VR.ATO.IITR.410106

                    /*  VR.ATO.IITR.410106
                    Business loss activity - Description of activity has a maximum length of 100
    
                    Legacy Rule Format:
                    IF LENGTH([iitr479]) > 100
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^IITR479) > 100
            
                    Data Elements:
            
                    ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
                    */
                    assertion = (Length(rplossSeqNumContext.IITR479) > 100);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.411106",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business loss activity - Description of activity must not exceed 100 characters",
                            LongDescription = @"For Business loss activity - Description of activity, the maximum allowable characters for this form is 100",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410106" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR479", Value = GetValueOrEmpty(rplossSeqNumContext.IITR479) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410106

                    #region VR.ATO.IITR.410111

                    /*  VR.ATO.IITR.410111
                    Product ruling number has a maximum length of 13
    
                    Legacy Rule Format:
                    IF LENGTH([iitr489]) > 13
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^IITR489) > 13
            
                    Data Elements:
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
                    */
                    assertion = (Length(rplossSeqNumContext.IITR489) > 13);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410111",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Product ruling number must not exceed 13 characters",
                            LongDescription = @"For Product ruling number, the maximum allowable characters for this form is 13",
                            Location = "/xbrli:xbrl/tns:Tax.ProductRulingNumber.Identifier[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410111" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410111

                    #region VR.ATO.IITR.410113

                    /*  VR.ATO.IITR.410113
                    Private ruling Number has a maximum length of 13
    
                    Legacy Rule Format:
                    IF LENGTH([iitr485]) > 13
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^IITR485) > 13
            
                    Data Elements:
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
                    */
                    assertion = (Length(rplossSeqNumContext.IITR485) > 13);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410113",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private ruling Number must not exceed 13 characters",
                            LongDescription = @"For Private ruling Number, the maximum allowable characters for this form is 13",
                            Location = "/xbrli:xbrl/tns:Tax.PrivateRulingNumber.Identifier[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410113" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410113

                    #region VR.ATO.IITR.410114

                    /*  VR.ATO.IITR.410114
                    Activity - Deferred non-commercial loss from a prior year has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [iitr486] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^IITR486, 'U', 11, 0)
            
                    Data Elements:
            
                    ^IITR486 = RP.{LOSSSeqNum}:Tax.Losses.PriorYearNonCommercial.Amount
                    */
                    assertion = NotMonetary(rplossSeqNumContext.IITR486, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410114",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Activity - Deferred non-commercial loss from a prior year is not in a valid monetary format",
                            LongDescription = @"Activity - Deferred non-commercial loss from a prior year must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:Tax.Losses.PriorYearNonCommercial.Amount[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410114" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR486", Value = GetValueOrEmpty(rplossSeqNumContext.IITR486) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410114

                    #region VR.ATO.IITR.410115

                    /*  VR.ATO.IITR.410115
                    Business loss activity - Net loss amount has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [iitr487] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^IITR487, 'U', 11, 0)
            
                    Data Elements:
            
                    ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount
                    */
                    assertion = NotMonetary(rplossSeqNumContext.IITR487, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410115",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business loss activity - Net loss amount is not in a valid monetary format",
                            LongDescription = @"Business loss activity - Net loss amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:Tax.Losses.Net.Amount[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410115" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR487", Value = GetValueOrEmpty(rplossSeqNumContext.IITR487) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410115

                    #region VR.ATO.IITR.410190

                    /*  VR.ATO.IITR.410190
                    If the sum of primary production deferred losses and non-primary deferred losses is greater than zero, then Business loss activity Industry code label is required.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr299] + [iitr300]) > 0 AND [iitr573] = 1 AND [iitr480] = NULL
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR299 + ^IITR300) > 0 AND ^IITR573 = 1 AND ^IITR480 = NULL
            
                    Data Elements:
            
                    ^IITR480 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationIndustry2006Extended.Code
            
                    ^IITR299 = RP:Tax.Losses.DeferredNonCommercialPrimaryProduction.Amount
            
                    ^IITR300 = RP:Tax.Losses.DeferredNonCommercialNonPrimaryProduction.Amount
            
                    ^IITR573 = RP.{LOSSSeqNum}:Report.ItemOrder.Number
                    */
                    assertion = (report.IITR299.GetValueOrDefault() + report.IITR300.GetValueOrDefault() > 0 && rplossSeqNumContext.IITR573 == 1 && rplossSeqNumContext.IITR480 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410190",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business loss activity - Industry code is required",
                            LongDescription = @"If the sum of Primary production deferred losses and Non-primary deferred losses exceeds zero, then 'Business loss activity - Industry code' must be provided",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationIndustry2006Extended.Code[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410190" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR299", Value = GetValueOrEmpty(report.IITR299) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR300", Value = GetValueOrEmpty(report.IITR300) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR573", Value = rplossSeqNumContext.IITR573.ToString() });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR480", Value = GetValueOrEmpty(rplossSeqNumContext.IITR480) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410190

                    #region VR.ATO.IITR.410199

                    /*  VR.ATO.IITR.410199
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
                    Legacy Rule Format:
                    IF ([iitr479] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr479] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR479 <> BLANK) AND (NotCharacterInSet(^IITR479, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
            
                    Data Elements:
            
                    ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
                    */
                    assertion = (string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR479) != true && !(IsMatch(rplossSeqNumContext.IITR479, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410199",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business loss activity - Description of activity contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410199" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR479", Value = GetValueOrEmpty(rplossSeqNumContext.IITR479) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410199

                    #region VR.ATO.IITR.410203

                    /*  VR.ATO.IITR.410203
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
                    Legacy Rule Format:
                    IF ([iitr489] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr489] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR489 <> BLANK) AND (NotCharacterInSet(^IITR489, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
            
                    Data Elements:
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
                    */
                    assertion = (string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR489) != true && !(IsMatch(rplossSeqNumContext.IITR489, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410203",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Product ruling number contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Tax.ProductRulingNumber.Identifier[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410203" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410203

                    #region VR.ATO.IITR.410205

                    /*  VR.ATO.IITR.410205
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character
    
                    Legacy Rule Format:
                    IF ([iitr485] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr485] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR485 <> BLANK) AND (NotCharacterInSet(^IITR485, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
            
                    Data Elements:
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
                    */
                    assertion = (string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR485) != true && !(IsMatch(rplossSeqNumContext.IITR485, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410205",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private ruling Number contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Tax.PrivateRulingNumber.Identifier[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410205" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410205

                    #region VR.ATO.IITR.410208

                    /*  VR.ATO.IITR.410208
                    When Private ruling number is provided, Product ruling number must not be provided
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF ([iitr485] <> NULL AND [iitr489] <> NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR485 <> NULL AND ^IITR489 <> NULL)
            
                    Data Elements:
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
                    */
                    assertion = (rplossSeqNumContext.IITR485 != null && rplossSeqNumContext.IITR489 != null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.410208",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"When Private ruling number is provided, Product ruling number must not be provided",
                            Location = "/xbrli:xbrl/tns:Tax.ProductRulingNumber.Identifier[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.410208" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.410208

                    #region VR.ATO.IITR.600083

                    /*  VR.ATO.IITR.600083
                    Where a Business Loss Activity instance has been provided, at least one of the Business Loss Activity details must be provided.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{LOSSSeqNum})
                    IF [iitr479] = NULLORBLANK AND [iitr480] = NULL AND [iitr481] = NULL AND [iitr482] = NULL AND [iitr488] = NULL AND [iitr489] = NULLORBLANK AND [iitr485] = NULLORBLANK AND [iitr486] = NULL AND [iitr487] = NULL
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^IITR479 = BLANK AND ^IITR480 = NULL AND ^IITR481 = NULL AND ^IITR482 = NULL AND ^IITR488 = NULL AND ^IITR489 = BLANK AND ^IITR485 = BLANK AND ^IITR486 = NULL AND ^IITR487 = NULL
            
                    Data Elements:
            
                    ^IITR479 = RP.{LOSSSeqNum}:OrganisationDetails.MainIncomeActivity.Description
            
                    ^IITR480 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationIndustry2006Extended.Code
            
                    ^IITR481 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationType.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
            
                    ^IITR488 = RP.{LOSSSeqNum}:Tax.ProductRuling.Year
            
                    ^IITR489 = RP.{LOSSSeqNum}:Tax.ProductRulingNumber.Identifier
            
                    ^IITR485 = RP.{LOSSSeqNum}:Tax.PrivateRulingNumber.Identifier
            
                    ^IITR486 = RP.{LOSSSeqNum}:Tax.Losses.PriorYearNonCommercial.Amount
            
                    ^IITR487 = RP.{LOSSSeqNum}:Tax.Losses.Net.Amount
                    */
                    assertion = (string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR479) == true && rplossSeqNumContext.IITR480 == null && rplossSeqNumContext.IITR481 == null && rplossSeqNumContext.IITR482 == null && rplossSeqNumContext.IITR488 == null && string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR489) == true && string.IsNullOrWhiteSpace(rplossSeqNumContext.IITR485) == true && rplossSeqNumContext.IITR486 == null && rplossSeqNumContext.IITR487 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.600083",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"At least one of the Business Loss Activity details must be provided",
                            LongDescription = @"Where a Business Loss Activity instance has been provided, at least one of the Business Loss Activity details must be provided",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.MainIncomeActivity.Description[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600083" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR479", Value = GetValueOrEmpty(rplossSeqNumContext.IITR479) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR480", Value = GetValueOrEmpty(rplossSeqNumContext.IITR480) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR481", Value = GetValueOrEmpty(rplossSeqNumContext.IITR481) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR488", Value = GetValueOrEmpty(rplossSeqNumContext.IITR488) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR489", Value = GetValueOrEmpty(rplossSeqNumContext.IITR489) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR485", Value = GetValueOrEmpty(rplossSeqNumContext.IITR485) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR486", Value = GetValueOrEmpty(rplossSeqNumContext.IITR486) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR487", Value = GetValueOrEmpty(rplossSeqNumContext.IITR487) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.600083

                    #region VR.ATO.IITR.700001

                    /*  VR.ATO.IITR.700001
                    A valid 'Business Loss Activity - Industry code' must be provided when 'Business Loss activity - type of loss' is from passive investments. Industry Codes 99991, 99992, 99770, 99780 are not valid.
    
                    Legacy Rule Format:
                    IF [iitr482] <> 0 AND [iitr480] = SET("99991", "99992", "99770", "99780")
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^IITR482 <> 0 AND InSet(^IITR480, '"99991", "99992", "99770", "99780"')
            
                    Data Elements:
            
                    ^IITR480 = RP.{LOSSSeqNum}:OrganisationDetails.OrganisationIndustry2006Extended.Code
            
                    ^IITR482 = RP.{LOSSSeqNum}:IncomeTax.LossesType.Code
                    */
                    assertion = (AsNumeric(rplossSeqNumContext.IITR482) != 0 && IsMatch(rplossSeqNumContext.IITR480, @"^(99991|99992|99770|99780)$"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.701001",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Industry Code 99991, 99992, 99770, 99780 can only be used where loss is from passive investments",
                            LongDescription = @"A valid 'Business Loss Activity - Industry code' must be provided when 'Business Loss activity - type of loss' is from passive investments. Industry Codes 99991, 99992, 99770, 99780 are not valid.",
                            Location = "/xbrli:xbrl/tns:OrganisationDetails.OrganisationIndustry2006Extended.Code[@contextRef='" + rplossSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.700001" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR482", Value = GetValueOrEmpty(rplossSeqNumContext.IITR482) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR480", Value = GetValueOrEmpty(rplossSeqNumContext.IITR480) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.700001
                }
            }

            #endregion // Foreach loop

            #region Repeating RPPHISeqNumContext
            if (report.RPPHISeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (IITR2020.RPPHISeqNumContext rpphiSeqNumContext in report.RPPHISeqNumContextCollection)
                {
                    itemIndexContext2++;

                    #region VR.ATO.GEN.001023

                    /*  VR.ATO.GEN.001023
                    TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
                    Legacy Rule Format:
                    IF (entity.identifier.TFN WHERE CONTEXT(ALL)) <> RP:entity.identifier.TFN
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^Context <> NULL AND ^OtherTFN <> ^TFN
            
                    Data Elements:
            
                    ^Context = RP:RP.{PHISeqNum}
            
                    ^OtherTFN = RP:RP.{PHISeqNum}
            
                    ^TFN = RP
                    */
                    assertion = (rpphiSeqNumContext.Exists != false && rpphiSeqNumContext.IdentifierTFN != report.RPIdentifierTFN);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.001023",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Unexpected TFN mismatch with Reporting Party",
                            LongDescription = @"TFN in entity identifier of context does not match the TFN provided for the Reporting Party",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(rpphiSeqNumContext.OccurrenceIndex) + "/xbrli:entity/xbrli:identifier",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.001023" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.001023

                    #region VR.ATO.GEN.500030

                    /*  VR.ATO.GEN.500030
                    Invalid context. Period start date must be the same across all duration contexts.
    
                    Legacy Rule Format:
                    IF period.startDate WHERE CONTEXT(ALL) <> RP:period.startDate
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^StartDate1 <> NULL AND ^StartDate1 <> ^StartDate
            
                    Data Elements:
            
                    ^StartDate = RP
            
                    ^StartDate1 = RP:RP.{PHISeqNum}
                    */
                    assertion = (rpphiSeqNumContext.StartDate != null && rpphiSeqNumContext.StartDate != report.RPStartDate);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500030",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid context. Period start date must be the same across all duration contexts.",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:startDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500030" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.500030

                    #region VR.ATO.GEN.500033

                    /*  VR.ATO.GEN.500033
                    Invalid context. Period end date must be the same across all duration contexts.
    
                    Legacy Rule Format:
                    IF period.endDate WHERE CONTEXT(ALL) <> RP:period.endDate
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^EndDate1 <> NULL AND ^EndDate1 <> ^EndDate
            
                    Data Elements:
            
                    ^EndDate = RP
            
                    ^EndDate1 = RP:RP.{PHISeqNum}
                    */
                    assertion = (rpphiSeqNumContext.EndDate != null && rpphiSeqNumContext.EndDate != report.RPEndDate);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500033",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid context. Period end date must be the same across all duration contexts.",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:period/xbrli:endDate",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500033" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.500033



                    #region VR.ATO.IITR.000600

                    /*  VR.ATO.IITR.000600
                    When providing Tax claim code as "No dependants", "Dependants", "Claiming your share of rebate" or" Claiming your spouses share of rebate", then Health insurer ID, Membership number, Your premiums eligible for Australian Government rebate, Your Australian Government rebate received, and Benefit code must be provided.
    
                    Legacy Rule Format:
                    IF ([iitr185] <> NULL) AND ([iitr185] = SET("No dependants","Dependants","Claiming your share of rebate","Claiming your spouses share of rebate")) AND ([iitr181] = NULLORBLANK OR [iitr180] = NULL OR [iitr182] = NULL OR [iitr183] = NULL OR [iitr184] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    InSet(^IITR185, '"No dependants","Dependants","Claiming your share of rebate","Claiming your spouses share of rebate"') AND (^IITR181 = BLANK OR ^IITR180 = NULL OR ^IITR182 = NULL OR ^IITR183 = NULL OR ^IITR184 = NULL)
            
                    Data Elements:
            
                    ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
                    ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
            
                    ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            
                    ^IITR184 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.Benefit.Code
                    */
                    assertion = (IsMatch(rpphiSeqNumContext.IITR185, @"^(No dependants|Dependants|Claiming your share of rebate|Claiming your spouses share of rebate)$") && (string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR181) == true || rpphiSeqNumContext.IITR180 == null || rpphiSeqNumContext.IITR182 == null || rpphiSeqNumContext.IITR183 == null || rpphiSeqNumContext.IITR184 == null));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000600",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"All private health insurance policy details required.",
                            LongDescription = @"All private health insurance policy details must be completed where tax claim code is ""No dependants"", ""Dependants"", ""Claiming your share of rebate"", or ""Claiming your spouses share of rebate"".",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000600" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR184", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR184) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000600

                    #region VR.ATO.IITR.000601

                    /*  VR.ATO.IITR.000601
                    The health insurer ID code of (other) has been entered but details of the health insurer have not been provided in the Additional Information field. The required details which describe the health insurer must be provided.
    
                    Legacy Rule Format:
                    IF (([iitr180] <> NULLORBLANK)) AND (([iitr180] = "OTH")) AND (([iitr31] = NULLORBLANK)) 
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ((^IITR180 <> BLANK)) AND ((^IITR180 = 'OTH')) AND ((^IITR31 = BLANK))
            
                    Data Elements:
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
                    ^IITR31 = RP:RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR180) != true && rpphiSeqNumContext.IITR180 == @"OTH" && string.IsNullOrWhiteSpace(report.IITR31) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000601",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Details of health insurer ID is required",
                            LongDescription = @"When the health insurer ID of (other) has been entered but details of the health insurer have not been provided in the Additional Information field, the required details which describe the health insurer must be provided",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceProvider.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000601" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR31", Value = GetValueOrEmpty(report.IITR31) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000601

                    #region VR.ATO.IITR.000602

                    /*  VR.ATO.IITR.000602
                    The health insurer ID code is invalid.
    
                    Legacy Rule Format:
                    IF ([iitr180] <> NULL) AND ([iitr180] <> SET(DOMAIN(Health Insurer ID Codes)))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR180 <> NULL) AND (NotInDomain(^IITR180, 'Health Insurer ID Codes'))
            
                    Data Elements:
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
                    */
                    assertion = (rpphiSeqNumContext.IITR180 != null && !(IsMatch(rpphiSeqNumContext.IITR180, @"^(ACA|AHB|AHM|AMA|AUF|BUP|CBC|CBH|CDH|CPS|ESH|FAI|GMH|HBF|HCF|HCI|HEA|HIF|LHM|LHS|MBP|MDH|MYO|NHB|NIB|NMW|NTF|OMF|OTH|PWA|QCH|QTU|RBH|RTE|SLM|SPE|SPS|TFS|WFD)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.001602",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Health insurer ID invalid",
                            LongDescription = @"Health insurer ID must be a code as assigned by the Australian Taxation Office",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceProvider.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000602" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000602

                    #region VR.ATO.IITR.000603

                    /*  VR.ATO.IITR.000603
                    Private health insurance policy Tax claim code is "Spouse claiming your share of rebate" or "Covered as dependent child" and Private health insurance policy's Health insurer ID and Membership number are missing.
    
                    Legacy Rule Format:
                    IF (([iitr185] <> NULLORBLANK)) AND (([iitr185] = SET("Spouse claiming your share of rebate","Covered as dependent child")) AND ([iitr180] = NULLORBLANK) AND ([iitr181] = NULLORBLANK))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ((^IITR185 <> BLANK)) AND ((InSet(^IITR185, '"Spouse claiming your share of rebate","Covered as dependent child"')) AND (^IITR180 = BLANK) AND (^IITR181 = BLANK))
            
                    Data Elements:
            
                    ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR185) != true && (IsMatch(rpphiSeqNumContext.IITR185, @"^(Spouse claiming your share of rebate|Covered as dependent child)$") && string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR180) == true && string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR181) == true));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000603",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private health insurance policy details are incomplete",
                            LongDescription = @"When providing Private health insurance policy's Tax claim code as ""Spouse claiming your share of rebate "" or ""Covered as dependent child"" then Private health insurance policy's Health insurer ID and Membership number must also be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000603" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000603

                    #region VR.ATO.IITR.000605

                    /*  VR.ATO.IITR.000605
                    Where there are any Private Health Insurance policy details that have been completed a Tax claim code must be present.
    
                    Legacy Rule Format:
                    IF ([iitr180] <> NULL OR [iitr181] <> NULLORBLANK OR [iitr182] <> NULL OR [iitr183] <> NULL OR [iitr184] <> NULL) AND ([iitr185] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR180 <> NULL OR ^IITR181 <> BLANK OR ^IITR182 <> NULL OR ^IITR183 <> NULL OR ^IITR184 <> NULL) AND (^IITR185 = NULL)
            
                    Data Elements:
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
            
                    ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
            
                    ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            
                    ^IITR184 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.Benefit.Code
            
                    ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
                    */
                    assertion = ((rpphiSeqNumContext.IITR180 != null || string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR181) != true || rpphiSeqNumContext.IITR182 != null || rpphiSeqNumContext.IITR183 != null || rpphiSeqNumContext.IITR184 != null) && rpphiSeqNumContext.IITR185 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000605",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Tax claim code is required",
                            LongDescription = @"Where there are any Private Health Insurance policy details that have been completed a Tax claim code must be present",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceProvider.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000605" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR184", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR184) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000605

                    #region VR.ATO.IITR.000618

                    /*  VR.ATO.IITR.000618
                    Private health insurance - Membership number has a maximum field length of 15
    
                    Legacy Rule Format:
                    IF LENGTH([iitr181]) > 15
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^IITR181) > 15
            
                    Data Elements:
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
                    */
                    assertion = (Length(rpphiSeqNumContext.IITR181) > 15);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000618",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private health insurance - Membership number must not exceed 15 characters",
                            LongDescription = @"For Private health insurance - Membership number, the maximum allowable characters for this form is 15",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceMembership.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000618" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000618

                    #region VR.ATO.IITR.000619

                    /*  VR.ATO.IITR.000619
                    Your premiums eligible for Australian Government rebate has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [iitr182] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^IITR182, 'U', 11, 0)
            
                    Data Elements:
            
                    ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
                    */
                    assertion = NotMonetary(rpphiSeqNumContext.IITR182, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000619",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Your premiums eligible for Australian Government rebate is not in a valid monetary format",
                            LongDescription = @"Your premiums eligible for Australian Government rebate must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.RebatableComponent.Amount[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000619" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000619

                    #region VR.ATO.IITR.000620

                    /*  VR.ATO.IITR.000620
                    Your Australian Government rebate received has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [iitr183] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^IITR183, 'U', 11, 0)
            
                    Data Elements:
            
                    ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
                    */
                    assertion = NotMonetary(rpphiSeqNumContext.IITR183, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000620",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Your Australian Government rebate is not in a valid monetary format",
                            LongDescription = @"Your Australian Government rebate must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000620" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000620

                    #region VR.ATO.IITR.000630

                    /*  VR.ATO.IITR.000630
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([iitr181] <> NULLORBLANK) AND (ANY CHARACTER OF [iitr181] <> SET(a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR181 <> BLANK) AND (NotCharacterInSet(^IITR181, 'a-z,A-Z,0-9,"!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "'))
            
                    Data Elements:
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR181) != true && !(IsMatch(rpphiSeqNumContext.IITR181, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ""]*$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.000630",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Private health insurance - Membership number contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceMembership.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.000630" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.000630

                    #region VR.ATO.IITR.210003

                    /*  VR.ATO.IITR.210003
                    Where the Tax claim code for private health insurance is "No dependants", "Dependants", "Claiming your share of rebate" or "Claiming your spouses share of rebate", entitlement in relation to the policy and either the rebate received or the premium eligible for rebate is between 1 to 100, check private health insurance details from policy statement
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{PHISeqNum})
                    IF ([iitr185] = SET("No dependants","Dependants","Claiming your share of rebate","Claiming your spouses share of rebate")) AND (([iitr183] > 0 AND [iitr183] < 101) OR ([iitr182] > 0 AND [iitr182] < 101))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^IITR185, '"No dependants","Dependants","Claiming your share of rebate","Claiming your spouses share of rebate"')) AND ((^IITR183 > 0 AND ^IITR183 < 101) OR (^IITR182 > 0 AND ^IITR182 < 101))
            
                    Data Elements:
            
                    ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
            
                    ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            
                    ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
                    */
                    assertion = (IsMatch(rpphiSeqNumContext.IITR185, @"^(No dependants|Dependants|Claiming your share of rebate|Claiming your spouses share of rebate)$") && (rpphiSeqNumContext.IITR183.GetValueOrDefault() > 0 && rpphiSeqNumContext.IITR183.GetValueOrDefault() < 101 || rpphiSeqNumContext.IITR182.GetValueOrDefault() > 0 && rpphiSeqNumContext.IITR182.GetValueOrDefault() < 101));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.210003",
                            Severity = ProcessMessageSeverity.Warning,
                            Description = @"Check private health insurance details from policy statement",
                            LongDescription = @"The amounts shown on the statement at J - Your premiums eligible for Australian Government rebate and K - Your Australian Government rebate received are to be entered at the private health insurance policy section.",
                            Location = "/xbrli:xbrl/tns:IncomeTax.HealthInsurance.TaxClaim.Code[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.210003" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.210003

                    #region VR.ATO.IITR.400058

                    /*  VR.ATO.IITR.400058
                    Scheme for Reporting Party Private Health must be set to "http://www.ato.gov.au/tfn"
    
                    Legacy Rule Format:
                    IF (RP.{PHISeqNum}:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                        RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
            
                    Data Elements:
            
                    ^IdentifierScheme = RP:RP.{PHISeqNum}
                    */
                    assertion = (rpphiSeqNumContext.IdentifierScheme != @"http://www.ato.gov.au/tfn");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.400058",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Entity identifier scheme for Reporting Party Private Health must be ""http://www.ato.gov.au/tfn""",
                            Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(rpphiSeqNumContext.OccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.400058" } },
                        };
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.400058

                    #region VR.ATO.IITR.600085

                    /*  VR.ATO.IITR.600085
                    Where a Private Health Insurance (PHI) instance has been provided, at least one of the PHI details must be provided.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{PHISeqNum})
                    IF ([iitr180] = NULLORBLANK) AND ([iitr181] = NULLORBLANK) AND ([iitr182] = NULL) AND ([iitr183] = NULL) AND ([iitr184] = NULLORBLANK) AND ([iitr185] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR180 = BLANK) AND (^IITR181 = BLANK) AND (^IITR182 = NULL) AND (^IITR183 = NULL) AND (^IITR184 = BLANK) AND (^IITR185 = BLANK)
            
                    Data Elements:
            
                    ^IITR180 = RP.{PHISeqNum}:Identifiers.HealthInsuranceProvider.Identifier
            
                    ^IITR181 = RP.{PHISeqNum}:Identifiers.HealthInsuranceMembership.Identifier
            
                    ^IITR182 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.RebatableComponent.Amount
            
                    ^IITR183 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.GovernmentRebateReceived.Amount
            
                    ^IITR184 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.Benefit.Code
            
                    ^IITR185 = RP.{PHISeqNum}:IncomeTax.HealthInsurance.TaxClaim.Code
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR180) == true && string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR181) == true && rpphiSeqNumContext.IITR182 == null && rpphiSeqNumContext.IITR183 == null && string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR184) == true && string.IsNullOrWhiteSpace(rpphiSeqNumContext.IITR185) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.IITR.600085",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"At least one of the Private Health Insurance details must be provided",
                            LongDescription = @"Where a Private Health Insurance (PHI) instance has been provided, at least one of the PHI details must be provided",
                            Location = "/xbrli:xbrl/tns:Identifiers.HealthInsuranceProvider.Identifier[@contextRef='" + rpphiSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.IITR.600085" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR180", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR180) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR181", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR181) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR182", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR182) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR183", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR183) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR184", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR184) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR185", Value = GetValueOrEmpty(rpphiSeqNumContext.IITR185) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.IITR.600085
                }
            }

            #endregion // Foreach loop

            #region Repeating IITR310Collection
            if (report.IITR310Collection != null)
            {
                int itemIndex1 = 0;
                foreach (string IITR310 in report.IITR310Collection)
                {
                    itemIndex1++;

                    #region VR.ATO.GEN.500076

                    /*  VR.ATO.GEN.500076
                    The same exemption or rollover code has been entered more than once.
    
                    Legacy Rule Format:
                    IF (RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code <> NULLORBLANK) AND (RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code = ANY OTHER OCCURRENCE OF RP:rvctc3.xx.xx:CapitalGainsTax.ExemptionOrRolloverApplied.Code)
                      RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^IITR310 <> BLANK) AND HasDuplicateValues(^IITR310)
            
                    Data Elements:
            
                    ^IITR310 = RP:CapitalGainsTax.ExemptionOrRolloverApplied.Code
                    */
                    assertion = (string.IsNullOrWhiteSpace(IITR310) != true && HasDuplicateValues(report.IITR310Collection));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500076",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Exemption or rollover code must be unique",
                            Location = "/xbrli:xbrl/tns:CapitalGainsTax.ExemptionOrRolloverApplied.Code" + OccurrenceIndex(DuplicateValueIndex(report.IITR310Collection) + 1) + "",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500076" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "IITR310", Value = GetValueOrEmpty(IITR310) });

                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.GEN.500076
                }
            }

            #endregion // Foreach loop

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
}
